
This is a patch file against 0.2.19.

Change to directory gnupg-0.2.19 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.3.0.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.3.0 now.



Prereq: 0.2.19

diff -urN gnupg-0.2.19/VERSION gnupg-0.3.0/VERSION
--- gnupg-0.2.19/VERSION	Fri May 29 12:54:06 1998
+++ gnupg-0.3.0/VERSION	Thu Jun 25 13:05:12 1998
@@ -1 +1 @@
-0.2.19
+0.3.0

diff -urN gnupg-0.2.19/ChangeLog gnupg-0.3.0/ChangeLog
--- gnupg-0.2.19/ChangeLog	Mon May 25 19:11:38 1998
+++ gnupg-0.3.0/ChangeLog	Thu Jun 25 11:19:14 1998
@@ -1,3 +1,11 @@
+Thu Jun 25 11:18:49 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* configure.in (--disable-dynload): New.
+
+Wed Jun 10 07:48:59 1998  Werner Koch,mobil,,,	(wk@tobold)
+
+	* configure.in (GNUPG_LIBDIR): New.
+
 Mon May 25 19:10:59 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* rand-unix.c (fast_random_poll): fixed syntax bug.
diff -urN gnupg-0.2.19/INSTALL gnupg-0.3.0/INSTALL
--- gnupg-0.2.19/INSTALL	Tue Apr 14 18:59:46 1998
+++ gnupg-0.3.0/INSTALL	Thu Jun 25 11:21:17 1998
@@ -25,12 +25,16 @@
 		    side-effect, this removes all debugging code and uses
 		    the -O2 flag for all C files.
 
+--disable-dynload   If you have problems with dynamic loading, this option
+		    disables all dynamic loading stuff.
+
+
 
 Problems
 ========
 
-If you have compile problems, try the configure options "--with-included-zlib"
-or "--disable-nls" (See ABOUT-NLS).
+If you have compile problems, try the configure options "--with-included-zlib",
+"--disable-nls" (See ABOUT-NLS) or --disable-dynload.
 
 I can't check all assembler files, so if you have problems assembling them
 (or the program crashes), simply delete the files in the mpi/<cpu> directory.
diff -urN gnupg-0.2.19/Makefile.in gnupg-0.3.0/Makefile.in
--- gnupg-0.2.19/Makefile.in	Fri May 29 12:55:40 1998
+++ gnupg-0.3.0/Makefile.in	Thu Jun 25 13:08:28 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
diff -urN gnupg-0.2.19/NEWS gnupg-0.3.0/NEWS
--- gnupg-0.2.19/NEWS	Thu May 28 15:40:04 1998
+++ gnupg-0.3.0/NEWS	Thu Jun 25 09:17:09 1998
@@ -1,3 +1,30 @@
+Noteworthy changes in version 0.3.0
+-----------------------------------
+
+    * New option --emulate-checksum-bug.  If your passphrase does not
+      work anymore, use this option and --change-passphrase to rewrite
+      your passphrase.
+
+    * More complete v4 key support: Preferences and expiration time
+      is set into the self signature.
+
+    * Key generation defaults to DSA/ElGamal keys, so that new keys are
+      interoperable with pgp5
+
+    * DSA key generation is faster and key generation does not anymore
+      remove entropy from the random generator (the primes are public
+      parameters, so there is really no need for a cryptographic secure
+      prime number generator which we had used).
+
+    * A complete new structure for representing the key parameters.
+
+    * Removed most public key knowledge into the cipher libray.
+
+    * Support for dynamic loading of new algorithms.
+
+    * Moved tiger to an extension module.
+
+
 Noteworthy changes in version 0.2.19
 ------------------------------------
 
diff -urN gnupg-0.2.19/README gnupg-0.3.0/README
--- gnupg-0.2.19/README	Fri May 29 12:53:55 1998
+++ gnupg-0.3.0/README	Thu Jun 25 13:05:56 1998
@@ -1,8 +1,12 @@
 
 		  GNUPG - The GNU Privacy Guard
 		 -------------------------------
+			  Version 0.3
 
-    THIS IS ALPHA SOFTWARE, YOU MAY ENCOUNTER SOME BUGS.
+
+    As you can see from the version number, the program may have some
+    bugs and some features may not work at all - please report this to
+    the mailing list.
 
     On a Linux box (version 2.x.x, alpha or x86 CPU) it should
     work reliably.  You may create your key on such a machine and
@@ -21,27 +25,22 @@
 
     Please subscribe to g10@net.lut.ac.uk by sending a mail with
     the word "subscribe" in the body to "g10-request@net.lut.ac.uk".
+    This mailing is closed (only subscribers can post) to avoid spam.
 
     See the file COPYING for copyright and warranty information.
 
     Due to the fact that GNUPG does not use use any patented algorithm,
     it cannot be compatible with old PGP versions, because those use
     IDEA (which is patented worldwide) and RSA (which is patented in
-    the United States until Sep 20, 2000).  I'm sorry about this, but
-    this is the world we have created (e.g. by using proprietary software).
+    the United States until Sep 20, 2000).
+
+    GNUPG is in most aspects compatible with other OpenPGP implementations.
 
-    Because the OpenPGP standard is still a draft, GNUPG now interoperates
-    with it and PGP 5.	The MUA Mutt will soon support GNUPG; it has a
-    mode to fallback to another program if the received message has been
-    created with RSA or IDEA.
-
-    The default algorithms used by GNUPG are ElGamal for public-key
-    encryption and signing; Blowfish with a 128 bit key for protecting
-    the secret-key components, conventional and session encryption;
-    RIPE MD-160 to create message digest.  DSA, SHA-1, CAST and TIGER are
-    also implemented, but not used by default.	I decided not
-    to use DSA as the default signing algorithm, because it allows only
-    for 1024 bit keys and this may not be enough in a couple of years.
+    The default algorithms are now DSA and ELGamal.  ELGamal for signing
+    is still available, but due to the larger size of such signatures it
+    is depreciated (Please note that the GNUPG implementation of ElGamal
+    signatures is *not* insecure).  Symmetric algorithms are: Blowfish
+    and CAST5,	Digest algorithms are MD5, RIPEMD160, SHA1 and TIGER/192.
 
 
 
@@ -321,8 +320,6 @@
     -----------
     This is work in progress, so you may find duplicated code fragments,
     ugly data structures, weird usage of filenames and other things.
-    I will run "indent" over the source when making a real distribution,
-    but for now I stick to my own formatting rules.
 
     The primary FTP site is "ftp://ftp.guug.de/pub/gcrypt/"
     The primary WWW page is "http://www.d.shuttle.de/isil/crypt/gnupg.html"
@@ -330,7 +327,8 @@
     If you like, send your keys to <gnupg-keys@isil.d.shuttle.de>; use
     "gpg --export --armor | mail gnupg-keys@isil.d.shuttle.de" to do this.
 
-    Please direct bug reports to <gnupg-bugs@isil.d.shuttle.de> or better
-    post them to the mailing list <g10@net.lut.ac.uk>.
+    Please direct bug reports to <gnupg-bugs@gnu.org> or better
+    post them to the mailing list <g10@net.lut.ac.uk> (this is a closed list,
+    please subscribe before posting).
 
 
diff -urN gnupg-0.2.19/THANKS gnupg-0.3.0/THANKS
--- gnupg-0.2.19/THANKS	Thu May 14 15:43:00 1998
+++ gnupg-0.3.0/THANKS	Thu Jun 11 08:50:31 1998
@@ -4,12 +4,14 @@
 errors.
 
 Anand Kumria		wildfire@progsoc.uts.edu.au
+Brian Warner		warner@lothar.com
 Charles Levert		charles@comm.polymtl.ca
 Christian von Roques	roques@pond.sub.org
 Daniel Eisenbud 	eisenbud@cs.swarthmore.edu
 Detlef Lannert		lannert@lannert.rz.uni-duesseldorf.de
 Ed Boraas		ecxjo@esperanto.org
 Ernst Molitor		ernst.molitor@uni-bonn.de
+Frank Heckenbach	heckenb@mi.uni-erlangen.de
 Hendrik Buschkamp	buschkamp@rheumanet.org
 Ian McKellar		imckellar@harvestroad.com.au
 James Troup		J.J.Troup@scm.brad.ac.uk
@@ -23,6 +25,7 @@
 Peter Gutmann		pgut001@cs.auckland.ac.nz
 Ralph Gillen		gillen@theochem.uni-duesseldorf.de
 Thomas Roessler 	roessler@guug.de
+Tom Spindler		dogcow@home.merit.edu
 Tom Zerucha		tzeruch@ceddec.com
 Tomas Fasth		tomas.fasth@twinspot.net
 Ulf Mller		3umoelle@informatik.uni-hamburg.de
diff -urN gnupg-0.2.19/TODO gnupg-0.3.0/TODO
--- gnupg-0.2.19/TODO	Thu May 28 15:38:50 1998
+++ gnupg-0.3.0/TODO	Thu Jun 25 09:15:43 1998
@@ -1,10 +1,13 @@
 
+    * make preferences work
+
+    * rewrite --list-packets or put it into another tool.
+
+    * add field to PKT_user_id to hold the hash context
+
     * add usage arguments to get_key_byname or return a PKC_LIST with
       all keys and add a selection.
 
-    * add expiration date and other stuff from v4 sigs to the trust
-      checking.
-
     * add readline support. Must enhance libreadline - Anyone?
 
     * Burn the buffers used by fopen(), or use read(2).
@@ -19,7 +22,6 @@
     * add checking of armor trailers
     * remove all "Fixmes"
 
-
     * bug: g10/trustdb.c#build_sigrecs called to often by do_list_path
       and remove the bad kludge. Maybe we should put all sigs into the trustdb
       and mark them as valid/invalid/nopubkey, and how do we check, that
@@ -27,16 +29,6 @@
       record, as it does not belong to the pubkey record?
 
     * add an option to create a new user id.
-      Make it possible to change the signature class of the self-signatures,
-      which can then be used to change the displayed order of user-ids:
-      Put the user-id with a self-signature of class 0x13 always on top
-      of the displayed list (needs changes in the user-id-from-keyid
-      functions).
-
-    * enhance --sign-key, so that multiple-user-ids can be signed
-      (use the new classes 0x14..17), partly implemented, but I think we
-      should better make use of notation data - for now we allow only one
-      user id.
 
     * add an option to re-create a public key from a secret key. Think about
       a backup system of only the secret part of the secret key.
diff -urN gnupg-0.2.19/acconfig.h gnupg-0.3.0/acconfig.h
--- gnupg-0.2.19/acconfig.h	Fri May  8 18:43:53 1998
+++ gnupg-0.3.0/acconfig.h	Thu Jun 11 09:19:23 1998
@@ -33,6 +33,7 @@
 #undef PACKAGE
 #undef G10_LOCALEDIR
 #undef PRINTABLE_OS_NAME
+#undef GNUPG_LIBDIR
 
 /* Define if your locale.h file contains LC_MESSAGES.  */
 #undef HAVE_LC_MESSAGES
@@ -71,13 +72,9 @@
 /* defined if we have a /dev/random and /dev/urandom */
 #undef HAVE_DEV_RANDOM
 
-/* RSA is only compiled in if you have these files. You can use
- * RSA without any restrictions, if your not in the U.S. or
- * wait until sep 20, 2000
- */
-#undef HAVE_RSA_CIPHER
-
-
+#undef USE_DYNAMIC_LINKING
+#undef HAVE_DL_DLOPEN
+#undef HAVE_DLD_DLD_LINK
 
 @BOTTOM@
 
diff -urN gnupg-0.2.19/checks/Makefile.am gnupg-0.3.0/checks/Makefile.am
--- gnupg-0.2.19/checks/Makefile.am	Mon May 18 15:39:14 1998
+++ gnupg-0.3.0/checks/Makefile.am	Thu Jun 25 12:13:42 1998
@@ -25,7 +25,7 @@
 
 prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 \
 		pubring.pkr secring.skr $(DATA_FILES)
-	@echo "def" | ../g10/gpg -v --no-operation; \
+	@echo "def" | ../g10/gpg --homedir . -v --no-operation; \
 	 echo timestamp >./prepared.stamp
 
 pubring.gpg: pubring.asc
diff -urN gnupg-0.2.19/checks/Makefile.in gnupg-0.3.0/checks/Makefile.in
--- gnupg-0.2.19/checks/Makefile.in	Fri May 29 12:56:33 1998
+++ gnupg-0.3.0/checks/Makefile.in	Thu Jun 25 13:09:31 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -229,7 +228,7 @@
 
 prepared.stamp: pubring.gpg secring.gpg gnupg.sig plain-3 \
 		pubring.pkr secring.skr $(DATA_FILES)
-	@echo "def" | ../g10/gpg -v --no-operation; \
+	@echo "def" | ../g10/gpg --homedir . -v --no-operation; \
 	 echo timestamp >./prepared.stamp
 
 pubring.gpg: pubring.asc
diff -urN gnupg-0.2.19/checks/conventional.test gnupg-0.3.0/checks/conventional.test
--- gnupg-0.2.19/checks/conventional.test	Mon May  4 20:15:08 1998
+++ gnupg-0.3.0/checks/conventional.test	Sat Jun 13 08:58:01 1998
@@ -10,7 +10,7 @@
 done
 for i in plain-1 data-80000 ; do
     echo "Hier spricht HAL" | ./run-gpg --passphrase-fd 0 \
-					--cipher-algo cast -c -o x --yes $i
+					--cipher-algo cast5 -c -o x --yes $i
     echo "Hier spricht HAL" | ./run-gpg --passphrase-fd 0    -o y --yes x
     cmp $i y || error "$i: mismatch"
 done
diff -urN gnupg-0.2.19/checks/defs.inc gnupg-0.3.0/checks/defs.inc
--- gnupg-0.2.19/checks/defs.inc	Tue Apr 28 09:37:46 1998
+++ gnupg-0.3.0/checks/defs.inc	Thu Jun 25 12:09:47 1998
@@ -21,8 +21,10 @@
 dsa_keyrings="--keyring ./pubring.pkr --secret-keyring ./secring.skr"
 
 
-plain_files="plain-1 plain-2 plain-3"
-data_files="data-500 data-9000 data-32000 data-80000"
+#plain_files="plain-1 plain-2 plain-3"
+#data_files="data-500 data-9000 data-32000 data-80000"
+plain_files="plain-1 plain-2"
+data_files="data-500 data-9000"
 exp_files=""
 
 
@@ -68,6 +70,7 @@
 cat <<EOF  >./options
 no-greeting
 no-secmem-warning
+load-extension ../cipher/tiger
 batch
 EOF
 
diff -urN gnupg-0.2.19/checks/encrypt-dsa.test gnupg-0.3.0/checks/encrypt-dsa.test
--- gnupg-0.2.19/checks/encrypt-dsa.test	Wed Apr  8 21:02:02 1998
+++ gnupg-0.3.0/checks/encrypt-dsa.test	Fri Jun 12 21:53:49 1998
@@ -11,7 +11,7 @@
 
 # and with cast
 for i in $plain_files $data_files ; do
-    ./run-gpg $dsa_keyrings --cipher-algo cast -e \
+    ./run-gpg $dsa_keyrings --cipher-algo cast5 -e \
 					-o x --yes -r "$dsa_usrname2" $i
     ./run-gpg $dsa_keyrings -o y --yes x
     cmp $i y || error "$i: mismatch"
diff -urN gnupg-0.2.19/checks/encrypt.test gnupg-0.3.0/checks/encrypt.test
--- gnupg-0.2.19/checks/encrypt.test	Wed Apr  8 12:42:37 1998
+++ gnupg-0.3.0/checks/encrypt.test	Tue Jun 16 16:27:14 1998
@@ -9,7 +9,7 @@
     cmp $i y || error "$i: mismatch"
 done
 for i in $plain_files $data_files ; do
-    ./run-gpg -e -o x --yes -r "$usrname2" --cipher-algo cast $i
+    ./run-gpg -e -o x --yes -r "$usrname2" --cipher-algo cast5 $i
     ./run-gpg -o y --yes x
     cmp $i y || error "$i: mismatch"
 done
diff -urN gnupg-0.2.19/checks/run-gpg gnupg-0.3.0/checks/run-gpg
--- gnupg-0.2.19/checks/run-gpg	Wed Apr  8 11:24:38 1998
+++ gnupg-0.3.0/checks/run-gpg	Sat Jun 13 08:56:51 1998
@@ -6,6 +6,7 @@
     rm err.tmp.$$
     exit 1
 fi
-grep -v 'gpg: Good signature from' err.tmp.$$ || true
+grep -v 'gpg: Good signature from' err.tmp.$$ \
+ | grep -v 'gpg: Signature made ' || true
 rm err.tmp.$$
 
diff -urN gnupg-0.2.19/checks/secring.asc gnupg-0.3.0/checks/secring.asc
--- gnupg-0.2.19/checks/secring.asc	Sun May  3 21:26:30 1998
+++ gnupg-0.3.0/checks/secring.asc	Tue Jun 16 15:54:40 1998
@@ -6,17 +6,17 @@
 sec   768G/6D11D6D3 1998-04-28 test three (pp=abc) <three@test.nowhere.nil>
 
 -----BEGIN PGP ARMORED FILE-----
-Version: GNUPG v0.2.16 (Linux)
+Version: GNUPG v0.2.19b (GNU/Linux)
 Comment: This is an alpha version!
 Comment: Use "gpgm --dearmor" for unpacking
 
 lQFHAzVFgbgERxADAPG0kMNVRUl24GfpzV4TPcXgw/jqSkFOIVGgin7k7UR6GOUMUz89wxVk
 ZRXsLAOdDrtvI5T1sSCmWmhsTKmw7aslLJugBM/70YuVSolR39vF1JDK8kEkx748CRVW+/ul
 mwADBQMA12YmsDbYGLI8FXnb/8V3YU7K39E5//Bwo90vTfzAE9Mwp1y9H5WHqoai/6JLgXK8
-DAOGpgCFhlVu8LO5O0IK3yaFhtkhC8SE/TKLzC76uSoeeSex+mJ+rqBcyDl9AONx/wQBA/c/
-kLpBoHpDRQ4A6ETACZ8C/1NQCBF5zcnjFERni2jcwTiASGFAB4nnIwr7lm9lZ3JxF2xW3LSY
-2EwlJixA1kIUWWLJHo/kEAT8rCd3wG+a/UMJwuTgSd4odq/lFe13dxo8eah8cgAY+dlFiBap
-r9WclDDI/SojOkVMR19mYWN0b3I6AADKAiaJiV+4kJIpYCgbjafKyy11LI3mgHQV8Hf9KiM6
+DAOGpgCFhlVu8LO5O0IK3yaFhtkhC8SE/TKLzC76uSoeeSex+mJ+rqBcyDl9AONx/wQBA1ax
+FAGSVKH6no4iMVtLeiYDACtVsQ4oTGIR7wAakh4QkO5j81Vg0+v3AGMNvTMlTmwtlGtmKv2M
+01WryUpzA9dKe8RBhe4Uofa7OVOAaN8RujSNXMM2XWCoH+Om8oGSzmMvT2MTOa4rrk6+Noer
+tShKnDDI/SojOkVMR19mYWN0b3I6AADKAiaJiV+4kJIpYCgbjafKyy11LI3mgHQV8Hf9KiM6
 RUxHX2ZhY3RvcjoAAMoDjg2kuv69NwxJNr89un9g6yT/mlXDM36tFf0qIzpFTEdfZmFjdG9y
 OgAAygPBg2CM/6uXiIHWF2kf/4p3sDJXQ3jZm8bH/SIjY3JlYXRlZCBieSBHTlVQRyB2MC4y
 LjE1YSAoTGludXgptChUZXN0IG9uZSAocHA9ZGVmKSA8b25lQHRlc3Qubm93aGVyZS5uaWw+
@@ -29,10 +29,10 @@
 FR4McJc/AAMFAyCwFfMOhS+z6YInnQDh7JTLan+7IdSHjUpAo0XarzAioCq6Ei0LaPVqa1zF
 L9yh5ky+06WTWnfvMSVCu0eRh1E0dTiBUDCb06HRvEVOiTmhqHk6loLOtb9NHxYMGOrGDtdX
 JJrHAAMfaR/MS44PJRtwrFDIBTOJWqjdX1Mu3wzB3443rS+hv9onUUjeLNbXFzXAxxHTLm4Z
-0JQ1Um2Yi4XGTYZkFNRPq5jE+Imoj/trN+T2rri1f+m/Y5ugSH/Zx7hurhc/3yJ//oCGYTNY
-0CsjOkVMR19mYWN0b3I6AADVEOrdw68kJz/XyG9/nJZ40oqzBklaf+BeatFD0CsjOkVMR19m
-YWN0b3I6AADVF7ggxjMhZ+iMjbJxRSS5vmro7mbuP+5W5gLR0CsjOkVMR19mYWN0b3I6AADV
-F5fMXChN1OIqFi7DHiaDKWyRJcNk6EaDu0BF0CIjY3JlYXRlZCBieSBHTlVQRyB2MC4yLjE1
+0JQ1Um2Yi4XGTYZkFNRPq5jE+Imoj/trN+T2rri1f+m/Y5ugSH/Zx7hurhc/3yJ//oCGYTNb
+/SsjOkVMR19mYWN0b3I6AADVEOrdw68kJz/XyG9/nJZ40oqzBklaf+BeatFD/SsjOkVMR19m
+YWN0b3I6AADVF7ggxjMhZ+iMjbJxRSS5vmro7mbuP+5W5gLR/SsjOkVMR19mYWN0b3I6AADV
+F5fMXChN1OIqFi7DHiaDKWyRJcNk6EaDu0BF/SIjY3JlYXRlZCBieSBHTlVQRyB2MC4yLjE1
 YSAoTGludXgptCd0ZXN0IHR3byAobm8gcHApIDx0d29AdGVzdC5ub3doZXJlLm5pbD6I3wMF
 EzVFggEO+eDoLl+k9BADkLEDHR+OG+ItBNWQE75V5vFHruJ0blRPEPaJL0GnVW/Lgi8jcUaM
 7RwJyZ2XeMiCeJHU1kgHTa/E5VSUZJM5q/w1c1vcy76Izxqgnx19TEFEcGxzbzHLyT3APQVg
@@ -42,9 +42,9 @@
 joHcNJWv2Ill9pvAMPoTuO6WLMLMkYtpbvxRP3a9KNAgedyweBJxST4gR6wfK5t8CNeNgUHi
 fQ4+WFPzAAMGAv9YAdDaBZdkIW2GPN7bi4P1JSJDPAmbcbV0fb30KtFIK1bg6Hi8dP5pZ1pv
 KZibB0ftK/LC9so5ez9EUPhSbYmjE1R4oScoV7pAjtWzzNz1/C/0LJlxc1nH5mr5NdcaTzX/
-BAEDCeZ5R0kN6fg2yGkyrcFmxQL/ZFqgKUqFq7IuzbBnliDeqVTUCiMoRS/T2ygWVgScPfSU
-iSixO3hRnJ6Z1tpIizlS+Al7SnpMJX7Qt46g3THrqQtax5KyLShgAtepL0Q32PTd66siLLb3
-iFPiLpggl2rxMMb9KiM6RUxHX2ZhY3RvcjoAAMoCbaGz3MaDbSFTmKdOGCSNFFsowjco3mWH
+BAEDG+unPjMgny2Egnnpj+C75wL9WMnkY/0W6WbEnAa5AQisByWpoBmEox4n3ujQqonm6UXY
+/gjQXe4Xc7ZwNOvDMo7FpSb22HAbXM0RX7WYSYiH3bFTS8ZbodTx9xhDK0rMPE/Ci7wbYMWZ
+YyTuRz49WOO1MMb9KiM6RUxHX2ZhY3RvcjoAAMoCbaGz3MaDbSFTmKdOGCSNFFsowjco3mWH
 U/0qIzpFTEdfZmFjdG9yOgAAygLi9An6HulYgRcvIO1/Rn1ZAcrG447MbdxD/SojOkVMR19m
 YWN0b3I6AADKAo2787sJdMSkDQ6ENCcVlu+yXsVSWa++zWH9IiNjcmVhdGVkIGJ5IEdOVVBH
 IHYwLjIuMTVhIChMaW51eCm0LHRlc3QgdGhyZWUgKHBwPWFiYykgPHRocmVlQHRlc3Qubm93
@@ -53,5 +53,5 @@
 dYdmlrSD+53gOH91KGeqpSrd7l0C/2ZhobXCxF03goKfNENvjej4HAGnzN0q0mpfu7L2wsCG
 4/kXKv8W6Z2JtYpnszyw6xJCh0dyup2RSYKbfZMrb1BfjwlrZE03Ah4QRmat5byprwl9oosJ
 tW5GlGnLFCLsPQ==
-=onv+
+=VGBx
 -----END PGP ARMORED FILE-----
diff -urN gnupg-0.2.19/checks/signencrypt-dsa.test gnupg-0.3.0/checks/signencrypt-dsa.test
--- gnupg-0.2.19/checks/signencrypt-dsa.test	Wed Apr  8 21:19:58 1998
+++ gnupg-0.3.0/checks/signencrypt-dsa.test	Tue Jun 16 12:24:49 1998
@@ -10,7 +10,7 @@
     cmp $i y || error "$i: mismatch"
 done
 
-for da in rmd160 sha1 md5; do
+for da in ripemd160 sha1 md5; do
     for i in $plain_files; do
 	./run-gpg $dsa_keyrings -se -o x --yes --digest-algo $da \
 		    -u "$dsa_usrname1" -r "$dsa_usrname2" $i
diff -urN gnupg-0.2.19/checks/sigs-dsa.test gnupg-0.3.0/checks/sigs-dsa.test
--- gnupg-0.2.19/checks/sigs-dsa.test	Fri May 15 16:22:25 1998
+++ gnupg-0.3.0/checks/sigs-dsa.test	Tue Jun 16 12:25:15 1998
@@ -9,7 +9,7 @@
     cmp $i y || error "$i: mismatch"
 done
 
-for da in rmd160 sha1 md5; do
+for da in ripemd160 sha1 md5; do
     for i in $plain_files; do
 	./run-gpg $dsa_keyrings --digest-algo $da \
 				-s -o x --yes -u $dsa_usrname1 $i
diff -urN gnupg-0.2.19/checks/sigs.test gnupg-0.3.0/checks/sigs.test
--- gnupg-0.2.19/checks/sigs.test	Mon May  4 09:53:54 1998
+++ gnupg-0.3.0/checks/sigs.test	Tue Jun 16 12:25:31 1998
@@ -9,7 +9,7 @@
     cmp $i y || error "$i: mismatch"
 done
 
-for da in rmd160 sha1 md5 tiger; do
+for da in ripemd160 sha1 md5 tiger; do
     for i in $plain_files; do
 	echo "$usrpass1" | ./run-gpg --passphrase-fd 0 --digest-algo $da \
 				-s -o x --yes $i
diff -urN gnupg-0.2.19/cipher/ChangeLog gnupg-0.3.0/cipher/ChangeLog
--- gnupg-0.2.19/cipher/ChangeLog	Fri May 22 07:31:02 1998
+++ gnupg-0.3.0/cipher/ChangeLog	Thu Jun 25 11:18:43 1998
@@ -1,3 +1,41 @@
+Thu Jun 25 11:18:25 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* Makefile.am: Support for extensions
+
+Thu Jun 18 12:09:38 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* random.c (mix_pool): simpler handling for level 0
+
+Mon Jun 15 14:40:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* tiger.c: Removed from dist, will reappear as dynload module
+
+Sat Jun 13 14:16:57 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* pubkey.c: Major changes to allow extensions. Changed the inteface
+	of all public key ciphers and added the ability to load extensions
+	on demand.
+
+	* misc.c: Removed.
+
+Wed Jun 10 07:52:08 1998  Werner Koch,mobil,,,	(wk@tobold)
+
+	* dynload.c: New.
+	* cipher.c: Major changes to allow extensions.
+
+Mon Jun  8 22:43:00 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.c: Major internal chnages to support extensions.
+	* blowfish.c (blowfish_get_info): New and made all internal
+	functions static, changed heder.
+	* cast5.c (cast5_get_info): Likewise.
+
+Mon Jun  8 12:27:52 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* tiger.c (transform): Fix for big endian
+
+	* cipher.c (do_cfb_decrypt): Big endian fix.
+
 Fri May 22 07:30:39 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* md.c (md_get_oid): Add a new one for TIGER.
diff -urN gnupg-0.2.19/cipher/Makefile.am gnupg-0.3.0/cipher/Makefile.am
--- gnupg-0.2.19/cipher/Makefile.am	Fri May 29 12:11:46 1998
+++ gnupg-0.3.0/cipher/Makefile.am	Thu Jun 25 11:02:36 1998
@@ -1,17 +1,26 @@
 ## Process this file with automake to produce Makefile.in
 
+gnupg_extensions = tiger
+
 INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
-EXTRA_DIST = @CIPHER_EXTRA_DIST@
 
 noinst_LIBRARIES = libcipher.a
+if ENABLE_GNUPG_EXTENSIONS
+pkglib_PROGRAMS  = $(gnupg_extensions)
+else
+pkglib_PROGRAMS  =
+endif
 
 
 libcipher_a_SOURCES = cipher.c	\
+		 pubkey.c	\
+		 md.c		\
+		 dynload.c	\
+		 dynload.h	\
 		 blowfish.c	\
 		 blowfish.h	\
 		 cast5.c	\
 		 cast5.h	\
-		 des.h		\
 		 elgamal.c	\
 		 elgamal.h	\
 		 md5.c		\
@@ -25,18 +34,23 @@
 		 rand-dummy.c	\
 		 rmd.h		\
 		 rmd160.c	\
-		 tiger.h	\
-		 tiger.c	\
 		 sha1.h 	\
 		 sha1.c 	\
 		 dsa.h		\
 		 dsa.c		\
-		 md.c		\
-		 md.h		\
-		 misc.c 	\
+		 g10c.c 	\
 		 smallprime.c
 
-libcipher_a_DEPENDENCIES = @CIPHER_EXTRA_OBJS@
-libcipher_a_LIBADD = @CIPHER_EXTRA_OBJS@
+EXTRA_tiger_SOURCES = tiger.c
+
+tiger: tiger.c
+	$(COMPILE) -shared -fPIC -o tiger tiger.c
 
+install-exec-hook:
+	@list='$(pkglib_PROGRAMS)'; for p in $$list; do \
+	  if test -f $(pkglibdir)/$$p; then \
+	    echo "chmod 644 $(pkglibdir)/$$p"; \
+	    chmod 644 $(pkglibdir)/$$p; \
+	  fi; \
+	done
 
diff -urN gnupg-0.2.19/cipher/Makefile.in gnupg-0.3.0/cipher/Makefile.in
--- gnupg-0.2.19/cipher/Makefile.in	Fri May 29 12:56:17 1998
+++ gnupg-0.3.0/cipher/Makefile.in	Thu Jun 25 13:09:05 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -92,17 +91,23 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
+gnupg_extensions = tiger
+
 INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
-EXTRA_DIST = @CIPHER_EXTRA_DIST@
 
 noinst_LIBRARIES = libcipher.a
+@ENABLE_GNUPG_EXTENSIONS_TRUE@pkglib_PROGRAMS  = $(gnupg_extensions)
+@ENABLE_GNUPG_EXTENSIONS_FALSE@pkglib_PROGRAMS  =
 
 libcipher_a_SOURCES = cipher.c	\
+		 pubkey.c	\
+		 md.c		\
+		 dynload.c	\
+		 dynload.h	\
 		 blowfish.c	\
 		 blowfish.h	\
 		 cast5.c	\
 		 cast5.h	\
-		 des.h		\
 		 elgamal.c	\
 		 elgamal.h	\
 		 md5.c		\
@@ -116,19 +121,14 @@
 		 rand-dummy.c	\
 		 rmd.h		\
 		 rmd160.c	\
-		 tiger.h	\
-		 tiger.c	\
 		 sha1.h 	\
 		 sha1.c 	\
 		 dsa.h		\
 		 dsa.c		\
-		 md.c		\
-		 md.h		\
-		 misc.c 	\
+		 g10c.c 	\
 		 smallprime.c
 
-libcipher_a_DEPENDENCIES = @CIPHER_EXTRA_OBJS@
-libcipher_a_LIBADD = @CIPHER_EXTRA_OBJS@
+EXTRA_tiger_SOURCES = tiger.c
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 CONFIG_CLEAN_FILES = 
@@ -139,10 +139,18 @@
 CPPFLAGS = @CPPFLAGS@
 LDFLAGS = @LDFLAGS@
 LIBS = @LIBS@
-libcipher_a_OBJECTS =  cipher.o blowfish.o cast5.o elgamal.o md5.o \
-primegen.o random.o rand-unix.o rand-w32.o rand-dummy.o rmd160.o \
-tiger.o sha1.o dsa.o md.o misc.o smallprime.o
+libcipher_a_LIBADD = 
+libcipher_a_OBJECTS =  cipher.o pubkey.o md.o dynload.o blowfish.o \
+cast5.o elgamal.o md5.o primegen.o random.o rand-unix.o rand-w32.o \
+rand-dummy.o rmd160.o sha1.o dsa.o g10c.o smallprime.o
 AR = ar
+PROGRAMS =  $(pkglib_PROGRAMS)
+
+tiger_SOURCES = tiger.c
+tiger_OBJECTS =  tiger.o
+tiger_LDADD = $(LDADD)
+tiger_DEPENDENCIES = 
+tiger_LDFLAGS = 
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
@@ -153,8 +161,8 @@
 
 TAR = tar
 GZIP = --best
-SOURCES = $(libcipher_a_SOURCES)
-OBJECTS = $(libcipher_a_OBJECTS)
+SOURCES = $(libcipher_a_SOURCES) tiger.c $(EXTRA_tiger_SOURCES)
+OBJECTS = $(libcipher_a_OBJECTS) tiger.o
 
 default: all
 
@@ -201,6 +209,31 @@
 	$(AR) cru libcipher.a $(libcipher_a_OBJECTS) $(libcipher_a_LIBADD)
 	$(RANLIB) libcipher.a
 
+mostlyclean-pkglibPROGRAMS:
+
+clean-pkglibPROGRAMS:
+	-test -z "$(pkglib_PROGRAMS)" || rm -f $(pkglib_PROGRAMS)
+
+distclean-pkglibPROGRAMS:
+
+maintainer-clean-pkglibPROGRAMS:
+
+install-pkglibPROGRAMS: $(pkglib_PROGRAMS)
+	@$(NORMAL_INSTALL)
+	$(mkinstalldirs) $(pkglibdir)
+	@list='$(pkglib_PROGRAMS)'; for p in $$list; do \
+	  if test -f $$p; then \
+	    echo "  $(INSTALL_PROGRAM) $$p $(pkglibdir)/`echo $$p|sed '$(transform)'`"; \
+	     $(INSTALL_PROGRAM) $$p $(pkglibdir)/`echo $$p|sed '$(transform)'`; \
+	  else :; fi; \
+	done
+
+uninstall-pkglibPROGRAMS:
+	@$(NORMAL_UNINSTALL)
+	list='$(pkglib_PROGRAMS)'; for p in $$list; do \
+	  rm -f $(pkglibdir)/`echo $$p|sed '$(transform)'`; \
+	done
+
 tags: TAGS
 
 ID: $(HEADERS) $(SOURCES) $(LISP)
@@ -246,50 +279,38 @@
 cipher.o: cipher.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	blowfish.h cast5.h des.h
+	../include/../cipher/random.h blowfish.h cast5.h dynload.h
 dsa.o: dsa.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h dsa.h
+	../include/../cipher/random.h dsa.h
+dynload.o: dynload.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/random.h dynload.h
 elgamal.o: elgamal.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	elgamal.h
+	../include/../cipher/random.h elgamal.h
+g10c.o: g10c.c ../config.h ../include/mpi.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h random.h \
+	../include/cipher.h ../include/../cipher/random.h \
+	../include/g10lib.h
 md.o: md.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h
+	../include/../cipher/random.h dynload.h md5.h sha1.h rmd.h
 md5.o: md5.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h md5.h
-misc.o: misc.c ../config.h ../include/util.h ../include/types.h \
+primegen.o: primegen.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h
-primegen.o: primegen.c ../config.h ../include/util.h ../include/types.h \
+	../include/../cipher/random.h
+pubkey.o: pubkey.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h
+	../include/../cipher/random.h elgamal.h dsa.h dynload.h
 rand-dummy.o: rand-dummy.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h ../include/ttyio.h \
@@ -315,17 +336,15 @@
 smallprime.o: smallprime.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h
-tiger.o: tiger.c ../config.h ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h tiger.h
 
 info:
 dvi:
 check: all
 	$(MAKE)
 installcheck:
-install-exec: 
+install-exec: install-pkglibPROGRAMS
 	@$(NORMAL_INSTALL)
+	$(MAKE) install-exec-hook
 
 install-data: 
 	@$(NORMAL_INSTALL)
@@ -333,13 +352,14 @@
 install: install-exec install-data all
 	@:
 
-uninstall: 
+uninstall: uninstall-pkglibPROGRAMS
 
-all: Makefile $(LIBRARIES)
+all: Makefile $(LIBRARIES) $(PROGRAMS)
 
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
+	$(mkinstalldirs)  $(pkglibdir)
 
 
 mostlyclean-generic:
@@ -357,17 +377,20 @@
 	-test -z "$(MAINTAINERCLEANFILES)" || rm -f $(MAINTAINERCLEANFILES)
 	-test -z "$(BUILT_SOURCES)" || rm -f $(BUILT_SOURCES)
 mostlyclean:  mostlyclean-noinstLIBRARIES mostlyclean-compile \
-		mostlyclean-tags mostlyclean-generic
+		mostlyclean-pkglibPROGRAMS mostlyclean-tags \
+		mostlyclean-generic
 
-clean:  clean-noinstLIBRARIES clean-compile clean-tags clean-generic \
-		mostlyclean
+clean:  clean-noinstLIBRARIES clean-compile clean-pkglibPROGRAMS \
+		clean-tags clean-generic mostlyclean
 
-distclean:  distclean-noinstLIBRARIES distclean-compile distclean-tags \
+distclean:  distclean-noinstLIBRARIES distclean-compile \
+		distclean-pkglibPROGRAMS distclean-tags \
 		distclean-generic clean
 	-rm -f config.status
 
 maintainer-clean:  maintainer-clean-noinstLIBRARIES \
-		maintainer-clean-compile maintainer-clean-tags \
+		maintainer-clean-compile \
+		maintainer-clean-pkglibPROGRAMS maintainer-clean-tags \
 		maintainer-clean-generic distclean
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
@@ -375,12 +398,26 @@
 .PHONY: default mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
 clean-noinstLIBRARIES maintainer-clean-noinstLIBRARIES \
 mostlyclean-compile distclean-compile clean-compile \
-maintainer-clean-compile tags mostlyclean-tags distclean-tags \
-clean-tags maintainer-clean-tags distdir info dvi installcheck \
-install-exec install-data install uninstall all installdirs \
-mostlyclean-generic distclean-generic clean-generic \
-maintainer-clean-generic clean mostlyclean distclean maintainer-clean
-
+maintainer-clean-compile mostlyclean-pkglibPROGRAMS \
+distclean-pkglibPROGRAMS clean-pkglibPROGRAMS \
+maintainer-clean-pkglibPROGRAMS uninstall-pkglibPROGRAMS \
+install-pkglibPROGRAMS tags mostlyclean-tags distclean-tags clean-tags \
+maintainer-clean-tags distdir info dvi installcheck install-exec \
+install-data install uninstall all installdirs mostlyclean-generic \
+distclean-generic clean-generic maintainer-clean-generic clean \
+mostlyclean distclean maintainer-clean
+
+
+tiger: tiger.c
+	$(COMPILE) -shared -fPIC -o tiger tiger.c
+
+install-exec-hook:
+	@list='$(pkglib_PROGRAMS)'; for p in $$list; do \
+	  if test -f $(pkglibdir)/$$p; then \
+	    echo "chmod 644 $(pkglibdir)/$$p"; \
+	    chmod 644 $(pkglibdir)/$$p; \
+	  fi; \
+	done
 
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
diff -urN gnupg-0.2.19/cipher/blowfish.c gnupg-0.3.0/cipher/blowfish.c
--- gnupg-0.2.19/cipher/blowfish.c	Wed Apr  8 12:26:40 1998
+++ gnupg-0.3.0/cipher/blowfish.c	Wed Jun 24 20:47:07 1998
@@ -38,6 +38,28 @@
 #include "types.h"
 #include "blowfish.h"
 
+#define CIPHER_ALGO_BLOWFISH	 4  /* blowfish 128 bit key */
+#define CIPHER_ALGO_BLOWFISH160 42  /* blowfish 160 bit key (not in OpenPGP)*/
+
+#define FNCCAST_SETKEY(f)  (void(*)(void*, byte*, unsigned))(f)
+#define FNCCAST_CRYPT(f)   (void(*)(void*, byte*, byte*))(f)
+
+#define BLOWFISH_BLOCKSIZE 8
+#define BLOWFISH_ROUNDS 16
+
+typedef struct {
+    u32 s0[256];
+    u32 s1[256];
+    u32 s2[256];
+    u32 s3[256];
+    u32 p[BLOWFISH_ROUNDS+2];
+} BLOWFISH_context;
+
+static void bf_setkey( BLOWFISH_context *c, byte *key, unsigned keylen );
+static void encrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf );
+static void decrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf );
+
+
 /* precomputed S boxes */
 static const u32 ks0[256] = {
     0xD1310BA6,0x98DFB5AC,0x2FFD72DB,0xD01ADFB7,0xB8E1AFED,0x6A267E96,
@@ -391,8 +413,8 @@
 #undef F
 #undef R
 
-void
-blowfish_encrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf )
+static void
+encrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf )
 {
     u32 d1, d2;
 
@@ -410,8 +432,8 @@
 }
 
 
-void
-blowfish_decrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf )
+static void
+decrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf )
 {
     u32 d1, d2;
 
@@ -439,27 +461,27 @@
     byte key3[] = { 0x41, 0x79, 0x6E, 0xA0, 0x52, 0x61, 0x6E, 0xE4 };
     byte cipher3[] = { 0xE1, 0x13, 0xF4, 0x10, 0x2C, 0xFC, 0xCE, 0x43 };
 
-    blowfish_setkey( &c, "abcdefghijklmnopqrstuvwxyz", 26 );
-    blowfish_encrypt_block( &c, buffer, plain );
+    bf_setkey( &c, "abcdefghijklmnopqrstuvwxyz", 26 );
+    encrypt_block( &c, buffer, plain );
     if( memcmp( buffer, "\x32\x4E\xD0\xFE\xF4\x13\xA2\x03", 8 ) )
 	log_error("wrong blowfish encryption\n");
-    blowfish_decrypt_block( &c, buffer, buffer );
+    decrypt_block( &c, buffer, buffer );
     if( memcmp( buffer, plain, 8 ) )
 	log_bug("blowfish failed\n");
 
-    blowfish_setkey( &c, key3, 8 );
-    blowfish_encrypt_block( &c, buffer, plain3 );
+    bf_setkey( &c, key3, 8 );
+    encrypt_block( &c, buffer, plain3 );
     if( memcmp( buffer, cipher3, 8 ) )
 	log_error("wrong blowfish encryption (3)\n");
-    blowfish_decrypt_block( &c, buffer, buffer );
+    decrypt_block( &c, buffer, buffer );
     if( memcmp( buffer, plain3, 8 ) )
 	log_bug("blowfish failed (3)\n");
 }
 
 
 
-void
-blowfish_setkey( BLOWFISH_context *c, byte *key, unsigned keylen )
+static void
+bf_setkey( BLOWFISH_context *c, byte *key, unsigned keylen )
 {
     int i, j;
     u32 data, datal, datar;
@@ -523,4 +545,32 @@
     }
 }
 
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+const char *
+blowfish_get_info( int algo, size_t *keylen,
+		   size_t *blocksize, size_t *contextsize,
+		   void (**r_setkey)( void *c, byte *key, unsigned keylen ),
+		   void (**r_encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		   void (**r_decrypt)( void *c, byte *outbuf, byte *inbuf )
+		 )
+{
+    *keylen = algo == CIPHER_ALGO_BLOWFISH ? 128 : 160;
+    *blocksize = BLOWFISH_BLOCKSIZE;
+    *contextsize = sizeof(BLOWFISH_context);
+    *r_setkey = FNCCAST_SETKEY(bf_setkey);
+    *r_encrypt= FNCCAST_CRYPT(encrypt_block);
+    *r_decrypt= FNCCAST_CRYPT(decrypt_block);
+
+    if( algo == CIPHER_ALGO_BLOWFISH )
+	return "BLOWFISH";
+    if( algo == CIPHER_ALGO_BLOWFISH160 )
+	return "BLOWFISH160";
+    return NULL;
+}
 
diff -urN gnupg-0.2.19/cipher/blowfish.h gnupg-0.3.0/cipher/blowfish.h
--- gnupg-0.2.19/cipher/blowfish.h	Tue Apr  7 19:10:54 1998
+++ gnupg-0.3.0/cipher/blowfish.h	Mon Jun  8 21:46:51 1998
@@ -22,19 +22,13 @@
 
 #include "types.h"
 
-#define BLOWFISH_BLOCKSIZE 8
-#define BLOWFISH_ROUNDS 16
 
-typedef struct {
-    u32 s0[256];
-    u32 s1[256];
-    u32 s2[256];
-    u32 s3[256];
-    u32 p[BLOWFISH_ROUNDS+2];
-} BLOWFISH_context;
-
-void blowfish_setkey( BLOWFISH_context *c, byte *key, unsigned keylen );
-void blowfish_encrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf );
-void blowfish_decrypt_block( BLOWFISH_context *bc, byte *outbuf, byte *inbuf );
+const char *
+blowfish_get_info( int algo, size_t *keylen,
+		   size_t *blocksize, size_t *contextsize,
+		   void (**setkey)( void *c, byte *key, unsigned keylen ),
+		   void (**encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		   void (**decrypt)( void *c, byte *outbuf, byte *inbuf )
+		 );
 
 #endif /*G10_BLOWFISH_H*/
diff -urN gnupg-0.2.19/cipher/cast5.c gnupg-0.3.0/cipher/cast5.c
--- gnupg-0.2.19/cipher/cast5.c	Tue Apr  7 18:26:31 1998
+++ gnupg-0.3.0/cipher/cast5.c	Wed Jun 24 20:47:52 1998
@@ -44,6 +44,26 @@
 #include "types.h"
 #include "cast5.h"
 
+
+#define CIPHER_ALGO_CAST5	 3
+
+#define FNCCAST_SETKEY(f)  (void(*)(void*, byte*, unsigned))(f)
+#define FNCCAST_CRYPT(f)   (void(*)(void*, byte*, byte*))(f)
+
+#define CAST5_BLOCKSIZE 8
+
+typedef struct {
+    u32  Km[16];
+    byte Kr[16];
+} CAST5_context;
+
+static void cast_setkey( CAST5_context *c, byte *key, unsigned keylen );
+static void encrypt_block( CAST5_context *bc, byte *outbuf, byte *inbuf );
+static void decrypt_block( CAST5_context *bc, byte *outbuf, byte *inbuf );
+
+
+
+
 static const u32 s1[256] = {
 0x30fb40d4, 0x9fa0ff0b, 0x6beccd2f, 0x3f258c7a, 0x1e213f2f, 0x9c004dd3, 0x6003e540, 0xcf9fc949,
 0xbfd4af27, 0x88bbbdb5, 0xe2034090, 0x98d09675, 0x6e63a0e0, 0x15c361d2, 0xc2e7661d, 0x22d4ff8e,
@@ -338,8 +358,8 @@
 #define F3(D,m,r)  (  (I = ((m) - (D))), (I=rol((r),I)),   \
     (((s1[I >> 24] + s2[(I>>16)&0xff]) ^ s3[(I>>8)&0xff]) - s4[I&0xff]) )
 
-void
-cast5_encrypt_block( CAST5_context *c, byte *outbuf, byte *inbuf )
+static void
+encrypt_block( CAST5_context *c, byte *outbuf, byte *inbuf )
 {
     u32 l, r, t;
     u32 I;   /* used by the Fx macros */
@@ -392,8 +412,8 @@
     outbuf[7] =  l	  & 0xff;
 }
 
-void
-cast5_decrypt_block(  CAST5_context *c, byte *outbuf, byte *inbuf )
+static void
+decrypt_block(	CAST5_context *c, byte *outbuf, byte *inbuf )
 {
     u32 l, r, t;
     u32 I;
@@ -445,11 +465,11 @@
     byte cipher[8]= { 0x23, 0x8B, 0x4F, 0xE5, 0x84, 0x7E, 0x44, 0xB2 };
     byte buffer[8];
 
-    cast5_setkey( &c, key, 16 );
-    cast5_encrypt_block( &c, buffer, plain );
+    cast_setkey( &c, key, 16 );
+    encrypt_block( &c, buffer, plain );
     if( memcmp( buffer, cipher, 8 ) )
 	log_error("wrong cast5-128 encryption\n");
-    cast5_decrypt_block( &c, buffer, buffer );
+    decrypt_block( &c, buffer, buffer );
     if( memcmp( buffer, plain, 8 ) )
 	log_bug("cast5-128 failed\n");
 
@@ -466,12 +486,12 @@
 			0x80,0xAC,0x05,0xB8,0xE8,0x3D,0x69,0x6E };
 
 	for(i=0; i < 1000000; i++ ) {
-	    cast5_setkey( &c, b0, 16 );
-	    cast5_encrypt_block( &c, a0, a0 );
-	    cast5_encrypt_block( &c, a0+8, a0+8 );
-	    cast5_setkey( &c, a0, 16 );
-	    cast5_encrypt_block( &c, b0, b0 );
-	    cast5_encrypt_block( &c, b0+8, b0+8 );
+	    cast_setkey( &c, b0, 16 );
+	    encrypt_block( &c, a0, a0 );
+	    encrypt_block( &c, a0+8, a0+8 );
+	    cast_setkey( &c, a0, 16 );
+	    encrypt_block( &c, b0, b0 );
+	    encrypt_block( &c, b0+8, b0+8 );
 	}
 	if( memcmp( a0, a1, 16 ) || memcmp( b0, b1, 16 ) )
 	    log_bug("cast5-128 maintenance test failed\n");
@@ -529,8 +549,8 @@
 }
 
 
-void
-cast5_setkey( CAST5_context *c, byte *key, unsigned keylen )
+static void
+cast_setkey( CAST5_context *c, byte *key, unsigned keylen )
 {
   static int initialized;
     int i;
@@ -564,4 +584,30 @@
   #undef zi
 }
 
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+const char *
+cast5_get_info( int algo, size_t *keylen,
+		   size_t *blocksize, size_t *contextsize,
+		   void (**r_setkey)( void *c, byte *key, unsigned keylen ),
+		   void (**r_encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		   void (**r_decrypt)( void *c, byte *outbuf, byte *inbuf )
+		 )
+{
+    *keylen = 128;
+    *blocksize = CAST5_BLOCKSIZE;
+    *contextsize = sizeof(CAST5_context);
+    *r_setkey = FNCCAST_SETKEY(cast_setkey);
+    *r_encrypt= FNCCAST_CRYPT(encrypt_block);
+    *r_decrypt= FNCCAST_CRYPT(decrypt_block);
+
+    if( algo == CIPHER_ALGO_CAST5 )
+	return "CAST5";
+    return NULL;
+}
 
diff -urN gnupg-0.2.19/cipher/cast5.h gnupg-0.3.0/cipher/cast5.h
--- gnupg-0.2.19/cipher/cast5.h	Tue Apr  7 18:49:53 1998
+++ gnupg-0.3.0/cipher/cast5.h	Mon Jun  8 22:11:45 1998
@@ -22,16 +22,12 @@
 
 #include "types.h"
 
-#define CAST5_BLOCKSIZE 8
-
-typedef struct {
-    u32  Km[16];
-    byte Kr[16];
-} CAST5_context;
-
-void cast5_setkey( CAST5_context *c, byte *key, unsigned keylen );
-void cast5_encrypt_block( CAST5_context *bc, byte *outbuf, byte *inbuf );
-void cast5_decrypt_block( CAST5_context *bc, byte *outbuf, byte *inbuf );
-
+const char *
+cast5_get_info( int algo, size_t *keylen,
+		   size_t *blocksize, size_t *contextsize,
+		   void (**setkey)( void *c, byte *key, unsigned keylen ),
+		   void (**encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		   void (**decrypt)( void *c, byte *outbuf, byte *inbuf )
+		 );
 
 #endif /*G10_CAST5_H*/
diff -urN gnupg-0.2.19/cipher/cipher.c gnupg-0.3.0/cipher/cipher.c
--- gnupg-0.2.19/cipher/cipher.c	Wed May 27 15:18:15 1998
+++ gnupg-0.3.0/cipher/cipher.c	Tue Jun 16 12:12:58 1998
@@ -31,34 +31,23 @@
 #include "cipher.h"
 #include "blowfish.h"
 #include "cast5.h"
-#include "des.h"
+#include "dynload.h"
+
 
 #define STD_BLOCKSIZE 8
+#define TABLE_SIZE 10
 
-#if BLOWFISH_BLOCKSIZE != STD_BLOCKSIZE
-  #error Invalid BLOWFISH blocksize
-#elif CAST5_BLOCKSIZE != STD_BLOCKSIZE
-  #error Invalid CAST blocksize
-#elif DES_BLOCKSIZE != STD_BLOCKSIZE
-  #error Invalid DES blocksize
-#endif
-
-
-static struct { const char *name; int algo; int keylen; } cipher_names[] = {
-    { "IDEA",        CIPHER_ALGO_IDEA        ,0   },
-    { "3DES",        CIPHER_ALGO_3DES        ,168 },
-    { "CAST",        CIPHER_ALGO_CAST        ,128 },
-    { "BLOWFISH160", CIPHER_ALGO_BLOWFISH160 ,160 },
-    { "SAFER_SK128", CIPHER_ALGO_SAFER_SK128 ,0   },
-    { "DES_SK",      CIPHER_ALGO_DES_SK      ,0   },
-    { "BLOWFISH",    CIPHER_ALGO_BLOWFISH    ,128 },
-    { "DUMMY"   ,    CIPHER_ALGO_DUMMY       ,128 },
-    {NULL} };
-
-
-/* Hmmm, no way for a void arg in function pointer? */
-#define FNCCAST_SETKEY(f)  (void(*)(void*, byte*, unsigned))(f)
-#define FNCCAST_CRYPT(f)   (void(*)(void*, byte*, byte*))(f)
+struct cipher_table_s {
+    const char *name;
+    int algo;
+    size_t keylen;
+    size_t contextsize; /* allocate this amount of context */
+    void (*setkey)( void *c, byte *key, unsigned keylen );
+    void (*encrypt)( void *c, byte *outbuf, byte *inbuf );
+    void (*decrypt)( void *c, byte *outbuf, byte *inbuf );
+};
+
+static struct cipher_table_s cipher_table[TABLE_SIZE];
 
 
 struct cipher_handle_s {
@@ -70,12 +59,7 @@
     void (*setkey)( void *c, byte *key, unsigned keylen );
     void (*encrypt)( void *c, byte *outbuf, byte *inbuf );
     void (*decrypt)( void *c, byte *outbuf, byte *inbuf );
-    void (*sync_cfb)( void *c );
-    union {
-	int		 context;
-	BLOWFISH_context blowfish;
-	CAST5_context cast5;
-    } c;
+    byte context[1];
 };
 
 
@@ -87,6 +71,136 @@
 dummy_decrypt_block( void *c, byte *outbuf, byte *inbuf ) { BUG(); }
 
 
+
+/****************
+ * Put the static entries into the table.
+ */
+static void
+setup_cipher_table()
+{
+
+    int i;
+    size_t blocksize;
+
+    i = 0;
+    cipher_table[i].algo = CIPHER_ALGO_BLOWFISH;
+    cipher_table[i].name = blowfish_get_info( cipher_table[i].algo,
+					 &cipher_table[i].keylen,
+					 &blocksize,
+					 &cipher_table[i].contextsize,
+					 &cipher_table[i].setkey,
+					 &cipher_table[i].encrypt,
+					 &cipher_table[i].decrypt     );
+    if( !cipher_table[i].name || blocksize != STD_BLOCKSIZE )
+	BUG();
+    i++;
+    cipher_table[i].algo = CIPHER_ALGO_CAST5;
+    cipher_table[i].name = cast5_get_info( cipher_table[i].algo,
+					 &cipher_table[i].keylen,
+					 &blocksize,
+					 &cipher_table[i].contextsize,
+					 &cipher_table[i].setkey,
+					 &cipher_table[i].encrypt,
+					 &cipher_table[i].decrypt     );
+    if( !cipher_table[i].name || blocksize != STD_BLOCKSIZE )
+	BUG();
+    i++;
+    cipher_table[i].algo = CIPHER_ALGO_BLOWFISH160;
+    cipher_table[i].name = blowfish_get_info( cipher_table[i].algo,
+					 &cipher_table[i].keylen,
+					 &blocksize,
+					 &cipher_table[i].contextsize,
+					 &cipher_table[i].setkey,
+					 &cipher_table[i].encrypt,
+					 &cipher_table[i].decrypt     );
+    if( !cipher_table[i].name || blocksize != STD_BLOCKSIZE )
+	BUG();
+    i++;
+    cipher_table[i].algo = CIPHER_ALGO_DUMMY;
+    cipher_table[i].name = "DUMMY";
+    cipher_table[i].keylen = 128;
+    cipher_table[i].contextsize = 0;
+    cipher_table[i].setkey = dummy_setkey;
+    cipher_table[i].encrypt = dummy_encrypt_block;
+    cipher_table[i].decrypt = dummy_decrypt_block;
+    i++;
+
+    for( ; i < TABLE_SIZE; i++ )
+	cipher_table[i].name = NULL;
+}
+
+
+/****************
+ * Try to load all modules and return true if new modules are available
+ */
+static int
+load_cipher_modules()
+{
+    static int done = 0;
+    static int initialized = 0;
+    void *context = NULL;
+    struct cipher_table_s *ct;
+    int ct_idx;
+    size_t blocksize;
+    int i;
+    const char *name;
+    int any = 0;
+
+    if( !initialized ) {
+	setup_cipher_table(); /* load static modules on the first call */
+	initialized = 1;
+	return 1;
+    }
+
+    if( done )
+	return 0;
+    done = 1;
+
+    for(ct_idx=0, ct = cipher_table; ct_idx < TABLE_SIZE; ct_idx++,ct++ ) {
+	if( !ct->name )
+	    break;
+    }
+    if( ct_idx >= TABLE_SIZE-1 )
+	BUG(); /* table already full */
+    /* now load all extensions */
+    while( (name = enum_gnupgext_ciphers( &context, &ct->algo,
+				&ct->keylen, &blocksize, &ct->contextsize,
+				&ct->setkey, &ct->encrypt, &ct->decrypt)) ) {
+	if( blocksize != STD_BLOCKSIZE ) {
+	    log_info("skipping cipher %d: unsupported blocksize\n", ct->algo);
+	    continue;
+	}
+	for(i=0; cipher_table[i].name; i++ )
+	    if( cipher_table[i].algo == ct->algo )
+		break;
+	if( cipher_table[i].name ) {
+	    log_info("skipping cipher %d: already loaded\n", ct->algo );
+	    continue;
+	}
+	/* put it into the table */
+	if( g10_opt_verbose > 1 )
+	    log_info("loaded cipher %d (%s)\n", ct->algo, name);
+	ct->name = name;
+	ct_idx++;
+	ct++;
+	any = 1;
+	/* check whether there are more available table slots */
+	if( ct_idx >= TABLE_SIZE-1 ) {
+	    log_info("cipher table full; ignoring other extensions\n");
+	    break;
+	}
+    }
+    enum_gnupgext_ciphers( &context, NULL, NULL, NULL, NULL,
+					   NULL, NULL, NULL );
+    return any;
+}
+
+
+
+
+
+
+
 /****************
  * Map a string to the cipher algo
  */
@@ -96,9 +210,11 @@
     int i;
     const char *s;
 
-    for(i=0; (s=cipher_names[i].name); i++ )
-	if( !stricmp( s, string ) )
-	    return cipher_names[i].algo;
+    do {
+	for(i=0; (s=cipher_table[i].name); i++ )
+	    if( !stricmp( s, string ) )
+		return cipher_table[i].algo;
+    } while( load_cipher_modules() );
     return 0;
 }
 
@@ -110,9 +226,11 @@
 {
     int i;
 
-    for(i=0; cipher_names[i].name; i++ )
-	if( cipher_names[i].algo == algo )
-	    return cipher_names[i].name;
+    do {
+	for(i=0; cipher_table[i].name; i++ )
+	    if( cipher_table[i].algo == algo )
+		return cipher_table[i].name;
+    } while( load_cipher_modules() );
     return NULL;
 }
 
@@ -122,16 +240,14 @@
 int
 check_cipher_algo( int algo )
 {
-    switch( algo ) {
-      case CIPHER_ALGO_BLOWFISH160:
-      case CIPHER_ALGO_BLOWFISH:
-      case CIPHER_ALGO_CAST:
-      case CIPHER_ALGO_3DES:
-      case CIPHER_ALGO_DUMMY:
-	return 0;
-      default:
-	return G10ERR_CIPHER_ALGO;
-    }
+    int i;
+
+    do {
+       for(i=0; cipher_table[i].name; i++ )
+	   if( cipher_table[i].algo == algo )
+	       return 0; /* okay */
+    } while( load_cipher_modules() );
+    return G10ERR_CIPHER_ALGO;
 }
 
 
@@ -141,14 +257,18 @@
     int i;
     unsigned len = 0;
 
-    for(i=0; cipher_names[i].name; i++ )
-	if( cipher_names[i].algo == algo ) {
-	    len = cipher_names[i].keylen;
-	    break;
+    do {
+	for(i=0; cipher_table[i].name; i++ ) {
+	    if( cipher_table[i].algo == algo ) {
+		len = cipher_table[i].keylen;
+		if( !len )
+		    log_bug("cipher %d w/o key length\n", algo );
+		return len;
+	    }
 	}
-    if( !len )
-	log_bug("cipher %d w/o key length\n", algo );
-    return len;
+    } while( load_cipher_modules() );
+    log_bug("cipher %d not found\n", algo );
+    return 0;
 }
 
 
@@ -160,13 +280,28 @@
 cipher_open( int algo, int mode, int secure )
 {
     CIPHER_HANDLE hd;
+    int i;
 
     fast_random_poll();
-    /* performance hint:
-     * It is possible to allocate less memory depending on the cipher */
-    hd = secure ? m_alloc_secure_clear( sizeof *hd )
-		: m_alloc_clear( sizeof *hd );
+    do {
+	for(i=0; cipher_table[i].name; i++ )
+	    if( cipher_table[i].algo == algo )
+		break;
+    } while( !cipher_table[i].name && load_cipher_modules() );
+    if( !cipher_table[i].name ) {
+	log_fatal("cipher_open: algorithm %d not available\n", algo );
+	return NULL;
+    }
+
+    /* ? perform selftest here and mark this with a flag in cipher_table ? */
+
+    hd = secure ? m_alloc_secure_clear( sizeof *hd
+					+ cipher_table[i].contextsize )
+		: m_alloc_clear( sizeof *hd + cipher_table[i].contextsize );
     hd->algo = algo;
+    hd->setkey	= cipher_table[i].setkey;
+    hd->encrypt = cipher_table[i].encrypt;
+    hd->decrypt = cipher_table[i].decrypt;
     if( algo == CIPHER_ALGO_DUMMY )
 	hd->mode = CIPHER_MODE_DUMMY;
     else if( mode == CIPHER_MODE_AUTO_CFB ) {
@@ -177,34 +312,6 @@
     }
     else
 	hd->mode = mode;
-    switch( algo )  {
-      case CIPHER_ALGO_BLOWFISH:
-      case CIPHER_ALGO_BLOWFISH160:
-	hd->setkey  = FNCCAST_SETKEY(blowfish_setkey);
-	hd->encrypt = FNCCAST_CRYPT(blowfish_encrypt_block);
-	hd->decrypt = FNCCAST_CRYPT(blowfish_decrypt_block);
-	break;
-
-      case CIPHER_ALGO_CAST:
-	hd->setkey  = FNCCAST_SETKEY(cast5_setkey);
-	hd->encrypt = FNCCAST_CRYPT(cast5_encrypt_block);
-	hd->decrypt = FNCCAST_CRYPT(cast5_decrypt_block);
-	break;
-#if 0
-      case CIPHER_ALGO_3DES:
-	hd->setkey  = FNCCAST_SETKEY(des_3des_setkey);
-	hd->encrypt = FNCCAST_CRYPT(des_encrypt_block);
-	hd->decrypt = FNCCAST_CRYPT(des_decrypt_block);
-	break;
-#endif
-      case CIPHER_ALGO_DUMMY:
-	hd->setkey  = FNCCAST_SETKEY(dummy_setkey);
-	hd->encrypt = FNCCAST_CRYPT(dummy_encrypt_block);
-	hd->decrypt = FNCCAST_CRYPT(dummy_decrypt_block);
-	break;
-
-      default: log_fatal("cipher_open: invalid algo %d\n", algo );
-    }
 
     return hd;
 }
@@ -220,7 +327,7 @@
 void
 cipher_setkey( CIPHER_HANDLE c, byte *key, unsigned keylen )
 {
-    (*c->setkey)( &c->c.context, key, keylen );
+    (*c->setkey)( &c->context, key, keylen );
 }
 
 
@@ -243,7 +350,7 @@
     unsigned n;
 
     for(n=0; n < nblocks; n++ ) {
-	(*c->encrypt)( &c->c.context, outbuf, inbuf );
+	(*c->encrypt)( &c->context, outbuf, inbuf );
 	inbuf  += STD_BLOCKSIZE;;
 	outbuf += STD_BLOCKSIZE;
     }
@@ -255,7 +362,7 @@
     unsigned n;
 
     for(n=0; n < nblocks; n++ ) {
-	(*c->decrypt)( &c->c.context, outbuf, inbuf );
+	(*c->decrypt)( &c->context, outbuf, inbuf );
 	inbuf  += STD_BLOCKSIZE;;
 	outbuf += STD_BLOCKSIZE;
     }
@@ -287,7 +394,7 @@
 	int i;
 	/* encrypt the IV (and save the current one) */
 	memcpy( c->lastiv, c->iv, STD_BLOCKSIZE );
-	(*c->encrypt)( &c->c.context, c->iv, c->iv );
+	(*c->encrypt)( &c->context, c->iv, c->iv );
 	/* XOR the input with the IV and store input into IV */
 	for(ivp=c->iv,i=0; i < STD_BLOCKSIZE; i++ )
 	    *outbuf++ = (*ivp++ ^= *inbuf++);
@@ -296,7 +403,7 @@
     if( nbytes ) { /* process the remaining bytes */
 	/* encrypt the IV (and save the current one) */
 	memcpy( c->lastiv, c->iv, STD_BLOCKSIZE );
-	(*c->encrypt)( &c->c.context, c->iv, c->iv );
+	(*c->encrypt)( &c->context, c->iv, c->iv );
 	c->unused = STD_BLOCKSIZE;
 	/* and apply the xor */
 	c->unused -= nbytes;
@@ -305,7 +412,6 @@
     }
 }
 
-
 static void
 do_cfb_decrypt( CIPHER_HANDLE c, byte *outbuf, byte *inbuf, unsigned nbytes )
 {
@@ -340,7 +446,7 @@
 	while( nbytes >= STD_BLOCKSIZE ) {
 	    /* encrypt the IV (and save the current one) */
 	    memcpy( c->lastiv, c->iv, STD_BLOCKSIZE );
-	    (*c->encrypt)( &c->c.context, c->iv, c->iv );
+	    (*c->encrypt)( &c->context, c->iv, c->iv );
 	    ivp = c->iv;
 	    /* XOR the input with the IV and store input into IV */
 	  #if SIZEOF_UNSIGNED_LONG == STD_BLOCKSIZE
@@ -371,6 +477,8 @@
 	    #error Please disable the align test.
 	  #endif
 	    nbytes -= STD_BLOCKSIZE;
+	    inbuf  += STD_BLOCKSIZE;
+	    outbuf += STD_BLOCKSIZE;
 	}
     }
     else { /* non aligned version */
@@ -379,7 +487,7 @@
 	    int i;
 	    /* encrypt the IV (and save the current one) */
 	    memcpy( c->lastiv, c->iv, STD_BLOCKSIZE );
-	    (*c->encrypt)( &c->c.context, c->iv, c->iv );
+	    (*c->encrypt)( &c->context, c->iv, c->iv );
 	    /* XOR the input with the IV and store input into IV */
 	    for(ivp=c->iv,i=0; i < STD_BLOCKSIZE; i++ ) {
 		temp = *inbuf++;
@@ -394,7 +502,7 @@
     if( nbytes ) { /* process the remaining bytes */
 	/* encrypt the IV (and save the current one) */
 	memcpy( c->lastiv, c->iv, STD_BLOCKSIZE );
-	(*c->encrypt)( &c->c.context, c->iv, c->iv );
+	(*c->encrypt)( &c->context, c->iv, c->iv );
 	c->unused = STD_BLOCKSIZE;
 	/* and apply the xor */
 	c->unused -= nbytes;
diff -urN gnupg-0.2.19/cipher/des.h gnupg-0.3.0/cipher/des.h
--- gnupg-0.2.19/cipher/des.h	Fri May 29 12:11:27 1998
+++ gnupg-0.3.0/cipher/des.h	Thu Jan  1 01:00:00 1970
@@ -1,37 +0,0 @@
-/* des.h
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-#ifndef G10_DES_H
-#define G10_DES_H
-
-#include "types.h"
-
-#define DES_BLOCKSIZE 8
-#define DES_ROUNDS 16
-
-typedef struct {
-    int tripledes;
-} DES_context;
-
-void des_setkey( DES_context *c, byte *key, unsigned keylen );
-void des_3des_setkey( DES_context *c, byte *key, unsigned keylen );
-void des_encrypt_block( DES_context *bc, byte *outbuf, byte *inbuf );
-void des_decrypt_block( DES_context *bc, byte *outbuf, byte *inbuf );
-
-#endif /*G10_DES_H*/
diff -urN gnupg-0.2.19/cipher/dsa.c gnupg-0.3.0/cipher/dsa.c
--- gnupg-0.2.19/cipher/dsa.c	Tue May  5 22:09:02 1998
+++ gnupg-0.3.0/cipher/dsa.c	Wed Jun 24 09:56:28 1998
@@ -28,6 +28,30 @@
 #include "cipher.h"
 #include "dsa.h"
 
+typedef struct {
+    MPI p;	    /* prime */
+    MPI q;	    /* group order */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+} DSA_public_key;
+
+
+typedef struct {
+    MPI p;	    /* prime */
+    MPI q;	    /* group order */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+    MPI x;	    /* secret exponent */
+} DSA_secret_key;
+
+
+static MPI gen_k( MPI q );
+static void test_keys( DSA_secret_key *sk, unsigned qbits );
+static int  check_secret_key( DSA_secret_key *sk );
+static void generate( DSA_secret_key *sk, unsigned nbits, MPI **ret_factors );
+static void sign(MPI r, MPI s, MPI input, DSA_secret_key *skey);
+static int  verify(MPI r, MPI s, MPI input, DSA_public_key *pkey);
+
 /****************
  * Generate a random secret exponent k less than q
  */
@@ -55,37 +79,23 @@
     return k;
 }
 
-void
-dsa_free_public_key( DSA_public_key *pk )
-{
-    mpi_free( pk->p ); pk->p = NULL;
-    mpi_free( pk->q ); pk->q = NULL;
-    mpi_free( pk->g ); pk->g = NULL;
-    mpi_free( pk->y ); pk->y = NULL;
-}
-
-void
-dsa_free_secret_key( DSA_secret_key *sk )
-{
-    mpi_free( sk->p ); sk->p = NULL;
-    mpi_free( sk->q ); sk->q = NULL;
-    mpi_free( sk->g ); sk->g = NULL;
-    mpi_free( sk->y ); sk->y = NULL;
-    mpi_free( sk->x ); sk->x = NULL;
-}
-
 
 static void
-test_keys( DSA_public_key *pk, DSA_secret_key *sk, unsigned qbits )
+test_keys( DSA_secret_key *sk, unsigned qbits )
 {
+    DSA_public_key pk;
     MPI test = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
     MPI out1_a = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
     MPI out1_b = mpi_alloc( qbits / BITS_PER_MPI_LIMB );
 
+    pk.p = sk->p;
+    pk.q = sk->q;
+    pk.g = sk->g;
+    pk.y = sk->y;
     mpi_set_bytes( test, qbits, get_random_byte, 0 );
 
-    dsa_sign( out1_a, out1_b, test, sk );
-    if( !dsa_verify( out1_a, out1_b, test, pk ) )
+    sign( out1_a, out1_b, test, sk );
+    if( !verify( out1_a, out1_b, test, &pk ) )
 	log_fatal("DSA:: sign, verify failed\n");
 
     mpi_free( test );
@@ -100,9 +110,8 @@
  * Returns: 2 structures filled with all needed values
  *	    and an array with the n-1 factors of (p-1)
  */
-void
-dsa_generate( DSA_public_key *pk, DSA_secret_key *sk,
-	      unsigned nbits, MPI **ret_factors )
+static void
+generate( DSA_secret_key *sk, unsigned nbits, MPI **ret_factors )
 {
     MPI p;    /* the prime */
     MPI q;    /* the 160 bit prime factor */
@@ -141,7 +150,7 @@
      * is the secret part. */
     if( DBG_CIPHER )
 	log_debug("choosing a random x ");
-    assert( qbits >= 16 );
+    assert( qbits >= 160 );
     x = mpi_alloc_secure( mpi_get_nlimbs(q) );
     mpi_sub_ui( h, q, 1 );  /* put q-1 into h */
     rndbuf = NULL;
@@ -176,10 +185,6 @@
     }
 
     /* copy the stuff to the key structures */
-    pk->p = mpi_copy(p);
-    pk->q = mpi_copy(q);
-    pk->g = mpi_copy(g);
-    pk->y = mpi_copy(y);
     sk->p = p;
     sk->q = q;
     sk->g = g;
@@ -187,7 +192,7 @@
     sk->x = x;
 
     /* now we can test our keys (this should never fail!) */
-    test_keys( pk, sk, qbits );
+    test_keys( sk, qbits );
 }
 
 
@@ -196,8 +201,8 @@
  * Test whether the secret key is valid.
  * Returns: if this is a valid key.
  */
-int
-dsa_check_secret_key( DSA_secret_key *sk )
+static int
+check_secret_key( DSA_secret_key *sk )
 {
     int rc;
     MPI y = mpi_alloc( mpi_get_nlimbs(sk->y) );
@@ -214,8 +219,8 @@
  * Make a DSA signature from HASH and put it into r and s.
  */
 
-void
-dsa_sign(MPI r, MPI s, MPI hash, DSA_secret_key *skey )
+static void
+sign(MPI r, MPI s, MPI hash, DSA_secret_key *skey )
 {
     MPI k;
     MPI kinv;
@@ -247,8 +252,8 @@
 /****************
  * Returns true if the signature composed from R and S is valid.
  */
-int
-dsa_verify(MPI r, MPI s, MPI hash, DSA_public_key *pkey )
+static int
+verify(MPI r, MPI s, MPI hash, DSA_public_key *pkey )
 {
     int rc;
     MPI w, u1, u2, v;
@@ -289,4 +294,120 @@
     mpi_free(v);
     return rc;
 }
+
+
+/*********************************************
+ **************  interface  ******************
+ *********************************************/
+
+int
+dsa_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+
+    generate( &sk, nbits, retfactors );
+    skey[0] = sk.p;
+    skey[1] = sk.q;
+    skey[2] = sk.g;
+    skey[3] = sk.y;
+    skey[4] = sk.x;
+    return 0;
+}
+
+
+int
+dsa_check_secret_key( int algo, MPI *skey )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+
+    sk.p = skey[0];
+    sk.q = skey[1];
+    sk.g = skey[2];
+    sk.y = skey[3];
+    sk.x = skey[4];
+    if( !check_secret_key( &sk ) )
+	return G10ERR_BAD_SECKEY;
+
+    return 0;
+}
+
+
+
+int
+dsa_sign( int algo, MPI *resarr, MPI data, MPI *skey )
+{
+    DSA_secret_key sk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+
+    sk.p = skey[0];
+    sk.q = skey[1];
+    sk.g = skey[2];
+    sk.y = skey[3];
+    sk.x = skey[4];
+    resarr[0] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    resarr[1] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    sign( resarr[0], resarr[1], data, &sk );
+    return 0;
+}
+
+int
+dsa_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev )
+{
+    DSA_public_key pk;
+
+    if( algo != PUBKEY_ALGO_DSA )
+	return G10ERR_PUBKEY_ALGO;
+
+    pk.p = pkey[0];
+    pk.q = pkey[1];
+    pk.g = pkey[2];
+    pk.y = pkey[3];
+    if( !verify( data[0], data[1], hash, &pk ) )
+	return G10ERR_BAD_SIGN;
+    return 0;
+}
+
+
+
+unsigned
+dsa_get_nbits( int algo, MPI *pkey )
+{
+    if( algo != PUBKEY_ALGO_DSA )
+	return 0;
+    return mpi_get_nbits( pkey[0] );
+}
+
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ * Usage: Bit 0 set : allows signing
+ *	      1 set : allows encryption
+ */
+const char *
+dsa_get_info( int algo, int *npkey, int *nskey, int *nenc, int *nsig,
+							 int *usage )
+{
+    *npkey = 4;
+    *nskey = 5;
+    *nenc = 0;
+    *nsig = 2;
+
+    switch( algo ) {
+      case PUBKEY_ALGO_DSA:   *usage = 1; return "DSA";
+      default: *usage = 0; return NULL;
+    }
+}
+
 
diff -urN gnupg-0.2.19/cipher/dsa.h gnupg-0.3.0/cipher/dsa.h
--- gnupg-0.2.19/cipher/dsa.h	Tue May  5 15:08:27 1998
+++ gnupg-0.3.0/cipher/dsa.h	Mon Jun 15 15:45:51 1998
@@ -20,31 +20,13 @@
 #ifndef G10_DSA_H
 #define G10_DSA_H
 
-#include "mpi.h"
-
-typedef struct {
-    MPI p;	    /* prime */
-    MPI q;	    /* group order */
-    MPI g;	    /* group generator */
-    MPI y;	    /* g^x mod p */
-} DSA_public_key;
-
-
-typedef struct {
-    MPI p;	    /* prime */
-    MPI q;	    /* group order */
-    MPI g;	    /* group generator */
-    MPI y;	    /* g^x mod p */
-    MPI x;	    /* secret exponent */
-} DSA_secret_key;
-
-
-void dsa_free_public_key( DSA_public_key *pk );
-void dsa_free_secret_key( DSA_secret_key *sk );
-int  dsa_check_secret_key( DSA_secret_key *sk );
-void dsa_generate( DSA_public_key *pk, DSA_secret_key *sk,
-		   unsigned nbits, MPI **ret_factors );
-void dsa_sign(MPI r, MPI s, MPI input, DSA_secret_key *skey);
-int  dsa_verify(MPI r, MPI s, MPI input, DSA_public_key *pkey);
+int dsa_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors );
+int dsa_check_secret_key( int algo, MPI *skey );
+int dsa_sign( int algo, MPI *resarr, MPI data, MPI *skey );
+int dsa_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev );
+unsigned dsa_get_nbits( int algo, MPI *pkey );
+const char *dsa_get_info( int algo, int *npkey, int *nskey,
+				    int *nenc, int *nsig, int *usage );
 
 #endif /*G10_DSA_H*/
diff -urN gnupg-0.2.19/cipher/dynload.c gnupg-0.3.0/cipher/dynload.c
--- gnupg-0.2.19/cipher/dynload.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/cipher/dynload.c	Wed Jun 24 20:23:25 1998
@@ -0,0 +1,367 @@
+/* dynload.c - load cipher extensions
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#ifdef HAVE_DL_DLOPEN
+  #include <dlfcn.h>
+#endif
+#include "util.h"
+#include "cipher.h"
+#include "dynload.h"
+
+typedef struct ext_list {
+    struct ext_list *next;
+    void *handle; /* handle from dlopen() */
+    int  failed;  /* already tried but failed */
+    void * (*enumfunc)(int, int*, int*, int*);
+    char *hintstr; /* pointer into name */
+    char name[1];
+} *EXTLIST;
+
+static EXTLIST extensions;
+
+typedef struct {
+    EXTLIST r;
+    int seq1;
+    int seq2;
+    void *sym;
+} ENUMCONTEXT;
+
+/****************
+ * Register an extension module.  The last registered module will
+ * be loaded first.  A name may have a list of classes
+ * appended; e.g:
+ *	mymodule.so(1:17,3:20,3:109)
+ * means that this module provides digest algorithm 17 and public key
+ * algorithms 20 and 109.  This is only a hint but if it is there the
+ * loader may decide to only load a module which claims to have a
+ * requested algorithm.
+ */
+void
+register_cipher_extension( const char *fname )
+{
+    EXTLIST r, el;
+    char *p, *pe;
+
+    if( *fname != '/' ) { /* do tilde expansion etc */
+	char *p ;
+
+	if( strchr(fname, '/') )
+	    p = make_filename(fname, NULL);
+	else
+	    p = make_filename(GNUPG_LIBDIR, fname, NULL);
+	el = m_alloc_clear( sizeof *el + strlen(p) );
+	strcpy(el->name, p );
+	m_free(p);
+    }
+    else {
+	el = m_alloc_clear( sizeof *el + strlen(fname) );
+	strcpy(el->name, fname );
+    }
+    /* check whether we have a class hint */
+    if( (p=strchr(el->name,'(')) && (pe=strchr(p+1,')')) && !pe[1] ) {
+	*p = *pe = 0;
+	el->hintstr = p+1;
+    }
+    else
+	el->hintstr = NULL;
+
+    /* check that it is not already registered */
+    for(r = extensions; r; r = r->next )
+	if( !compare_filenames(r->name, el->name) ) {
+	    log_info("extension '%s' already registered\n", el->name );
+	    m_free(el);
+	    return;
+	}
+    /* and register */
+    el->next = extensions;
+    extensions = el;
+}
+
+
+static int
+load_extension( EXTLIST el )
+{
+  #ifdef USE_DYNAMIC_LINKING
+    char **name;
+    void *sym;
+    const char *err;
+    int seq = 0;
+    int class, vers;
+
+
+    el->handle = dlopen(el->name, RTLD_NOW);
+    if( !el->handle ) {
+	log_error("%s: error loading extension: %s\n", el->name, dlerror() );
+	goto failure;
+    }
+    name = (char**)dlsym(el->handle, "gnupgext_version");
+    if( (err=dlerror()) ) {
+	log_error("%s: not a gnupg extension: %s\n", el->name, err );
+	goto failure;
+    }
+
+    if( g10_opt_verbose )
+	log_info("%s: %s%s%s%s\n", el->name, *name,
+		  el->hintstr? " (":"",
+		  el->hintstr? el->hintstr:"",
+		  el->hintstr? ")":"");
+
+    sym = dlsym(el->handle, "gnupgext_enum_func");
+    if( (err=dlerror()) ) {
+	log_error("%s: invalid gnupg extension: %s\n", el->name, err );
+	goto failure;
+    }
+    el->enumfunc = (void *(*)(int,int*,int*,int*))sym;
+
+    if( g10_opt_verbose > 1 ) {
+	/* list the contents of the module */
+	while( (sym = (*el->enumfunc)(0, &seq, &class, &vers)) ) {
+	    if( vers != 1 ) {
+		log_info("%s: ignoring func with version %d\n",el->name,vers);
+		continue;
+	    }
+	    switch( class ) {
+	      case 11:
+	      case 21:
+	      case 31:
+		log_info("%s: provides %s algorithm %d\n", el->name,
+				class == 11? "md"     :
+				class == 21? "cipher" : "pubkey",
+						       *(int*)sym);
+		break;
+	      default:
+		/*log_debug("%s: skipping class %d\n", el->name, class);*/
+		break;
+	    }
+	}
+    }
+    return 0;
+
+  failure:
+    if( el->handle ) {
+	dlclose(el->handle);
+	el->handle = NULL;
+    }
+    el->failed = 1;
+  #endif /*USE_DYNAMIC_LINKING*/
+    return -1;
+}
+
+
+
+int
+enum_gnupgext_digests( void **enum_context,
+	    int *algo,
+	    const char *(**r_get_info)( int, size_t*,byte**, int*, int*,
+				       void (**)(void*),
+				       void (**)(void*,byte*,size_t),
+				       void (**)(void*),byte *(**)(void*)) )
+{
+    EXTLIST r;
+    ENUMCONTEXT *ctx;
+
+    if( !*enum_context ) { /* init context */
+	ctx = m_alloc_clear( sizeof( *ctx ) );
+	ctx->r = extensions;
+	*enum_context = ctx;
+    }
+    else if( !algo ) { /* release the context */
+	m_free(*enum_context);
+	*enum_context = NULL;
+	return 0;
+    }
+    else
+	ctx = *enum_context;
+
+    for( r = ctx->r; r; r = r->next )  {
+	int class, vers;
+
+	if( r->failed )
+	    continue;
+	if( !r->handle && load_extension(r) )
+	    continue;
+	/* get a digest info function */
+	if( ctx->sym )
+	    goto inner_loop;
+	while( (ctx->sym = (*r->enumfunc)(10, &ctx->seq1, &class, &vers)) ) {
+	    void *sym;
+	    /* must check class because enumfunc may be wrong coded */
+	    if( vers != 1 || class != 10 )
+		continue;
+	  inner_loop:
+	    *r_get_info = ctx->sym;
+	    while( (sym = (*r->enumfunc)(11, &ctx->seq2, &class, &vers)) ) {
+		if( vers != 1 || class != 11 )
+		    continue;
+		*algo = *(int*)sym;
+		ctx->r = r;
+		return 1;
+	    }
+	    ctx->seq2 = 0;
+	}
+	ctx->seq1 = 0;
+    }
+    ctx->r = r;
+    return 0;
+}
+
+const char *
+enum_gnupgext_ciphers( void **enum_context, int *algo,
+		       size_t *keylen, size_t *blocksize, size_t *contextsize,
+		       void (**setkey)( void *c, byte *key, unsigned keylen ),
+		       void (**encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		       void (**decrypt)( void *c, byte *outbuf, byte *inbuf )
+		     )
+{
+    EXTLIST r;
+    ENUMCONTEXT *ctx;
+    const char * (*finfo)(int, size_t*, size_t*, size_t*,
+			  void (**)( void *, byte *, unsigned),
+			  void (**)( void *, byte *, byte *),
+			  void (**)( void *, byte *, byte *));
+
+    if( !*enum_context ) { /* init context */
+	ctx = m_alloc_clear( sizeof( *ctx ) );
+	ctx->r = extensions;
+	*enum_context = ctx;
+    }
+    else if( !algo ) { /* release the context */
+	m_free(*enum_context);
+	*enum_context = NULL;
+	return NULL;
+    }
+    else
+	ctx = *enum_context;
+
+    for( r = ctx->r; r; r = r->next )  {
+	int class, vers;
+
+	if( r->failed )
+	    continue;
+	if( !r->handle && load_extension(r) )
+	    continue;
+	/* get a cipher info function */
+	if( ctx->sym )
+	    goto inner_loop;
+	while( (ctx->sym = (*r->enumfunc)(20, &ctx->seq1, &class, &vers)) ) {
+	    void *sym;
+	    /* must check class because enumfunc may be wrong coded */
+	    if( vers != 1 || class != 20 )
+		continue;
+	  inner_loop:
+	    finfo = ctx->sym;
+	    while( (sym = (*r->enumfunc)(21, &ctx->seq2, &class, &vers)) ) {
+		const char *algname;
+		if( vers != 1 || class != 21 )
+		    continue;
+		*algo = *(int*)sym;
+		algname = (*finfo)( *algo, keylen, blocksize, contextsize,
+				    setkey, encrypt, decrypt );
+		if( algname ) {
+		    ctx->r = r;
+		    return algname;
+		}
+	    }
+	    ctx->seq2 = 0;
+	}
+	ctx->seq1 = 0;
+    }
+    ctx->r = r;
+    return NULL;
+}
+
+const char *
+enum_gnupgext_pubkeys( void **enum_context, int *algo,
+    int *npkey, int *nskey, int *nenc, int *nsig, int *usage,
+    int (**generate)( int algo, unsigned nbits, MPI *skey, MPI **retfactors ),
+    int (**check_secret_key)( int algo, MPI *skey ),
+    int (**encrypt)( int algo, MPI *resarr, MPI data, MPI *pkey ),
+    int (**decrypt)( int algo, MPI *result, MPI *data, MPI *skey ),
+    int (**sign)( int algo, MPI *resarr, MPI data, MPI *skey ),
+    int (**verify)( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev ),
+    unsigned (**get_nbits)( int algo, MPI *pkey ) )
+{
+    EXTLIST r;
+    ENUMCONTEXT *ctx;
+    const char * (*finfo)( int, int *, int *, int *, int *, int *,
+			   int (**)( int, unsigned, MPI *, MPI **),
+			   int (**)( int, MPI * ),
+			   int (**)( int, MPI *, MPI , MPI * ),
+			   int (**)( int, MPI *, MPI *, MPI * ),
+			   int (**)( int, MPI *, MPI , MPI * ),
+			   int (**)( int, MPI , MPI *, MPI *,
+					    int (*)(void*,MPI), void *),
+			   unsigned (**)( int , MPI * ) );
+
+    if( !*enum_context ) { /* init context */
+	ctx = m_alloc_clear( sizeof( *ctx ) );
+	ctx->r = extensions;
+	*enum_context = ctx;
+    }
+    else if( !algo ) { /* release the context */
+	m_free(*enum_context);
+	*enum_context = NULL;
+	return NULL;
+    }
+    else
+	ctx = *enum_context;
+
+    for( r = ctx->r; r; r = r->next )  {
+	int class, vers;
+
+	if( r->failed )
+	    continue;
+	if( !r->handle && load_extension(r) )
+	    continue;
+	/* get a pubkey info function */
+	if( ctx->sym )
+	    goto inner_loop;
+	while( (ctx->sym = (*r->enumfunc)(30, &ctx->seq1, &class, &vers)) ) {
+	    void *sym;
+	    if( vers != 1 || class != 30 )
+		continue;
+	  inner_loop:
+	    finfo = ctx->sym;
+	    while( (sym = (*r->enumfunc)(31, &ctx->seq2, &class, &vers)) ) {
+		const char *algname;
+		if( vers != 1 || class != 31 )
+		    continue;
+		*algo = *(int*)sym;
+		algname = (*finfo)( *algo, npkey, nskey, nenc, nsig, usage,
+				    generate, check_secret_key, encrypt,
+				    decrypt, sign, verify, get_nbits );
+		if( algname ) {
+		    ctx->r = r;
+		    return algname;
+		}
+	    }
+	    ctx->seq2 = 0;
+	}
+	ctx->seq1 = 0;
+    }
+    ctx->r = r;
+    return NULL;
+}
+
diff -urN gnupg-0.2.19/cipher/dynload.h gnupg-0.3.0/cipher/dynload.h
--- gnupg-0.2.19/cipher/dynload.h	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/cipher/dynload.h	Tue Jun 16 12:01:43 1998
@@ -0,0 +1,52 @@
+/* dynload.5
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+#ifndef G10_CIPHER_DYNLOAD_H
+#define G10_CIPHER_DYNLOAD_H
+
+int
+enum_gnupgext_digests( void **enum_context,
+	    int *algo,
+	    const char *(**r_get_info)( int, size_t*,byte**, int*, int*,
+				       void (**)(void*),
+				       void (**)(void*,byte*,size_t),
+				       void (**)(void*),byte *(**)(void*)) );
+
+const char *
+enum_gnupgext_ciphers( void **enum_context, int *algo,
+		       size_t *keylen, size_t *blocksize, size_t *contextsize,
+		       void (**setkey)( void *c, byte *key, unsigned keylen ),
+		       void (**encrypt)( void *c, byte *outbuf, byte *inbuf ),
+		       void (**decrypt)( void *c, byte *outbuf, byte *inbuf )
+		     );
+
+
+const char *
+enum_gnupgext_pubkeys( void **enum_context, int *algo,
+    int *npkey, int *nskey, int *nenc, int *nsig, int *usage,
+    int (**generate)( int algo, unsigned nbits, MPI *skey, MPI **retfactors ),
+    int (**check_secret_key)( int algo, MPI *skey ),
+    int (**encrypt)( int algo, MPI *resarr, MPI data, MPI *pkey ),
+    int (**decrypt)( int algo, MPI *result, MPI *data, MPI *skey ),
+    int (**sign)( int algo, MPI *resarr, MPI data, MPI *skey ),
+    int (**verify)( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev ),
+    unsigned (**get_nbits)( int algo, MPI *pkey ) );
+
+#endif /*G10_CIPHER_DYNLOAD_H*/
diff -urN gnupg-0.2.19/cipher/elgamal.c gnupg-0.3.0/cipher/elgamal.c
--- gnupg-0.2.19/cipher/elgamal.c	Tue May  5 21:31:48 1998
+++ gnupg-0.3.0/cipher/elgamal.c	Mon Jun 15 15:49:52 1998
@@ -31,42 +31,53 @@
 #include "cipher.h"
 #include "elgamal.h"
 
-
-void
-elg_free_public_key( ELG_public_key *pk )
-{
-    mpi_free( pk->p ); pk->p = NULL;
-    mpi_free( pk->g ); pk->g = NULL;
-    mpi_free( pk->y ); pk->y = NULL;
-}
-
-void
-elg_free_secret_key( ELG_secret_key *sk )
-{
-    mpi_free( sk->p ); sk->p = NULL;
-    mpi_free( sk->g ); sk->g = NULL;
-    mpi_free( sk->y ); sk->y = NULL;
-    mpi_free( sk->x ); sk->x = NULL;
-}
+typedef struct {
+    MPI p;	    /* prime */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+} ELG_public_key;
+
+
+typedef struct {
+    MPI p;	    /* prime */
+    MPI g;	    /* group generator */
+    MPI y;	    /* g^x mod p */
+    MPI x;	    /* secret exponent */
+} ELG_secret_key;
+
+
+static void test_keys( ELG_secret_key *sk, unsigned nbits );
+static MPI gen_k( MPI p );
+static void generate( ELG_secret_key *sk, unsigned nbits, MPI **factors );
+static int  check_secret_key( ELG_secret_key *sk );
+static void encrypt(MPI a, MPI b, MPI input, ELG_public_key *pkey );
+static void decrypt(MPI output, MPI a, MPI b, ELG_secret_key *skey );
+static void sign(MPI a, MPI b, MPI input, ELG_secret_key *skey);
+static int  verify(MPI a, MPI b, MPI input, ELG_public_key *pkey);
 
 
 static void
-test_keys( ELG_public_key *pk, ELG_secret_key *sk, unsigned nbits )
+test_keys( ELG_secret_key *sk, unsigned nbits )
 {
+    ELG_public_key pk;
     MPI test = mpi_alloc( nbits / BITS_PER_MPI_LIMB );
     MPI out1_a = mpi_alloc( nbits / BITS_PER_MPI_LIMB );
     MPI out1_b = mpi_alloc( nbits / BITS_PER_MPI_LIMB );
     MPI out2 = mpi_alloc( nbits / BITS_PER_MPI_LIMB );
 
+    pk.p = sk->p;
+    pk.g = sk->g;
+    pk.y = sk->y;
+
     mpi_set_bytes( test, nbits, get_random_byte, 0 );
 
-    elg_encrypt( out1_a, out1_b, test, pk );
-    elg_decrypt( out2, out1_a, out1_b, sk );
+    encrypt( out1_a, out1_b, test, &pk );
+    decrypt( out2, out1_a, out1_b, sk );
     if( mpi_cmp( test, out2 ) )
 	log_fatal("ElGamal operation: encrypt, decrypt failed\n");
 
-    elg_sign( out1_a, out1_b, test, sk );
-    if( !elg_verify( out1_a, out1_b, test, pk ) )
+    sign( out1_a, out1_b, test, sk );
+    if( !verify( out1_a, out1_b, test, &pk ) )
 	log_fatal("ElGamal operation: sign, verify failed\n");
 
     mpi_free( test );
@@ -115,9 +126,8 @@
  * Returns: 2 structures filles with all needed values
  *	    and an array with n-1 factors of (p-1)
  */
-void
-elg_generate( ELG_public_key *pk, ELG_secret_key *sk,
-	      unsigned nbits, MPI **ret_factors )
+static void
+generate(  ELG_secret_key *sk, unsigned nbits, MPI **ret_factors )
 {
     MPI p;    /* the prime */
     MPI p_min1;
@@ -186,16 +196,13 @@
     }
 
     /* copy the stuff to the key structures */
-    pk->p = mpi_copy(p);
-    pk->g = mpi_copy(g);
-    pk->y = mpi_copy(y);
     sk->p = p;
     sk->g = g;
     sk->y = y;
     sk->x = x;
 
     /* now we can test our keys (this should never fail!) */
-    test_keys( pk, sk, nbits - 64 );
+    test_keys( sk, nbits - 64 );
 
     mpi_free( p_min1 );
     mpi_free( temp   );
@@ -206,8 +213,8 @@
  * Test whether the secret key is valid.
  * Returns: if this is a valid key.
  */
-int
-elg_check_secret_key( ELG_secret_key *sk )
+static int
+check_secret_key( ELG_secret_key *sk )
 {
     int rc;
     MPI y = mpi_alloc( mpi_get_nlimbs(sk->y) );
@@ -219,8 +226,8 @@
 }
 
 
-void
-elg_encrypt(MPI a, MPI b, MPI input, ELG_public_key *pkey )
+static void
+encrypt(MPI a, MPI b, MPI input, ELG_public_key *pkey )
 {
     MPI k;
 
@@ -249,8 +256,8 @@
 
 
 
-void
-elg_decrypt(MPI output, MPI a, MPI b, ELG_secret_key *skey )
+static void
+decrypt(MPI output, MPI a, MPI b, ELG_secret_key *skey )
 {
     MPI t1 = mpi_alloc_secure( mpi_get_nlimbs( skey->p ) );
 
@@ -276,8 +283,8 @@
  * Make an Elgamal signature out of INPUT
  */
 
-void
-elg_sign(MPI a, MPI b, MPI input, ELG_secret_key *skey )
+static void
+sign(MPI a, MPI b, MPI input, ELG_secret_key *skey )
 {
     MPI k;
     MPI t   = mpi_alloc( mpi_get_nlimbs(a) );
@@ -322,8 +329,8 @@
 /****************
  * Returns true if the signature composed of A and B is valid.
  */
-int
-elg_verify(MPI a, MPI b, MPI input, ELG_public_key *pkey )
+static int
+verify(MPI a, MPI b, MPI input, ELG_public_key *pkey )
 {
     int rc;
     MPI t1;
@@ -374,4 +381,153 @@
     mpi_free(t2);
     return rc;
 }
+
+/*********************************************
+ **************  interface  ******************
+ *********************************************/
+
+int
+elg_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors )
+{
+    ELG_secret_key sk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    generate( &sk, nbits, retfactors );
+    skey[0] = sk.p;
+    skey[1] = sk.g;
+    skey[2] = sk.y;
+    skey[3] = sk.x;
+    return 0;
+}
+
+
+int
+elg_check_secret_key( int algo, MPI *skey )
+{
+    ELG_secret_key sk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    sk.p = skey[0];
+    sk.g = skey[1];
+    sk.y = skey[2];
+    sk.x = skey[3];
+    if( !check_secret_key( &sk ) )
+	return G10ERR_BAD_SECKEY;
+
+    return 0;
+}
+
+
+
+int
+elg_encrypt( int algo, MPI *resarr, MPI data, MPI *pkey )
+{
+    ELG_public_key pk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    pk.p = pkey[0];
+    pk.g = pkey[1];
+    pk.y = pkey[2];
+    resarr[0] = mpi_alloc( mpi_get_nlimbs( pk.p ) );
+    resarr[1] = mpi_alloc( mpi_get_nlimbs( pk.p ) );
+    encrypt( resarr[0], resarr[1], data, &pk );
+    return 0;
+}
+
+int
+elg_decrypt( int algo, MPI *result, MPI *data, MPI *skey )
+{
+    ELG_secret_key sk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    sk.p = skey[0];
+    sk.g = skey[1];
+    sk.y = skey[2];
+    sk.x = skey[3];
+    *result = mpi_alloc_secure( mpi_get_nlimbs( sk.p ) );
+    decrypt( *result, data[0], data[1], &sk );
+    return 0;
+}
+
+int
+elg_sign( int algo, MPI *resarr, MPI data, MPI *skey )
+{
+    ELG_secret_key sk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    sk.p = skey[0];
+    sk.g = skey[1];
+    sk.y = skey[2];
+    sk.x = skey[3];
+    resarr[0] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    resarr[1] = mpi_alloc( mpi_get_nlimbs( sk.p ) );
+    sign( resarr[0], resarr[1], data, &sk );
+    return 0;
+}
+
+int
+elg_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev )
+{
+    ELG_public_key pk;
+
+    if( !is_ELGAMAL(algo) )
+	return G10ERR_PUBKEY_ALGO;
+
+    pk.p = pkey[0];
+    pk.g = pkey[1];
+    pk.y = pkey[2];
+    if( !verify( data[0], data[1], hash, &pk ) )
+	return G10ERR_BAD_SIGN;
+    return 0;
+}
+
+
+
+unsigned
+elg_get_nbits( int algo, MPI *pkey )
+{
+    if( !is_ELGAMAL(algo) )
+	return 0;
+    return mpi_get_nbits( pkey[0] );
+}
+
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ * Usage: Bit 0 set : allows signing
+ *	      1 set : allows encryption
+ * NOTE: This function allows signing also for ELG-E, chich is not
+ * okay but a bad hack to allow to work with olf gpg keys. The real check
+ * is done in the gnupg ocde depending on the packet version.
+ */
+const char *
+elg_get_info( int algo, int *npkey, int *nskey, int *nenc, int *nsig,
+							 int *usage )
+{
+    *npkey = 3;
+    *nskey = 4;
+    *nenc = 2;
+    *nsig = 2;
+
+    switch( algo ) {
+      case PUBKEY_ALGO_ELGAMAL:   *usage = 2|1; return "ELG";
+      case PUBKEY_ALGO_ELGAMAL_E: *usage = 2|1; return "ELG-E";
+      default: *usage = 0; return NULL;
+    }
+}
+
 
diff -urN gnupg-0.2.19/cipher/elgamal.h gnupg-0.3.0/cipher/elgamal.h
--- gnupg-0.2.19/cipher/elgamal.h	Mon Feb 23 13:12:57 1998
+++ gnupg-0.3.0/cipher/elgamal.h	Mon Jun 15 15:46:00 1998
@@ -20,31 +20,16 @@
 #ifndef G10_ELGAMAL_H
 #define G10_ELGAMAL_H
 
-#include "mpi.h"
+int elg_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors );
+int elg_check_secret_key( int algo, MPI *skey );
+int elg_encrypt( int algo, MPI *resarr, MPI data, MPI *pkey );
+int elg_decrypt( int algo, MPI *result, MPI *data, MPI *skey );
+int elg_sign( int algo, MPI *resarr, MPI data, MPI *skey );
+int elg_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev );
+unsigned elg_get_nbits( int algo, MPI *pkey );
+const char *elg_get_info( int algo, int *npkey, int *nskey,
+				    int *nenc, int *nsig, int *usage );
 
-typedef struct {
-    MPI p;	    /* prime */
-    MPI g;	    /* group generator */
-    MPI y;	    /* g^x mod p */
-} ELG_public_key;
-
-
-typedef struct {
-    MPI p;	    /* prime */
-    MPI g;	    /* group generator */
-    MPI y;	    /* g^x mod p */
-    MPI x;	    /* secret exponent */
-} ELG_secret_key;
-
-
-void elg_free_public_key( ELG_public_key *pk );
-void elg_free_secret_key( ELG_secret_key *sk );
-void elg_generate( ELG_public_key *pk, ELG_secret_key *sk,
-				unsigned nbits, MPI **factors );
-int  elg_check_secret_key( ELG_secret_key *sk );
-void elg_encrypt(MPI a, MPI b, MPI input, ELG_public_key *pkey );
-void elg_decrypt(MPI output, MPI a, MPI b, ELG_secret_key *skey );
-void elg_sign(MPI a, MPI b, MPI input, ELG_secret_key *skey);
-int  elg_verify(MPI a, MPI b, MPI input, ELG_public_key *pkey);
 
 #endif /*G10_ELGAMAL_H*/
diff -urN gnupg-0.2.19/cipher/g10c.c gnupg-0.3.0/cipher/g10c.c
--- gnupg-0.2.19/cipher/g10c.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/cipher/g10c.c	Mon Jun 15 17:40:52 1998
@@ -0,0 +1,44 @@
+/* g10c.c  -  Wrapper for cipher functions
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi.h"
+#include "random.h"
+#include "cipher.h"
+#define _g10lib_INTERNAL 1
+#include "g10lib.h"
+
+const char *g10c_revision_string(int dummy) { return "$Revision: 1.2 $"; }
+
+MPI
+g10c_generate_secret_prime( unsigned nbits )
+{
+    return generate_secret_prime( nbits );
+}
+
+byte
+g10c_get_random_byte( int level )
+{
+    return get_random_byte( level );
+}
+
+
diff -urN gnupg-0.2.19/cipher/md.c gnupg-0.3.0/cipher/md.c
--- gnupg-0.2.19/cipher/md.c	Fri May 22 07:39:53 1998
+++ gnupg-0.3.0/cipher/md.c	Wed Jun 24 19:54:25 1998
@@ -18,6 +18,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
+#define DEFINES_MD_HANDLE 1
+
 #include <config.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -26,6 +28,176 @@
 #include "util.h"
 #include "cipher.h"
 #include "errors.h"
+#include "dynload.h"
+#include "md5.h"
+#include "sha1.h"
+#include "rmd.h"
+
+
+/****************
+ * This structure is used for the list of available algorithms
+ * and for the list of algorithms in MD_HANDLE.
+ */
+struct md_digest_list_s {
+    struct md_digest_list_s *next;
+    const char *name;
+    int algo;
+    byte *asnoid;
+    int asnlen;
+    int mdlen;
+    void (*init)( void *c );
+    void (*write)( void *c, byte *buf, size_t nbytes );
+    void (*final)( void *c );
+    byte *(*read)( void *c );
+    size_t contextsize; /* allocate this amount of context */
+    char context[1];
+};
+
+static struct md_digest_list_s *digest_list;
+
+
+
+static struct md_digest_list_s *
+new_list_item( int algo,
+	       const char *(*get_info)( int, size_t*,byte**, int*, int*,
+				       void (**)(void*),
+				       void (**)(void*,byte*,size_t),
+				       void (**)(void*),byte *(**)(void*)) )
+{
+    struct md_digest_list_s *r;
+
+    r = m_alloc_clear( sizeof *r );
+    r->algo = algo,
+    r->name = (*get_info)( algo, &r->contextsize,
+			   &r->asnoid, &r->asnlen, &r->mdlen,
+			   &r->init, &r->write, &r->final, &r->read );
+    if( !r->name ) {
+	m_free(r);
+	r = NULL;
+    }
+    return r;
+}
+
+/****************
+ * Put the static entries into the table.
+ */
+static void
+setup_digest_list()
+{
+    struct md_digest_list_s *r;
+
+    r = new_list_item( DIGEST_ALGO_MD5, md5_get_info );
+    if( r ) { r->next = digest_list; digest_list = r; }
+
+    r = new_list_item( DIGEST_ALGO_RMD160, rmd160_get_info );
+    if( r ) { r->next = digest_list; digest_list = r; }
+
+    r = new_list_item( DIGEST_ALGO_SHA1, sha1_get_info );
+    if( r ) { r->next = digest_list; digest_list = r; }
+}
+
+
+/****************
+ * Try to load all modules and return true if new modules are available
+ */
+static int
+load_digest_modules()
+{
+    static int done = 0;
+    static int initialized = 0;
+    struct md_digest_list_s *r;
+    void *context = NULL;
+    int algo;
+    int any = 0;
+    const char *(*get_info)( int, size_t*,byte**, int*, int*,
+			    void (**)(void*),
+			    void (**)(void*,byte*,size_t),
+			    void (**)(void*),byte *(**)(void*));
+
+    if( !initialized ) {
+	setup_digest_list(); /* load static modules on the first call */
+	initialized = 1;
+	return 1;
+    }
+
+    if( done )
+	return 0;
+    done = 1;
+
+    while( enum_gnupgext_digests( &context, &algo, &get_info ) ) {
+	for(r=digest_list; r; r = r->next )
+	    if( r->algo == algo )
+		break;
+	if( r ) {
+	    log_info("skipping digest %d: already loaded\n", algo );
+	    continue;
+	}
+	r = new_list_item( algo, get_info );
+	if( ! r ) {
+	    log_info("skipping digest %d: no name\n", algo );
+	    continue;
+	}
+	/* put it into the list */
+	if( g10_opt_verbose > 1 )
+	    log_info("loaded digest %d\n", algo);
+	r->next = digest_list;
+	digest_list = r;
+	any = 1;
+    }
+    enum_gnupgext_digests( &context, NULL, NULL );
+    return any;
+}
+
+
+
+/****************
+ * Map a string to the digest algo
+ */
+int
+string_to_digest_algo( const char *string )
+{
+    struct md_digest_list_s *r;
+
+    do {
+	for(r = digest_list; r; r = r->next )
+	    if( !stricmp( r->name, string ) )
+		return r->algo;
+    } while( !r && load_digest_modules() );
+    return 0;
+}
+
+
+/****************
+ * Map a digest algo to a string
+ */
+const char *
+digest_algo_to_string( int algo )
+{
+    struct md_digest_list_s *r;
+
+    do {
+	for(r = digest_list; r; r = r->next )
+	    if( r->algo == algo )
+		return r->name;
+    } while( !r && load_digest_modules() );
+    return NULL;
+}
+
+
+int
+check_digest_algo( int algo )
+{
+    struct md_digest_list_s *r;
+
+    do {
+	for(r = digest_list; r; r = r->next )
+	    if( r->algo == algo )
+		return 0;
+    } while( !r && load_digest_modules() );
+    return G10ERR_DIGEST_ALGO;
+}
+
+
 
 /****************
  * Open a message digest handle for use with algorithm ALGO.
@@ -36,7 +208,6 @@
 md_open( int algo, int secure )
 {
     MD_HANDLE hd;
-
     hd = secure ? m_alloc_secure_clear( sizeof *hd )
 		: m_alloc_clear( sizeof *hd );
     hd->secure = secure;
@@ -49,30 +220,29 @@
 void
 md_enable( MD_HANDLE h, int algo )
 {
-    if( algo == DIGEST_ALGO_MD5 ) {
-	if( !h->use_md5 )
-	    md5_init( &h->md5 );
-	h->use_md5 = 1;
-    }
-    else if( algo == DIGEST_ALGO_RMD160 ) {
-	if( !h->use_rmd160 )
-	    rmd160_init( &h->rmd160 );
-	h->use_rmd160 = 1;
-    }
-    else if( algo == DIGEST_ALGO_SHA1 ) {
-	if( !h->use_sha1 )
-	    sha1_init( &h->sha1 );
-	h->use_sha1 = 1;
-    }
-  #ifdef WITH_TIGER_HASH
-    else if( algo == DIGEST_ALGO_TIGER ) {
-	if( !h->use_tiger )
-	    tiger_init( &h->tiger );
-	h->use_tiger = 1;
-    }
-  #endif
-    else
-	log_bug("md_enable(%d)", algo );
+    struct md_digest_list_s *r, *ac;
+
+    for( ac=h->list; ac; ac = ac->next )
+	if( ac->algo == algo )
+	    return ; /* already enabled */
+    /* find the algorithm */
+    do {
+	for(r = digest_list; r; r = r->next )
+	    if( r->algo == algo )
+		break;
+    } while( !r && load_digest_modules() );
+    if( !r ) {
+	log_error("md_enable: algorithm %d not available\n", algo );
+	return;
+    }
+    /* and allocate a new list entry */
+    ac = h->secure? m_alloc_secure( sizeof *ac + r->contextsize )
+		  : m_alloc( sizeof *ac + r->contextsize );
+    *ac = *r;
+    ac->next = h->list;
+    h->list = ac;
+    /* and init this instance */
+    (*ac->init)( &ac->context );
 }
 
 
@@ -80,10 +250,21 @@
 md_copy( MD_HANDLE a )
 {
     MD_HANDLE b;
+    struct md_digest_list_s *ar, *br;
 
     b = a->secure ? m_alloc_secure( sizeof *b )
 		  : m_alloc( sizeof *b );
     memcpy( b, a, sizeof *a );
+    b->list = NULL;
+    /* and now copy the compelte list of algorithms */
+    /* I know that the copied list is reversed, but that doesn't matter */
+    for( ar=a->list; ar; ar = ar->next ) {
+	br = a->secure ? m_alloc_secure( sizeof *br + ar->contextsize )
+		       : m_alloc( sizeof *br + ar->contextsize );
+	memcpy( br, ar, sizeof(*br) + ar->contextsize );
+	br->next = b->list;
+	b->list = br;
+    }
     return b;
 }
 
@@ -91,10 +272,16 @@
 void
 md_close(MD_HANDLE a)
 {
+    struct md_digest_list_s *r, *r2;
+
     if( !a )
 	return;
     if( a->debug )
 	md_stop_debug(a);
+    for(r=a->list; r; r = r2 ) {
+	r2 = r->next;
+	m_free(r);
+    }
     m_free(a);
 }
 
@@ -102,29 +289,17 @@
 void
 md_write( MD_HANDLE a, byte *inbuf, size_t inlen)
 {
+    struct md_digest_list_s *r;
+
     if( a->debug ) {
 	if( a->bufcount && fwrite(a->buffer, a->bufcount, 1, a->debug ) != 1 )
 	    BUG();
 	if( inlen && fwrite(inbuf, inlen, 1, a->debug ) != 1 )
 	    BUG();
     }
-    if( a->use_rmd160 ) {
-	rmd160_write( &a->rmd160, a->buffer, a->bufcount );
-	rmd160_write( &a->rmd160, inbuf, inlen	);
-    }
-    if( a->use_sha1 ) {
-	sha1_write( &a->sha1, a->buffer, a->bufcount );
-	sha1_write( &a->sha1, inbuf, inlen  );
-    }
-  #ifdef WITH_TIGER_HASH
-    if( a->use_tiger ) {
-	tiger_write( &a->tiger, a->buffer, a->bufcount );
-	tiger_write( &a->tiger, inbuf, inlen  );
-    }
-  #endif
-    if( a->use_md5 ) {
-	md5_write( &a->md5, a->buffer, a->bufcount );
-	md5_write( &a->md5, inbuf, inlen  );
+    for(r=a->list; r; r = r->next ) {
+	(*r->write)( &r->context, a->buffer, a->bufcount );
+	(*r->write)( &r->context, inbuf, inlen );
     }
     a->bufcount = 0;
 }
@@ -134,18 +309,14 @@
 void
 md_final(MD_HANDLE a)
 {
+    struct md_digest_list_s *r;
+
     if( a->bufcount )
 	md_write( a, NULL, 0 );
-    if( a->use_rmd160 )
-	rmd160_final( &a->rmd160 );
-    if( a->use_sha1 )
-	sha1_final( &a->sha1 );
-  #ifdef WITH_TIGER_HASH
-    if( a->use_tiger )
-	tiger_final( &a->tiger );
-  #endif
-    if( a->use_md5 )
-	md5_final( &a->md5 );
+
+    for(r=a->list; r; r = r->next ) {
+	(*r->final)( &r->context );
+    }
 }
 
 
@@ -155,46 +326,34 @@
 byte *
 md_read( MD_HANDLE a, int algo )
 {
-    if( !algo ) {
-	if( a->use_rmd160 )
-	    return rmd160_read( &a->rmd160 );
-	if( a->use_sha1 )
-	    return sha1_read( &a->sha1 );
-      #ifdef WITH_TIGER_HASH
-	if( a->use_tiger )
-	    return tiger_read( &a->tiger );
-      #endif
-	if( a->use_md5 )
-	    return md5_read( &a->md5 );
+    struct md_digest_list_s *r;
+
+    if( !algo ) {  /* return the first algorithm */
+	if( (r=a->list) ) {
+	    if( r->next )
+		log_error("warning: more than algorithm in md_read(0)\n");
+	    return (*r->read)( &r->context );
+	}
     }
     else {
-	if( algo == DIGEST_ALGO_RMD160 )
-	    return rmd160_read( &a->rmd160 );
-	if( algo == DIGEST_ALGO_SHA1 )
-	    return sha1_read( &a->sha1 );
-      #ifdef WITH_TIGER_HASH
-	if( algo == DIGEST_ALGO_TIGER )
-	    return tiger_read( &a->tiger );
-      #endif
-	if( algo == DIGEST_ALGO_MD5 )
-	    return md5_read( &a->md5 );
+	for(r=a->list; r; r = r->next )
+	    if( r->algo == algo )
+		return (*r->read)( &r->context );
     }
     BUG();
+    return NULL;
 }
 
 int
 md_get_algo( MD_HANDLE a )
 {
-    if( a->use_rmd160 )
-	return DIGEST_ALGO_RMD160;
-    if( a->use_sha1 )
-	return DIGEST_ALGO_SHA1;
-  #ifdef WITH_TIGER_HASH
-    if( a->use_tiger )
-	return DIGEST_ALGO_TIGER;
-  #endif
-    if( a->use_md5 )
-	return DIGEST_ALGO_MD5;
+    struct md_digest_list_s *r;
+
+    if( (r=a->list) ) {
+	if( r->next )
+	    log_error("warning: more than algorithm in md_get_algo()\n");
+	return r->algo;
+    }
     return 0;
 }
 
@@ -204,69 +363,39 @@
 int
 md_digest_length( int algo )
 {
-    switch( algo ) {
-      case DIGEST_ALGO_TIGER:
-	return 24;
-      case DIGEST_ALGO_RMD160:
-      case DIGEST_ALGO_SHA1:
-	return 20;
-      default:
-	return 16;
-    }
+    struct md_digest_list_s *r;
+
+    do {
+	for(r = digest_list; r; r = r->next ) {
+	    if( r->algo == algo )
+		return r->mdlen;
+	}
+    } while( !r && load_digest_modules() );
+    log_error("warning: no length for md algo %d\n", algo);
+    return 0;
 }
 
 
-/* fixme: put the oids in a table and add a mode to enumerate the OIDs
- * to make g10/sig-check.c more portable */
+/* fixme: add a mode to enumerate the OIDs
+ *	  to make g10/sig-check.c more portable */
 const byte *
 md_asn_oid( int algo, size_t *asnlen, size_t *mdlen )
 {
-    size_t alen;
-    byte *p;
+    struct md_digest_list_s *r;
 
-    if( algo == DIGEST_ALGO_MD5 ) {
-	static byte asn[18] = /* Object ID is 1.2.840.113549.2.5 */
-		    { 0x30, 0x20, 0x30, 0x0c, 0x06, 0x08, 0x2a, 0x86,0x48,
-		      0x86, 0xf7, 0x0d, 0x02, 0x05, 0x05, 0x00, 0x04, 0x10 };
-	alen = DIM(asn); p = asn;
-    }
-    else if( algo == DIGEST_ALGO_RMD160 ) {
-	static byte asn[15] = /* Object ID is 1.3.36.3.2.1 */
-	  { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x24, 0x03,
-	    0x02, 0x01, 0x05, 0x00, 0x04, 0x14 };
-	alen = DIM(asn); p = asn;
-    }
-    else if( algo == DIGEST_ALGO_TIGER ) {
-	/* 40: SEQUENCE {
-	 * 12:	 SEQUENCE {
-	 *  8:	   OCTET STRING   :54 49 47 45 52 31 39 32
-	 *  0:	   NULL
-	 *   :	   }
-	 * 24:	 OCTET STRING
-	 *   :	 }
-	 *
-	 * By replacing the 5th byte (0x04) with 0x16 we would have;
-	 *	  8:	 IA5String 'TIGER192'
-	 */
-	static byte asn[18] =
-		    { 0x30, 0x28, 0x30, 0x0c, 0x04, 0x08, 0x54, 0x49, 0x47,
-		      0x45, 0x52, 0x31, 0x39, 0x32, 0x05, 0x00, 0x04, 0x18 };
-	alen = DIM(asn); p = asn;
-    }
-    else if( algo == DIGEST_ALGO_SHA1 ) {
-	static byte asn[15] = /* Object ID is 1.3.14.3.2.26 */
-		    { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x0e, 0x03,
-		      0x02, 0x1a, 0x05, 0x00, 0x04, 0x14 };
-	alen = DIM(asn); p = asn;
-    }
-    else
-	log_bug("md_asn_oid(%d)", algo );
-
-    if( asnlen )
-	*asnlen = alen;
-    if( mdlen )
-	*mdlen = p[alen-1];
-    return p;
+    do {
+	for(r = digest_list; r; r = r->next ) {
+	    if( r->algo == algo ) {
+		if( asnlen )
+		    *asnlen = r->asnlen;
+		if( mdlen )
+		    *mdlen = r->mdlen;
+		return r->asnoid;
+	    }
+	}
+    } while( !r && load_digest_modules() );
+    log_bug("warning: no asn for md algo %d\n", algo);
+    return NULL;
 }
 
 
diff -urN gnupg-0.2.19/cipher/md.h gnupg-0.3.0/cipher/md.h
--- gnupg-0.2.19/cipher/md.h	Fri May  8 17:33:06 1998
+++ gnupg-0.3.0/cipher/md.h	Thu Jan  1 01:00:00 1970
@@ -1,72 +0,0 @@
-/* md.h - digest functions
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-#ifndef G10_MD_H
-#define G10_MD_H
-
-#include <stdio.h>
-#include "types.h"
-#include "rmd.h"
-#include "sha1.h"
-#include "md5.h"
-#include "tiger.h"
-
-#define MD_BUFFER_SIZE 512
-
-typedef struct {
-    int use_rmd160;
-    RMD160_CONTEXT rmd160;
-    int use_sha1;
-    SHA1_CONTEXT sha1;
-  #ifdef WITH_TIGER_HASH
-    int use_tiger;
-    TIGER_CONTEXT tiger;
-  #endif
-    int use_md5;
-    MD5_CONTEXT md5;
-    byte buffer[MD_BUFFER_SIZE]; /* primary buffer */
-    int  bufcount;
-    int  secure;
-    FILE  *debug;
-} *MD_HANDLE;
-
-
-#define md_putc(h,c)					    \
-	    do {					    \
-		if( (h)->bufcount == MD_BUFFER_SIZE )	    \
-		    md_write( (h), NULL, 0 );		    \
-		(h)->buffer[(h)->bufcount++] = (c) & 0xff;  \
-	    } while(0)
-
-/*-- md.c --*/
-MD_HANDLE md_open( int algo, int secure );
-void md_enable( MD_HANDLE hd, int algo );
-MD_HANDLE md_copy( MD_HANDLE a );
-void md_close(MD_HANDLE a);
-void md_write( MD_HANDLE a, byte *inbuf, size_t inlen);
-void md_final(MD_HANDLE a);
-byte *md_read( MD_HANDLE a, int algo );
-int md_get_algo( MD_HANDLE a );
-int md_digest_length( int algo );
-const byte *md_asn_oid( int algo, size_t *asnlen, size_t *mdlen );
-void md_start_debug( MD_HANDLE a, const char *suffix );
-void md_stop_debug( MD_HANDLE a );
-#define md_is_secure(a) ((a)->secure)
-
-#endif /*G10_MD_H*/
diff -urN gnupg-0.2.19/cipher/md5.c gnupg-0.3.0/cipher/md5.c
--- gnupg-0.2.19/cipher/md5.c	Tue Apr 14 19:01:34 1998
+++ gnupg-0.3.0/cipher/md5.c	Tue Jun 16 10:59:29 1998
@@ -38,6 +38,15 @@
 #include "memory.h"
 
 
+typedef struct {
+    u32 A,B,C,D;	  /* chaining variables */
+    u32 total[2];
+    u32  buflen;
+    char buffer[128];
+} MD5_CONTEXT;
+
+
+
 #ifdef BIG_ENDIAN_HOST
   #define SWAP(n) \
     (((n) << 24) | (((n) & 0xff00) << 8) | (((n) >> 8) & 0xff00) | ((n) >> 24))
@@ -49,7 +58,7 @@
    64-byte boundary.  (RFC 1321, 3.1: Step 1)  */
 static const unsigned char fillbuf[64] = { 0x80, 0 /* , 0, 0, ...  */ };
 
-void
+static void
 md5_init( MD5_CONTEXT *ctx )
 {
     ctx->A = 0x67452301;
@@ -237,7 +246,7 @@
  * account for the presence of each of the characters inBuf[0..inLen-1]
  * in the message whose digest is being computed.
  */
-void
+static void
 md5_write( MD5_CONTEXT *ctx, const void *buffer, size_t len)
 {
     /* When we already have some bits in our internal buffer concatenate
@@ -287,7 +296,7 @@
  * Returns 16 bytes representing the digest.
  */
 
-void
+static void
 md5_final( MD5_CONTEXT *ctx )
 {
     /* Take yet unprocessed bytes into account.  */
@@ -315,6 +324,46 @@
     ((u32 *)ctx->buffer)[1] = SWAP (ctx->B);
     ((u32 *)ctx->buffer)[2] = SWAP (ctx->C);
     ((u32 *)ctx->buffer)[3] = SWAP (ctx->D);
+}
+
+static byte *
+md5_read( MD5_CONTEXT *hd )
+{
+    return hd->buffer;
+}
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+const char *
+md5_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asnlen, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     )
+{
+    static byte asn[18] = /* Object ID is 1.2.840.113549.2.5 */
+		    { 0x30, 0x20, 0x30, 0x0c, 0x06, 0x08, 0x2a, 0x86,0x48,
+		      0x86, 0xf7, 0x0d, 0x02, 0x05, 0x05, 0x00, 0x04, 0x10 };
+
+    if( algo != 1 )
+	return NULL;
+
+    *contextsize = sizeof(MD5_CONTEXT);
+    *r_asnoid = asn;
+    *r_asnlen = DIM(asn);
+    *r_mdlen = 16;
+    *r_init  = (void (*)(void *))md5_init;
+    *r_write = (void (*)(void *, byte*, size_t))md5_write;
+    *r_final = (void (*)(void *))md5_final;
+    *r_read  = (byte *(*)(void *))md5_read;
+
+    return "MD5";
 }
 
 
diff -urN gnupg-0.2.19/cipher/md5.h gnupg-0.3.0/cipher/md5.h
--- gnupg-0.2.19/cipher/md5.h	Tue Feb 24 12:32:59 1998
+++ gnupg-0.3.0/cipher/md5.h	Tue Jun 16 11:38:22 1998
@@ -20,19 +20,15 @@
 #ifndef G10_MD5_H
 #define G10_MD5_H
 
-#include "types.h"
 
-typedef struct {
-    u32 A,B,C,D;	  /* chaining variables */
-    u32 total[2];
-    u32  buflen;
-    char buffer[128];
-} MD5_CONTEXT;
+const char *
+md5_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asn_len, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     );
 
-
-void md5_init( MD5_CONTEXT *ctx );
-void md5_write( MD5_CONTEXT *ctx, const void *buffer, size_t len);
-void md5_final( MD5_CONTEXT *ctx);
-#define md5_read(h) ( (h)->buffer )
 
 #endif /*G10_MD5_H*/
diff -urN gnupg-0.2.19/cipher/misc.c gnupg-0.3.0/cipher/misc.c
--- gnupg-0.2.19/cipher/misc.c	Thu May 28 15:28:15 1998
+++ gnupg-0.3.0/cipher/misc.c	Thu Jan  1 01:00:00 1970
@@ -1,175 +0,0 @@
-/* misc.c  -  utility functions
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-
-#include <config.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <errno.h>
-#include "util.h"
-#include "cipher.h"
-
-
-static struct { const char *name; int algo;} pubkey_names[] = {
-    { "RSA",           PUBKEY_ALGO_RSA     },
-    { "RSA-E",         PUBKEY_ALGO_RSA_E   },
-    { "RSA-S",         PUBKEY_ALGO_RSA_S   },
-    { "ELG",           PUBKEY_ALGO_ELGAMAL },
-    { "ELG-E",         PUBKEY_ALGO_ELGAMAL_E },
-    { "ELGAMAL",       PUBKEY_ALGO_ELGAMAL },
-    { "DSA",           PUBKEY_ALGO_DSA     },
-    {NULL} };
-
-/* Note: the first string is the one used by ascii armor */
-static struct { const char *name; int algo;} digest_names[] = {
-    { "MD5",           DIGEST_ALGO_MD5    },
-    { "SHA1",          DIGEST_ALGO_SHA1   },
-    { "SHA-1",         DIGEST_ALGO_SHA1   },
-    { "RIPEMD160",     DIGEST_ALGO_RMD160 },
-    { "RMD160",        DIGEST_ALGO_RMD160 },
-    { "RMD-160",       DIGEST_ALGO_RMD160 },
-    { "RIPE-MD-160",   DIGEST_ALGO_RMD160 },
-    { "TIGER",         DIGEST_ALGO_TIGER  },
-    {NULL} };
-
-
-
-
-
-/****************
- * Map a string to the pubkey algo
- */
-int
-string_to_pubkey_algo( const char *string )
-{
-    int i;
-    const char *s;
-
-    for(i=0; (s=pubkey_names[i].name); i++ )
-	if( !stricmp( s, string ) )
-	    return pubkey_names[i].algo;
-    return 0;
-}
-
-
-/****************
- * Map a pubkey algo to a string
- */
-const char *
-pubkey_algo_to_string( int algo )
-{
-    int i;
-
-    if( is_ELGAMAL(algo) )
-	algo = PUBKEY_ALGO_ELGAMAL;
-    else if( is_RSA(algo) )
-	algo = PUBKEY_ALGO_RSA;
-
-    for(i=0; pubkey_names[i].name; i++ )
-	if( pubkey_names[i].algo == algo )
-	    return pubkey_names[i].name;
-    return NULL;
-}
-
-
-
-/****************
- * Map a string to the digest algo
- */
-int
-string_to_digest_algo( const char *string )
-{
-    int i;
-    const char *s;
-
-    for(i=0; (s=digest_names[i].name); i++ )
-	if( !stricmp( s, string ) )
-	    return digest_names[i].algo;
-    return 0;
-}
-
-
-/****************
- * Map a digest algo to a string
- */
-const char *
-digest_algo_to_string( int algo )
-{
-    int i;
-
-    for(i=0; digest_names[i].name; i++ )
-	if( digest_names[i].algo == algo )
-	    return digest_names[i].name;
-    return NULL;
-}
-
-
-
-
-int
-check_pubkey_algo( int algo )
-{
-    return check_pubkey_algo2( algo, 0 );
-}
-
-/****************
- * a usage of 0 means: don't care
- */
-int
-check_pubkey_algo2( int algo, unsigned usage )
-{
-    switch( algo ) {
-      case PUBKEY_ALGO_DSA:
-	if( usage & 2 )
-	    return G10ERR_WR_PUBKEY_ALGO;
-	return 0;
-
-      case PUBKEY_ALGO_ELGAMAL:
-      case PUBKEY_ALGO_ELGAMAL_E:
-	return 0;
-
-    #ifdef HAVE_RSA_CIPHER
-      case PUBKEY_ALGO_RSA:
-	return 0;
-    #endif
-      default:
-	return G10ERR_PUBKEY_ALGO;
-    }
-}
-
-
-int
-check_digest_algo( int algo )
-{
-    switch( algo ) {
-    #ifdef WITH_TIGER_HASH
-      case DIGEST_ALGO_TIGER:
-    #endif
-      case DIGEST_ALGO_MD5:
-      case DIGEST_ALGO_RMD160:
-      case DIGEST_ALGO_SHA1:
-	return 0;
-      default:
-	return G10ERR_DIGEST_ALGO;
-    }
-}
-
-
-
diff -urN gnupg-0.2.19/cipher/primegen.c gnupg-0.3.0/cipher/primegen.c
--- gnupg-0.2.19/cipher/primegen.c	Tue May  5 22:26:51 1998
+++ gnupg-0.3.0/cipher/primegen.c	Sat Jun 13 10:09:58 1998
@@ -112,6 +112,8 @@
 
     /* make a pool of 3n+5 primes (this is an arbitrary value) */
     m = n*3+5;
+    if( mode == 1 )
+	m += 5; /* need some more for DSA */
     if( m < 25 )
 	m = 25;
     pool = m_alloc_clear( m * sizeof *pool );
diff -urN gnupg-0.2.19/cipher/pubkey.c gnupg-0.3.0/cipher/pubkey.c
--- gnupg-0.2.19/cipher/pubkey.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/cipher/pubkey.c	Tue Jun 16 12:13:17 1998
@@ -0,0 +1,535 @@
+/* pubkey.c  -	pubkey dispatcher
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <assert.h>
+#include "util.h"
+#include "errors.h"
+#include "mpi.h"
+#include "cipher.h"
+#include "elgamal.h"
+#include "dsa.h"
+#include "dynload.h"
+
+
+#define TABLE_SIZE 10
+
+struct pubkey_table_s {
+    const char *name;
+    int algo;
+    int npkey;
+    int nskey;
+    int nenc;
+    int nsig;
+    int usage;
+    int (*generate)( int algo, unsigned nbits, MPI *skey, MPI **retfactors );
+    int (*check_secret_key)( int algo, MPI *skey );
+    int (*encrypt)( int algo, MPI *resarr, MPI data, MPI *pkey );
+    int (*decrypt)( int algo, MPI *result, MPI *data, MPI *skey );
+    int (*sign)( int algo, MPI *resarr, MPI data, MPI *skey );
+    int (*verify)( int algo, MPI hash, MPI *data, MPI *pkey,
+		   int (*cmp)(void *, MPI), void *opaquev );
+    unsigned (*get_nbits)( int algo, MPI *pkey );
+};
+
+static struct pubkey_table_s pubkey_table[TABLE_SIZE];
+
+
+
+static int
+dummy_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors )
+{ log_bug("no generate() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static int
+dummy_check_secret_key( int algo, MPI *skey )
+{ log_bug("no check_secret_key() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static int
+dummy_encrypt( int algo, MPI *resarr, MPI data, MPI *pkey )
+{ log_bug("no encrypt() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static int
+dummy_decrypt( int algo, MPI *result, MPI *data, MPI *skey )
+{ log_bug("no decrypt() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static int
+dummy_sign( int algo, MPI *resarr, MPI data, MPI *skey )
+{ log_bug("no sign() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static int
+dummy_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		int (*cmp)(void *, MPI), void *opaquev )
+{ log_bug("no verify() for %d\n", algo ); return G10ERR_PUBKEY_ALGO; }
+
+static unsigned
+dummy_get_nbits( int algo, MPI *pkey )
+{ log_bug("no get_nbits() for %d\n", algo ); return 0; }
+
+
+/****************
+ * Put the static entries into the table.
+ */
+static void
+setup_pubkey_table()
+{
+    int i;
+
+    i = 0;
+    pubkey_table[i].algo = PUBKEY_ALGO_ELGAMAL;
+    pubkey_table[i].name = elg_get_info( pubkey_table[i].algo,
+					 &pubkey_table[i].npkey,
+					 &pubkey_table[i].nskey,
+					 &pubkey_table[i].nenc,
+					 &pubkey_table[i].nsig,
+					 &pubkey_table[i].usage );
+    pubkey_table[i].generate	     = elg_generate;
+    pubkey_table[i].check_secret_key = elg_check_secret_key;
+    pubkey_table[i].encrypt	     = elg_encrypt;
+    pubkey_table[i].decrypt	     = elg_decrypt;
+    pubkey_table[i].sign	     = elg_sign;
+    pubkey_table[i].verify	     = elg_verify;
+    pubkey_table[i].get_nbits	     = elg_get_nbits;
+    if( !pubkey_table[i].name )
+	BUG();
+    i++;
+    pubkey_table[i].algo = PUBKEY_ALGO_ELGAMAL_E;
+    pubkey_table[i].name = elg_get_info( pubkey_table[i].algo,
+					 &pubkey_table[i].npkey,
+					 &pubkey_table[i].nskey,
+					 &pubkey_table[i].nenc,
+					 &pubkey_table[i].nsig,
+					 &pubkey_table[i].usage );
+    pubkey_table[i].generate	     = elg_generate;
+    pubkey_table[i].check_secret_key = elg_check_secret_key;
+    pubkey_table[i].encrypt	     = elg_encrypt;
+    pubkey_table[i].decrypt	     = elg_decrypt;
+    pubkey_table[i].sign	     = elg_sign;
+    pubkey_table[i].verify	     = elg_verify;
+    pubkey_table[i].get_nbits	     = elg_get_nbits;
+    if( !pubkey_table[i].name )
+	BUG();
+    i++;
+    pubkey_table[i].algo = PUBKEY_ALGO_DSA;
+    pubkey_table[i].name = dsa_get_info( pubkey_table[i].algo,
+					 &pubkey_table[i].npkey,
+					 &pubkey_table[i].nskey,
+					 &pubkey_table[i].nenc,
+					 &pubkey_table[i].nsig,
+					 &pubkey_table[i].usage );
+    pubkey_table[i].generate	     = dsa_generate;
+    pubkey_table[i].check_secret_key = dsa_check_secret_key;
+    pubkey_table[i].encrypt	     = dummy_encrypt;
+    pubkey_table[i].decrypt	     = dummy_decrypt;
+    pubkey_table[i].sign	     = dsa_sign;
+    pubkey_table[i].verify	     = dsa_verify;
+    pubkey_table[i].get_nbits	     = dsa_get_nbits;
+    if( !pubkey_table[i].name )
+	BUG();
+    i++;
+
+    for( ; i < TABLE_SIZE; i++ )
+	pubkey_table[i].name = NULL;
+}
+
+
+/****************
+ * Try to load all modules and return true if new modules are available
+ */
+static int
+load_pubkey_modules()
+{
+    static int initialized = 0;
+    static int done = 0;
+    void *context = NULL;
+    struct pubkey_table_s *ct;
+    int ct_idx;
+    int i;
+    const char *name;
+    int any = 0;
+
+
+    if( !initialized ) {
+	setup_pubkey_table();
+	initialized = 1;
+	return 1;
+    }
+    if( done )
+	return 0;
+    done = 1;
+    for(ct_idx=0, ct = pubkey_table; ct_idx < TABLE_SIZE; ct_idx++,ct++ ) {
+	if( !ct->name )
+	    break;
+    }
+    if( ct_idx >= TABLE_SIZE-1 )
+	BUG(); /* table already full */
+    /* now load all extensions */
+    while( (name = enum_gnupgext_pubkeys( &context, &ct->algo,
+				&ct->npkey, &ct->nskey, &ct->nenc,
+				&ct->nsig,  &ct->usage,
+				&ct->generate,
+				&ct->check_secret_key,
+				&ct->encrypt,
+				&ct->decrypt,
+				&ct->sign,
+				&ct->verify,
+				&ct->get_nbits )) ) {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == ct->algo )
+		break;
+	if( pubkey_table[i].name ) {
+	    log_info("skipping pubkey %d: already loaded\n", ct->algo );
+	    continue;
+	}
+
+	if( !ct->generate  )  ct->generate = dummy_generate;
+	if( !ct->check_secret_key )  ct->check_secret_key =
+						    dummy_check_secret_key;
+	if( !ct->encrypt   )  ct->encrypt  = dummy_encrypt;
+	if( !ct->decrypt   )  ct->decrypt  = dummy_decrypt;
+	if( !ct->sign	   )  ct->sign	   = dummy_sign;
+	if( !ct->verify    )  ct->verify   = dummy_verify;
+	if( !ct->get_nbits )  ct->get_nbits= dummy_get_nbits;
+	/* put it into the table */
+	if( g10_opt_verbose > 1 )
+	    log_info("loaded pubkey %d (%s)\n", ct->algo, name);
+	ct->name = name;
+	ct_idx++;
+	ct++;
+	any = 1;
+	/* check whether there are more available table slots */
+	if( ct_idx >= TABLE_SIZE-1 ) {
+	    log_info("pubkey table full; ignoring other extensions\n");
+	    break;
+	}
+    }
+    enum_gnupgext_pubkeys( &context, NULL, NULL, NULL, NULL, NULL, NULL,
+			       NULL, NULL, NULL, NULL, NULL, NULL, NULL );
+    return any;
+}
+
+
+/****************
+ * Map a string to the pubkey algo
+ */
+int
+string_to_pubkey_algo( const char *string )
+{
+    int i;
+    const char *s;
+
+    do {
+	for(i=0; (s=pubkey_table[i].name); i++ )
+	    if( !stricmp( s, string ) )
+		return pubkey_table[i].algo;
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+
+/****************
+ * Map a pubkey algo to a string
+ */
+const char *
+pubkey_algo_to_string( int algo )
+{
+    int i;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return pubkey_table[i].name;
+    } while( load_pubkey_modules() );
+    return NULL;
+}
+
+
+
+int
+check_pubkey_algo( int algo )
+{
+    return check_pubkey_algo2( algo, 0 );
+}
+
+/****************
+ * a usage of 0 means: don't care
+ */
+int
+check_pubkey_algo2( int algo, unsigned usage )
+{
+    int i;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo ) {
+		if( (usage & 1) && !(pubkey_table[i].usage & 1) )
+		    return G10ERR_WR_PUBKEY_ALGO;
+		if( (usage & 2) && !(pubkey_table[i].usage & 2) )
+		    return G10ERR_WR_PUBKEY_ALGO;
+		return 0; /* okay */
+	    }
+    } while( load_pubkey_modules() );
+    return G10ERR_PUBKEY_ALGO;
+}
+
+
+
+
+/****************
+ * Return the number of public key material numbers
+ */
+int
+pubkey_get_npkey( int algo )
+{
+    int i;
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return pubkey_table[i].npkey;
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+/****************
+ * Return the number of secret key material numbers
+ */
+int
+pubkey_get_nskey( int algo )
+{
+    int i;
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return pubkey_table[i].nskey;
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+/****************
+ * Return the number of signature material numbers
+ */
+int
+pubkey_get_nsig( int algo )
+{
+    int i;
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return pubkey_table[i].nsig;
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+/****************
+ * Return the number of encryption material numbers
+ */
+int
+pubkey_get_nenc( int algo )
+{
+    int i;
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return pubkey_table[i].nenc;
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+/****************
+ * Get the number of nbits from the public key
+ */
+unsigned
+pubkey_nbits( int algo, MPI *pkey )
+{
+    int i;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return (*pubkey_table[i].get_nbits)( algo, pkey );
+    } while( load_pubkey_modules() );
+    return 0;
+}
+
+
+int
+pubkey_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors )
+{
+    int i;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return (*pubkey_table[i].generate)( algo, nbits,
+						    skey, retfactors );
+    } while( load_pubkey_modules() );
+    return G10ERR_PUBKEY_ALGO;
+}
+
+
+int
+pubkey_check_secret_key( int algo, MPI *skey )
+{
+    int i;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo )
+		return (*pubkey_table[i].check_secret_key)( algo, skey );
+    } while( load_pubkey_modules() );
+    return G10ERR_PUBKEY_ALGO;
+}
+
+
+/****************
+ * This is the interface to the public key encryption.
+ * Encrypt DATA with PKEY and put it into RESARR which
+ * should be an array of MPIs of size PUBKEY_MAX_NENC (or less if the
+ * algorithm allows this - check with pubkey_get_nenc() )
+ */
+int
+pubkey_encrypt( int algo, MPI *resarr, MPI data, MPI *pkey )
+{
+    int i, rc;
+
+    /* FIXME: check that data fits into the key (in xxx_encrypt)*/
+
+    if( DBG_CIPHER ) {
+	log_debug("pubkey_encrypt: algo=%d\n", algo );
+	for(i=0; i < pubkey_get_npkey(algo); i++ )
+	    log_mpidump("  pkey:", pkey[i] );
+	log_mpidump("  data:", data );
+    }
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo ) {
+		rc = (*pubkey_table[i].encrypt)( algo, resarr, data, pkey );
+		goto ready;
+	    }
+    } while( load_pubkey_modules() );
+    rc = G10ERR_PUBKEY_ALGO;
+  ready:
+    if( !rc && DBG_CIPHER ) {
+	for(i=0; i < pubkey_get_nenc(algo); i++ )
+	    log_mpidump("  encr:", resarr[i] );
+    }
+    return rc;
+}
+
+
+
+/****************
+ * This is the interface to the public key decryption.
+ * ALGO gives the algorithm to use and this implicitly determines
+ * the size of the arrays.
+ * result is a pointer to a mpi variable which will receive a
+ * newly allocated mpi or NULL in case of an error.
+ */
+int
+pubkey_decrypt( int algo, MPI *result, MPI *data, MPI *skey )
+{
+    int i, rc;
+
+    *result = NULL; /* so the caller can always do an mpi_free */
+    if( DBG_CIPHER ) {
+	log_debug("pubkey_decrypt: algo=%d\n", algo );
+	for(i=0; i < pubkey_get_nskey(algo); i++ )
+	    log_mpidump("  skey:", skey[i] );
+	for(i=0; i < pubkey_get_nenc(algo); i++ )
+	    log_mpidump("  data:", data[i] );
+    }
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo ) {
+		rc = (*pubkey_table[i].decrypt)( algo, result, data, skey );
+		goto ready;
+	    }
+    } while( load_pubkey_modules() );
+    rc = G10ERR_PUBKEY_ALGO;
+  ready:
+    if( !rc && DBG_CIPHER ) {
+	log_mpidump(" plain:", *result );
+    }
+    return rc;
+}
+
+
+/****************
+ * This is the interface to the public key signing.
+ * Sign hash with skey and put the result into resarr which
+ * should be an array of MPIs of size PUBKEY_MAX_NSIG (or less if the
+ * algorithm allows this - check with pubkey_get_nsig() )
+ */
+int
+pubkey_sign( int algo, MPI *resarr, MPI data, MPI *skey )
+{
+    int i, rc;
+
+    if( DBG_CIPHER ) {
+	log_debug("pubkey_sign: algo=%d\n", algo );
+	for(i=0; i < pubkey_get_nskey(algo); i++ )
+	    log_mpidump("  skey:", skey[i] );
+	log_mpidump("  data:", data );
+    }
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo ) {
+		rc = (*pubkey_table[i].sign)( algo, resarr, data, skey );
+		goto ready;
+	    }
+    } while( load_pubkey_modules() );
+    rc = G10ERR_PUBKEY_ALGO;
+  ready:
+    if( !rc && DBG_CIPHER ) {
+	for(i=0; i < pubkey_get_nsig(algo); i++ )
+	    log_mpidump("   sig:", resarr[i] );
+    }
+    return rc;
+}
+
+/****************
+ * Verify a public key signature.
+ * Return 0 if the signature is good
+ */
+int
+pubkey_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		    int (*cmp)(void *, MPI), void *opaquev )
+{
+    int i, rc;
+
+    do {
+	for(i=0; pubkey_table[i].name; i++ )
+	    if( pubkey_table[i].algo == algo ) {
+		rc = (*pubkey_table[i].verify)( algo, hash, data, pkey,
+							    cmp, opaquev );
+		goto ready;
+	    }
+    } while( load_pubkey_modules() );
+    rc = G10ERR_PUBKEY_ALGO;
+  ready:
+    return rc;
+}
+
diff -urN gnupg-0.2.19/cipher/rand-dummy.c gnupg-0.3.0/cipher/rand-dummy.c
--- gnupg-0.2.19/cipher/rand-dummy.c	Sun May 10 21:15:20 1998
+++ gnupg-0.3.0/cipher/rand-dummy.c	Thu Jun 11 09:19:24 1998
@@ -69,7 +69,7 @@
 {
   #if HAVE_GETHRTIME
     {	hrtime_t tv;
-	tv = gethrtime(void);
+	tv = gethrtime();
 	add_randomness( &tv, sizeof(tv), 1 );
     }
   #elif HAVE_GETTIMEOFTIME
diff -urN gnupg-0.2.19/cipher/rand-unix.c gnupg-0.3.0/cipher/rand-unix.c
--- gnupg-0.2.19/cipher/rand-unix.c	Mon May 25 19:11:45 1998
+++ gnupg-0.3.0/cipher/rand-unix.c	Thu Jun 18 11:59:57 1998
@@ -124,21 +124,16 @@
     int n;
     int warn=0;
 
-    if( level == 2 ) {
+    if( level >= 2 ) {
 	if( fd_random == -1 )
 	    fd_random = open_device( "/dev/random", 8 );
 	fd = fd_random;
     }
     else {
-	/* fixme: we should use a simpler one for level 0,
-	 * because reading from /dev/urandom removes entropy
-	 * and the next read on /dev/random may have to wait */
 	if( fd_urandom == -1 )
 	    fd_urandom = open_device( "/dev/urandom", 9 );
 	fd = fd_urandom;
     }
-
-
     do {
 	fd_set rfds;
 	struct timeval tv;
diff -urN gnupg-0.2.19/cipher/random.c gnupg-0.3.0/cipher/random.c
--- gnupg-0.2.19/cipher/random.c	Sun May 10 21:25:06 1998
+++ gnupg-0.3.0/cipher/random.c	Thu Jun 18 12:17:53 1998
@@ -211,10 +211,6 @@
 
     if( length >= POOLSIZE )
 	BUG(); /* not allowed */
-    if( !level ) { /* read simple random bytes */
-	read_random_source( buffer, length, level );
-	return;
-    }
 
     /* for level 2 make sure that there is enough random in the pool */
     if( level == 2 && pool_balance < length ) {
@@ -236,33 +232,45 @@
     /* make sure the pool is filled */
     while( !pool_filled )
 	random_poll();
+
     /* do always a fast random poll */
     fast_random_poll();
 
-    /* mix the pool (if add_randomness() didn't it) */
-    if( !just_mixed )
+    if( !level ) { /* no need for cryptographic strong random */
+	/* create a new pool */
+	for(i=0,dp=(ulong*)keypool, sp=(ulong*)rndpool;
+				    i < POOLWORDS; i++, dp++, sp++ )
+	    *dp = *sp + ADD_VALUE;
+	/* must mix both pools */
 	mix_pool(rndpool);
-
-    /* create a new pool */
-    for(i=0,dp=(ulong*)keypool, sp=(ulong*)rndpool;
-				i < POOLWORDS; i++, dp++, sp++ )
-	*dp = *sp + ADD_VALUE;
-    /* and mix both pools */
-    mix_pool(rndpool);
-    mix_pool(keypool);
-    /* read the required data
-     * we use a readpoiter to read from a different postion each
-     * time */
-    while( length-- ) {
-	*buffer++ = keypool[pool_readpos++];
-	if( pool_readpos >= POOLSIZE )
-	    pool_readpos = 0;
-	pool_balance--;
+	mix_pool(keypool);
+	memcpy( buffer, keypool, length );
+    }
+    else {
+	/* mix the pool (if add_randomness() didn't it) */
+	if( !just_mixed )
+	    mix_pool(rndpool);
+	/* create a new pool */
+	for(i=0,dp=(ulong*)keypool, sp=(ulong*)rndpool;
+				    i < POOLWORDS; i++, dp++, sp++ )
+	    *dp = *sp + ADD_VALUE;
+	/* and mix both pools */
+	mix_pool(rndpool);
+	mix_pool(keypool);
+	/* read the required data
+	 * we use a readpoiter to read from a different postion each
+	 * time */
+	while( length-- ) {
+	    *buffer++ = keypool[pool_readpos++];
+	    if( pool_readpos >= POOLSIZE )
+		pool_readpos = 0;
+	    pool_balance--;
+	}
+	if( pool_balance < 0 )
+	    pool_balance = 0;
+	/* and clear the keypool */
+	memset( keypool, 0, POOLSIZE );
     }
-    if( pool_balance < 0 )
-	pool_balance = 0;
-    /* and clear the keypool */
-    memset( keypool, 0, POOLSIZE );
 }
 
 
diff -urN gnupg-0.2.19/cipher/rmd.h gnupg-0.3.0/cipher/rmd.h
--- gnupg-0.2.19/cipher/rmd.h	Tue Mar  3 13:31:38 1998
+++ gnupg-0.3.0/cipher/rmd.h	Tue Jun 16 10:56:08 1998
@@ -20,8 +20,8 @@
 #ifndef G10_RMD_H
 #define G10_RMD_H
 
-#include "types.h"
 
+/* we need this here because random.c must have direct access */
 typedef struct {
     u32  h0,h1,h2,h3,h4;
     u32  nblocks;
@@ -29,11 +29,19 @@
     int  count;
 } RMD160_CONTEXT;
 
-
-void rmd160_init( RMD160_CONTEXT *c );
-void rmd160_write( RMD160_CONTEXT *hd, byte *inbuf, size_t inlen);
-void rmd160_final(RMD160_CONTEXT *hd);
+void rmd160_init( RMD160_CONTEXT *hd );
 void rmd160_mixblock( RMD160_CONTEXT *hd, char *buffer );
-#define rmd160_read(h) ( (h)->buf )
+
+
+
+const char *
+rmd160_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asn_len, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     );
+
 
 #endif /*G10_RMD_H*/
diff -urN gnupg-0.2.19/cipher/rmd160.c gnupg-0.3.0/cipher/rmd160.c
--- gnupg-0.2.19/cipher/rmd160.c	Fri May 15 13:45:58 1998
+++ gnupg-0.3.0/cipher/rmd160.c	Tue Jun 16 10:56:35 1998
@@ -27,6 +27,7 @@
 #include "memory.h"
 #include "rmd.h"
 
+
 /*********************************
  * RIPEMD-160 is not patented, see (as of 25.10.97)
  *   http://www.esat.kuleuven.ac.be/~bosselae/ripemd160.html
@@ -411,7 +412,7 @@
 /* Update the message digest with the contents
  * of INBUF with length INLEN.
  */
-void
+static void
 rmd160_write( RMD160_CONTEXT *hd, byte *inbuf, size_t inlen)
 {
     if( hd->count == 64 ) { /* flush the buffer */
@@ -443,7 +444,7 @@
 /****************
  * Apply the rmd160 transform function on the buffer which must have
  * a length 64 bytes. Do not use this function together with the
- * other functions, use rmd160_init to initialize intzernal variables.
+ * other functions, use rmd160_init to initialize internal variables.
  * Returns: 16 bytes in buffer with the mixed contentes of buffer.
  */
 void
@@ -464,7 +465,7 @@
 /* The routine terminates the computation
  */
 
-void
+static void
 rmd160_final( RMD160_CONTEXT *hd )
 {
     u32 t, msb, lsb;
@@ -523,4 +524,43 @@
   #undef X
 }
 
+static byte *
+rmd160_read( RMD160_CONTEXT *hd )
+{
+    return hd->buf;
+}
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+const char *
+rmd160_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asnlen, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     )
+{
+    static byte asn[15] = /* Object ID is 1.3.36.3.2.1 */
+	  { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x24, 0x03,
+	    0x02, 0x01, 0x05, 0x00, 0x04, 0x14 };
+
+    if( algo != 3 )
+	return NULL;
+
+    *contextsize = sizeof(RMD160_CONTEXT);
+    *r_asnoid = asn;
+    *r_asnlen = DIM(asn);
+    *r_mdlen = 20;
+    *r_init  = (void (*)(void *))rmd160_init;
+    *r_write = (void (*)(void *, byte*, size_t))rmd160_write;
+    *r_final = (void (*)(void *))rmd160_final;
+    *r_read  = (byte *(*)(void *))rmd160_read;
+
+    return "RIPEMD160";
+}
 
diff -urN gnupg-0.2.19/cipher/sha1.c gnupg-0.3.0/cipher/sha1.c
--- gnupg-0.2.19/cipher/sha1.c	Tue Apr 14 19:01:44 1998
+++ gnupg-0.3.0/cipher/sha1.c	Tue Jun 16 10:49:56 1998
@@ -41,6 +41,12 @@
 #include "sha1.h"
 
 
+typedef struct {
+    u32  h0,h1,h2,h3,h4;
+    u32  nblocks;
+    byte buf[64];
+    int  count;
+} SHA1_CONTEXT;
 
 
 #if defined(__GNUC__) && defined(__i386__)
@@ -216,7 +222,7 @@
 /* Update the message digest with the contents
  * of INBUF with length INLEN.
  */
-void
+static void
 sha1_write( SHA1_CONTEXT *hd, byte *inbuf, size_t inlen)
 {
     if( hd->count == 64 ) { /* flush the buffer */
@@ -253,7 +259,7 @@
  * Returns: 20 bytes representing the digest.
  */
 
-void
+static void
 sha1_final(SHA1_CONTEXT *hd)
 {
     u32 t, msb, lsb;
@@ -313,4 +319,42 @@
 
 }
 
+static byte *
+sha1_read( SHA1_CONTEXT *hd )
+{
+    return hd->buf;
+}
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+const char *
+sha1_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asnlen, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     )
+{
+    static byte asn[15] = /* Object ID is 1.3.14.3.2.26 */
+		    { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x0e, 0x03,
+		      0x02, 0x1a, 0x05, 0x00, 0x04, 0x14 };
+    if( algo != 2 )
+	return NULL;
+
+    *contextsize = sizeof(SHA1_CONTEXT);
+    *r_asnoid = asn;
+    *r_asnlen = DIM(asn);
+    *r_mdlen = 20;
+    *r_init  = (void (*)(void *))sha1_init;
+    *r_write = (void (*)(void *, byte*, size_t))sha1_write;
+    *r_final = (void (*)(void *))sha1_final;
+    *r_read  = (byte *(*)(void *))sha1_read;
+
+    return "SHA1";
+}
 
diff -urN gnupg-0.2.19/cipher/sha1.h gnupg-0.3.0/cipher/sha1.h
--- gnupg-0.2.19/cipher/sha1.h	Mon Feb 23 13:12:57 1998
+++ gnupg-0.3.0/cipher/sha1.h	Tue Jun 16 10:35:15 1998
@@ -20,19 +20,14 @@
 #ifndef G10_SHA1_H
 #define G10_SHA1_H
 
-#include "types.h"
 
-typedef struct {
-    u32  h0,h1,h2,h3,h4;
-    u32  nblocks;
-    byte buf[64];
-    int  count;
-} SHA1_CONTEXT;
-
-
-void sha1_init( SHA1_CONTEXT *c );
-void sha1_write( SHA1_CONTEXT *hd, byte *inbuf, size_t inlen);
-void sha1_final( SHA1_CONTEXT *hd);
-#define sha1_read(h) ( (h)->buf )
+const char *
+sha1_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asn_len, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     );
 
 #endif /*G10_SHA1_H*/
diff -urN gnupg-0.2.19/cipher/tiger.c gnupg-0.3.0/cipher/tiger.c
--- gnupg-0.2.19/cipher/tiger.c	Tue May  5 08:32:10 1998
+++ gnupg-0.3.0/cipher/tiger.c	Thu Jun 25 11:05:04 1998
@@ -25,9 +25,15 @@
 #include <assert.h>
 #include "util.h"
 #include "memory.h"
-#include "tiger.h"
 
-#ifdef WITH_TIGER_HASH
+
+typedef struct {
+    u64  a, b, c;
+    u32  nblocks;
+    byte buf[64];
+    int  count;
+} TIGER_CONTEXT;
+
 
 /*********************************
  * Okay, okay, this is not the fastest code - improvements are welcome.
@@ -619,7 +625,7 @@
 }
 
 
-void
+static void
 tiger_init( TIGER_CONTEXT *hd )
 {
     hd->a = 0x0123456789abcdefLL;
@@ -703,10 +709,10 @@
     u64 x[8];
   #ifdef BIG_ENDIAN_HOST
     #define MKWORD(d,n) \
-		(  ((u64)(d)[8*(n)+0]) << 56 | ((u64)(d)[8*(n)+1]) << 48  \
-		 | ((u64)(d)[8*(n)+2]) << 40 | ((u64)(d)[8*(n)+3]) << 32  \
-		 | ((u64)(d)[8*(n)+4]) << 24 | ((u64)(d)[8*(n)+5]) << 16  \
-		 | ((u64)(d)[8*(n)+6]) << 8  | ((u64)(d)[8*(n)+7])	 )
+		(  ((u64)(d)[8*(n)+7]) << 56 | ((u64)(d)[8*(n)+6]) << 48  \
+		 | ((u64)(d)[8*(n)+5]) << 40 | ((u64)(d)[8*(n)+4]) << 32  \
+		 | ((u64)(d)[8*(n)+3]) << 24 | ((u64)(d)[8*(n)+2]) << 16  \
+		 | ((u64)(d)[8*(n)+1]) << 8  | ((u64)(d)[8*(n)	])	 )
     x[0] = MKWORD(data, 0);
     x[1] = MKWORD(data, 1);
     x[2] = MKWORD(data, 2);
@@ -752,7 +758,7 @@
 /* Update the message digest with the contents
  * of INBUF with length INLEN.
  */
-void
+static void
 tiger_write( TIGER_CONTEXT *hd, byte *inbuf, size_t inlen)
 {
     if( hd->count == 64 ) { /* flush the buffer */
@@ -786,7 +792,7 @@
 /* The routine terminates the computation
  */
 
-void
+static void
 tiger_final( TIGER_CONTEXT *hd )
 {
     u32 t, msb, lsb;
@@ -845,5 +851,118 @@
   #undef X
 }
 
-#endif /* WITH_TIGER_HASH */
+static byte *
+tiger_read( TIGER_CONTEXT *hd )
+{
+    return hd->buf;
+}
+
+/****************
+ * Return some information about the algorithm.  We need algo here to
+ * distinguish different flavors of the algorithm.
+ * Returns: A pointer to string describing the algorithm or NULL if
+ *	    the ALGO is invalid.
+ */
+static const char *
+tiger_get_info( int algo, size_t *contextsize,
+	       byte **r_asnoid, int *r_asnlen, int *r_mdlen,
+	       void (**r_init)( void *c ),
+	       void (**r_write)( void *c, byte *buf, size_t nbytes ),
+	       void (**r_final)( void *c ),
+	       byte *(**r_read)( void *c )
+	     )
+{
+    /* 40: SEQUENCE {
+     * 12:   SEQUENCE {
+     *	8:     OCTET STRING   :54 49 47 45 52 31 39 32
+     *	0:     NULL
+     *	 :     }
+     * 24:   OCTET STRING
+     *	 :   }
+     *
+     * By replacing the 5th byte (0x04) with 0x16 we would have;
+     *	      8:     IA5String 'TIGER192'
+     */
+    static byte asn[18] =
+		{ 0x30, 0x28, 0x30, 0x0c, 0x04, 0x08, 0x54, 0x49, 0x47,
+		  0x45, 0x52, 0x31, 0x39, 0x32, 0x05, 0x00, 0x04, 0x18 };
+
+    if( algo != 6 )
+	return NULL;
+
+    *contextsize = sizeof(TIGER_CONTEXT);
+    *r_asnoid = asn;
+    *r_asnlen = DIM(asn);
+    *r_mdlen = 24;
+    *r_init  = (void (*)(void *))tiger_init;
+    *r_write = (void (*)(void *, byte*, size_t))tiger_write;
+    *r_final = (void (*)(void *))tiger_final;
+    *r_read  = (byte *(*)(void *))tiger_read;
+
+    return "TIGER";
+}
+
+
+
+const char * const gnupgext_version = "TIGER ($Revision: 1.5 $)";
+
+static struct {
+    int class;
+    int version;
+    int  value;
+    void (*func)(void);
+} func_table[] = {
+    { 10, 1, 0, (void(*)(void))tiger_get_info },
+    { 11, 1, 6 },
+};
+
+
+
+/****************
+ * Enumerate the names of the functions together with informations about
+ * this function. Set sequence to an integer with a initial value of 0 and
+ * do not change it.
+ * If what is 0 all kind of functions are returned.
+ * Return values: class := class of function:
+ *			   10 = message digest algorithm info function
+ *			   11 = integer with available md algorithms
+ *			   20 = cipher algorithm info function
+ *			   21 = integer with available cipher algorithms
+ *			   30 = public key algorithm info function
+ *			   31 = integer with available pubkey algorithms
+ *		  version = interface version of the function/pointer
+ *			    (currently this is 1 for all functions)
+ */
+void *
+gnupgext_enum_func( int what, int *sequence, int *class, int *vers )
+{
+    void *ret;
+    int i = *sequence;
+
+    /*log_info("gnupgext_enum_func in rsa+idea called what=%d i=%d: ", what, i);*/
+    do {
+	if( i >= DIM(func_table) || i < 0 ) {
+	    /*fprintf(stderr, "failed\n");*/
+	    return NULL;
+	}
+	*class = func_table[i].class;
+	*vers  = func_table[i].version;
+	switch( *class ) {
+	  case 11:
+	  case 21:
+	  case 31:
+	    ret = &func_table[i].value;
+	    break;
+	  default:
+	    ret = func_table[i].func;
+	    break;
+	}
+	i++;
+    } while( what && what != *class );
+
+    *sequence = i;
+    /*fprintf(stderr, "success\n");*/
+    return ret;
+}
+
 
diff -urN gnupg-0.2.19/cipher/tiger.h gnupg-0.3.0/cipher/tiger.h
--- gnupg-0.2.19/cipher/tiger.h	Sun Apr 26 19:51:03 1998
+++ gnupg-0.3.0/cipher/tiger.h	Thu Jan  1 01:00:00 1970
@@ -1,44 +0,0 @@
-/* tiger.h  - TIGER hash function
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-#ifndef G10_TIGER_H
-#define G10_TIGER_H
-
-#include "types.h"
-
-#ifdef HAVE_U64_TYPEDEF
-
-#define WITH_TIGER_HASH 1
-
-typedef struct {
-    u64  a, b, c;
-    u32  nblocks;
-    byte buf[64];
-    int  count;
-} TIGER_CONTEXT;
-
-
-void tiger_init( TIGER_CONTEXT *c );
-void tiger_write( TIGER_CONTEXT *hd, byte *inbuf, size_t inlen);
-void tiger_final(TIGER_CONTEXT *hd);
-#define tiger_read(h) ( (h)->buf )
-
-#endif /* HAVE_TIGER_HASH */
-
-#endif /*G10_TIGER_H*/
diff -urN gnupg-0.2.19/config.h.in gnupg-0.3.0/config.h.in
--- gnupg-0.2.19/config.h.in	Fri May  8 18:46:28 1998
+++ gnupg-0.3.0/config.h.in	Thu Jun 11 09:27:31 1998
@@ -88,6 +88,7 @@
 #undef PACKAGE
 #undef G10_LOCALEDIR
 #undef PRINTABLE_OS_NAME
+#undef GNUPG_LIBDIR
 
 /* Define if your locale.h file contains LC_MESSAGES.  */
 #undef HAVE_LC_MESSAGES
@@ -120,11 +121,9 @@
 /* defined if we have a /dev/random and /dev/urandom */
 #undef HAVE_DEV_RANDOM
 
-/* RSA is only compiled in if you have these files. You can use
- * RSA without any restrictions, if your not in the U.S. or
- * wait until sep 20, 2000
- */
-#undef HAVE_RSA_CIPHER
+#undef USE_DYNAMIC_LINKING
+#undef HAVE_DL_DLOPEN
+#undef HAVE_DLD_DLD_LINK
 
 /* The number of bytes in a unsigned int.  */
 #undef SIZEOF_UNSIGNED_INT
@@ -236,6 +235,12 @@
 
 /* Define if you have the <zlib.h> header file.  */
 #undef HAVE_ZLIB_H
+
+/* Define if you have the dl library (-ldl).  */
+#undef HAVE_LIBDL
+
+/* Define if you have the dld library (-ldld).  */
+#undef HAVE_LIBDLD
 
 /* Define if you have the i library (-li).  */
 #undef HAVE_LIBI
diff -urN gnupg-0.2.19/configure gnupg-0.3.0/configure
--- gnupg-0.2.19/configure	Fri May 15 18:44:05 1998
+++ gnupg-0.3.0/configure	Thu Jun 25 13:06:37 1998
@@ -14,6 +14,8 @@
 ac_help="$ac_help
   --disable-dev-random    disable the use of dev random"
 ac_help="$ac_help
+  --disable-dynload	   disable dynamic loading"
+ac_help="$ac_help
   --enable-m-debug	   enable debugging of memory allocation"
 ac_help="$ac_help
   --disable-m-guard       disable memory guard facility"
@@ -590,8 +592,17 @@
 fi
 
 
+# Check whether --enable-dynload or --disable-dynload was given.
+if test "${enable_dynload+set}" = set; then
+  enableval="$enable_dynload"
+  try_dynload=$enableval
+else
+  try_dynload=yes
+fi
+
+
 echo $ac_n "checking whether memory debugging is requested""... $ac_c" 1>&6
-echo "configure:595: checking whether memory debugging is requested" >&5
+echo "configure:606: checking whether memory debugging is requested" >&5
 # Check whether --enable-m-debug or --disable-m-debug was given.
 if test "${enable_m_debug+set}" = set; then
   enableval="$enable_m_debug"
@@ -609,7 +620,7 @@
     use_m_guard=yes
 else
     echo $ac_n "checking whether memory guard is requested""... $ac_c" 1>&6
-echo "configure:613: checking whether memory guard is requested" >&5
+echo "configure:624: checking whether memory guard is requested" >&5
     # Check whether --enable-m-guard or --disable-m-guard was given.
 if test "${enable_m_guard+set}" = set; then
   enableval="$enable_m_guard"
@@ -632,7 +643,7 @@
 
 
 echo $ac_n "checking whether included zlib is requested""... $ac_c" 1>&6
-echo "configure:636: checking whether included zlib is requested" >&5
+echo "configure:647: checking whether included zlib is requested" >&5
 # Check whether --with-included-zlib or --without-included-zlib was given.
 if test "${with_included_zlib+set}" = set; then
   withval="$with_included_zlib"
@@ -672,7 +683,7 @@
 fi
 
 echo $ac_n "checking host system type""... $ac_c" 1>&6
-echo "configure:676: checking host system type" >&5
+echo "configure:687: checking host system type" >&5
 
 host_alias=$host
 case "$host_alias" in
@@ -693,7 +704,7 @@
 echo "$ac_t""$host" 1>&6
 
 echo $ac_n "checking target system type""... $ac_c" 1>&6
-echo "configure:697: checking target system type" >&5
+echo "configure:708: checking target system type" >&5
 
 target_alias=$target
 case "$target_alias" in
@@ -711,7 +722,7 @@
 echo "$ac_t""$target" 1>&6
 
 echo $ac_n "checking build system type""... $ac_c" 1>&6
-echo "configure:715: checking build system type" >&5
+echo "configure:726: checking build system type" >&5
 
 build_alias=$build
 case "$build_alias" in
@@ -734,7 +745,7 @@
   program_prefix=${target_alias}-
 
  echo $ac_n "checking cached information""... $ac_c" 1>&6
-echo "configure:738: checking cached information" >&5
+echo "configure:749: checking cached information" >&5
     wk_hostcheck="$target"
     if eval "test \"`echo '$''{'wk_cv_hostcheck'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -754,7 +765,7 @@
 
 
 echo $ac_n "checking whether ${MAKE-make} sets \${MAKE}""... $ac_c" 1>&6
-echo "configure:758: checking whether ${MAKE-make} sets \${MAKE}" >&5
+echo "configure:769: checking whether ${MAKE-make} sets \${MAKE}" >&5
 set dummy ${MAKE-make}; ac_make=`echo "$2" | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_prog_make_${ac_make}_set'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -802,7 +813,7 @@
 
 missing_dir=`cd $ac_aux_dir && pwd`
 echo $ac_n "checking for working aclocal""... $ac_c" 1>&6
-echo "configure:806: checking for working aclocal" >&5
+echo "configure:817: checking for working aclocal" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -815,7 +826,7 @@
 fi
 
 echo $ac_n "checking for working autoconf""... $ac_c" 1>&6
-echo "configure:819: checking for working autoconf" >&5
+echo "configure:830: checking for working autoconf" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -828,7 +839,7 @@
 fi
 
 echo $ac_n "checking for working automake""... $ac_c" 1>&6
-echo "configure:832: checking for working automake" >&5
+echo "configure:843: checking for working automake" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -841,7 +852,7 @@
 fi
 
 echo $ac_n "checking for working autoheader""... $ac_c" 1>&6
-echo "configure:845: checking for working autoheader" >&5
+echo "configure:856: checking for working autoheader" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -856,7 +867,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:860: checking for $ac_word" >&5
+echo "configure:871: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -885,7 +896,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:889: checking for $ac_word" >&5
+echo "configure:900: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -933,7 +944,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:937: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:948: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -943,11 +954,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 947 "configure"
+#line 958 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:951: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:962: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -967,12 +978,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:971: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:982: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:976: checking whether we are using GNU C" >&5
+echo "configure:987: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -981,7 +992,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:985: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:996: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -996,7 +1007,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:1000: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:1011: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1024,7 +1035,7 @@
 fi
 
 echo $ac_n "checking for POSIXized ISC""... $ac_c" 1>&6
-echo "configure:1028: checking for POSIXized ISC" >&5
+echo "configure:1039: checking for POSIXized ISC" >&5
 if test -d /etc/conf/kconfig.d &&
   grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1
 then
@@ -1057,12 +1068,13 @@
 #define USE_RAND_W32 1
 EOF
 
+	GNUPG_LIBDIR="c:/lib/gnupg"
 	;;
     *)
 # Extract the first word of "ranlib", so it can be a program name with args.
 set dummy ranlib; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1066: checking for $ac_word" >&5
+echo "configure:1078: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_RANLIB'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1099,7 +1111,7 @@
 # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
 # ./install, which can be erroneously created by make from ./install.sh.
 echo $ac_n "checking for a BSD compatible install""... $ac_c" 1>&6
-echo "configure:1103: checking for a BSD compatible install" >&5
+echo "configure:1115: checking for a BSD compatible install" >&5
 if test -z "$INSTALL"; then
 if eval "test \"`echo '$''{'ac_cv_path_install'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1151,7 +1163,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1155: checking for $ac_word" >&5
+echo "configure:1167: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1180,7 +1192,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1184: checking for $ac_word" >&5
+echo "configure:1196: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1228,7 +1240,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:1232: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:1244: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -1238,11 +1250,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 1242 "configure"
+#line 1254 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:1246: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:1258: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -1262,12 +1274,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:1266: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:1278: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:1271: checking whether we are using GNU C" >&5
+echo "configure:1283: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1276,7 +1288,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:1280: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:1292: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -1291,7 +1303,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:1295: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:1307: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1319,7 +1331,7 @@
 fi
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:1323: checking how to run the C preprocessor" >&5
+echo "configure:1335: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
   CPP=
@@ -1334,13 +1346,13 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1338 "configure"
+#line 1350 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1344: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1356: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1351,13 +1363,13 @@
   rm -rf conftest*
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1355 "configure"
+#line 1367 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1361: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1373: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1383,8 +1395,13 @@
 #define USE_RAND_UNIX 1
 EOF
 
+	GNUPG_LIBDIR="$g10_prefix/lib/gnupg"
        ;;
 esac
+cat >> confdefs.h <<EOF
+#define GNUPG_LIBDIR "$GNUPG_LIBDIR"
+EOF
+
 
 case "${target}" in
     i386--mingw32)
@@ -1403,13 +1420,153 @@
 
 
 
+
+if test "$try_dynload" = yes ; then
+echo $ac_n "checking for dlopen in -ldl""... $ac_c" 1>&6
+echo "configure:1427: checking for dlopen in -ldl" >&5
+ac_lib_var=`echo dl'_'dlopen | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-ldl  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 1435 "configure"
+#include "confdefs.h"
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char dlopen();
+
+int main() {
+dlopen()
+; return 0; }
+EOF
+if { (eval echo configure:1446: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=no"
+fi
+rm -f conftest*
+LIBS="$ac_save_LIBS"
+
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo dl | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
+EOF
+
+  LIBS="-ldl $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+if test "$ac_cv_lib_dl_dlopen" = "yes"; then
+  cat >> confdefs.h <<\EOF
+#define USE_DYNAMIC_LINKING 1
+EOF
+
+  cat >> confdefs.h <<\EOF
+#define HAVE_DL_DLOPEN 1
+EOF
+
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+else
+echo $ac_n "checking for dld_link in -ldld""... $ac_c" 1>&6
+echo "configure:1486: checking for dld_link in -ldld" >&5
+ac_lib_var=`echo dld'_'dld_link | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-ldld  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 1494 "configure"
+#include "confdefs.h"
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char dld_link();
+
+int main() {
+dld_link()
+; return 0; }
+EOF
+if { (eval echo configure:1505: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=no"
+fi
+rm -f conftest*
+LIBS="$ac_save_LIBS"
+
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo dld | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
+EOF
+
+  LIBS="-ldld $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+if test "$ac_cv_lib_dld_dld_link" = "yes"; then
+  cat >> confdefs.h <<\EOF
+#define USE_DYNAMIC_LINKING 1
+EOF
+
+  cat >> confdefs.h <<\EOF
+#define HAVE_DLD_DLD_LINK 1
+EOF
+
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+fi
+fi
+else
+  echo $ac_n "checking for dynamic loading""... $ac_c" 1>&6
+echo "configure:1547: checking for dynamic loading" >&5
+  DYNLINK_LDFLAGS=
+  use_gnupg_extensions=no
+  echo "$ac_t""has been disabled" 1>&6
+fi
+
+
+
+if test "$use_gnupg_extensions" = yes ; then
+  ENABLE_GNUPG_EXTENSIONS_TRUE=
+  ENABLE_GNUPG_EXTENSIONS_FALSE='#'
+else
+  ENABLE_GNUPG_EXTENSIONS_TRUE='#'
+  ENABLE_GNUPG_EXTENSIONS_FALSE=
+fi
+
+
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1408: checking for ANSI C header files" >&5
+echo "configure:1565: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1413 "configure"
+#line 1570 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 #include <stdarg.h>
@@ -1417,7 +1574,7 @@
 #include <float.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1421: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1578: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1434,7 +1591,7 @@
 if test $ac_cv_header_stdc = yes; then
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1438 "configure"
+#line 1595 "configure"
 #include "confdefs.h"
 #include <string.h>
 EOF
@@ -1452,7 +1609,7 @@
 if test $ac_cv_header_stdc = yes; then
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1456 "configure"
+#line 1613 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 EOF
@@ -1473,7 +1630,7 @@
   :
 else
   cat > conftest.$ac_ext <<EOF
-#line 1477 "configure"
+#line 1634 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 #define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
@@ -1484,7 +1641,7 @@
 exit (0); }
 
 EOF
-if { (eval echo configure:1488: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1645: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   :
 else
@@ -1511,17 +1668,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1515: checking for $ac_hdr" >&5
+echo "configure:1672: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1520 "configure"
+#line 1677 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1525: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1682: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1551,12 +1708,12 @@
 
 
 echo $ac_n "checking for working const""... $ac_c" 1>&6
-echo "configure:1555: checking for working const" >&5
+echo "configure:1712: checking for working const" >&5
 if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1560 "configure"
+#line 1717 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -1605,7 +1762,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1609: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1766: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_const=yes
 else
@@ -1626,21 +1783,21 @@
 fi
 
 echo $ac_n "checking for inline""... $ac_c" 1>&6
-echo "configure:1630: checking for inline" >&5
+echo "configure:1787: checking for inline" >&5
 if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 1637 "configure"
+#line 1794 "configure"
 #include "confdefs.h"
 
 int main() {
 } $ac_kw foo() {
 ; return 0; }
 EOF
-if { (eval echo configure:1644: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1801: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_inline=$ac_kw; break
 else
@@ -1666,12 +1823,12 @@
 esac
 
 echo $ac_n "checking for size_t""... $ac_c" 1>&6
-echo "configure:1670: checking for size_t" >&5
+echo "configure:1827: checking for size_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1675 "configure"
+#line 1832 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -1699,12 +1856,12 @@
 fi
 
 echo $ac_n "checking return type of signal handlers""... $ac_c" 1>&6
-echo "configure:1703: checking return type of signal handlers" >&5
+echo "configure:1860: checking return type of signal handlers" >&5
 if eval "test \"`echo '$''{'ac_cv_type_signal'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1708 "configure"
+#line 1865 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <signal.h>
@@ -1721,7 +1878,7 @@
 int i;
 ; return 0; }
 EOF
-if { (eval echo configure:1725: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1882: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_type_signal=void
 else
@@ -1740,12 +1897,12 @@
 
 
 echo $ac_n "checking for sys_siglist declaration in signal.h or unistd.h""... $ac_c" 1>&6
-echo "configure:1744: checking for sys_siglist declaration in signal.h or unistd.h" >&5
+echo "configure:1901: checking for sys_siglist declaration in signal.h or unistd.h" >&5
 if eval "test \"`echo '$''{'ac_cv_decl_sys_siglist'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1749 "configure"
+#line 1906 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #include <signal.h>
@@ -1757,7 +1914,7 @@
 char *msg = *(sys_siglist + 1);
 ; return 0; }
 EOF
-if { (eval echo configure:1761: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1918: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_decl_sys_siglist=yes
 else
@@ -1782,14 +1939,14 @@
         echo "configure: warning: cross compiling; assuming little endianess" 1>&2
     fi
     echo $ac_n "checking endianess""... $ac_c" 1>&6
-echo "configure:1786: checking endianess" >&5
+echo "configure:1943: checking endianess" >&5
     if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
    wk_cv_c_endian=unknown
         # See if sys/param.h defines the BYTE_ORDER macro.
         cat > conftest.$ac_ext <<EOF
-#line 1793 "configure"
+#line 1950 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
         #include <sys/param.h>
@@ -1800,11 +1957,11 @@
         #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1804: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1961: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   # It does; now see whether it defined to BIG_ENDIAN or not.
         cat > conftest.$ac_ext <<EOF
-#line 1808 "configure"
+#line 1965 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
         #include <sys/param.h>
@@ -1815,7 +1972,7 @@
         #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1819: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1976: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_c_endian=big
 else
@@ -1836,7 +1993,7 @@
             
 else
   cat > conftest.$ac_ext <<EOF
-#line 1840 "configure"
+#line 1997 "configure"
 #include "confdefs.h"
 main () {
               /* Are we little or big endian?  From Harbison&Steele.  */
@@ -1849,7 +2006,7 @@
               exit (u.c[sizeof (long) - 1] == 1);
               }
 EOF
-if { (eval echo configure:1853: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2010: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   wk_cv_c_endian=little
 else
@@ -1881,12 +2038,12 @@
 
 
  echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
-echo "configure:1885: checking for byte typedef" >&5
+echo "configure:2042: checking for byte typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1890 "configure"
+#line 2047 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1897,7 +2054,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1901: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2058: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_byte=yes
 else
@@ -1918,12 +2075,12 @@
     fi
   
  echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
-echo "configure:1922: checking for ushort typedef" >&5
+echo "configure:2079: checking for ushort typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1927 "configure"
+#line 2084 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1934,7 +2091,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1938: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2095: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ushort=yes
 else
@@ -1955,12 +2112,12 @@
     fi
   
  echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
-echo "configure:1959: checking for ulong typedef" >&5
+echo "configure:2116: checking for ulong typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1964 "configure"
+#line 2121 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1971,7 +2128,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1975: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2132: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ulong=yes
 else
@@ -1992,12 +2149,12 @@
     fi
   
  echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
-echo "configure:1996: checking for u16 typedef" >&5
+echo "configure:2153: checking for u16 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2001 "configure"
+#line 2158 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -2008,7 +2165,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:2012: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2169: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u16=yes
 else
@@ -2029,12 +2186,12 @@
     fi
   
  echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
-echo "configure:2033: checking for u32 typedef" >&5
+echo "configure:2190: checking for u32 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2038 "configure"
+#line 2195 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -2045,7 +2202,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:2049: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2206: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u32=yes
 else
@@ -2067,7 +2224,7 @@
   
 
 echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
-echo "configure:2071: checking size of unsigned short" >&5
+echo "configure:2228: checking size of unsigned short" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2075,7 +2232,7 @@
   ac_cv_sizeof_unsigned_short=2
 else
   cat > conftest.$ac_ext <<EOF
-#line 2079 "configure"
+#line 2236 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2086,7 +2243,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2090: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2247: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_short=`cat conftestval`
 else
@@ -2106,7 +2263,7 @@
 
 
 echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
-echo "configure:2110: checking size of unsigned int" >&5
+echo "configure:2267: checking size of unsigned int" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2114,7 +2271,7 @@
   ac_cv_sizeof_unsigned_int=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 2118 "configure"
+#line 2275 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2125,7 +2282,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2129: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2286: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_int=`cat conftestval`
 else
@@ -2145,7 +2302,7 @@
 
 
 echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
-echo "configure:2149: checking size of unsigned long" >&5
+echo "configure:2306: checking size of unsigned long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2153,7 +2310,7 @@
   ac_cv_sizeof_unsigned_long=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 2157 "configure"
+#line 2314 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2164,7 +2321,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2168: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2325: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_long=`cat conftestval`
 else
@@ -2193,12 +2350,12 @@
 
 
 echo $ac_n "checking for vprintf""... $ac_c" 1>&6
-echo "configure:2197: checking for vprintf" >&5
+echo "configure:2354: checking for vprintf" >&5
 if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2202 "configure"
+#line 2359 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char vprintf(); below.  */
@@ -2221,7 +2378,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2225: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2382: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_vprintf=yes"
 else
@@ -2245,12 +2402,12 @@
 
 if test "$ac_cv_func_vprintf" != yes; then
 echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
-echo "configure:2249: checking for _doprnt" >&5
+echo "configure:2406: checking for _doprnt" >&5
 if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2254 "configure"
+#line 2411 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char _doprnt(); below.  */
@@ -2273,7 +2430,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2277: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2434: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func__doprnt=yes"
 else
@@ -2300,12 +2457,12 @@
 for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2304: checking for $ac_func" >&5
+echo "configure:2461: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2309 "configure"
+#line 2466 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2328,7 +2485,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2332: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2489: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2355,12 +2512,12 @@
 for ac_func in memmove gettimeofday getrusage gethrtime
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2359: checking for $ac_func" >&5
+echo "configure:2516: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2364 "configure"
+#line 2521 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2383,7 +2540,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2387: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2544: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2411,7 +2568,7 @@
 
 if test "$try_dev_random" = yes ; then
 echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2415: checking for random device" >&5
+echo "configure:2572: checking for random device" >&5
 if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2428,7 +2585,7 @@
 fi
 else
     echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2432: checking for random device" >&5
+echo "configure:2589: checking for random device" >&5
     ac_cv_have_dev_random=no
     echo "$ac_t""has been disabled" 1>&6
 fi
@@ -2437,7 +2594,7 @@
 
 
 echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:2441: checking for mpi assembler functions" >&5
+echo "configure:2598: checking for mpi assembler functions" >&5
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
      if test "x$wk_link_files_src" = "x"; then
@@ -2500,17 +2657,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2504: checking for $ac_hdr" >&5
+echo "configure:2661: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2509 "configure"
+#line 2666 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2514: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2671: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2580,36 +2737,13 @@
 
 
 
-CIPHER_EXTRA_OBJS=""
-CIPHER_EXTRA_DIST=""
-echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:2587: checking for extra cipher modules" >&5
-if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  if test -f $srcdir/cipher/rsa.c && test -f $srcdir/cipher/rsa.h; then
-  ac_cv_have_rsa_cipher=yes; else ac_cv_have_rsa_cipher=no; fi
-fi
-
-echo "$ac_t""$ac_cv_have_rsa_cipher" 1>&6
-if test $ac_cv_have_rsa_cipher = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_RSA_CIPHER 1
-EOF
-
-    CIPHER_EXTRA_OBJS="rsa.o"
-    CIPHER_EXTRA_DIST="rsa.c rsa.h"
-fi
-
-
-
 echo $ac_n "checking for off_t""... $ac_c" 1>&6
-echo "configure:2608: checking for off_t" >&5
+echo "configure:2742: checking for off_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2613 "configure"
+#line 2747 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -2639,19 +2773,19 @@
 # The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
 # for constant arguments.  Useless!
 echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
-echo "configure:2643: checking for working alloca.h" >&5
+echo "configure:2777: checking for working alloca.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2648 "configure"
+#line 2782 "configure"
 #include "confdefs.h"
 #include <alloca.h>
 int main() {
 char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:2655: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2789: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_header_alloca_h=yes
 else
@@ -2672,12 +2806,12 @@
 fi
 
 echo $ac_n "checking for alloca""... $ac_c" 1>&6
-echo "configure:2676: checking for alloca" >&5
+echo "configure:2810: checking for alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2681 "configure"
+#line 2815 "configure"
 #include "confdefs.h"
 
 #ifdef __GNUC__
@@ -2700,7 +2834,7 @@
 char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:2704: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2838: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_func_alloca_works=yes
 else
@@ -2732,12 +2866,12 @@
 
 
 echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
-echo "configure:2736: checking whether alloca needs Cray hooks" >&5
+echo "configure:2870: checking whether alloca needs Cray hooks" >&5
 if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2741 "configure"
+#line 2875 "configure"
 #include "confdefs.h"
 #if defined(CRAY) && ! defined(CRAY2)
 webecray
@@ -2762,12 +2896,12 @@
 if test $ac_cv_os_cray = yes; then
 for ac_func in _getb67 GETB67 getb67; do
   echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2766: checking for $ac_func" >&5
+echo "configure:2900: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2771 "configure"
+#line 2905 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2790,7 +2924,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2794: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2928: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2817,7 +2951,7 @@
 fi
 
 echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
-echo "configure:2821: checking stack direction for C alloca" >&5
+echo "configure:2955: checking stack direction for C alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2825,7 +2959,7 @@
   ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 2829 "configure"
+#line 2963 "configure"
 #include "confdefs.h"
 find_stack_direction ()
 {
@@ -2844,7 +2978,7 @@
   exit (find_stack_direction() < 0);
 }
 EOF
-if { (eval echo configure:2848: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2982: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_c_stack_direction=1
 else
@@ -2869,17 +3003,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2873: checking for $ac_hdr" >&5
+echo "configure:3007: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2878 "configure"
+#line 3012 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2883: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3017: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2908,12 +3042,12 @@
 for ac_func in getpagesize
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2912: checking for $ac_func" >&5
+echo "configure:3046: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2917 "configure"
+#line 3051 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2936,7 +3070,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2940: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3074: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2961,7 +3095,7 @@
 done
 
 echo $ac_n "checking for working mmap""... $ac_c" 1>&6
-echo "configure:2965: checking for working mmap" >&5
+echo "configure:3099: checking for working mmap" >&5
 if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2969,7 +3103,7 @@
   ac_cv_func_mmap_fixed_mapped=no
 else
   cat > conftest.$ac_ext <<EOF
-#line 2973 "configure"
+#line 3107 "configure"
 #include "confdefs.h"
 
 /* Thanks to Mike Haertel and Jim Avera for this test.
@@ -3109,7 +3243,7 @@
 }
 
 EOF
-if { (eval echo configure:3113: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3247: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_func_mmap_fixed_mapped=yes
 else
@@ -3137,17 +3271,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:3141: checking for $ac_hdr" >&5
+echo "configure:3275: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3146 "configure"
+#line 3280 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3151: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3285: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3177,12 +3311,12 @@
 __argz_count __argz_stringify __argz_next
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3181: checking for $ac_func" >&5
+echo "configure:3315: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3186 "configure"
+#line 3320 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3205,7 +3339,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3209: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3343: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3234,12 +3368,12 @@
      for ac_func in stpcpy
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3238: checking for $ac_func" >&5
+echo "configure:3372: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3243 "configure"
+#line 3377 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3262,7 +3396,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3266: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3400: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3296,19 +3430,19 @@
 
    if test $ac_cv_header_locale_h = yes; then
     echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
-echo "configure:3300: checking for LC_MESSAGES" >&5
+echo "configure:3434: checking for LC_MESSAGES" >&5
 if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3305 "configure"
+#line 3439 "configure"
 #include "confdefs.h"
 #include <locale.h>
 int main() {
 return LC_MESSAGES
 ; return 0; }
 EOF
-if { (eval echo configure:3312: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3446: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   am_cv_val_LC_MESSAGES=yes
 else
@@ -3329,7 +3463,7 @@
     fi
   fi
    echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
-echo "configure:3333: checking whether NLS is requested" >&5
+echo "configure:3467: checking whether NLS is requested" >&5
         # Check whether --enable-nls or --disable-nls was given.
 if test "${enable_nls+set}" = set; then
   enableval="$enable_nls"
@@ -3349,7 +3483,7 @@
 EOF
 
       echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
-echo "configure:3353: checking whether included gettext is requested" >&5
+echo "configure:3487: checking whether included gettext is requested" >&5
       # Check whether --with-included-gettext or --without-included-gettext was given.
 if test "${with_included_gettext+set}" = set; then
   withval="$with_included_gettext"
@@ -3368,17 +3502,17 @@
 
         ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
-echo "configure:3372: checking for libintl.h" >&5
+echo "configure:3506: checking for libintl.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3377 "configure"
+#line 3511 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3382: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3516: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3395,19 +3529,19 @@
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
-echo "configure:3399: checking for gettext in libc" >&5
+echo "configure:3533: checking for gettext in libc" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3404 "configure"
+#line 3538 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3411: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3545: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libc=yes
 else
@@ -3423,7 +3557,7 @@
 
            if test "$gt_cv_func_gettext_libc" != "yes"; then
              echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
-echo "configure:3427: checking for bindtextdomain in -lintl" >&5
+echo "configure:3561: checking for bindtextdomain in -lintl" >&5
 ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3431,7 +3565,7 @@
   ac_save_LIBS="$LIBS"
 LIBS="-lintl  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3435 "configure"
+#line 3569 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
@@ -3442,7 +3576,7 @@
 bindtextdomain()
 ; return 0; }
 EOF
-if { (eval echo configure:3446: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3580: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3458,19 +3592,19 @@
 if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libintl""... $ac_c" 1>&6
-echo "configure:3462: checking for gettext in libintl" >&5
+echo "configure:3596: checking for gettext in libintl" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libintl'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3467 "configure"
+#line 3601 "configure"
 #include "confdefs.h"
 
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3474: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3608: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libintl=yes
 else
@@ -3498,7 +3632,7 @@
               # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3502: checking for $ac_word" >&5
+echo "configure:3636: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3532,12 +3666,12 @@
                 for ac_func in dcgettext
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3536: checking for $ac_func" >&5
+echo "configure:3670: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3541 "configure"
+#line 3675 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3560,7 +3694,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3564: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3698: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3587,7 +3721,7 @@
                 # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3591: checking for $ac_word" >&5
+echo "configure:3725: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3619,7 +3753,7 @@
                 # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3623: checking for $ac_word" >&5
+echo "configure:3757: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3651,7 +3785,7 @@
 fi
 
                 cat > conftest.$ac_ext <<EOF
-#line 3655 "configure"
+#line 3789 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -3659,7 +3793,7 @@
                                return _nl_msg_cat_cntr
 ; return 0; }
 EOF
-if { (eval echo configure:3663: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3797: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   CATOBJEXT=.gmo
                    DATADIRNAME=share
@@ -3682,7 +3816,7 @@
 
         if test "$CATOBJEXT" = "NONE"; then
           echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
-echo "configure:3686: checking whether catgets can be used" >&5
+echo "configure:3820: checking whether catgets can be used" >&5
           # Check whether --with-catgets or --without-catgets was given.
 if test "${with_catgets+set}" = set; then
   withval="$with_catgets"
@@ -3695,7 +3829,7 @@
 
           if test "$nls_cv_use_catgets" = "yes"; then
                         echo $ac_n "checking for main in -li""... $ac_c" 1>&6
-echo "configure:3699: checking for main in -li" >&5
+echo "configure:3833: checking for main in -li" >&5
 ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3703,14 +3837,14 @@
   ac_save_LIBS="$LIBS"
 LIBS="-li  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3707 "configure"
+#line 3841 "configure"
 #include "confdefs.h"
 
 int main() {
 main()
 ; return 0; }
 EOF
-if { (eval echo configure:3714: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3848: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3738,12 +3872,12 @@
 fi
 
             echo $ac_n "checking for catgets""... $ac_c" 1>&6
-echo "configure:3742: checking for catgets" >&5
+echo "configure:3876: checking for catgets" >&5
 if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3747 "configure"
+#line 3881 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char catgets(); below.  */
@@ -3766,7 +3900,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3770: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3904: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_catgets=yes"
 else
@@ -3788,7 +3922,7 @@
                # Extract the first word of "gencat", so it can be a program name with args.
 set dummy gencat; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3792: checking for $ac_word" >&5
+echo "configure:3926: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3820,7 +3954,7 @@
                  # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3824: checking for $ac_word" >&5
+echo "configure:3958: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3853,7 +3987,7 @@
                    # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3857: checking for $ac_word" >&5
+echo "configure:3991: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3888,7 +4022,7 @@
                  # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3892: checking for $ac_word" >&5
+echo "configure:4026: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3946,7 +4080,7 @@
         # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3950: checking for $ac_word" >&5
+echo "configure:4084: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3980,7 +4114,7 @@
         # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3984: checking for $ac_word" >&5
+echo "configure:4118: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -4012,7 +4146,7 @@
         # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4016: checking for $ac_word" >&5
+echo "configure:4150: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -4102,7 +4236,7 @@
        LINGUAS=
      else
        echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
-echo "configure:4106: checking for catalogs to be installed" >&5
+echo "configure:4240: checking for catalogs to be installed" >&5
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
          case "$ALL_LINGUAS" in
@@ -4130,17 +4264,17 @@
    if test "$CATOBJEXT" = ".cat"; then
      ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
-echo "configure:4134: checking for linux/version.h" >&5
+echo "configure:4268: checking for linux/version.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 4139 "configure"
+#line 4273 "configure"
 #include "confdefs.h"
 #include <linux/version.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:4144: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:4278: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -4392,12 +4526,13 @@
 s%@INSTALL_PROGRAM@%$INSTALL_PROGRAM%g
 s%@INSTALL_DATA@%$INSTALL_DATA%g
 s%@CPP@%$CPP%g
+s%@ENABLE_GNUPG_EXTENSIONS_TRUE@%$ENABLE_GNUPG_EXTENSIONS_TRUE%g
+s%@ENABLE_GNUPG_EXTENSIONS_FALSE@%$ENABLE_GNUPG_EXTENSIONS_FALSE%g
+s%@DYNLINK_LDFLAGS@%$DYNLINK_LDFLAGS%g
 s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
 s%@ENABLE_LOCAL_ZLIB_TRUE@%$ENABLE_LOCAL_ZLIB_TRUE%g
 s%@ENABLE_LOCAL_ZLIB_FALSE@%$ENABLE_LOCAL_ZLIB_FALSE%g
 s%@ZLIBS@%$ZLIBS%g
-s%@CIPHER_EXTRA_OBJS@%$CIPHER_EXTRA_OBJS%g
-s%@CIPHER_EXTRA_DIST@%$CIPHER_EXTRA_DIST%g
 s%@ALLOCA@%$ALLOCA%g
 s%@USE_NLS@%$USE_NLS%g
 s%@MSGFMT@%$MSGFMT%g
diff -urN gnupg-0.2.19/configure.in gnupg-0.3.0/configure.in
--- gnupg-0.2.19/configure.in	Mon May 11 10:21:30 1998
+++ gnupg-0.3.0/configure.in	Thu Jun 25 12:09:28 1998
@@ -31,6 +31,10 @@
 [  --disable-dev-random    disable the use of dev random],
     try_dev_random=$enableval, try_dev_random=yes)
 
+AC_ARG_ENABLE(dynload,
+[  --disable-dynload	   disable dynamic loading],
+    try_dynload=$enableval, try_dynload=yes)
+
 AC_MSG_CHECKING([whether memory debugging is requested])
 AC_ARG_ENABLE(m-debug,
 [  --enable-m-debug	   enable debugging of memory allocation],
@@ -86,6 +90,7 @@
 	RANLIB="i386--mingw32-ranlib"
 	ac_cv_have_dev_random=no
 	AC_DEFINE(USE_RAND_W32)
+	GNUPG_LIBDIR="c:/lib/gnupg"
 	;;
     *)
 AC_PROG_RANLIB
@@ -93,8 +98,10 @@
 AC_PROG_CC
 AC_PROG_CPP
 	AC_DEFINE(USE_RAND_UNIX)
+	GNUPG_LIBDIR="$g10_prefix/lib/gnupg"
        ;;
 esac
+AC_DEFINE_UNQUOTED(GNUPG_LIBDIR, "$GNUPG_LIBDIR")
 
 case "${target}" in
     i386--mingw32)
@@ -111,6 +118,33 @@
 
 dnl Checks for libraries.
 
+
+if test "$try_dynload" = yes ; then
+AC_CHECK_LIB(dl,dlopen)
+if test "$ac_cv_lib_dl_dlopen" = "yes"; then
+  AC_DEFINE(USE_DYNAMIC_LINKING)
+  AC_DEFINE(HAVE_DL_DLOPEN)
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+else
+AC_CHECK_LIB(dld,dld_link)
+if test "$ac_cv_lib_dld_dld_link" = "yes"; then
+  AC_DEFINE(USE_DYNAMIC_LINKING)
+  AC_DEFINE(HAVE_DLD_DLD_LINK)
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+fi
+fi
+else
+  AC_MSG_CHECKING(for dynamic loading)
+  DYNLINK_LDFLAGS=
+  use_gnupg_extensions=no
+  AC_MSG_RESULT(has been disabled)
+fi
+
+AM_CONDITIONAL(ENABLE_GNUPG_EXTENSIONS, test "$use_gnupg_extensions" = yes )
+AC_SUBST(DYNLINK_LDFLAGS)
+
 dnl Checks for header files.
 AC_HEADER_STDC
 AC_CHECK_HEADERS(unistd.h)
@@ -213,20 +247,6 @@
 fi
 AC_SUBST(ZLIBS)
 
-
-dnl checking whether we have other cipher source files
-CIPHER_EXTRA_OBJS=""
-CIPHER_EXTRA_DIST=""
-AC_CACHE_CHECK(for extra cipher modules, ac_cv_have_rsa_cipher,
-[if test -f $srcdir/cipher/rsa.c && test -f $srcdir/cipher/rsa.h; then
-  ac_cv_have_rsa_cipher=yes; else ac_cv_have_rsa_cipher=no; fi])
-if test $ac_cv_have_rsa_cipher = yes; then
-    AC_DEFINE(HAVE_RSA_CIPHER)
-    CIPHER_EXTRA_OBJS="rsa.o"
-    CIPHER_EXTRA_DIST="rsa.c rsa.h"
-fi
-AC_SUBST(CIPHER_EXTRA_OBJS)
-AC_SUBST(CIPHER_EXTRA_DIST)
 
 AM_GNU_GETTEXT
 G10_LOCALEDIR="$g10_prefix/$DATADIRNAME/locale"
diff -urN gnupg-0.2.19/doc/DETAILS gnupg-0.3.0/doc/DETAILS
--- gnupg-0.2.19/doc/DETAILS	Fri May 29 12:47:06 1998
+++ gnupg-0.3.0/doc/DETAILS	Sat Jun 13 14:26:31 1998
@@ -103,7 +103,7 @@
 	     and useful if we have duplicate keyids
 	     It points back to the directory node.
      1 byte pubkey algorithm
-     1 byte reserved
+     1 byte length of the fingerprint (in bytes)
      20 bytes fingerprint of the public key
      1 byte ownertrust:
      3 byte reserved
@@ -259,6 +259,8 @@
 +  that this may also be used for compressed data streams, but we must use
 +  another packet version to tell the application that it can not assume,
 +  that this is the last packet.
+
+
 
 
 
diff -urN gnupg-0.2.19/doc/Makefile.in gnupg-0.3.0/doc/Makefile.in
--- gnupg-0.2.19/doc/Makefile.in	Fri May 29 12:56:31 1998
+++ gnupg-0.3.0/doc/Makefile.in	Thu Jun 25 13:09:25 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
diff -urN gnupg-0.2.19/doc/gpg.1 gnupg-0.3.0/doc/gpg.1
--- gnupg-0.2.19/doc/gpg.1	Fri May 15 15:52:15 1998
+++ gnupg-0.3.0/doc/gpg.1	Wed Jun 24 21:14:13 1998
@@ -73,7 +73,7 @@
 .nr % 0
 .rr F
 .\}
-.TH gpg gpg.1 "15 May 1998" " " "GNU Tools"
+.TH gpg gpg.1 "24 Jun 1998" " " "GNU Tools"
 .IX Title "gpg gpg.1"
 .UC
 .IX Name "gpg - GNU Privacy Guard"
@@ -378,6 +378,11 @@
     Shortcut for \fB--options\fR \fI/dev/null\fR.  This option is
     detected before an attempt to open an option file.
 .PP
+\fB--load-extension\fR \fImodulename\fR
+    Load an extension module. If \fImodulename\fR does not
+    contain a slash it is searched in \fB/usr/local/lib/gnupg\fR
+    See the manual for more information about extensions.
+.PP
 \fB--debug\fR \fIflags\fR
     Set debugging flags. All flags are or-ed and \fIflags\fR may
     be given in C syntax (e.g. 0x0042).
@@ -492,8 +497,11 @@
 \fIgpgm\fR\|(1)  \fIgpgd\fR\|(1)
 .SH "WARNINGS"
 .IX Header "WARNINGS"
-Use a \fBgood\fR password for your user account and a non-simple passphrase
-to protect your secret key.
+Use a \fBgood\fR password for your user account and a \fBgood\fR passphrase
+to protect your secret key.  This passphrase is the weakest part of the
+whole system.  Programs to do dictionary attacks on your secret keyring
+are very easy to write and so you should protect your \fB~/.gnupg/\fR
+directory very good.
 .PP
 Keep in mind that, if this program is used over a network (telnet), it
 is \fBvery\fR easy to spy out your passphrase!
diff -urN gnupg-0.2.19/doc/gpg.1pod gnupg-0.3.0/doc/gpg.1pod
--- gnupg-0.2.19/doc/gpg.1pod	Fri May 15 15:49:15 1998
+++ gnupg-0.3.0/doc/gpg.1pod	Wed Jun 24 21:13:48 1998
@@ -215,6 +215,11 @@
     Shortcut for B<--options> I</dev/null>.  This option is
     detected before an attempt to open an option file.
 
+B<--load-extension> I<modulename>
+    Load an extension module. If I<modulename> does not
+    contain a slash it is searched in B</usr/local/lib/gnupg>
+    See the manual for more information about extensions.
+
 B<--debug> I<flags>
     Set debugging flags. All flags are or-ed and I<flags> may
     be given in C syntax (e.g. 0x0042).
@@ -335,8 +340,11 @@
 
 =head1 WARNINGS
 
-Use a B<good> password for your user account and a non-simple passphrase
-to protect your secret key.
+Use a B<good> password for your user account and a B<good> passphrase
+to protect your secret key.  This passphrase is the weakest part of the
+whole system.  Programs to do dictionary attacks on your secret keyring
+are very easy to write and so you should protect your B<~/.gnupg/>
+directory very good.
 
 Keep in mind that, if this program is used over a network (telnet), it
 is B<very> easy to spy out your passphrase!
diff -urN gnupg-0.2.19/g10/ChangeLog gnupg-0.3.0/g10/ChangeLog
--- gnupg-0.2.19/g10/ChangeLog	Fri May 29 10:31:45 1998
+++ gnupg-0.3.0/g10/ChangeLog	Wed Jun 24 16:42:42 1998
@@ -1,3 +1,46 @@
+Wed Jun 24 16:40:22 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* armor.c (armor_filter): Now creates valid onepass_sig packets
+	with all detected hash algorithms.
+	* mainproc.c (proc_plaintext): Now uses the hash algos as specified
+	in the onepass_sig packets (if there are any)
+
+Mon Jun 22 11:54:08 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* plaintext.c (handle_plaintext): add arg to disable outout
+	* mainproc.c (proc_plaintext): disable output when in sigs_only mode.
+
+Thu Jun 18 13:17:27 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* keygen.c: Removed all rsa packet stuff, chnaged defaults
+	for key generation.
+
+Sun Jun 14 21:28:31 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* misc.c (checksum_u16): Fixed a stupid bug which caused a
+	wrong checksum calculation for the secret key protection and
+	add a backward compatibility option.
+	* g10.c (main): Add option --emulate-checksum-bug.
+
+Thu Jun 11 13:26:44 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* packet.h: Major changes to the structure of public key material
+	which is now stored in an array and not anaymore in a union of
+	algorithm specific structures.	These is needed to make the system
+	more extendable and makes a lot of stuff much simpler. Changed
+	all over the system.
+
+	* dsa.c, rsa.c, elg.c: Removed.
+
+Wed Jun 10 07:22:02 1998  Werner Koch,mobil,,,	(wk@tobold)
+
+	* g10.c ("load-extension"): New option.
+
+Mon Jun  8 22:23:37 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* seckey-cert.c (do_check): Removed cipher constants
+	(protect_secret_key): Ditto.
+
 Fri May 29 10:00:28 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* trustdb.c (query_trust_info): New.
diff -urN gnupg-0.2.19/g10/Makefile.am gnupg-0.3.0/g10/Makefile.am
--- gnupg-0.2.19/g10/Makefile.am	Thu May 28 10:16:19 1998
+++ gnupg-0.3.0/g10/Makefile.am	Thu Jun 25 12:05:25 1998
@@ -3,6 +3,7 @@
 INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
+LDFLAGS = @LDFLAGS@ @DYNLINK_LDFLAGS@
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
 noinst_PROGRAMS = gpgd
@@ -25,9 +26,6 @@
 	      mdfilter.c	\
 	      textfilter.c	\
 	      cipher.c		\
-	      elg.c		\
-	      dsa.c		\
-	      rsa.c		\
 	      misc.c		\
 	      options.h 	\
 	      openfile.c	\
diff -urN gnupg-0.2.19/g10/Makefile.in gnupg-0.3.0/g10/Makefile.in
--- gnupg-0.2.19/g10/Makefile.in	Fri May 29 12:56:28 1998
+++ gnupg-0.3.0/g10/Makefile.in	Thu Jun 25 13:09:20 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -95,6 +94,7 @@
 INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
 EXTRA_DIST = OPTIONS  pubring.asc
 OMIT_DEPENDENCIES = zlib.h zconf.h
+LDFLAGS = @LDFLAGS@ @DYNLINK_LDFLAGS@
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
 noinst_PROGRAMS = gpgd
@@ -117,9 +117,6 @@
 	      mdfilter.c	\
 	      textfilter.c	\
 	      cipher.c		\
-	      elg.c		\
-	      dsa.c		\
-	      rsa.c		\
 	      misc.c		\
 	      options.h 	\
 	      openfile.c	\
@@ -172,36 +169,34 @@
 
 DEFS = @DEFS@ -I. -I$(srcdir) -I..
 CPPFLAGS = @CPPFLAGS@
-LDFLAGS = @LDFLAGS@
 LIBS = @LIBS@
 gpg_OBJECTS =  g10.o build-packet.o compress.o free-packet.o getkey.o \
 pkclist.o skclist.o ringedit.o kbnode.o mainproc.o armor.o mdfilter.o \
-textfilter.o cipher.o elg.o dsa.o rsa.o misc.o openfile.o keyid.o \
-trustdb.o parse-packet.o passphrase.o pubkey-enc.o seckey-cert.o \
-seskey.o import.o export.o comment.o status.o sign.o keyedit.o \
-plaintext.o encr-data.o encode.o revoke.o keylist.o sig-check.o \
-signal.o verify.o decrypt.o keygen.o
+textfilter.o cipher.o misc.o openfile.o keyid.o trustdb.o \
+parse-packet.o passphrase.o pubkey-enc.o seckey-cert.o seskey.o \
+import.o export.o comment.o status.o sign.o keyedit.o plaintext.o \
+encr-data.o encode.o revoke.o keylist.o sig-check.o signal.o verify.o \
+decrypt.o keygen.o
 gpg_LDADD = $(LDADD)
 gpg_DEPENDENCIES =  ../cipher/libcipher.a ../mpi/libmpi.a \
 ../util/libutil.a
 gpg_LDFLAGS = 
 gpgm_OBJECTS =  dearmor.o build-packet.o compress.o free-packet.o \
 getkey.o pkclist.o skclist.o ringedit.o kbnode.o mainproc.o armor.o \
-mdfilter.o textfilter.o cipher.o elg.o dsa.o rsa.o misc.o openfile.o \
-keyid.o trustdb.o parse-packet.o passphrase.o pubkey-enc.o \
-seckey-cert.o seskey.o import.o export.o comment.o status.o sign.o \
-keyedit.o plaintext.o encr-data.o encode.o revoke.o keylist.o \
-sig-check.o signal.o
+mdfilter.o textfilter.o cipher.o misc.o openfile.o keyid.o trustdb.o \
+parse-packet.o passphrase.o pubkey-enc.o seckey-cert.o seskey.o \
+import.o export.o comment.o status.o sign.o keyedit.o plaintext.o \
+encr-data.o encode.o revoke.o keylist.o sig-check.o signal.o
 gpgm_DEPENDENCIES =  g10maint.o ../cipher/libcipher.a ../mpi/libmpi.a \
 ../util/libutil.a
 gpgm_LDFLAGS = 
 gpgd_OBJECTS =  gpgd.o ks-proto.o build-packet.o compress.o \
 free-packet.o getkey.o pkclist.o skclist.o ringedit.o kbnode.o \
-mainproc.o armor.o mdfilter.o textfilter.o cipher.o elg.o dsa.o rsa.o \
-misc.o openfile.o keyid.o trustdb.o parse-packet.o passphrase.o \
-pubkey-enc.o seckey-cert.o seskey.o import.o export.o comment.o \
-status.o sign.o keyedit.o plaintext.o encr-data.o encode.o revoke.o \
-keylist.o sig-check.o signal.o
+mainproc.o armor.o mdfilter.o textfilter.o cipher.o misc.o openfile.o \
+keyid.o trustdb.o parse-packet.o passphrase.o pubkey-enc.o \
+seckey-cert.o seskey.o import.o export.o comment.o status.o sign.o \
+keyedit.o plaintext.o encr-data.o encode.o revoke.o keylist.o \
+sig-check.o signal.o
 gpgd_LDADD = $(LDADD)
 gpgd_DEPENDENCIES =  ../cipher/libcipher.a ../mpi/libmpi.a \
 ../util/libutil.a
@@ -335,360 +330,191 @@
 armor.o: armor.c ../config.h ../include/errors.h ../include/iobuf.h \
 	../include/types.h ../include/memory.h ../include/util.h \
 	../include/mpi.h filter.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	packet.h options.h main.h keydb.h status.h
+	../include/../cipher/random.h packet.h options.h main.h keydb.h \
+	status.h
 build-packet.o: build-packet.c ../config.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	../include/util.h options.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h ../include/util.h options.h
 cipher.o: cipher.c ../config.h ../include/errors.h ../include/iobuf.h \
 	../include/types.h ../include/memory.h ../include/util.h \
 	../include/mpi.h filter.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	packet.h options.h
+	../include/../cipher/random.h packet.h options.h
 comment.o: comment.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	../include/util.h main.h keydb.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h ../include/util.h main.h keydb.h
 compress.o: compress.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h options.h
+	../include/../cipher/random.h filter.h options.h
 dearmor.o: dearmor.c ../config.h ../include/errors.h ../include/iobuf.h \
 	../include/types.h ../include/memory.h ../include/util.h \
 	../include/mpi.h filter.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	packet.h options.h main.h keydb.h
+	../include/../cipher/random.h packet.h options.h main.h keydb.h
 decrypt.o: decrypt.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h ../include/i18n.h
-dsa.o: dsa.c ../config.h options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
-elg.o: elg.c ../config.h options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h \
+	../include/i18n.h
 encode.o: encode.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h
 encr-data.o: encr-data.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h options.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	options.h
 export.o: export.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h
 free-packet.o: free-packet.c ../config.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/util.h \
-	../include/errors.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/util.h ../include/errors.h
 g10.o: g10.c ../config.h packet.h ../include/types.h ../include/iobuf.h \
 	../include/mpi.h ../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h ../include/util.h ../include/errors.h main.h keydb.h \
-	options.h trustdb.h ../include/ttyio.h ../include/i18n.h \
-	status.h
+	../include/../cipher/random.h filter.h ../include/util.h \
+	../include/errors.h main.h keydb.h options.h trustdb.h \
+	../include/ttyio.h ../include/i18n.h status.h
 getkey.o: getkey.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h keydb.h options.h
+	../include/../cipher/random.h filter.h keydb.h options.h main.h
 gpgd.o: gpgd.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	options.h main.h keydb.h packet.h filter.h
+	../include/../cipher/random.h options.h main.h keydb.h packet.h \
+	filter.h
 import.o: import.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h trustdb.h main.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h trustdb.h main.h
 kbnode.o: kbnode.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h keydb.h
+	../include/../cipher/random.h filter.h keydb.h
 keyedit.o: keyedit.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h ../include/ttyio.h \
-	../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h ../include/i18n.h
 keygen.o: keygen.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h main.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h ../include/ttyio.h options.h \
-	../include/i18n.h
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	../include/ttyio.h options.h ../include/i18n.h
 keyid.o: keyid.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h main.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h options.h
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	options.h
 keylist.o: keylist.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h trustdb.h main.h ../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h trustdb.h main.h \
+	../include/i18n.h
 ks-proto.o: ks-proto.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ks-proto.h
 mainproc.o: mainproc.c ../config.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h options.h \
-	../include/util.h ../include/errors.h keydb.h main.h status.h \
-	../include/i18n.h trustdb.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	options.h ../include/util.h ../include/errors.h keydb.h main.h \
+	status.h ../include/i18n.h trustdb.h
 mdfilter.o: mdfilter.c ../config.h ../include/errors.h \
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h
+	../include/../cipher/random.h
 misc.o: misc.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h main.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	options.h
 openfile.o: openfile.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/ttyio.h options.h main.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h keydb.h packet.h filter.h
+	../include/cipher.h ../include/../cipher/random.h keydb.h \
+	packet.h filter.h
 parse-packet.o: parse-packet.c ../config.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/util.h \
-	../include/errors.h options.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/util.h ../include/errors.h options.h main.h keydb.h
 passphrase.o: passphrase.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h options.h \
 	../include/ttyio.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h main.h ../include/i18n.h
+	../include/../cipher/random.h keydb.h packet.h filter.h main.h \
+	../include/i18n.h
 pkclist.o: pkclist.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h trustdb.h ../include/ttyio.h \
-	../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h trustdb.h \
+	../include/ttyio.h ../include/i18n.h
 plaintext.o: plaintext.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h options.h packet.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/ttyio.h \
-	main.h keydb.h ../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/ttyio.h main.h keydb.h ../include/i18n.h
 pubkey-enc.o: pubkey-enc.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h status.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	keydb.h status.h
 revoke.o: revoke.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h ../include/ttyio.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h
 ringedit.o: ringedit.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h keydb.h
-rsa.o: rsa.c ../config.h options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
+	../include/../cipher/random.h filter.h keydb.h
 seckey-cert.o: seckey-cert.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h main.h options.h \
-	../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	keydb.h main.h options.h ../include/i18n.h
 seskey.o: seskey.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h main.h \
-	keydb.h packet.h filter.h
+	../include/../cipher/random.h main.h keydb.h packet.h filter.h
 sig-check.o: sig-check.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h main.h status.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	keydb.h main.h status.h ../include/i18n.h
 sign.o: sign.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h ../include/ttyio.h \
-	../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h ../include/i18n.h
 signal.o: signal.c ../config.h options.h ../include/errors.h \
 	../include/memory.h ../include/util.h ../include/types.h \
 	../include/mpi.h ../include/iobuf.h main.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h ../include/ttyio.h
+	../include/../cipher/random.h keydb.h packet.h filter.h \
+	../include/ttyio.h
 skclist.o: skclist.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h
 status.o: status.c ../config.h status.h
 textfilter.o: textfilter.c ../config.h ../include/errors.h \
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h
+	../include/../cipher/random.h
 trustdb.o: trustdb.c ../config.h ../include/errors.h ../include/iobuf.h \
 	../include/types.h keydb.h packet.h ../include/mpi.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	filter.h ../include/util.h trustdb.h options.h main.h \
-	../include/i18n.h
+	../include/../cipher/random.h filter.h ../include/util.h \
+	trustdb.h options.h main.h ../include/i18n.h
 verify.o: verify.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/tiger.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h ../include/ttyio.h \
-	../include/i18n.h
+	../include/cipher.h ../include/../cipher/random.h filter.h \
+	../include/errors.h keydb.h ../include/util.h main.h \
+	../include/ttyio.h ../include/i18n.h
 
 info:
 dvi:
diff -urN gnupg-0.2.19/g10/armor.c gnupg-0.3.0/g10/armor.c
--- gnupg-0.2.19/g10/armor.c	Thu May 21 11:26:53 1998
+++ gnupg-0.3.0/g10/armor.c	Wed Jun 24 17:19:29 1998
@@ -100,8 +100,10 @@
 };
 
 
-static fhdr_state_t find_header( fhdr_state_t state, byte *buf,
-		     size_t *r_buflen, IOBUF a, size_t n, unsigned *r_empty);
+static fhdr_state_t find_header( fhdr_state_t state,
+				 byte *buf, size_t *r_buflen,
+				 IOBUF a, size_t n,
+				 unsigned *r_empty, int *r_hashes );
 
 
 static void
@@ -227,7 +229,7 @@
 	    found |= 2;
 	else if( !strncmp( s, "MD5", s2-s ) )
 	    found |= 4;
-	else if( !strncmp( s, "MD2", s2-s ) )
+	else if( !strncmp( s, "TIGER", s2-s ) )
 	    found |= 8;
 	else
 	    return 0;
@@ -250,7 +252,7 @@
  */
 static fhdr_state_t
 find_header( fhdr_state_t state, byte *buf, size_t *r_buflen,
-					IOBUF a, size_t n, unsigned *r_empty)
+	     IOBUF a, size_t n, unsigned *r_empty, int *r_hashes )
 {
     int c=0, i;
     const char *s;
@@ -319,6 +321,7 @@
 	    if( n < buflen || c == '\n' ) {
 		if( n && buf[0] != '\r') { /* maybe a header */
 		    if( strchr( buf, ':') ) { /* yes */
+			int hashes;
 			if( buf[n-1] == '\r' )
 			    buf[--n] = 0;
 			if( opt.verbose ) {
@@ -326,12 +329,15 @@
 			    print_string( stderr, buf, n, 0 );
 			    putc('\n', stderr);
 			}
-			if( clearsig && !parse_hash_header( buf ) ) {
+			if( clearsig && !(hashes=parse_hash_header( buf )) ) {
 			    log_error("invalid clearsig header\n");
 			    state = fhdrERROR;
 			}
-			else
+			else {
 			    state = fhdrWAITHeader;
+			    if( r_hashes )
+				*r_hashes |= hashes;
+			}
 		    }
 		    else
 			state = fhdrCHECKDashEscaped3;
@@ -602,7 +608,8 @@
 	state = fhdrHASArmor;
 
     n = DIM(afx->helpbuf);
-    state = find_header( state, afx->helpbuf, &n, a, afx->helplen, &emplines);
+    state = find_header( state, afx->helpbuf, &n, a,
+				afx->helplen, &emplines, &afx->hashes);
     switch( state ) {
       case fhdrNOArmor:
 	afx->inp_checked = 1;
@@ -684,7 +691,8 @@
 	/* read a new one */
 	n = DIM(afx->helpbuf);
 	afx->helpidx = 0;
-	state = find_header( state, afx->helpbuf, &n, a, 0, &emplines );
+	state = find_header( state, afx->helpbuf, &n, a, 0,
+						&emplines, &afx->hashes );
 	switch( state) {
 	  case fhdrERROR:
 	    invalid_armor();
@@ -884,7 +892,7 @@
 	*ret_len = n;
     }
     else if( control == IOBUFCTRL_UNDERFLOW ) {
-	if( size < 30 )
+	if( size < 15+(4*15) )	/* need space for up to 4 onepass_sigs */
 	    BUG(); /* supplied buffer too short */
 
 	if( afx->inp_eof ) {
@@ -907,27 +915,53 @@
 		afx->helplen = 0;
 	    }
 	    else if( afx->faked ) {
-		/* the buffer is at least 30 bytes long, so it
+		unsigned hashes = afx->hashes;
+		/* the buffer is at least 15+n*15 bytes long, so it
 		 * is easy to construct the packets */
 
-		/* first a onepass signature packet */
-		buf[0] = 0x90; /* old packet format, type 4, 1 length byte */
-		buf[1] = 13;   /* length */
-		buf[2] = 3;    /* version */
-		buf[3] = 0x01; /* sigclass 0x01 (data in canonical text mode)*/
-		buf[4] = 0;    /* digest algo (don't know) */
-		buf[5] = 0;    /* public key algo (don't know) */
-		memset(buf+6, 0, 8); /* don't know the keyid */
-		buf[14] = 1;   /* this is the last one */
+		hashes &= 1|2|4|8;
+		if( !hashes )
+		    hashes |= 4;  /* default to MD 5 */
+		n=0;
+		do {
+		    /* first some onepass signature packets */
+		    buf[n++] = 0x90; /* old format, type 4, 1 length byte */
+		    buf[n++] = 13;   /* length */
+		    buf[n++] = 3;    /* version */
+		    buf[n++] = 0x01; /* sigclass 0x01 (canonical text mode)*/
+		    if( hashes & 1 ) {
+			hashes &= ~1;
+			buf[n++] = DIGEST_ALGO_RMD160;
+		    }
+		    else if( hashes & 2 ) {
+			hashes &= ~2;
+			buf[n++] = DIGEST_ALGO_SHA1;
+		    }
+		    else if( hashes & 4 ) {
+			hashes &= ~4;
+			buf[n++] = DIGEST_ALGO_MD5;
+		    }
+		    else if( hashes & 8 ) {
+			hashes &= ~8;
+			buf[n++] = DIGEST_ALGO_TIGER;
+		    }
+		    else
+			buf[n++] = 0;	 /* (don't know) */
+
+		    buf[n++] = 0;    /* public key algo (don't know) */
+		    memset(buf+n, 0, 8); /* don't know the keyid */
+		    n += 8;
+		    buf[n++] = !hashes;   /* last one */
+		} while( hashes );
 
 		/* followed by a plaintext packet */
-		buf[15] = 0xaf; /* old packet format, type 11, var length */
-		buf[16] = 0;	/* set the length header */
-		buf[17] = 6;
-		buf[18] = 't';  /* canonical text mode */
-		buf[19] = 0;	/* namelength */
-		memset(buf+20, 0, 4); /* timestamp */
-		n = 24;
+		buf[n++] = 0xaf; /* old packet format, type 11, var length */
+		buf[n++] = 0;	 /* set the length header */
+		buf[n++] = 6;
+		buf[n++] = 't';  /* canonical text mode */
+		buf[n++] = 0;	 /* namelength */
+		memset(buf+n, 0, 4); /* timestamp */
+		n += 4;
 	    }
 	    else if( !rc )
 		rc = radix64_read( afx, a, &n, buf, size );
diff -urN gnupg-0.2.19/g10/build-packet.c gnupg-0.3.0/g10/build-packet.c
--- gnupg-0.2.19/g10/build-packet.c	Sat May 16 16:01:59 1998
+++ gnupg-0.3.0/g10/build-packet.c	Tue Jun 23 18:04:53 1998
@@ -177,6 +177,7 @@
 do_public_cert( IOBUF out, int ctb, PKT_public_cert *pkc )
 {
     int rc = 0;
+    int n, i;
     IOBUF a = iobuf_temp();
 
     if( !pkc->version )
@@ -187,31 +188,14 @@
     if( pkc->version < 4 )
 	write_16(a, pkc->valid_days );
     iobuf_put(a, pkc->pubkey_algo );
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
-	mpi_write(a, pkc->d.elg.p );
-	mpi_write(a, pkc->d.elg.g );
-	mpi_write(a, pkc->d.elg.y );
-    }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_write(a, pkc->d.dsa.p );
-	mpi_write(a, pkc->d.dsa.q );
-	mpi_write(a, pkc->d.dsa.g );
-	mpi_write(a, pkc->d.dsa.y );
-    }
-    else if( is_RSA(pkc->pubkey_algo) ) {
-	mpi_write(a, pkc->d.rsa.n );
-	mpi_write(a, pkc->d.rsa.e );
-    }
-    else {
-	rc = G10ERR_PUBKEY_ALGO;
-	goto leave;
-    }
+    n = pubkey_get_npkey( pkc->pubkey_algo );
+    for(i=0; i < n; i++ )
+	mpi_write(a, pkc->pkey[i] );
 
     write_header2(out, ctb, iobuf_get_temp_length(a), pkc->hdrbytes, 1 );
     if( iobuf_write_temp( out, a ) )
 	rc = G10ERR_WRITE_FILE;
 
-  leave:
     iobuf_close(a);
     return rc;
 }
@@ -227,7 +211,7 @@
     int rc = 0;
     int c;
     IOBUF a = iobuf_temp();
-  #if 1
+  #if 0
     FILE *fp = fopen("dump.pkc", "a");
     int i=0;
 
@@ -241,7 +225,7 @@
     if( (rc = build_packet( a, &pkt )) )
 	log_fatal("build public_cert for hashing failed: %s\n", g10_errstr(rc));
     while( (c=iobuf_get(a)) != -1 ) {
-      #if 1
+      #if 0
 	fprintf( fp," %02x", c );
 	if( (++i == 24) ) {
 	    putc('\n', fp);
@@ -250,7 +234,7 @@
       #endif
 	md_putc( md, c );
     }
-  #if 1
+  #if 0
     putc('\n', fp);
     fclose(fp);
   #endif
@@ -262,6 +246,7 @@
 do_secret_cert( IOBUF out, int ctb, PKT_secret_cert *skc )
 {
     int rc = 0;
+    int i, nskey, npkey;
     IOBUF a = iobuf_temp();
 
     if( !skc->version )
@@ -272,34 +257,18 @@
     if( skc->version < 4 )
 	write_16(a, skc->valid_days );
     iobuf_put(a, skc->pubkey_algo );
-    if( is_ELGAMAL(skc->pubkey_algo) ) {
-	mpi_write(a, skc->d.elg.p );
-	mpi_write(a, skc->d.elg.g );
-	mpi_write(a, skc->d.elg.y );
-	if( skc->is_protected ) {
-	    iobuf_put(a, 0xff );
+    nskey = pubkey_get_nskey( skc->pubkey_algo );
+    npkey = pubkey_get_npkey( skc->pubkey_algo );
+    assert( npkey < nskey );
+
+    for(i=0; i < npkey; i++ )
+	mpi_write(a, skc->skey[i] );
+    if( skc->is_protected ) {
+	if( is_RSA(skc->pubkey_algo) && skc->version < 4 ) {
 	    iobuf_put(a, skc->protect.algo );
-	    iobuf_put(a, skc->protect.s2k.mode );
-	    iobuf_put(a, skc->protect.s2k.hash_algo );
-	    if( skc->protect.s2k.mode == 1
-		|| skc->protect.s2k.mode == 4 )
-		iobuf_write(a, skc->protect.s2k.salt, 8 );
-	    if( skc->protect.s2k.mode == 4 )
-		write_32(a, skc->protect.s2k.count );
 	    iobuf_write(a, skc->protect.iv, 8 );
 	}
-	else
-	    iobuf_put(a, 0 );
-
-	mpi_write(a, skc->d.elg.x );
-	write_16(a, skc->csum );
-    }
-    else if( skc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_write(a, skc->d.dsa.p );
-	mpi_write(a, skc->d.dsa.q );
-	mpi_write(a, skc->d.dsa.g );
-	mpi_write(a, skc->d.dsa.y );
-	if( skc->is_protected ) {
+	else {
 	    iobuf_put(a, 0xff );
 	    iobuf_put(a, skc->protect.algo );
 	    iobuf_put(a, skc->protect.s2k.mode );
@@ -311,37 +280,17 @@
 		write_32(a, skc->protect.s2k.count );
 	    iobuf_write(a, skc->protect.iv, 8 );
 	}
-	else
-	    iobuf_put(a, 0 );
-
-	mpi_write(a, skc->d.dsa.x );
-	write_16(a, skc->csum );
-    }
-    else if( is_RSA(skc->pubkey_algo) ) {
-	mpi_write(a, skc->d.rsa.n );
-	mpi_write(a, skc->d.rsa.e );
-	if( skc->is_protected ) {
-	    iobuf_put(a, skc->protect.algo );
-	    iobuf_write(a, skc->protect.iv, 8 );
-	}
-	else
-	    iobuf_put(a, 0 );
-	mpi_write(a, skc->d.rsa.d );
-	mpi_write(a, skc->d.rsa.p );
-	mpi_write(a, skc->d.rsa.q );
-	mpi_write(a, skc->d.rsa.u );
-	write_16(a, skc->csum );
-    }
-    else {
-	rc = G10ERR_PUBKEY_ALGO;
-	goto leave;
     }
+    else
+	iobuf_put(a, 0 );
+    for(   ; i < nskey; i++ )
+	mpi_write(a, skc->skey[i] );
+    write_16(a, skc->csum );
 
     write_header2(out, ctb, iobuf_get_temp_length(a), skc->hdrbytes, 1 );
     if( iobuf_write_temp( out, a ) )
 	rc = G10ERR_WRITE_FILE;
 
-  leave:
     iobuf_close(a);
     return rc;
 }
@@ -381,29 +330,21 @@
 do_pubkey_enc( IOBUF out, int ctb, PKT_pubkey_enc *enc )
 {
     int rc = 0;
+    int n, i;
     IOBUF a = iobuf_temp();
 
     write_version( a, ctb );
     write_32(a, enc->keyid[0] );
     write_32(a, enc->keyid[1] );
     iobuf_put(a,enc->pubkey_algo );
-    if( is_ELGAMAL(enc->pubkey_algo) ) {
-	mpi_write(a, enc->d.elg.a );
-	mpi_write(a, enc->d.elg.b );
-    }
-    else if( is_RSA(enc->pubkey_algo) ) {
-	mpi_write(a, enc->d.rsa.rsa_integer );
-    }
-    else {
-	rc = G10ERR_PUBKEY_ALGO;
-	goto leave;
-    }
+    n = pubkey_get_nenc( enc->pubkey_algo );
+    for(i=0; i < n; i++ )
+	mpi_write(a, enc->data[i] );
 
     write_header(out, ctb, iobuf_get_temp_length(a) );
     if( iobuf_write_temp( out, a ) )
 	rc = G10ERR_WRITE_FILE;
 
-  leave:
     iobuf_close(a);
     return rc;
 }
@@ -575,6 +516,12 @@
 
     switch( type ) {
       case SIGSUBPKT_SIG_CREATED:
+      case SIGSUBPKT_PRIV_ADD_SIG:
+      case SIGSUBPKT_PREF_SYM:
+      case SIGSUBPKT_PREF_HASH:
+      case SIGSUBPKT_PREF_COMPR:
+      case SIGSUBPKT_KS_FLAGS:
+      case SIGSUBPKT_KEY_EXPIRE:
 	       hashed = 1; break;
       default: hashed = 0; break;
     }
@@ -596,8 +543,8 @@
 				  : m_alloc( n+2 );
     }
 
-    data[n0+0] = (n >> 8) & 0xff;
-    data[n0+1] = n & 0xff;
+    data[0] = (n >> 8) & 0xff;
+    data[1] = n & 0xff;
     data[n0+2] = buflen+1;
     data[n0+3] = type;
     memcpy(data+n0+4, buffer, buflen );
@@ -649,6 +596,7 @@
 do_signature( IOBUF out, int ctb, PKT_signature *sig )
 {
     int rc = 0;
+    int n, i;
     IOBUF a = iobuf_temp();
 
     if( !sig->version )
@@ -683,27 +631,14 @@
     }
     iobuf_put(a, sig->digest_start[0] );
     iobuf_put(a, sig->digest_start[1] );
-    if( is_ELGAMAL(sig->pubkey_algo) ) {
-	mpi_write(a, sig->d.elg.a );
-	mpi_write(a, sig->d.elg.b );
-    }
-    else if( sig->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_write(a, sig->d.dsa.r );
-	mpi_write(a, sig->d.dsa.s );
-    }
-    else if( is_RSA(sig->pubkey_algo) ) {
-	mpi_write(a, sig->d.rsa.rsa_integer );
-    }
-    else {
-	rc = G10ERR_PUBKEY_ALGO;
-	goto leave;
-    }
+    n = pubkey_get_nsig( sig->pubkey_algo );
+    for(i=0; i < n; i++ )
+	mpi_write(a, sig->data[i] );
 
     write_header(out, ctb, iobuf_get_temp_length(a) );
     if( iobuf_write_temp( out, a ) )
 	rc = G10ERR_WRITE_FILE;
 
-  leave:
     iobuf_close(a);
     return rc;
 }
diff -urN gnupg-0.2.19/g10/dsa.c gnupg-0.3.0/g10/dsa.c
--- gnupg-0.2.19/g10/dsa.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/dsa.c	Thu Jan  1 01:00:00 1970
@@ -1,69 +0,0 @@
-/* dsa.c
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-
-#include <config.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <errno.h>
-#include <assert.h>
-
-#include "options.h"
-#include "packet.h"
-#include "errors.h"
-#include "iobuf.h"
-#include "keydb.h"
-#include "memory.h"
-#include "util.h"
-#include "main.h"
-
-
-void
-g10_dsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
-	      MD_HANDLE md, int digest_algo )
-{
-    MPI frame;
-    byte *dp;
-
-    assert( sig->pubkey_algo == PUBKEY_ALGO_DSA );
-    if( !digest_algo )
-	digest_algo = md_get_algo(md);
-
-    dp = md_read( md, digest_algo );
-    sig->digest_algo = digest_algo;
-    sig->digest_start[0] = dp[0];
-    sig->digest_start[1] = dp[1];
-    sig->d.dsa.r = mpi_alloc( mpi_get_nlimbs(skc->d.dsa.p) );
-    sig->d.dsa.s = mpi_alloc( mpi_get_nlimbs(skc->d.dsa.p) );
-    frame = mpi_alloc( (md_digest_length(digest_algo)+BYTES_PER_MPI_LIMB-1)
-		       / BYTES_PER_MPI_LIMB );
-    mpi_set_buffer( frame, md_read(md, digest_algo),
-			   md_digest_length(digest_algo), 0 );
-    if( DBG_CIPHER )
-	log_mpidump("used sig frame: ", frame);
-    dsa_sign( sig->d.dsa.r, sig->d.dsa.s, frame, &skc->d.dsa );
-    mpi_free(frame);
-    if( opt.verbose ) {
-	char *ustr = get_user_id_string( sig->keyid );
-	log_info("DSA signature from: %s\n", ustr );
-	m_free(ustr);
-    }
-}
-
diff -urN gnupg-0.2.19/g10/elg.c gnupg-0.3.0/g10/elg.c
--- gnupg-0.2.19/g10/elg.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/elg.c	Thu Jan  1 01:00:00 1970
@@ -1,92 +0,0 @@
-/* elg.c
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-
-#include <config.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <errno.h>
-#include <assert.h>
-
-#include "options.h"
-#include "packet.h"
-#include "errors.h"
-#include "iobuf.h"
-#include "keydb.h"
-#include "memory.h"
-#include "util.h"
-#include "main.h"
-
-void
-g10_elg_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek )
-{
-    MPI frame;
-
-    assert( is_ELGAMAL(enc->pubkey_algo) );
-
-    enc->d.elg.a = mpi_alloc( mpi_get_nlimbs(pkc->d.elg.p) );
-    enc->d.elg.b = mpi_alloc( mpi_get_nlimbs(pkc->d.elg.p) );
-    keyid_from_pkc( pkc, enc->keyid );
-    frame = encode_session_key( dek, mpi_get_nbits(pkc->d.elg.p) );
-    if( DBG_CIPHER )
-	log_mpidump("Plain DEK frame: ", frame);
-    elg_encrypt( enc->d.elg.a, enc->d.elg.b, frame, &pkc->d.elg );
-    mpi_free( frame );
-    if( DBG_CIPHER ) {
-	log_mpidump("Encry DEK a: ", enc->d.elg.a );
-	log_mpidump("      DEK b: ", enc->d.elg.b );
-    }
-    if( opt.verbose ) {
-	char *ustr = get_user_id_string( enc->keyid );
-	log_info("ElGamal encrypted for: %s\n", ustr );
-	m_free(ustr);
-    }
-}
-
-
-void
-g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig,
-	      MD_HANDLE md, int digest_algo )
-{
-    MPI frame;
-    byte *dp;
-
-    assert( is_ELGAMAL(sig->pubkey_algo) );
-    if( !digest_algo )
-	digest_algo = md_get_algo(md);
-
-    dp = md_read( md, digest_algo );
-    sig->digest_algo = digest_algo;
-    sig->digest_start[0] = dp[0];
-    sig->digest_start[1] = dp[1];
-    sig->d.elg.a = mpi_alloc( mpi_get_nlimbs(skc->d.elg.p) );
-    sig->d.elg.b = mpi_alloc( mpi_get_nlimbs(skc->d.elg.p) );
-    frame = encode_md_value( md, digest_algo,  mpi_get_nbits(skc->d.elg.p));
-    if( DBG_CIPHER )
-	log_mpidump("calc sig frame (elg): ", frame);
-    elg_sign( sig->d.elg.a, sig->d.elg.b, frame, &skc->d.elg );
-    mpi_free(frame);
-    if( opt.verbose ) {
-	char *ustr = get_user_id_string( sig->keyid );
-	log_info("ElGamal signature from: %s\n", ustr );
-	m_free(ustr);
-    }
-}
-
diff -urN gnupg-0.2.19/g10/encode.c gnupg-0.3.0/g10/encode.c
--- gnupg-0.2.19/g10/encode.c	Tue May 26 13:54:05 1998
+++ gnupg-0.3.0/g10/encode.c	Fri Jun 12 21:08:37 1998
@@ -89,7 +89,7 @@
     cfx.dek = NULL;
     if( mode ) {
 	s2k = m_alloc_clear( sizeof *s2k );
-	s2k->mode = 1;
+	s2k->mode = opt.rfc1991? 0:1;
 	s2k->hash_algo = opt.def_digest_algo ? opt.def_digest_algo
 					     : DEFAULT_DIGEST_ALGO;
 	cfx.dek = passphrase_to_dek( NULL, opt.def_cipher_algo, s2k, 2 );
@@ -116,7 +116,7 @@
 	write_comment( out, "#created by GNUPG v" VERSION " ("
 					    PRINTABLE_OS_NAME ")");
 
-    if( s2k ) {
+    if( s2k && !opt.rfc1991 ) {
 	PKT_symkey_enc *enc = m_alloc_clear( sizeof *enc );
 	enc->version = 4;
 	enc->cipher_algo = cfx.dek->algo;
@@ -329,26 +329,36 @@
     int rc;
 
     for( ; pkc_list; pkc_list = pkc_list->next ) {
+	MPI frame;
 
 	pkc = pkc_list->pkc;
 	enc = m_alloc_clear( sizeof *enc );
 	enc->pubkey_algo = pkc->pubkey_algo;
-	if( is_ELGAMAL(enc->pubkey_algo) )
-	    g10_elg_encrypt( pkc, enc, dek );
-	else if( is_RSA(enc->pubkey_algo) )
-	    g10_rsa_encrypt( pkc, enc, dek );
-	else
-	    BUG();
-	/* and write it */
-	init_packet(&pkt);
-	pkt.pkttype = PKT_PUBKEY_ENC;
-	pkt.pkt.pubkey_enc = enc;
-	rc = build_packet( out, &pkt );
+	keyid_from_pkc( pkc, enc->keyid );
+	frame = encode_session_key( dek, pubkey_nbits( pkc->pubkey_algo,
+							  pkc->pkey ) );
+	rc = pubkey_encrypt( pkc->pubkey_algo, enc->data, frame, pkc->pkey );
+	mpi_free( frame );
+	if( rc )
+	    log_error("pubkey_encrypt failed: %s\n", g10_errstr(rc) );
+	else {
+	    if( opt.verbose ) {
+		char *ustr = get_user_id_string( enc->keyid );
+		log_info("%s encrypted for: %s\n",
+		    pubkey_algo_to_string(enc->pubkey_algo), ustr );
+		m_free(ustr);
+	    }
+	    /* and write it */
+	    init_packet(&pkt);
+	    pkt.pkttype = PKT_PUBKEY_ENC;
+	    pkt.pkt.pubkey_enc = enc;
+	    rc = build_packet( out, &pkt );
+	    if( rc )
+	       log_error("build_packet(pubkey_enc) failed: %s\n", g10_errstr(rc));
+	}
 	free_pubkey_enc(enc);
-	if( rc ) {
-	    log_error("build pubkey_enc packet failed: %s\n", g10_errstr(rc) );
+	if( rc )
 	    return rc;
-	}
     }
     return 0;
 }
diff -urN gnupg-0.2.19/g10/filter.h gnupg-0.3.0/g10/filter.h
--- gnupg-0.2.19/g10/filter.h	Fri May 15 15:21:05 1998
+++ gnupg-0.3.0/g10/filter.h	Wed Jun 24 16:26:44 1998
@@ -37,6 +37,7 @@
     byte helpbuf[100];
     int  helpidx, helplen;
     unsigned empty;    /* empty line counter */
+    int hashes;        /* detected hash algorithms */
     int faked;
     int parse_state;
     int inp_checked;   /* set if inp has been checked */
diff -urN gnupg-0.2.19/g10/free-packet.c gnupg-0.3.0/g10/free-packet.c
--- gnupg-0.2.19/g10/free-packet.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/free-packet.c	Fri Jun 12 18:13:07 1998
@@ -40,28 +40,20 @@
 void
 free_pubkey_enc( PKT_pubkey_enc *enc )
 {
-    if( is_ELGAMAL(enc->pubkey_algo) ) {
-	mpi_free( enc->d.elg.a );
-	mpi_free( enc->d.elg.b );
-    }
-    else if( is_RSA(enc->pubkey_algo) )
-	mpi_free( enc->d.rsa.rsa_integer );
+    int n, i;
+    n = pubkey_get_nenc( enc->pubkey_algo );
+    for(i=0; i < n; i++ )
+	mpi_free( enc->data[i] );
     m_free(enc);
 }
 
 void
 free_seckey_enc( PKT_signature *sig )
 {
-    if( is_ELGAMAL(sig->pubkey_algo) ) {
-	mpi_free( sig->d.elg.a );
-	mpi_free( sig->d.elg.b );
-    }
-    else if( sig->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_free( sig->d.dsa.r );
-	mpi_free( sig->d.dsa.s );
-    }
-    else if( is_RSA(sig->pubkey_algo) )
-	mpi_free( sig->d.rsa.rsa_integer );
+    int n, i;
+    n = pubkey_get_nenc( sig->pubkey_algo );
+    for(i=0; i < n; i++ )
+	mpi_free( sig->data[i] );
     m_free(sig->hashed_data);
     m_free(sig->unhashed_data);
     m_free(sig);
@@ -72,23 +64,15 @@
 void
 release_public_cert_parts( PKT_public_cert *cert )
 {
-    if( is_ELGAMAL(cert->pubkey_algo) ) {
-	mpi_free( cert->d.elg.p ); cert->d.elg.p = NULL;
-	mpi_free( cert->d.elg.g ); cert->d.elg.g = NULL;
-	mpi_free( cert->d.elg.y ); cert->d.elg.y = NULL;
-    }
-    else if( cert->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_free( cert->d.dsa.p ); cert->d.dsa.p = NULL;
-	mpi_free( cert->d.dsa.q ); cert->d.dsa.q = NULL;
-	mpi_free( cert->d.dsa.g ); cert->d.dsa.g = NULL;
-	mpi_free( cert->d.dsa.y ); cert->d.dsa.y = NULL;
-    }
-    else if( is_RSA(cert->pubkey_algo) ) {
-	mpi_free( cert->d.rsa.n ); cert->d.rsa.n = NULL;
-	mpi_free( cert->d.rsa.e ); cert->d.rsa.e = NULL;
+    int n, i;
+    n = pubkey_get_npkey( cert->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	mpi_free( cert->pkey[i] );
+	cert->pkey[i] = NULL;
     }
 }
 
+
 void
 free_public_cert( PKT_public_cert *cert )
 {
@@ -99,50 +83,26 @@
 PKT_public_cert *
 copy_public_cert( PKT_public_cert *d, PKT_public_cert *s )
 {
+    int n, i;
+
     if( !d )
 	d = m_alloc(sizeof *d);
     memcpy( d, s, sizeof *d );
-    if( is_ELGAMAL(s->pubkey_algo) ) {
-	d->d.elg.p = mpi_copy( s->d.elg.p );
-	d->d.elg.g = mpi_copy( s->d.elg.g );
-	d->d.elg.y = mpi_copy( s->d.elg.y );
-    }
-    else if( s->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	d->d.dsa.p = mpi_copy( s->d.dsa.p );
-	d->d.dsa.q = mpi_copy( s->d.dsa.q );
-	d->d.dsa.g = mpi_copy( s->d.dsa.g );
-	d->d.dsa.y = mpi_copy( s->d.dsa.y );
-    }
-    else if( is_RSA(s->pubkey_algo) ) {
-	d->d.rsa.n = mpi_copy( s->d.rsa.n );
-	d->d.rsa.e = mpi_copy( s->d.rsa.e );
-    }
+    n = pubkey_get_npkey( s->pubkey_algo );
+    for(i=0; i < n; i++ )
+	d->pkey[i] = mpi_copy( s->pkey[i] );
     return d;
 }
 
 void
 release_secret_cert_parts( PKT_secret_cert *cert )
 {
-    if( is_ELGAMAL(cert->pubkey_algo) ) {
-	mpi_free( cert->d.elg.p ); cert->d.elg.p = NULL;
-	mpi_free( cert->d.elg.g ); cert->d.elg.g = NULL;
-	mpi_free( cert->d.elg.y ); cert->d.elg.y = NULL;
-	mpi_free( cert->d.elg.x ); cert->d.elg.x = NULL;
-    }
-    else if( cert->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	mpi_free( cert->d.dsa.p ); cert->d.dsa.p = NULL;
-	mpi_free( cert->d.dsa.q ); cert->d.dsa.q = NULL;
-	mpi_free( cert->d.dsa.g ); cert->d.dsa.g = NULL;
-	mpi_free( cert->d.dsa.y ); cert->d.dsa.y = NULL;
-	mpi_free( cert->d.dsa.x ); cert->d.dsa.x = NULL;
-    }
-    else if( is_RSA(cert->pubkey_algo) ) {
-	mpi_free( cert->d.rsa.n ); cert->d.rsa.n = NULL;
-	mpi_free( cert->d.rsa.e ); cert->d.rsa.e = NULL;
-	mpi_free( cert->d.rsa.d ); cert->d.rsa.d = NULL;
-	mpi_free( cert->d.rsa.p ); cert->d.rsa.p = NULL;
-	mpi_free( cert->d.rsa.q ); cert->d.rsa.q = NULL;
-	mpi_free( cert->d.rsa.u ); cert->d.rsa.u = NULL;
+    int n, i;
+
+    n = pubkey_get_nskey( cert->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	mpi_free( cert->skey[i] );
+	cert->skey[i] = NULL;
     }
 }
 
@@ -156,30 +116,14 @@
 PKT_secret_cert *
 copy_secret_cert( PKT_secret_cert *d, PKT_secret_cert *s )
 {
+    int n, i;
+
     if( !d )
 	d = m_alloc(sizeof *d);
     memcpy( d, s, sizeof *d );
-    if( is_ELGAMAL(s->pubkey_algo) ) {
-	d->d.elg.p = mpi_copy( s->d.elg.p );
-	d->d.elg.g = mpi_copy( s->d.elg.g );
-	d->d.elg.y = mpi_copy( s->d.elg.y );
-	d->d.elg.x = mpi_copy( s->d.elg.x );
-    }
-    else if( s->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	d->d.dsa.p = mpi_copy( s->d.dsa.p );
-	d->d.dsa.q = mpi_copy( s->d.dsa.q );
-	d->d.dsa.g = mpi_copy( s->d.dsa.g );
-	d->d.dsa.y = mpi_copy( s->d.dsa.y );
-	d->d.dsa.x = mpi_copy( s->d.dsa.x );
-    }
-    else if( is_RSA(s->pubkey_algo) ) {
-	d->d.rsa.n = mpi_copy( s->d.rsa.n );
-	d->d.rsa.e = mpi_copy( s->d.rsa.e );
-	d->d.rsa.d = mpi_copy( s->d.rsa.d );
-	d->d.rsa.p = mpi_copy( s->d.rsa.p );
-	d->d.rsa.q = mpi_copy( s->d.rsa.q );
-	d->d.rsa.u = mpi_copy( s->d.rsa.u );
-    }
+    n = pubkey_get_nskey( s->pubkey_algo );
+    for(i=0; i < n; i++ )
+	d->skey[i] = mpi_copy( s->skey[i] );
     return d;
 }
 
@@ -298,6 +242,8 @@
 int
 cmp_public_certs( PKT_public_cert *a, PKT_public_cert *b )
 {
+    int n, i;
+
     if( a->timestamp != b->timestamp )
 	return -1;
     if( a->valid_days != b->valid_days )
@@ -305,28 +251,9 @@
     if( a->pubkey_algo != b->pubkey_algo )
 	return -1;
 
-    if( is_ELGAMAL(a->pubkey_algo) ) {
-	if( mpi_cmp( a->d.elg.p , b->d.elg.p ) )
-	    return -1;
-	if( mpi_cmp( a->d.elg.g , b->d.elg.g ) )
-	    return -1;
-	if( mpi_cmp( a->d.elg.y , b->d.elg.y ) )
-	    return -1;
-    }
-    else if( a->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	if( mpi_cmp( a->d.dsa.p , b->d.dsa.p ) )
-	    return -1;
-	if( mpi_cmp( a->d.dsa.q , b->d.dsa.q ) )
-	    return -1;
-	if( mpi_cmp( a->d.dsa.g , b->d.dsa.g ) )
-	    return -1;
-	if( mpi_cmp( a->d.dsa.y , b->d.dsa.y ) )
-	    return -1;
-    }
-    else if( is_RSA(a->pubkey_algo) ) {
-	if( mpi_cmp( a->d.rsa.n , b->d.rsa.n ) )
-	    return -1;
-	if( mpi_cmp( a->d.rsa.e , b->d.rsa.e ) )
+    n = pubkey_get_npkey( b->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	if( mpi_cmp( a->pkey[i], b->pkey[i] ) )
 	    return -1;
     }
 
@@ -339,6 +266,8 @@
 int
 cmp_public_secret_cert( PKT_public_cert *pkc, PKT_secret_cert *skc )
 {
+    int n, i;
+
     if( pkc->timestamp != skc->timestamp )
 	return -1;
     if( pkc->valid_days != skc->valid_days )
@@ -346,31 +275,11 @@
     if( pkc->pubkey_algo != skc->pubkey_algo )
 	return -1;
 
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
-	if( mpi_cmp( pkc->d.elg.p , skc->d.elg.p ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.elg.g , skc->d.elg.g ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.elg.y , skc->d.elg.y ) )
-	    return -1;
-    }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	if( mpi_cmp( pkc->d.dsa.p , skc->d.dsa.p ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.dsa.q , skc->d.dsa.q ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.dsa.g , skc->d.dsa.g ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.dsa.y , skc->d.dsa.y ) )
+    n = pubkey_get_npkey( pkc->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	if( mpi_cmp( pkc->pkey[i] , skc->skey[i] ) )
 	    return -1;
     }
-    else if( is_RSA(pkc->pubkey_algo) ) {
-	if( mpi_cmp( pkc->d.rsa.n , skc->d.rsa.n ) )
-	    return -1;
-	if( mpi_cmp( pkc->d.rsa.e , skc->d.rsa.e ) )
-	    return -1;
-    }
-
     return 0;
 }
 
diff -urN gnupg-0.2.19/g10/g10.c gnupg-0.3.0/g10/g10.c
--- gnupg-0.2.19/g10/g10.c	Fri May 29 10:15:27 1998
+++ gnupg-0.3.0/g10/g10.c	Wed Jun 17 18:12:48 1998
@@ -111,6 +111,8 @@
     { 534, "no-comment", 0,   N_("do not write comment packets")},
     { 535, "completes-needed", 1, N_("(default is 1)")},
     { 536, "marginals-needed", 1, N_("(default is 3)")},
+    { 560, "load-extension" ,2, N_("|file|load extension module")},
+    { 561, "rfc1991",   0, N_("emulate the mode described in RFC1991")},
   #ifdef IS_G10
     { 527, "cipher-algo", 2 , N_("|NAME|use cipher algorithm NAME")},
     { 528, "pubkey-algo", 2 , N_("|NAME|use public key algorithm NAME")},
@@ -162,6 +164,7 @@
     { 553, "skip-verify",0, "@" },
     { 557, "compress-keys",0, "@"},
     { 559, "always-trust", 0, "@"},
+    { 562, "emulate-checksum-bug", 0, "@"},
 
 {0} };
 
@@ -315,9 +318,10 @@
     if( opt.debug & DBG_MPI_VALUE )
 	mpi_debug_mode = 1;
     if( opt.debug & DBG_CIPHER_VALUE )
-	cipher_debug_mode = 1;
+	g10c_debug_mode = 1;
     if( opt.debug & DBG_IOBUF_VALUE )
 	iobuf_debug_mode = 1;
+
 }
 
 
@@ -427,7 +431,7 @@
     orig_argv = argv;
     pargs.argc = &argc;
     pargs.argv = &argv;
-    pargs.flags=  1;  /* do not remove the args */
+    pargs.flags= 1|(1<<6);  /* do not remove the args, ignore version */
     while( arg_parse( &pargs, opts) ) {
 	if( pargs.r_opt == 510 || pargs.r_opt == 511 )
 	    parse_debug++;
@@ -540,7 +544,8 @@
 	#endif /* IS_G10MAINT */
 
 	  case 'o': opt.outfile = pargs.r.ret_str; break;
-	  case 'v': opt.verbose++; opt.list_sigs=1; break;
+	  case 'v': g10_opt_verbose++;
+		    opt.verbose++; opt.list_sigs=1; break;
 	  case 'k': set_cmd( &cmd, aKMode ); break;
 
 	  case 500: opt.batch = 1; greeting = 0; break;
@@ -565,7 +570,8 @@
 	  case 520: default_keyring = 0; break;
 	  case 521: set_cmd( &cmd, aListPackets); break;
 	  case 522: greeting = 0; break;
-	  case 526: opt.verbose = 0; opt.list_sigs=0; break;
+	  case 526: g10_opt_verbose = 0;
+		    opt.verbose = 0; opt.list_sigs=0; break;
 	  case 530: set_cmd( &cmd, aImport); break;
 	  case 532: quick_random_gen(1); break;
 	  case 534: opt.no_comment=1; break;
@@ -586,6 +592,9 @@
 	  case 557: opt.compress_keys = 1; break;
 	  case 558: set_cmd( &cmd, aListSecretKeys); break;
 	  case 559: opt.always_trust = 1; break;
+	  case 560: register_cipher_extension(pargs.r.ret_str); break;
+	  case 561: opt.rfc1991 = 1; break;
+	  case 562: opt.emulate_bugs |= 1; break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
@@ -629,6 +638,7 @@
 	    opt.list_sigs++;
 
 	opt.verbose = opt.verbose > 1;
+	g10_opt_verbose = opt.verbose;
     }
 
 
@@ -1098,9 +1108,8 @@
 	md_enable( md, DIGEST_ALGO_MD5 );
 	md_enable( md, DIGEST_ALGO_SHA1 );
 	md_enable( md, DIGEST_ALGO_RMD160 );
-      #ifdef WITH_TIGER_HASH
-	md_enable( md, DIGEST_ALGO_TIGER );
-      #endif
+	if( !check_digest_algo(DIGEST_ALGO_TIGER) )
+	    md_enable( md, DIGEST_ALGO_TIGER );
     }
 
     while( (n=fread( buf, 1, DIM(buf), fp )) )
@@ -1121,10 +1130,10 @@
 			    print_hex(md_read(md, DIGEST_ALGO_SHA1), 20 );
 	    printf("\n%sRMD160 = ", fname?pname:""  );
 			    print_hex(md_read(md, DIGEST_ALGO_RMD160), 20 );
-	  #ifdef WITH_TIGER_HASH
-	    printf("\n%s TIGER = ", fname?pname:""  );
+	    if( !check_digest_algo(DIGEST_ALGO_TIGER) ) {
+		printf("\n%s TIGER = ", fname?pname:""  );
 			    print_hex(md_read(md, DIGEST_ALGO_TIGER), 24 );
-	  #endif
+	    }
 	}
 	putchar('\n');
     }
diff -urN gnupg-0.2.19/g10/getkey.c gnupg-0.3.0/g10/getkey.c
--- gnupg-0.2.19/g10/getkey.c	Wed May 27 13:41:10 1998
+++ gnupg-0.3.0/g10/getkey.c	Wed Jun 24 16:16:22 1998
@@ -30,6 +30,7 @@
 #include "iobuf.h"
 #include "keydb.h"
 #include "options.h"
+#include "main.h"
 
 #define MAX_PKC_CACHE_ENTRIES 500
 
@@ -474,16 +475,18 @@
 /****************
  * Search for a key with the given fingerprint and return the
  * complete keyblock which may have more than only this key.
- * The fingerprint should always be 20 bytes, fill with zeroes
- * for 16 byte fprints.
  */
 int
-get_keyblock_byfprint( KBNODE *ret_keyblock, const byte *fprint )
+get_keyblock_byfprint( KBNODE *ret_keyblock, const byte *fprint,
+						size_t fprint_len )
 {
     int rc;
     PKT_public_cert *pkc = m_alloc_clear( sizeof *pkc );
 
-    rc = lookup( pkc, 20, NULL, fprint, ret_keyblock );
+    if( fprint_len == 20 || fprint_len == 16 )
+	rc = lookup( pkc, fprint_len, NULL, fprint, ret_keyblock );
+    else
+	rc = G10ERR_GENERAL; /* Oops */
 
     free_public_cert( pkc );
     return rc;
@@ -593,6 +596,58 @@
 }
 
 
+
+/****************
+ * Assume that knode points to a public key packet  and keyblock is
+ * the entire keyblock.  This function adds all relevant information from
+ * a selfsignature to the public key.
+ */
+
+static void
+add_stuff_from_selfsig( KBNODE keyblock, KBNODE knode )
+{
+    PKT_public_cert *pkc = knode->pkt->pkt.public_cert;
+    PKT_signature *sig;
+    KBNODE k;
+    u32 kid[2];
+
+    assert(    knode->pkt->pkttype == PKT_PUBLIC_CERT
+	    || knode->pkt->pkttype == PKT_PUBKEY_SUBCERT );
+
+    if( pkc->version < 4 )
+	return; /* this is only needed for version >=4 packets */
+
+    /* find the selfsignature */
+    if( knode->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
+	k = find_kbnode( keyblock, PKT_PUBLIC_CERT );
+	if( !k )
+	   BUG(); /* keyblock without primary key!!! */
+	keyid_from_pkc( knode->pkt->pkt.public_cert, kid );
+    }
+    else
+	keyid_from_pkc( pkc, kid );
+    for(k=keyblock; k; k = k->next ) {
+	if( k->pkt->pkttype == PKT_SIGNATURE
+	    && (sig=k->pkt->pkt.signature)->sig_class >= 0x10
+	    && sig->sig_class <= 0x13
+	    && sig->keyid[0] == kid[0]
+	    && sig->keyid[1] == kid[1]
+	    && sig->version > 3 ) {
+	    /* okay this is (the first) self-signature which can be used
+	     * fixme: Check how to handle subkey bindings
+	     * FIXME: We should only use this if the signature is valid
+	     *	      but this is time consuming - we muts provide another
+	     *	      way to handle this
+	     */
+	    const byte *p;
+	    p = parse_sig_subpkt( sig->hashed_data, SIGSUBPKT_KEY_EXPIRE, NULL );
+	    pkc->valid_days = p? ((buffer_to_u32(p)+86399L)/86400L):0;
+	    /* fixme: add usage etc. to pkc */
+	    break;
+	}
+    }
+}
+
 /****************
  * Lookup a key by scanning all keyrings
  *   mode 1 = lookup by NAME (exact)
@@ -716,6 +771,7 @@
 	    assert(    k->pkt->pkttype == PKT_PUBLIC_CERT
 		    || k->pkt->pkttype == PKT_PUBKEY_SUBCERT );
 	    copy_public_cert( pkc, k->pkt->pkt.public_cert );
+	    add_stuff_from_selfsig( keyblock, k );
 	    if( ret_keyblock ) {
 		*ret_keyblock = keyblock;
 		keyblock = NULL;
diff -urN gnupg-0.2.19/g10/gpgd.c gnupg-0.3.0/g10/gpgd.c
--- gnupg-0.2.19/g10/gpgd.c	Wed May 20 17:10:18 1998
+++ gnupg-0.3.0/g10/gpgd.c	Mon Jun 15 17:33:31 1998
@@ -129,7 +129,7 @@
     if( opt.debug & DBG_MPI_VALUE )
 	mpi_debug_mode = 1;
     if( opt.debug & DBG_CIPHER_VALUE )
-	cipher_debug_mode = 1;
+	g10c_debug_mode = 1;
     if( opt.debug & DBG_IOBUF_VALUE )
 	iobuf_debug_mode = 1;
 }
diff -urN gnupg-0.2.19/g10/keydb.h gnupg-0.3.0/g10/keydb.h
--- gnupg-0.2.19/g10/keydb.h	Wed May 27 14:16:51 1998
+++ gnupg-0.3.0/g10/keydb.h	Sat Jun 13 14:30:15 1998
@@ -109,7 +109,8 @@
 int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
 int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
 int get_seckey( PKT_secret_cert *skc, u32 *keyid );
-int get_keyblock_byfprint( KBNODE *ret_keyblock, const byte *fprint );
+int get_keyblock_byfprint( KBNODE *ret_keyblock, const byte *fprint,
+						 size_t fprint_len );
 int seckey_available( u32 *keyid );
 int get_seckey_byname( PKT_secret_cert *skc, const char *name, int unlock );
 int enum_secret_keys( void **context, PKT_secret_cert *skc );
diff -urN gnupg-0.2.19/g10/keyedit.c gnupg-0.3.0/g10/keyedit.c
--- gnupg-0.2.19/g10/keyedit.c	Tue May 26 14:37:19 1998
+++ gnupg-0.3.0/g10/keyedit.c	Thu Jun 18 12:18:13 1998
@@ -347,7 +347,7 @@
 						   node->pkt->pkt.user_id,
 						   NULL,
 						   skc_rover->skc,
-						   0x10, 0 );
+						   0x10, 0, NULL, NULL );
 		    if( rc ) {
 			log_error("make_keysig_packet failed: %s\n", g10_errstr(rc));
 			goto leave;
@@ -720,7 +720,9 @@
 make_keysig_packet( PKT_signature **ret_sig, PKT_public_cert *pkc,
 		    PKT_user_id *uid, PKT_public_cert *subpkc,
 		    PKT_secret_cert *skc,
-		    int sigclass, int digest_algo )
+		    int sigclass, int digest_algo,
+		    int (*mksubpkt)(PKT_signature *, void *), void *opaque
+		   )
 {
     PKT_signature *sig;
     int rc=0;
@@ -763,45 +765,50 @@
     sig->digest_algo = digest_algo;
     sig->timestamp = make_timestamp();
     sig->sig_class = sigclass;
-
-    if( sig->version >= 4 ) {
+    if( sig->version >= 4 )
 	build_sig_subpkt_from_sig( sig );
-	md_putc( md, sig->version );
-    }
-    md_putc( md, sig->sig_class );
-    if( sig->version < 4 ) {
-	u32 a = sig->timestamp;
-	md_putc( md, (a >> 24) & 0xff );
-	md_putc( md, (a >> 16) & 0xff );
-	md_putc( md, (a >>  8) & 0xff );
-	md_putc( md,  a        & 0xff );
-    }
-    else {
-	byte buf[6];
-	size_t n;
 
-	md_putc( md, sig->pubkey_algo );
-	md_putc( md, sig->digest_algo );
-	if( sig->hashed_data ) {
-	    n = (sig->hashed_data[0] << 8) | sig->hashed_data[1];
-	    md_write( md, sig->hashed_data, n+2 );
-	    n += 6;
+    if( sig->version >= 4 && mksubpkt )
+	rc = (*mksubpkt)( sig, opaque );
+
+    if( !rc ) {
+	if( sig->version >= 4 )
+	    md_putc( md, sig->version );
+	md_putc( md, sig->sig_class );
+	if( sig->version < 4 ) {
+	    u32 a = sig->timestamp;
+	    md_putc( md, (a >> 24) & 0xff );
+	    md_putc( md, (a >> 16) & 0xff );
+	    md_putc( md, (a >>	8) & 0xff );
+	    md_putc( md,  a	   & 0xff );
+	}
+	else {
+	    byte buf[6];
+	    size_t n;
+
+	    md_putc( md, sig->pubkey_algo );
+	    md_putc( md, sig->digest_algo );
+	    if( sig->hashed_data ) {
+		n = (sig->hashed_data[0] << 8) | sig->hashed_data[1];
+		md_write( md, sig->hashed_data, n+2 );
+		n += 6;
+	    }
+	    else
+		n = 6;
+	    /* add some magic */
+	    buf[0] = sig->version;
+	    buf[1] = 0xff;
+	    buf[2] = n >> 24; /* hmmm, n is only 16 bit, so this is always 0 */
+	    buf[3] = n >> 16;
+	    buf[4] = n >>  8;
+	    buf[5] = n;
+	    md_write( md, buf, 6 );
+
 	}
-	else
-	    n = 6;
-	/* add some magic */
-	buf[0] = sig->version;
-	buf[1] = 0xff;
-	buf[2] = n >> 24; /* hmmm, n is only 16 bit, so this is always 0 */
-	buf[3] = n >> 16;
-	buf[4] = n >>  8;
-	buf[5] = n;
-	md_write( md, buf, 6 );
+	md_final(md);
 
+	rc = complete_sig( sig, skc, md );
     }
-    md_final(md);
-
-    rc = complete_sig( sig, skc, md );
 
     md_close( md );
     if( rc )
diff -urN gnupg-0.2.19/g10/keygen.c gnupg-0.3.0/g10/keygen.c
--- gnupg-0.2.19/g10/keygen.c	Tue May 26 15:20:31 1998
+++ gnupg-0.3.0/g10/keygen.c	Wed Jun 24 15:48:36 1998
@@ -35,11 +35,6 @@
 #include "i18n.h"
 
 
-#if defined(HAVE_RSA_CIPHER) && 0
-  #define ENABLE_RSA_KEYGEN 1
-#endif
-
-
 static void
 write_uid( KBNODE root, const char *s )
 {
@@ -54,6 +49,65 @@
 }
 
 
+
+static int
+add_key_expire( PKT_signature *sig, void *opaque )
+{
+    PKT_secret_cert *skc = opaque;
+    byte buf[8];
+    u32  u;
+
+    if( skc->valid_days ) {
+	u = skc->valid_days * 86400L;
+	buf[0] = (u >> 24) & 0xff;
+	buf[1] = (u >> 16) & 0xff;
+	buf[2] = (u >>	8) & 0xff;
+	buf[3] = u & 0xff;
+	build_sig_subpkt( sig, SIGSUBPKT_KEY_EXPIRE, buf, 4 );
+    }
+
+    return 0;
+}
+
+
+/****************
+ * Add preference to the self signature packet.
+ * This is only called for packets with version > 3.
+ */
+static int
+add_prefs( PKT_signature *sig, void *opaque )
+{
+    byte buf[8];
+
+    add_key_expire( sig, opaque );
+
+    buf[0] = CIPHER_ALGO_BLOWFISH;
+    buf[1] = CIPHER_ALGO_CAST5;
+    build_sig_subpkt( sig, SIGSUBPKT_PREF_SYM, buf, 2 );
+
+    buf[0] = DIGEST_ALGO_RMD160;
+    buf[1] = DIGEST_ALGO_SHA1;
+    buf[2] = DIGEST_ALGO_TIGER;
+    buf[3] = DIGEST_ALGO_MD5;
+    build_sig_subpkt( sig, SIGSUBPKT_PREF_HASH, buf, 4 );
+
+    buf[0] = 2;
+    buf[1] = 1;
+    build_sig_subpkt( sig, SIGSUBPKT_PREF_COMPR, buf, 2 );
+
+    buf[0] = 0x80; /* no modify - It is reasonable that a key holder
+		    * has the possibility to reject signatures from users
+		    * who are known to sign everything without any
+		    * validation - so a signed key should be send
+		    * to the holder who in turn can put it on a keyserver
+		    */
+    build_sig_subpkt( sig, SIGSUBPKT_KS_FLAGS, buf, 1 );
+
+    return 0;
+}
+
+
+
 static int
 write_selfsig( KBNODE root, KBNODE pub_root, PKT_secret_cert *skc )
 {
@@ -79,7 +133,8 @@
     pkc = node->pkt->pkt.public_cert;
 
     /* and make the signature */
-    rc = make_keysig_packet( &sig, pkc, uid, NULL, skc, 0x13, 0 );
+    rc = make_keysig_packet( &sig, pkc, uid, NULL, skc, 0x13, 0,
+			     add_prefs, skc );
     if( rc ) {
 	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc) );
 	return rc;
@@ -119,7 +174,8 @@
 	BUG();
 
     /* and make the signature */
-    rc = make_keysig_packet( &sig, pkc, NULL, subpkc, skc, 0x18, 0 );
+    rc = make_keysig_packet( &sig, pkc, NULL, subpkc, skc, 0x18, 0,
+				    add_key_expire, skc );
     if( rc ) {
 	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc) );
 	return rc;
@@ -134,7 +190,7 @@
 
 
 static int
-gen_elg(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
+gen_elg(int algo, unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
 	STRING2KEY *s2k, PKT_secret_cert **ret_skc, u16 valid_days,
 							int version )
 {
@@ -143,29 +199,33 @@
     PACKET *pkt;
     PKT_secret_cert *skc;
     PKT_public_cert *pkc;
-    ELG_public_key pk;
-    ELG_secret_key sk;
+    MPI skey[4];
     MPI *factors;
 
-    elg_generate( &pk, &sk, nbits, &factors );
+    assert( is_ELGAMAL(algo) );
+    rc = pubkey_generate( algo, nbits, skey, &factors );
+    if( rc ) {
+	log_error("pubkey_generate failed: %s\n", g10_errstr(rc) );
+	return rc;
+    }
 
     skc = m_alloc_clear( sizeof *skc );
     pkc = m_alloc_clear( sizeof *pkc );
     skc->timestamp = pkc->timestamp = make_timestamp();
     skc->version = pkc->version = version;
     skc->valid_days = pkc->valid_days = valid_days;
-    skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_ELGAMAL;
-		       pkc->d.elg.p = pk.p;
-		       pkc->d.elg.g = pk.g;
-		       pkc->d.elg.y = pk.y;
-    skc->d.elg.p = sk.p;
-    skc->d.elg.g = sk.g;
-    skc->d.elg.y = sk.y;
-    skc->d.elg.x = sk.x;
+    skc->pubkey_algo = pkc->pubkey_algo = algo;
+		       pkc->pkey[0] = mpi_copy( skey[0] );
+		       pkc->pkey[1] = mpi_copy( skey[1] );
+		       pkc->pkey[2] = mpi_copy( skey[2] );
+    skc->skey[0] = skey[0];
+    skc->skey[1] = skey[1];
+    skc->skey[2] = skey[2];
+    skc->skey[3] = skey[3];
     skc->is_protected = 0;
     skc->protect.algo = 0;
 
-    skc->csum = checksum_mpi( skc->d.elg.x );
+    skc->csum = checksum_mpi_counted_nbits( skc->skey[3] );
     if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
 	*ret_skc = copy_secret_cert( NULL, skc );
 
@@ -200,72 +260,6 @@
 }
 
 
-
-#ifdef ENABLE_RSA_KEYGEN
-static int
-gen_rsa(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
-	STRING2KEY *s2k, PKT_secret_cert **ret_skc, u16 valid_days )
-{
-    int rc;
-    PACKET *pkt;
-    PKT_secret_cert *skc;
-    PKT_public_cert *pkc;
-    RSA_public_key pk;
-    RSA_secret_key sk;
-
-    rsa_generate( &pk, &sk, nbits );
-
-    skc = m_alloc_clear( sizeof *skc );
-    pkc = m_alloc_clear( sizeof *pkc );
-    skc->timestamp = pkc->timestamp = make_timestamp();
-    skc->valid_days = pkc->valid_days = valid_days;
-    skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_RSA;
-		       memset(&pkc->mfx, 0, sizeof pkc->mfx);
-		       pkc->d.rsa.rsa_n = pk.n;
-		       pkc->d.rsa.rsa_e = pk.e;
-    skc->d.rsa.rsa_n = sk.n;
-    skc->d.rsa.rsa_e = sk.e;
-    skc->d.rsa.rsa_d = sk.d;
-    skc->d.rsa.rsa_p = sk.p;
-    skc->d.rsa.rsa_q = sk.q;
-    skc->d.rsa.rsa_u = sk.u;
-    skc->d.rsa.csum  = checksum_mpi( skc->d.rsa.rsa_d );
-    skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_p );
-    skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_q );
-    skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_u );
-
-    if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
-	*ret_skc = copy_secret_cert( NULL, skc );
-
-    if( dek ) {
-	skc->d.rsa.is_protected = 1;
-	skc->d.rsa.protect_algo = CIPHER_ALGO_BLOWFISH;
-	randomize_buffer( skc->d.rsa.protect.blowfish.iv, 8, 1);
-	skc->d.rsa.csum += checksum( skc->d.rsa.protect.blowfish.iv, 8 );
-	rc = protect_secret_key( skc, dek );
-	if( rc ) {
-	    log_error("protect_secret_key failed: %s\n", g10_errstr(rc) );
-	    free_public_cert(pkc);
-	    free_secret_cert(skc);
-	    return rc;
-	}
-    }
-
-    pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = ret_skc ? PKT_PUBLIC_CERT : PKT_PUBKEY_SUBCERT;
-    pkt->pkt.public_cert = pkc;
-    add_kbnode(pub_root, new_kbnode( pkt ));
-
-    pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = ret_skc ? PKT_SECRET_CERT : PKT_SECKEY_SUBCERT;
-    pkt->pkt.secret_cert = skc;
-    add_kbnode(sec_root, new_kbnode( pkt ));
-
-    return rc;
-}
-#endif /*ENABLE_RSA_KEYGEN*/
-
-
 /****************
  * Generate a DSA key
  */
@@ -278,39 +272,39 @@
     PACKET *pkt;
     PKT_secret_cert *skc;
     PKT_public_cert *pkc;
-    DSA_public_key pk;
-    DSA_secret_key sk;
+    MPI skey[5];
     MPI *factors;
 
     if( nbits > 1024 )
 	nbits = 1024;
 
-    dsa_generate( &pk, &sk, nbits, &factors );
+    rc = pubkey_generate( PUBKEY_ALGO_DSA, nbits, skey, &factors );
+    if( rc ) {
+	log_error("pubkey_generate failed: %s\n", g10_errstr(rc) );
+	return rc;
+    }
 
     skc = m_alloc_clear( sizeof *skc );
     pkc = m_alloc_clear( sizeof *pkc );
     skc->timestamp = pkc->timestamp = make_timestamp();
     skc->version = pkc->version = 4;
-    /* valid days are not stored in the packet, but it is
-     * used here to put it into the signature.
-     */
     skc->valid_days = pkc->valid_days = valid_days;
     skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_DSA;
-		       pkc->d.dsa.p = pk.p;
-		       pkc->d.dsa.q = pk.q;
-		       pkc->d.dsa.g = pk.g;
-		       pkc->d.dsa.y = pk.y;
-    skc->d.dsa.p = sk.p;
-    skc->d.dsa.q = sk.q;
-    skc->d.dsa.g = sk.g;
-    skc->d.dsa.y = sk.y;
-    skc->d.dsa.x = sk.x;
+		       pkc->pkey[0] = mpi_copy( skey[0] );
+		       pkc->pkey[1] = mpi_copy( skey[1] );
+		       pkc->pkey[2] = mpi_copy( skey[2] );
+		       pkc->pkey[3] = mpi_copy( skey[3] );
+    skc->skey[0] = skey[0];
+    skc->skey[1] = skey[1];
+    skc->skey[2] = skey[2];
+    skc->skey[3] = skey[3];
+    skc->skey[4] = skey[4];
     skc->is_protected = 0;
     skc->protect.algo = 0;
 
-    skc->csum = checksum_mpi( skc->d.dsa.x );
+    skc->csum = checksum_mpi_counted_nbits( skc->skey[4] );
     if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
-	 *ret_skc = copy_secret_cert( NULL, skc );
+	*ret_skc = copy_secret_cert( NULL, skc );
 
     if( dek ) {
 	skc->protect.algo = dek->algo;
@@ -376,47 +370,52 @@
 }
 
 
+/****************
+ * Returns o to create both a DSA and a ElGamal key.
+ */
 static int
-ask_algo( int *ret_v4 )
+ask_algo( int *ret_v4, int addmode )
 {
     char *answer;
     int algo;
 
-    tty_printf(_("Please select the algorithm to use:\n"
-		 "   (1) ElGamal is the suggested one.\n"
-		 "   (2) ElGamal using v4 packets (OpenPGP)\n"
-		 "   (3) DSA can only be used for signatures.\n"));
-  #ifdef ENABLE_RSA_KEYGEN
-    tty_printf(_("   (4) RSA cannot be used in the U.S.\n"));
-  #endif
+    tty_printf(_("Please select what kind of key you want:\n"));
+    if( !addmode )
+	tty_printf(_("   (%d) DSA and ElGamal (default)\n"), 1 );
+    tty_printf(    _("   (%d) ElGamal (sign and encrypt)\n"), 2 );
+    tty_printf(    _("   (%d) ElGamal (encrypt only)\n"), 3 );
+    tty_printf(    _("   (%d) DSA (sign only)\n"), 4 );
+    tty_printf(    _("   (%d) ElGamal in a v3 packet\n"), 5 );
 
-    *ret_v4 = 0;
+    *ret_v4 = 1;
     for(;;) {
-      #ifdef ENABLE_RSA_KEYGEN
-	answer = tty_get(_("Your selection? (1,2,3,4) "));
-      #else
-	answer = tty_get(_("Your selection? (1,2,3) "));
-      #endif
+	answer = tty_get(_("Your selection? "));
 	tty_kill_prompt();
 	algo = *answer? atoi(answer): 1;
 	m_free(answer);
-	if( algo == 1 || algo == 2 ) {
-	    if( algo == 2 )
-		*ret_v4 = 1;
+	if( algo == 1 && !addmode ) {
+	    algo = 0;	/* create both keys */
+	    break;
+	}
+	else if( algo == 2 ) {
 	    algo = PUBKEY_ALGO_ELGAMAL;
 	    break;
 	}
 	else if( algo == 3 ) {
-	    *ret_v4 = 1;
-	    algo = PUBKEY_ALGO_DSA;
+	    algo = PUBKEY_ALGO_ELGAMAL_E;
 	    break;
 	}
-      #ifdef ENABLE_RSA_KEYGEN
 	else if( algo == 4 ) {
-	    algo = PUBKEY_ALGO_RSA;
+	    algo = PUBKEY_ALGO_DSA;
+	    break;
+	}
+	else if( algo == 5 ) {
+	    algo = PUBKEY_ALGO_ELGAMAL_E;
+	    *ret_v4 = 0;
 	    break;
 	}
-      #endif
+	else
+	    tty_printf(_("Invalid selection.\n"));
     }
     return algo;
 }
@@ -696,13 +695,9 @@
 "network and the disks) during the prime generation; this gives the random\n"
 "number generator a better chance to gain enough entropy.\n") );
 
-    if( algo == PUBKEY_ALGO_ELGAMAL )
-	rc = gen_elg(nbits, pub_root, sec_root, dek, s2k,
+    if( algo == PUBKEY_ALGO_ELGAMAL || algo == PUBKEY_ALGO_ELGAMAL_E )
+	rc = gen_elg(algo, nbits, pub_root, sec_root, dek, s2k,
 			   skc, valid_days, v4_packet? 4:3 );
-  #ifdef ENABLE_RSA_KEYGEN
-    else if( algo == PUBKEY_ALGO_RSA )
-	rc = gen_rsa(nbits, pub_root, sec_root, dek, s2k, skc, valid_days  );
-  #endif
     else if( algo == PUBKEY_ALGO_DSA )
 	rc = gen_dsa(nbits, pub_root, sec_root, dek, s2k, skc, valid_days);
     else
@@ -738,13 +733,19 @@
     int algo;
     int ndays;
     int v4;
+    int both = 0;
 
     if( opt.batch || opt.answer_yes || opt.answer_no ) {
 	log_error(_("Key generation can only be used in interactive mode\n"));
 	return;
     }
 
-    algo = ask_algo( &v4 );
+    algo = ask_algo( &v4, 0 );
+    if( !algo ) {
+	algo = PUBKEY_ALGO_ELGAMAL;
+	both = 1;
+	tty_printf(_("DSA keypair will have 1024 bits.\n"));
+    }
     nbits = ask_keysize( algo );
     ndays = ask_valid_days();
     uid = ask_user_id();
@@ -767,7 +768,12 @@
     pub_root = make_comment_node("#"); delete_kbnode(pub_root);
     sec_root = make_comment_node("#"); delete_kbnode(sec_root);
 
-    rc = do_create( algo, nbits, pub_root, sec_root, dek, s2k, &skc, ndays, v4);
+    if( both )
+	rc = do_create( PUBKEY_ALGO_DSA, 1024, pub_root, sec_root,
+					       dek, s2k, &skc, ndays, 1);
+    else
+	rc = do_create( algo,		nbits, pub_root, sec_root,
+					       dek, s2k, &skc, ndays, v4);
     if( !rc )
 	write_uid(pub_root, uid );
     if( !rc )
@@ -777,6 +783,16 @@
     if( !rc )
 	rc = write_selfsig(sec_root, pub_root, skc);
 
+    if( both ) {
+	rc = do_create( algo, nbits, pub_root, sec_root,
+					  dek, s2k, NULL, ndays, 1 );
+	if( !rc )
+	    rc = write_keybinding(pub_root, pub_root, skc);
+	if( !rc )
+	    rc = write_keybinding(sec_root, pub_root, skc);
+    }
+
+
     if( !rc ) {
 	KBPOS pub_kbpos;
 	KBPOS sec_kbpos;
@@ -951,7 +967,8 @@
 	goto leave;
 
 
-    algo = ask_algo( &v4 );
+    algo = ask_algo( &v4, 1 );
+    assert(algo);
     nbits = ask_keysize( algo );
     ndays = ask_valid_days();
 
diff -urN gnupg-0.2.19/g10/keyid.c gnupg-0.3.0/g10/keyid.c
--- gnupg-0.2.19/g10/keyid.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/keyid.c	Sat Jun 13 08:24:56 1998
@@ -47,182 +47,72 @@
     }
 }
 
-/* this is special code for V3 which uses ElGamal and
- * calculates a fingerprint like V4, but with rmd160
- * and a version byte of 3. Returns an md handle, caller must
- * do md_close()
- */
 
 static MD_HANDLE
-v3_elg_fingerprint_md( PKT_public_cert *pkc )
+do_fingerprint_md( PKT_public_cert *pkc )
 {
     MD_HANDLE md;
-    byte *buf1, *buf2, *buf3;
-    byte *p1, *p2, *p3;
-    unsigned n1, n2, n3;
-    unsigned nb1, nb2, nb3;
     unsigned n;
-
-    nb1 = mpi_get_nbits(pkc->d.elg.p);
-    p1 = buf1 = mpi_get_buffer( pkc->d.elg.p, &n1, NULL );
-    nb2 = mpi_get_nbits(pkc->d.elg.g);
-    p2 = buf2 = mpi_get_buffer( pkc->d.elg.g, &n2, NULL );
-    nb3 = mpi_get_nbits(pkc->d.elg.y);
-    p3 = buf3 = mpi_get_buffer( pkc->d.elg.y, &n3, NULL );
-
-    /* calculate length of packet (1+4+2+1+2+n1+2+n2+2+n3) */
-    n = 14 + n1 + n2 + n3;
-    md = md_open( DIGEST_ALGO_RMD160, 0);
+    unsigned nb[PUBKEY_MAX_NPKEY];
+    unsigned nn[PUBKEY_MAX_NPKEY];
+    byte *pp[PUBKEY_MAX_NPKEY];
+    int i;
+    int npkey = pubkey_get_npkey( pkc->pubkey_algo );
+
+    md = md_open( pkc->version < 4 ? DIGEST_ALGO_RMD160 : DIGEST_ALGO_SHA1, 0);
+    n = pkc->version < 4 ? 8 : 6;
+    for(i=0; i < npkey; i++ ) {
+	nb[i] = mpi_get_nbits(pkc->pkey[i]);
+	pp[i] = mpi_get_buffer( pkc->pkey[i], nn+i, NULL );
+	n += 2 + nn[i];
+    }
 
     md_putc( md, 0x99 );     /* ctb */
     md_putc( md, n >> 8 );   /* 2 byte length header */
     md_putc( md, n );
-    md_putc( md, 3 );	     /* version */
+    if( pkc->version < 4 )
+	md_putc( md, 3 );
+    else
+	md_putc( md, 4 );
+
     {	u32 a = pkc->timestamp;
 	md_putc( md, a >> 24 );
 	md_putc( md, a >> 16 );
 	md_putc( md, a >>  8 );
 	md_putc( md, a	     );
     }
-    {	u16 a = pkc->valid_days;
+    if( pkc->version < 4 ) {
+	u16 a = pkc->valid_days;
 	md_putc( md, a >> 8 );
 	md_putc( md, a	    );
     }
     md_putc( md, pkc->pubkey_algo );
-    md_putc( md, nb1>>8); md_putc( md, nb1 ); md_write( md, p1, n1 );
-    md_putc( md, nb2>>8); md_putc( md, nb2 ); md_write( md, p2, n2 );
-    md_putc( md, nb3>>8); md_putc( md, nb3 ); md_write( md, p3, n3 );
-    m_free(buf1);
-    m_free(buf2);
-    m_free(buf3);
-    md_final( md );
-
-    return md;
-}
-
-static MD_HANDLE
-elg_fingerprint_md( PKT_public_cert *pkc )
-{
-    MD_HANDLE md;
-    byte *buf1, *buf3, *buf4 ;
-    byte *p1, *p3, *p4;
-    unsigned n1, n3, n4;
-    unsigned nb1, nb3, nb4;
-    unsigned n;
-
-    nb1 = mpi_get_nbits(pkc->d.elg.p);
-    p1 = buf1 = mpi_get_buffer( pkc->d.elg.p, &n1, NULL );
-    nb3 = mpi_get_nbits(pkc->d.elg.g);
-    p3 = buf3 = mpi_get_buffer( pkc->d.elg.g, &n3, NULL );
-    nb4 = mpi_get_nbits(pkc->d.elg.y);
-    p4 = buf4 = mpi_get_buffer( pkc->d.elg.y, &n4, NULL );
-
-    /* calculate length of packet */
-    n = 12 + n1 + n3 +n4 ;
-    md = md_open( DIGEST_ALGO_SHA1, 0);
-
-    md_putc( md, 0x99 );     /* ctb */
-    md_putc( md, n >> 8 );   /* 2 byte length header */
-    md_putc( md, n );
-    md_putc( md, 4 );	     /* version */
-    {	u32 a = pkc->timestamp;
-	md_putc( md, a >> 24 );
-	md_putc( md, a >> 16 );
-	md_putc( md, a >>  8 );
-	md_putc( md, a	     );
-    }
-    md_putc( md, pkc->pubkey_algo );
-    md_putc( md, nb1>>8); md_putc( md, nb1 ); md_write( md, p1, n1 );
-    md_putc( md, nb3>>8); md_putc( md, nb3 ); md_write( md, p3, n3 );
-    md_putc( md, nb4>>8); md_putc( md, nb4 ); md_write( md, p4, n4 );
-    m_free(buf1);
-    m_free(buf3);
-    m_free(buf4);
-    md_final( md );
-
-    return md;
-}
-
-
-static MD_HANDLE
-dsa_fingerprint_md( PKT_public_cert *pkc )
-{
-    MD_HANDLE md;
-    byte *buf1, *buf2, *buf3, *buf4 ;
-    byte *p1, *p2, *p3, *p4;
-    unsigned n1, n2, n3, n4;
-    unsigned nb1, nb2, nb3, nb4;
-    unsigned n;
-
-    nb1 = mpi_get_nbits(pkc->d.dsa.p);
-    p1 = buf1 = mpi_get_buffer( pkc->d.dsa.p, &n1, NULL );
-    nb2 = mpi_get_nbits(pkc->d.dsa.q);
-    p2 = buf2 = mpi_get_buffer( pkc->d.dsa.q, &n2, NULL );
-    nb3 = mpi_get_nbits(pkc->d.dsa.g);
-    p3 = buf3 = mpi_get_buffer( pkc->d.dsa.g, &n3, NULL );
-    nb4 = mpi_get_nbits(pkc->d.dsa.y);
-    p4 = buf4 = mpi_get_buffer( pkc->d.dsa.y, &n4, NULL );
-
-    /* calculate length of packet */
-    n = 14 + n1 + n2 + n3 +n4 ;
-    md = md_open( DIGEST_ALGO_SHA1, 0);
-
-    md_putc( md, 0x99 );     /* ctb */
-    md_putc( md, n >> 8 );   /* 2 byte length header */
-    md_putc( md, n );
-    md_putc( md, 4 );	     /* version */
-    {	u32 a = pkc->timestamp;
-	md_putc( md, a >> 24 );
-	md_putc( md, a >> 16 );
-	md_putc( md, a >>  8 );
-	md_putc( md, a	     );
+    for(i=0; i < npkey; i++ ) {
+	md_putc( md, nb[i]>>8);
+	md_putc( md, nb[i] );
+	md_write( md, pp[i], nn[i] );
+	m_free(pp[i]);
     }
-    md_putc( md, pkc->pubkey_algo );
-    md_putc( md, nb1>>8); md_putc( md, nb1 ); md_write( md, p1, n1 );
-    md_putc( md, nb2>>8); md_putc( md, nb2 ); md_write( md, p2, n2 );
-    md_putc( md, nb3>>8); md_putc( md, nb3 ); md_write( md, p3, n3 );
-    md_putc( md, nb4>>8); md_putc( md, nb4 ); md_write( md, p4, n4 );
-    m_free(buf1);
-    m_free(buf2);
-    m_free(buf3);
-    m_free(buf4);
     md_final( md );
 
     return md;
 }
 
 static MD_HANDLE
-elg_fingerprint_md_skc( PKT_secret_cert *skc )
+do_fingerprint_md_skc( PKT_secret_cert *skc )
 {
     PKT_public_cert pkc;
+    int npkey = pubkey_get_npkey( skc->pubkey_algo ); /* npkey is correct! */
+    int i;
 
     pkc.pubkey_algo = skc->pubkey_algo;
     pkc.version     = skc->version;
     pkc.timestamp = skc->timestamp;
     pkc.valid_days = skc->valid_days;
     pkc.pubkey_algo = skc->pubkey_algo;
-    pkc.d.elg.p = skc->d.elg.p;
-    pkc.d.elg.g = skc->d.elg.g;
-    pkc.d.elg.y = skc->d.elg.y;
-    if( pkc.version < 4 )
-	return v3_elg_fingerprint_md( &pkc );
-    else
-	return elg_fingerprint_md( &pkc );
-}
-
-static MD_HANDLE
-dsa_fingerprint_md_skc( PKT_secret_cert *skc )
-{
-    PKT_public_cert pkc;
-
-    pkc.pubkey_algo = skc->pubkey_algo;
-    pkc.timestamp = skc->timestamp;
-    pkc.pubkey_algo = skc->pubkey_algo;
-    pkc.d.dsa.p = skc->d.dsa.p;
-    pkc.d.dsa.q = skc->d.dsa.q;
-    pkc.d.dsa.g = skc->d.dsa.g;
-    pkc.d.dsa.y = skc->d.dsa.y;
-    return dsa_fingerprint_md( &pkc );
+    for( i=0; i < npkey; i++ )
+	pkc.pkey[i] = skc->skey[i];
+    return do_fingerprint_md( &pkc );
 }
 
 
@@ -239,35 +129,20 @@
     if( !keyid )
 	keyid = dummy_keyid;
 
-    if( is_ELGAMAL(skc->pubkey_algo) ) {
-	const byte *dp;
-	MD_HANDLE md;
-	md = elg_fingerprint_md_skc(skc);
-	if( skc->version < 4 )
-	    dp = md_read( md, DIGEST_ALGO_RMD160 );
-	else
-	    dp = md_read( md, DIGEST_ALGO_SHA1 );
-	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
-	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
-	lowbits = keyid[1];
-	md_close(md);
+    if( skc->version < 4 && is_RSA(skc->pubkey_algo) ) {
+	lowbits = mpi_get_keyid( skc->skey[0], keyid ); /* take n */
     }
-    else if( skc->pubkey_algo == PUBKEY_ALGO_DSA ) {
+    else {
 	const byte *dp;
 	MD_HANDLE md;
-	md = dsa_fingerprint_md_skc(skc);
-	dp = md_read( md, DIGEST_ALGO_SHA1 );
+	md = do_fingerprint_md_skc(skc);
+	dp = md_read( md, 0 );
 	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
 	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
 	lowbits = keyid[1];
 	md_close(md);
     }
-    else if( is_RSA(skc->pubkey_algo) ) {
-	lowbits = mpi_get_keyid( skc->d.rsa.n, keyid );
-    }
-    else {
-	keyid[0] = keyid[1] = lowbits = 0;
-    }
+
     return lowbits;
 }
 
@@ -285,38 +160,19 @@
     if( !keyid )
 	keyid = dummy_keyid;
 
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
-	const byte *dp;
-	MD_HANDLE md;
-	if( pkc->version < 4 ) {
-	    md = v3_elg_fingerprint_md(pkc);
-	    dp = md_read( md, DIGEST_ALGO_RMD160 );
-	}
-	else {
-	    md = elg_fingerprint_md(pkc);
-	    dp = md_read( md, DIGEST_ALGO_SHA1 );
-	}
-	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
-	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
-	lowbits = keyid[1];
-	md_close(md);
+    if( pkc->version < 4 && is_RSA(pkc->pubkey_algo) ) {
+	lowbits = mpi_get_keyid( pkc->pkey[0], keyid ); /* from n */
     }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA  ) {
+    else {
 	const byte *dp;
 	MD_HANDLE md;
-	md = dsa_fingerprint_md(pkc);
-	dp = md_read( md, DIGEST_ALGO_SHA1 );
+	md = do_fingerprint_md(pkc);
+	dp = md_read( md, 0 );
 	keyid[0] = dp[12] << 24 | dp[13] << 16 | dp[14] << 8 | dp[15] ;
 	keyid[1] = dp[16] << 24 | dp[17] << 16 | dp[18] << 8 | dp[19] ;
 	lowbits = keyid[1];
 	md_close(md);
     }
-    else if( is_RSA(pkc->pubkey_algo) ) {
-	lowbits = mpi_get_keyid( pkc->d.rsa.n, keyid );
-    }
-    else {
-	keyid[0] = keyid[1] = lowbits = 0;
-    }
 
     return lowbits;
 }
@@ -338,17 +194,7 @@
 unsigned
 nbits_from_pkc( PKT_public_cert *pkc )
 {
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
-	return mpi_get_nbits( pkc->d.elg.p );
-    }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	return mpi_get_nbits( pkc->d.dsa.p );
-    }
-    else if( is_RSA(pkc->pubkey_algo) ) {
-	return mpi_get_nbits( pkc->d.rsa.n );
-    }
-    else
-	return 0;
+    return pubkey_nbits( pkc->pubkey_algo, pkc->pkey );
 }
 
 /****************
@@ -357,17 +203,7 @@
 unsigned
 nbits_from_skc( PKT_secret_cert *skc )
 {
-    if( is_ELGAMAL(skc->pubkey_algo) ) {
-	return mpi_get_nbits( skc->d.elg.p );
-    }
-    else if( skc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	return mpi_get_nbits( skc->d.dsa.p );
-    }
-    else if( is_RSA(skc->pubkey_algo) ) {
-	return mpi_get_nbits( skc->d.rsa.n );
-    }
-    else
-	return 0;
+    return pubkey_nbits( skc->pubkey_algo, skc->skey );
 }
 
 /****************
@@ -417,40 +253,6 @@
  * The length of the array is returned in ret_len. Caller must free
  * the array.
  */
-byte *
-fingerprint_from_skc( PKT_secret_cert *skc, size_t *ret_len )
-{
-    PKT_public_cert pkc;
-    byte *p;
-
-    pkc.pubkey_algo = skc->pubkey_algo;
-    pkc.version     = skc->version;
-    if( is_ELGAMAL(pkc.pubkey_algo) ) {
-	pkc.timestamp = skc->timestamp;
-	pkc.valid_days = skc->valid_days;
-	pkc.pubkey_algo = skc->pubkey_algo;
-	pkc.d.elg.p = skc->d.elg.p;
-	pkc.d.elg.g = skc->d.elg.g;
-	pkc.d.elg.y = skc->d.elg.y;
-    }
-    else if( pkc.pubkey_algo == PUBKEY_ALGO_DSA ) {
-	pkc.timestamp = skc->timestamp;
-	pkc.valid_days = skc->valid_days;
-	pkc.pubkey_algo = skc->pubkey_algo;
-	pkc.d.dsa.p = skc->d.dsa.p;
-	pkc.d.dsa.q = skc->d.dsa.q;
-	pkc.d.dsa.g = skc->d.dsa.g;
-	pkc.d.dsa.y = skc->d.dsa.y;
-    }
-    else if( is_RSA(pkc.pubkey_algo) ) {
-	pkc.d.rsa.n = skc->d.rsa.n;
-	pkc.d.rsa.e = skc->d.rsa.e;
-    }
-    p = fingerprint_from_pkc( &pkc, ret_len );
-    memset(&pkc, 0, sizeof pkc); /* not really needed */
-    return p;
-}
-
 
 
 
@@ -462,38 +264,54 @@
     size_t len;
     unsigned n;
 
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
+    if( pkc->version < 4 && is_RSA(pkc->pubkey_algo) ) {
+	/* RSA in version 3 packets is special */
 	MD_HANDLE md;
-	if( pkc->version < 4 ) {
-	    md = v3_elg_fingerprint_md(pkc);
-	    dp = md_read( md, DIGEST_ALGO_RMD160 );
-	}
-	else {
-	    md = elg_fingerprint_md(pkc);
-	    dp = md_read( md, DIGEST_ALGO_SHA1 );
-	}
-	array = m_alloc( 20 );
-	len = 20;
-	memcpy(array, dp, 20 );
+
+	md = md_open( DIGEST_ALGO_MD5, 0);
+	p = buf = mpi_get_buffer( pkc->pkey[0], &n, NULL );
+	md_write( md, p, n );
+	m_free(buf);
+	p = buf = mpi_get_buffer( pkc->pkey[1], &n, NULL );
+	md_write( md, p, n );
+	m_free(buf);
+	md_final(md);
+	array = m_alloc( 16 );
+	len = 16;
+	memcpy(array, md_read(md, DIGEST_ALGO_MD5), 16 );
 	md_close(md);
     }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
+    else {
 	MD_HANDLE md;
-	md = dsa_fingerprint_md(pkc);
-	dp = md_read( md, DIGEST_ALGO_SHA1 );
-	array = m_alloc( 20 );
-	len = 20;
-	memcpy(array, dp, 20 );
+	md = do_fingerprint_md(pkc);
+	dp = md_read( md, 0 );
+	len = md_digest_length( md_get_algo( md ) );
+	array = m_alloc( len );
+	memcpy(array, dp, len );
 	md_close(md);
     }
-    else if( is_RSA(pkc->pubkey_algo) ) {
+
+    *ret_len = len;
+    return array;
+}
+
+byte *
+fingerprint_from_skc( PKT_secret_cert *skc, size_t *ret_len )
+{
+    byte *p, *buf, *array;
+    const char *dp;
+    size_t len;
+    unsigned n;
+
+    if( skc->version < 4 && is_RSA(skc->pubkey_algo) ) {
+	/* RSA in version 3 packets is special */
 	MD_HANDLE md;
 
 	md = md_open( DIGEST_ALGO_MD5, 0);
-	p = buf = mpi_get_buffer( pkc->d.rsa.n, &n, NULL );
+	p = buf = mpi_get_buffer( skc->skey[1], &n, NULL );
 	md_write( md, p, n );
 	m_free(buf);
-	p = buf = mpi_get_buffer( pkc->d.rsa.e, &n, NULL );
+	p = buf = mpi_get_buffer( skc->skey[0], &n, NULL );
 	md_write( md, p, n );
 	m_free(buf);
 	md_final(md);
@@ -503,8 +321,13 @@
 	md_close(md);
     }
     else {
-	array = m_alloc(1);
-	len = 0; /* ooops */
+	MD_HANDLE md;
+	md = do_fingerprint_md_skc(skc);
+	dp = md_read( md, 0 );
+	len = md_digest_length( md_get_algo( md ) );
+	array = m_alloc( len );
+	memcpy(array, dp, len );
+	md_close(md);
     }
 
     *ret_len = len;
diff -urN gnupg-0.2.19/g10/keylist.c gnupg-0.3.0/g10/keylist.c
--- gnupg-0.2.19/g10/keylist.c	Fri May 29 10:31:59 1998
+++ gnupg-0.3.0/g10/keylist.c	Mon Jun  1 15:00:46 1998
@@ -319,6 +319,7 @@
 	    if( opt.with_colons )
 		printf(":%02x:", sig->sig_class );
 	    putchar('\n');
+	    /* FIXME: check or list other sigs here (subpkt PRIV_ADD_SIG)*/
 	}
     }
     if( !any ) {/* oops, no user id */
diff -urN gnupg-0.2.19/g10/main.h gnupg-0.3.0/g10/main.h
--- gnupg-0.2.19/g10/main.h	Wed May 27 13:43:45 1998
+++ gnupg-0.3.0/g10/main.h	Tue Jun 23 18:19:09 1998
@@ -49,6 +49,8 @@
 u16 checksum_u16( unsigned n );
 u16 checksum( byte *p, unsigned n );
 u16 checksum_mpi( MPI a );
+u16 checksum_mpi_counted_nbits( MPI a );
+u32 buffer_to_u32( const byte *buffer );
 
 /*-- encode.c --*/
 int encode_symmetric( const char *filename );
@@ -85,25 +87,12 @@
 /*-- seskey.c --*/
 void make_session_key( DEK *dek );
 MPI encode_session_key( DEK *dek, unsigned nbits );
-MPI encode_md_value( MD_HANDLE md, int hash_algo, unsigned nbits );
+MPI encode_md_value( int pubkey_algo,  MD_HANDLE md,
+		     int hash_algo, unsigned nbits );
 
 /*-- comment.c --*/
 KBNODE make_comment_node( const char *s );
 KBNODE make_mpi_comment_node( const char *s, MPI a );
-
-/*-- elg.c --*/
-void g10_elg_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
-void g10_elg_sign( PKT_secret_cert *skc, PKT_signature *sig,
-					 MD_HANDLE md, int digest_algo );
-
-/*-- dsa.c --*/
-void g10_dsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
-					 MD_HANDLE md, int digest_algo );
-
-/*-- rsa.c --*/
-void g10_rsa_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek );
-void g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
-					 MD_HANDLE md, int digest_algo );
 
 /*-- import.c --*/
 int import_pubkeys( const char *filename );
diff -urN gnupg-0.2.19/g10/mainproc.c gnupg-0.3.0/g10/mainproc.c
--- gnupg-0.2.19/g10/mainproc.c	Fri May 29 11:14:49 1998
+++ gnupg-0.3.0/g10/mainproc.c	Wed Jun 24 20:49:20 1998
@@ -232,24 +232,42 @@
 proc_plaintext( CTX c, PACKET *pkt )
 {
     PKT_plaintext *pt = pkt->pkt.plaintext;
-    int rc;
+    int any, rc;
+    KBNODE n;
 
     if( opt.verbose )
 	log_info("original file name='%.*s'\n", pt->namelen, pt->name);
     free_md_filter_context( &c->mfx );
-    /* FIXME: take the digest algo(s) to use from the
-     * onepass_sig packet (if we have these)
-     * And look at the sigclass to check whether we should use the
-     * textmode filter (sigclass 0x01)
+    /* fixme: look at the sigclass to check whether we should use the
+     *	      textmode filter (sigclass 0x01)
      */
-    c->mfx.md = md_open( DIGEST_ALGO_RMD160, 0);
-    /*md_start_debug(c->mfx.md, "proc_plaintext");*/
-    md_enable( c->mfx.md, DIGEST_ALGO_SHA1 );
-    md_enable( c->mfx.md, DIGEST_ALGO_MD5 );
-    md_enable( c->mfx.md, DIGEST_ALGO_TIGER );
-    rc = handle_plaintext( pt, &c->mfx );
+    c->mfx.md = md_open( 0, 0);
+    any = 0;
+    for(n=c->list; n; n = n->next ) {
+	if( n->pkt->pkttype == PKT_ONEPASS_SIG
+	    && n->pkt->pkt.onepass_sig->digest_algo ) {
+	    md_enable( c->mfx.md, n->pkt->pkt.onepass_sig->digest_algo );
+	    any = 1;
+	}
+    }
+    if( !any ) { /* no onepass sig packet: enable all algos */
+	md_enable( c->mfx.md, DIGEST_ALGO_RMD160 );
+	md_enable( c->mfx.md, DIGEST_ALGO_SHA1 );
+	md_enable( c->mfx.md, DIGEST_ALGO_MD5 );
+    }
+    if( c->mfx.md ) {
+	m_check(c->mfx.md);
+	if( c->mfx.md->list )
+	    m_check( c->mfx.md->list );
+    }
+    rc = handle_plaintext( pt, &c->mfx, c->sigs_only );
     if( rc )
 	log_error( "handle plaintext failed: %s\n", g10_errstr(rc));
+    if( c->mfx.md ) {
+	m_check(c->mfx.md);
+	if( c->mfx.md->list )
+	    m_check( c->mfx.md->list );
+    }
     free_packet(pkt);
     c->last_was_session_key = 0;
 }
@@ -311,6 +329,12 @@
     if( (rc=check_digest_algo(algo)) )
 	return rc;
 
+    if( c->mfx.md ) {
+	m_check(c->mfx.md);
+	if( c->mfx.md->list )
+	    m_check( c->mfx.md->list );
+    }
+
     if( sig->sig_class == 0x00 ) {
 	if( c->mfx.md )
 	    md = md_copy( c->mfx.md );
@@ -791,7 +815,7 @@
     tstr = asctime(localtime (&stamp));
     astr = pubkey_algo_to_string( sig->pubkey_algo );
     log_info(_("Signature made %.*s using %s key ID %08lX\n"),
-		strlen(tstr)-1, tstr, astr? astr: "?", (ulong)sig->keyid[1] );
+	    (int)strlen(tstr)-1, tstr, astr? astr: "?", (ulong)sig->keyid[1] );
 
     rc = do_check_sig(c, node, NULL );
     if( !rc || rc == G10ERR_BAD_SIGN ) {
diff -urN gnupg-0.2.19/g10/misc.c gnupg-0.3.0/g10/misc.c
--- gnupg-0.2.19/g10/misc.c	Fri May 15 18:37:44 1998
+++ gnupg-0.3.0/g10/misc.c	Tue Jun 23 18:20:13 1998
@@ -28,8 +28,21 @@
 #endif
 #include "util.h"
 #include "main.h"
+#include "options.h"
 
 
+const char *g10m_revision_string(int);
+const char *g10c_revision_string(int);
+const char *g10u_revision_string(int);
+
+volatile void
+pull_in_libs(void)
+{
+    g10m_revision_string(0);
+    g10c_revision_string(0);
+    g10u_revision_string(0);
+}
+
 
 #if defined(__linux__) && defined(__alpha__)
 #warning using trap_unaligned
@@ -63,7 +76,22 @@
     u16 a;
 
     a  = (n >> 8) & 0xff;
-    a |= n & 0xff;
+    if( opt.emulate_bugs & 1 ) {
+       a |= n & 0xff;
+       log_debug("csum_u16 emulated for n=%u\n", n);
+    }
+    else
+       a += n & 0xff;
+    return a;
+}
+
+static u16
+checksum_u16_nobug( unsigned n )
+{
+    u16 a;
+
+    a  = (n >> 8) & 0xff;
+    a += n & 0xff;
     return a;
 }
 
@@ -83,12 +111,56 @@
     u16 csum;
     byte *buffer;
     unsigned nbytes;
+    unsigned nbits;
 
     buffer = mpi_get_buffer( a, &nbytes, NULL );
-    csum = checksum_u16( mpi_get_nbits(a) );
+    /* some versions of gpg encode wrong values for the length of an mpi
+     * so that mpi_get_nbits() which counts the mpi yields another (shorter)
+     * value than the one store with the mpi.  mpi_get_nbit_info() returns
+     * this stored value if it is still available.
+     */
+
+    if( opt.emulate_bugs & 1 )
+	nbits = 0;
+    else
+	nbits = mpi_get_nbit_info(a);
+    if( !nbits )
+       nbits = mpi_get_nbits(a);
+    csum = checksum_u16( nbits );
     csum += checksum( buffer, nbytes );
     m_free( buffer );
     return csum;
 }
 
+/****************
+ * This is the correct function
+ */
+u16
+checksum_mpi_counted_nbits( MPI a )
+{
+    u16 csum;
+    byte *buffer;
+    unsigned nbytes;
+    unsigned nbits;
+
+    buffer = mpi_get_buffer( a, &nbytes, NULL );
+    nbits = mpi_get_nbits(a);
+    mpi_set_nbit_info(a,nbits);
+    csum = checksum_u16_nobug( nbits );
+    csum += checksum( buffer, nbytes );
+    m_free( buffer );
+    return csum;
+}
+
+
+u32
+buffer_to_u32( const byte *buffer )
+{
+    unsigned long a;
+    a =  *buffer << 24;
+    a |= buffer[1] << 16;
+    a |= buffer[2] << 8;
+    a |= buffer[3];
+    return a;
+}
 
diff -urN gnupg-0.2.19/g10/options.h gnupg-0.3.0/g10/options.h
--- gnupg-0.2.19/g10/options.h	Wed May 27 19:22:34 1998
+++ gnupg-0.3.0/g10/options.h	Sun Jun 14 21:34:53 1998
@@ -47,6 +47,8 @@
     int skip_verify;
     int compress_keys;
     int always_trust;
+    int rfc1991;
+    unsigned emulate_bugs; /* bug emulation flags */
 } opt;
 
 
diff -urN gnupg-0.2.19/g10/packet.h gnupg-0.3.0/g10/packet.h
--- gnupg-0.2.19/g10/packet.h	Tue May 26 14:16:50 1998
+++ gnupg-0.3.0/g10/packet.h	Tue Jun 23 18:13:12 1998
@@ -27,12 +27,6 @@
 #include "cipher.h"
 #include "filter.h"
 
-#ifndef HAVE_RSA_CIPHER
-/* although we don't have RSA we need these structures to handle keyrings */
-typedef struct { MPI e, n;	       } RSA_public_key;
-typedef struct { MPI e, n, p, q, d, u; } RSA_secret_key;
-#endif
-
 typedef enum {
 	PKT_NONE	   =0,
 	PKT_PUBKEY_ENC	   =1, /* public key encrypted packet */
@@ -74,14 +68,7 @@
     u32     keyid[2];	    /* 64 bit keyid */
     byte    version;
     byte    pubkey_algo;    /* algorithm used for public key scheme */
-    union {
-      struct {
-	MPI  a, b;	    /* integers with the encrypteded DEK */
-      } elg;
-      struct {
-	MPI  rsa_integer;   /* integer containing the DEK */
-      } rsa;
-    } d;
+    MPI     data[PUBKEY_MAX_NENC];
 } PKT_pubkey_enc;
 
 
@@ -106,20 +93,16 @@
     byte *hashed_data;	    /* all subpackets with hashed  data (v4 only) */
     byte *unhashed_data;    /* ditto for unhashed data */
     byte digest_start[2];   /* first 2 bytes of the digest */
-    union {
-      struct {
-	MPI  a, b;	      /* integers with the digest */
-      } elg;
-      struct {
-	MPI  r, s;	      /* integers with the digest */
-      } dsa;
-      struct {
-	MPI  rsa_integer;     /* the encrypted digest */
-      } rsa;
-    } d;
+    MPI  data[PUBKEY_MAX_NSIG];
 } PKT_signature;
 
 
+/****************
+ * Note about the pkey/skey elements:  We assume that the secret keys
+ * has the same elemts as the public key at the begin of the array, so
+ * that npkey < nskey and it is possible to compare the secret and
+ * public keys by comparing the first npkey elements of pkey againts skey.
+ */
 typedef struct {
     u32     timestamp;	    /* certificate made */
     u16     valid_days;     /* valid for this number of days */
@@ -127,11 +110,7 @@
     byte    version;
     byte    pubkey_algo;    /* algorithm used for public key scheme */
     ulong   local_id;	    /* internal use, valid if > 0 */
-    union {
-	ELG_public_key elg;
-	DSA_public_key dsa;
-	RSA_public_key rsa;
-    } d;
+    MPI     pkey[PUBKEY_MAX_NPKEY];
 } PKT_public_cert;
 
 typedef struct {
@@ -149,11 +128,7 @@
 	STRING2KEY s2k;
 	byte iv[8]; /* initialization vector for CFB mode */
     } protect;
-    union {
-	ELG_secret_key elg;
-	DSA_secret_key dsa;
-	RSA_secret_key rsa;
-    } d;
+    MPI skey[PUBKEY_MAX_NSKEY];
     u16 csum;		/* checksum */
 } PKT_secret_cert;
 
@@ -234,7 +209,8 @@
     SIGSUBPKT_PRIMARY_UID  =25, /* primary user id */
     SIGSUBPKT_POLICY	   =26, /* policy URL */
     SIGSUBPKT_KEY_FLAGS    =27, /* key flags */
-    SIGSUBPKT_SIGNERS_UID  =28	/* signer's user id */
+    SIGSUBPKT_SIGNERS_UID  =28, /* signer's user id */
+    SIGSUBPKT_PRIV_ADD_SIG =101 /* signatur is also valid for this uid */
 } sigsubpkttype_t;
 
 
@@ -300,7 +276,7 @@
 int encrypt_data( PKT_encrypted *ed, DEK *dek );
 
 /*-- plaintext.c --*/
-int handle_plaintext( PKT_plaintext *pt, md_filter_context_t *mfx );
+int handle_plaintext( PKT_plaintext *pt, md_filter_context_t *mfx,int nooutput);
 int ask_for_detached_datafile( md_filter_context_t *mfx, const char *inname );
 
 /*-- comment.c --*/
@@ -310,6 +286,8 @@
 int make_keysig_packet( PKT_signature **ret_sig, PKT_public_cert *pkc,
 			PKT_user_id *uid, PKT_public_cert *subpkc,
 			PKT_secret_cert *skc,
-			int sigclass, int digest_algo );
+			int sigclass, int digest_algo,
+			int (*mksubpkt)(PKT_signature *, void *),
+			void *opaque  );
 
 #endif /*G10_PACKET_H*/
diff -urN gnupg-0.2.19/g10/parse-packet.c gnupg-0.3.0/g10/parse-packet.c
--- gnupg-0.2.19/g10/parse-packet.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/parse-packet.c	Tue Jun 23 19:10:38 1998
@@ -32,6 +32,7 @@
 #include "memory.h"
 #include "filter.h"
 #include "options.h"
+#include "main.h"
 
 static int mpi_print_mode = 0;
 static int list_mode = 0;
@@ -64,6 +65,7 @@
 static int  parse_encrypted( IOBUF inp, int pkttype, unsigned long pktlen,
 							   PACKET *packet );
 
+
 static unsigned short
 read_16(IOBUF inp)
 {
@@ -84,16 +86,6 @@
     return a;
 }
 
-static unsigned long
-buffer_to_u32( const byte *buffer )
-{
-    unsigned long a;
-    a =  *buffer << 24;
-    a |= buffer[1] << 16;
-    a |= buffer[2] << 8;
-    a |= buffer[3];
-    return a;
-}
 
 int
 set_packet_list_mode( int mode )
@@ -318,6 +310,7 @@
 	break;
       case PKT_RING_TRUST:
 	parse_trust(inp, pkttype, pktlen);
+	rc = 0;
 	break;
       case PKT_PLAINTEXT:
 	rc = parse_plaintext(inp, pkttype, pktlen, pkt );
@@ -502,6 +495,7 @@
 parse_pubkeyenc( IOBUF inp, int pkttype, unsigned long pktlen, PACKET *packet )
 {
     unsigned n;
+    int i, ndata;
     PKT_pubkey_enc *k;
 
     k = packet->pkt.pubkey_enc = m_alloc(sizeof *packet->pkt.pubkey_enc );
@@ -520,31 +514,20 @@
     if( list_mode )
 	printf(":pubkey enc packet: version %d, algo %d, keyid %08lX%08lX\n",
 	  k->version, k->pubkey_algo, (ulong)k->keyid[0], (ulong)k->keyid[1]);
-    if( is_ELGAMAL(k->pubkey_algo) ) {
-	n = pktlen;
-	k->d.elg.a = mpi_read(inp, &n, 0); pktlen -=n;
-	n = pktlen;
-	k->d.elg.b = mpi_read(inp, &n, 0 ); pktlen -=n;
-	if( list_mode ) {
-	    printf("\telg a: ");
-	    mpi_print(stdout, k->d.elg.a, mpi_print_mode );
-	    printf("\n\telg b: ");
-	    mpi_print(stdout, k->d.elg.b, mpi_print_mode );
-	    putchar('\n');
-	}
-    }
-    else if( is_RSA(k->pubkey_algo) ) {
+
+    ndata = pubkey_get_nenc(k->pubkey_algo);
+    if( !ndata && list_mode )
+	printf("\tunsupported algorithm %d\n", k->pubkey_algo );
+
+    for( i=0; i < ndata; i++ ) {
 	n = pktlen;
-	k->d.rsa.rsa_integer = mpi_read(inp, &n, 0 ); pktlen -=n;
+	k->data[i] = mpi_read(inp, &n, 0); pktlen -=n;
 	if( list_mode ) {
-	    printf("\trsa integer: ");
-	    mpi_print(stdout, k->d.rsa.rsa_integer, mpi_print_mode );
+	    printf("\tdata: ");
+	    mpi_print(stdout, k->data[i], mpi_print_mode );
 	    putchar('\n');
 	}
     }
-    else if( list_mode )
-	printf("\tunknown algorithm %d\n", k->pubkey_algo );
-
 
   leave:
     skip_rest(inp, pktlen);
@@ -615,6 +598,7 @@
 	   : type == SIGSUBPKT_POLICY	   ? "policy URL"
 	   : type == SIGSUBPKT_KEY_FLAGS   ? "key flags"
 	   : type == SIGSUBPKT_SIGNERS_UID ? "signer's user id"
+	   : type == SIGSUBPKT_PRIV_ADD_SIG? "signs additional user id"
 			      : "?");
 	}
 	else if( type == reqtype )
@@ -629,6 +613,8 @@
 	*ret_n = n;
     switch( type ) {
       case SIGSUBPKT_SIG_CREATED:
+      case SIGSUBPKT_SIG_EXPIRE:
+      case SIGSUBPKT_KEY_EXPIRE:
 	if( n < 4 )
 	    break;
 	return buffer;
@@ -636,6 +622,13 @@
 	if( n < 8 )
 	    break;
 	return buffer;
+      case SIGSUBPKT_PRIV_ADD_SIG:
+	/* because we use private data, we check the GNUPG marker */
+	if( n < 24 )
+	    break;
+	if( buffer[0] != 'G' || buffer[1] != 'P' || buffer[2] != 'G' )
+	    return NULL;
+	return buffer+3;
       default: BUG(); /* not yet needed */
     }
     log_error("subpacket of type %d too short\n", type);
@@ -655,6 +648,7 @@
     unsigned n;
     int is_v4=0;
     int rc=0;
+    int i, ndata;
 
     if( pktlen < 16 ) {
 	log_error("packet(%d) too short\n", pkttype);
@@ -755,43 +749,21 @@
 	    parse_sig_subpkt( sig->unhashed_data,SIGSUBPKT_LIST_UNHASHED, NULL);
 	}
     }
-    if( is_ELGAMAL(sig->pubkey_algo) ) {
-	n = pktlen;
-	sig->d.elg.a = mpi_read(inp, &n, 0 ); pktlen -=n;
-	n = pktlen;
-	sig->d.elg.b = mpi_read(inp, &n, 0 ); pktlen -=n;
-	if( list_mode ) {
-	    printf("\telg a: ");
-	    mpi_print(stdout, sig->d.elg.a, mpi_print_mode );
-	    printf("\n\telg b: ");
-	    mpi_print(stdout, sig->d.elg.b, mpi_print_mode );
-	    putchar('\n');
-	}
-    }
-    else if( sig->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	n = pktlen;
-	sig->d.dsa.r = mpi_read(inp, &n, 0 ); pktlen -=n;
-	n = pktlen;
-	sig->d.dsa.s = mpi_read(inp, &n, 0 ); pktlen -=n;
-	if( list_mode ) {
-	    printf("\tdsa r: ");
-	    mpi_print(stdout, sig->d.elg.a, mpi_print_mode );
-	    printf("\n\tdsa s: ");
-	    mpi_print(stdout, sig->d.elg.b, mpi_print_mode );
-	    putchar('\n');
-	}
-    }
-    else if( is_RSA(sig->pubkey_algo) ) {
+
+    ndata = pubkey_get_nsig(sig->pubkey_algo);
+    if( !ndata && list_mode )
+	printf("\tunknown algorithm %d\n", sig->pubkey_algo );
+
+    for( i=0; i < ndata; i++ ) {
 	n = pktlen;
-	sig->d.rsa.rsa_integer = mpi_read(inp, &n, 0 ); pktlen -=n;
+	sig->data[i] = mpi_read(inp, &n, 0 );
+	pktlen -=n;
 	if( list_mode ) {
-	    printf("\trsa integer: ");
-	    mpi_print(stdout, sig->d.rsa.rsa_integer, mpi_print_mode );
+	    printf("\tdata: ");
+	    mpi_print(stdout, sig->data[i], mpi_print_mode );
 	    putchar('\n');
 	}
     }
-    else if( list_mode )
-	printf("\tunknown algorithm %d\n", sig->pubkey_algo );
 
 
   leave:
@@ -924,17 +896,17 @@
 	    putchar('\n');
 	}
 	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
-	    pkt->pkt.public_cert->d.elg.p = elg_p;
-	    pkt->pkt.public_cert->d.elg.g = elg_g;
-	    pkt->pkt.public_cert->d.elg.y = elg_y;
+	    pkt->pkt.public_cert->pkey[0] = elg_p;
+	    pkt->pkt.public_cert->pkey[1] = elg_g;
+	    pkt->pkt.public_cert->pkey[2] = elg_y;
 	}
 	else {
 	    PKT_secret_cert *cert = pkt->pkt.secret_cert;
 	    byte temp[8];
 
-	    pkt->pkt.secret_cert->d.elg.p = elg_p;
-	    pkt->pkt.secret_cert->d.elg.g = elg_g;
-	    pkt->pkt.secret_cert->d.elg.y = elg_y;
+	    pkt->pkt.secret_cert->skey[0] = elg_p;
+	    pkt->pkt.secret_cert->skey[1] = elg_g;
+	    pkt->pkt.secret_cert->skey[2] = elg_y;
 	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
 	    if( cert->protect.algo ) {
 		cert->is_protected = 1;
@@ -994,15 +966,15 @@
 
 		}
 		else {
-		    if( list_mode )
-			printf(  "\tprotect algo: %d\n",
-						cert->protect.algo);
 		    /* old version, we don't have a S2K, so we fake one */
 		    cert->protect.s2k.mode = 0;
 		    /* We need this kludge to cope with old GNUPG versions */
 		    cert->protect.s2k.hash_algo =
 			 cert->protect.algo == CIPHER_ALGO_BLOWFISH160?
 				      DIGEST_ALGO_RMD160 : DIGEST_ALGO_MD5;
+		    if( list_mode )
+			printf(  "\tprotect algo: %d  (hash algo: %d)\n",
+			     cert->protect.algo, cert->protect.s2k.hash_algo );
 		}
 		if( pktlen < 8 ) {
 		    rc = G10ERR_INVALID_PACKET;
@@ -1024,20 +996,15 @@
 	     * If the user is so careless, not to protect his secret key,
 	     * we can assume, that he operates an open system :=(.
 	     * So we put the key into secure memory when we unprotect it. */
-	    n = pktlen; cert->d.elg.x = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[3] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    if( cert->is_protected )
+		mpi_set_protect_flag(cert->skey[3]);
 
 	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
-	    printf("\telg x: ");
-	    mpi_print(stdout, cert->d.elg.x, mpi_print_mode  );
-	    putchar('\n');
 		printf("\t[secret value x is not shown]\n"
 		       "\tchecksum: %04hx\n", cert->csum);
 	    }
-	  /*log_mpidump("elg p=", cert->d.elg.p );
-	    log_mpidump("elg g=", cert->d.elg.g );
-	    log_mpidump("elg y=", cert->d.elg.y );
-	    log_mpidump("elg x=", cert->d.elg.x ); */
 	}
     }
     else if( algorithm == PUBKEY_ALGO_DSA ) {
@@ -1058,19 +1025,19 @@
 	    putchar('\n');
 	}
 	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
-	    pkt->pkt.public_cert->d.dsa.p = dsa_p;
-	    pkt->pkt.public_cert->d.dsa.q = dsa_q;
-	    pkt->pkt.public_cert->d.dsa.g = dsa_g;
-	    pkt->pkt.public_cert->d.dsa.y = dsa_y;
+	    pkt->pkt.public_cert->pkey[0] = dsa_p;
+	    pkt->pkt.public_cert->pkey[1] = dsa_q;
+	    pkt->pkt.public_cert->pkey[2] = dsa_g;
+	    pkt->pkt.public_cert->pkey[3] = dsa_y;
 	}
 	else {
 	    PKT_secret_cert *cert = pkt->pkt.secret_cert;
 	    byte temp[8];
 
-	    pkt->pkt.secret_cert->d.dsa.p = dsa_p;
-	    pkt->pkt.secret_cert->d.dsa.q = dsa_q;
-	    pkt->pkt.secret_cert->d.dsa.g = dsa_g;
-	    pkt->pkt.secret_cert->d.dsa.y = dsa_y;
+	    pkt->pkt.secret_cert->skey[0] = dsa_p;
+	    pkt->pkt.secret_cert->skey[1] = dsa_q;
+	    pkt->pkt.secret_cert->skey[2] = dsa_g;
+	    pkt->pkt.secret_cert->skey[3] = dsa_y;
 	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
 	    if( cert->protect.algo ) {
 		cert->is_protected = 1;
@@ -1156,18 +1123,15 @@
 	     * If the user is so careless, not to protect his secret key,
 	     * we can assume, that he operates an open system :=(.
 	     * So we put the key into secure memory when we unprotect it. */
-	    n = pktlen; cert->d.dsa.x = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[4] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    if( cert->is_protected )
+		mpi_set_protect_flag(cert->skey[4]);
 
 	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
 		printf("\t[secret value x is not shown]\n"
 		       "\tchecksum: %04hx\n", cert->csum);
 	    }
-	  /*log_mpidump("dsa p=", cert->d.dsa.p );
-	    log_mpidump("dsa q=", cert->d.dsa.q );
-	    log_mpidump("dsa g=", cert->d.dsa.g );
-	    log_mpidump("dsa y=", cert->d.dsa.y );
-	    log_mpidump("dsa x=", cert->d.dsa.x ); */
 	}
     }
     else if( is_RSA(algorithm) ) {
@@ -1183,15 +1147,15 @@
 	    putchar('\n');
 	}
 	if( pkttype == PKT_PUBLIC_CERT || pkttype == PKT_PUBKEY_SUBCERT ) {
-	    pkt->pkt.public_cert->d.rsa.n = rsa_pub_mod;
-	    pkt->pkt.public_cert->d.rsa.e = rsa_pub_exp;
+	    pkt->pkt.public_cert->pkey[0] = rsa_pub_mod;
+	    pkt->pkt.public_cert->pkey[1] = rsa_pub_exp;
 	}
 	else {
 	    PKT_secret_cert *cert = pkt->pkt.secret_cert;
 	    byte temp[8];
 
-	    pkt->pkt.secret_cert->d.rsa.n = rsa_pub_mod;
-	    pkt->pkt.secret_cert->d.rsa.e = rsa_pub_exp;
+	    pkt->pkt.secret_cert->skey[0] = rsa_pub_mod;
+	    pkt->pkt.secret_cert->skey[1] = rsa_pub_exp;
 	    cert->protect.algo = iobuf_get_noeof(inp); pktlen--;
 	    if( list_mode )
 		printf(  "\tprotect algo: %d\n", cert->protect.algo);
@@ -1205,28 +1169,30 @@
 			printf(" %02x", temp[i] );
 		    putchar('\n');
 		}
-		if( cert->protect.algo == CIPHER_ALGO_BLOWFISH160 )
-		    memcpy(cert->protect.iv, temp, 8 );
+		memcpy(cert->protect.iv, temp, 8 );
+		/* old version, we don't have a S2K, so we fake one */
+		cert->protect.s2k.mode = 0;
+		cert->protect.s2k.hash_algo = DIGEST_ALGO_MD5;
 	    }
 	    else
 		cert->is_protected = 0;
 	    /* (See comments at the code for elg keys) */
-	    n = pktlen; cert->d.rsa.d = mpi_read(inp, &n, 0 ); pktlen -=n;
-	    n = pktlen; cert->d.rsa.p = mpi_read(inp, &n, 0 ); pktlen -=n;
-	    n = pktlen; cert->d.rsa.q = mpi_read(inp, &n, 0 ); pktlen -=n;
-	    n = pktlen; cert->d.rsa.u = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[2] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[3] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[4] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    n = pktlen; cert->skey[5] = mpi_read(inp, &n, 0 ); pktlen -=n;
+	    if( cert->is_protected ) {
+		mpi_set_protect_flag(cert->skey[2]);
+		mpi_set_protect_flag(cert->skey[3]);
+		mpi_set_protect_flag(cert->skey[4]);
+		mpi_set_protect_flag(cert->skey[5]);
+	    }
 
 	    cert->csum = read_16(inp); pktlen -= 2;
 	    if( list_mode ) {
 		printf("\t[secret values d,p,q,u are not shown]\n"
 		       "\tchecksum: %04hx\n", cert->csum);
 	    }
-	 /* log_mpidump("rsa n=", cert->d.rsa.n );
-	    log_mpidump("rsa e=", cert->d.rsa.e );
-	    log_mpidump("rsa d=", cert->d.rsa.d );
-	    log_mpidump("rsa p=", cert->d.rsa.p );
-	    log_mpidump("rsa q=", cert->d.rsa.q );
-	    log_mpidump("rsa u=", cert->d.rsa.u ); */
 	}
     }
     else if( list_mode )
diff -urN gnupg-0.2.19/g10/plaintext.c gnupg-0.3.0/g10/plaintext.c
--- gnupg-0.2.19/g10/plaintext.c	Thu May 21 12:40:56 1998
+++ gnupg-0.3.0/g10/plaintext.c	Wed Jun 24 19:53:08 1998
@@ -40,16 +40,18 @@
  *	 bytes from the plaintext.
  */
 int
-handle_plaintext( PKT_plaintext *pt, md_filter_context_t *mfx )
+handle_plaintext( PKT_plaintext *pt, md_filter_context_t *mfx, int nooutput )
 {
-    char *fname;
+    char *fname = NULL;
     FILE *fp = NULL;
     int rc = 0;
     int c;
     int convert = pt->mode == 't';
 
     /* create the filename as C string */
-    if( opt.outfile ) {
+    if( nooutput )
+	;
+    else if( opt.outfile ) {
 	fname = m_alloc( strlen( opt.outfile ) + 1);
 	strcpy(fname, opt.outfile );
     }
@@ -59,14 +61,16 @@
 	fname[pt->namelen] = 0;
     }
 
-    if( !*fname || (*fname=='-' && !fname[1])) {
+    if( nooutput )
+	;
+    else if( !*fname || (*fname=='-' && !fname[1])) {
 	/* no filename or "-" given; write to stdout */
 	fp = stdout;
     }
     else if( overwrite_filep( fname ) )
 	goto leave;
 
-    if( fp )
+    if( fp || nooutput )
 	;
     else if( !(fp = fopen(fname,"wb")) ) {
 	log_error("Error creating '%s': %s\n", fname, strerror(errno) );
@@ -86,10 +90,13 @@
 		md_putc(mfx->md, c );
 	    if( convert && c == '\r' )
 		continue; /* FIXME: this hack is too simple */
-	    if( putc( c, fp ) == EOF ) {
-		log_error("Error writing to '%s': %s\n", fname, strerror(errno) );
-		rc = G10ERR_WRITE_FILE;
-		goto leave;
+	    if( fp ) {
+		if( putc( c, fp ) == EOF ) {
+		    log_error("Error writing to '%s': %s\n",
+					    fname, strerror(errno) );
+		    rc = G10ERR_WRITE_FILE;
+		    goto leave;
+		}
 	    }
 	}
     }
@@ -99,11 +106,13 @@
 		md_putc(mfx->md, c );
 	    if( convert && c == '\r' )
 		continue; /* FIXME: this hack is too simple */
-	    if( putc( c, fp ) == EOF ) {
-		log_error("Error writing to '%s': %s\n",
-					    fname, strerror(errno) );
-		rc = G10ERR_WRITE_FILE;
-		goto leave;
+	    if( fp ) {
+		if( putc( c, fp ) == EOF ) {
+		    log_error("Error writing to '%s': %s\n",
+						fname, strerror(errno) );
+		    rc = G10ERR_WRITE_FILE;
+		    goto leave;
+		}
 	    }
 	}
 	iobuf_clear_eof(pt->buf);
diff -urN gnupg-0.2.19/g10/pubkey-enc.c gnupg-0.3.0/g10/pubkey-enc.c
--- gnupg-0.2.19/g10/pubkey-enc.c	Thu May 28 10:42:07 1998
+++ gnupg-0.3.0/g10/pubkey-enc.c	Fri Jun 12 21:51:02 1998
@@ -46,36 +46,19 @@
     u16 csum, csum2;
     PKT_secret_cert *skc = m_alloc_clear( sizeof *skc );
 
-  #ifndef HAVE_RSA_CIPHER
-    if( is_RSA(k->pubkey_algo) )
+    if( is_RSA(k->pubkey_algo) ) /* warn about that */
 	write_status(STATUS_RSA_OR_IDEA);
-  #endif
+    rc=check_pubkey_algo( k->pubkey_algo );
+    if( rc )
+	goto leave;
 
     skc->pubkey_algo = k->pubkey_algo;	 /* we want a pubkey with this algo*/
     if( (rc = get_seckey( skc, k->keyid )) )
 	goto leave;
 
-    if( is_ELGAMAL(k->pubkey_algo) ) {
-	if( DBG_CIPHER ) {
-	    log_mpidump("Encr DEK a:", k->d.elg.a );
-	    log_mpidump("     DEK b:", k->d.elg.b );
-	}
-	plain_dek = mpi_alloc_secure( mpi_get_nlimbs(skc->d.elg.p) );
-	elg_decrypt( plain_dek, k->d.elg.a, k->d.elg.b, &skc->d.elg );
-    }
-  #ifdef HAVE_RSA_CIPHER
-    else if( is_RSA(k->pubkey_algo) ) {
-	if( DBG_CIPHER )
-	    log_mpidump("Encr DEK frame:", k->d.rsa.rsa_integer );
-
-	plain_dek = mpi_alloc_secure( mpi_get_nlimbs(skc->d.rsa.n) );
-	rsa_secret( plain_dek, k->d.rsa.rsa_integer, &skc->d.rsa );
-    }
-  #endif/*HAVE_RSA_CIPHER*/
-    else {
-	rc = G10ERR_PUBKEY_ALGO; /* unsupported algorithm */
+    rc = pubkey_decrypt(k->pubkey_algo, &plain_dek, k->data, skc->skey );
+    if( rc )
 	goto leave;
-    }
     free_secret_cert( skc ); skc = NULL;
     frame = mpi_get_buffer( plain_dek, &nframe, NULL );
     mpi_free( plain_dek ); plain_dek = NULL;
@@ -117,25 +100,18 @@
 
     dek->keylen = nframe - (n+1) - 2;
     dek->algo = frame[n++];
-    switch( dek->algo ) {
-      case CIPHER_ALGO_IDEA:
+    if( dek->algo ==  CIPHER_ALGO_IDEA )
 	write_status(STATUS_RSA_OR_IDEA);
-	rc = G10ERR_NI_CIPHER;
-	goto leave;
-      case CIPHER_ALGO_BLOWFISH160:
-	if( dek->keylen != 20 )
-	    { rc = G10ERR_WRONG_SECKEY; goto leave; }
-	break;
-      case CIPHER_ALGO_BLOWFISH:
-      case CIPHER_ALGO_CAST:
-	if( dek->keylen != 16 )
-	    { rc = G10ERR_WRONG_SECKEY; goto leave; }
-	break;
-      default:
+    rc = check_cipher_algo( dek->algo );
+    if( rc ) {
 	dek->algo = 0;
-	rc = G10ERR_CIPHER_ALGO;
 	goto leave;
     }
+    if( (dek->keylen*8) != cipher_get_keylen( dek->algo ) ) {
+	rc = G10ERR_WRONG_SECKEY;
+	goto leave;
+    }
+
     /* copy the key to DEK and compare the checksum */
     csum  = frame[nframe-2] << 8;
     csum |= frame[nframe-1];
diff -urN gnupg-0.2.19/g10/revoke.c gnupg-0.3.0/g10/revoke.c
--- gnupg-0.2.19/g10/revoke.c	Tue May 26 12:52:12 1998
+++ gnupg-0.3.0/g10/revoke.c	Thu Jun 18 11:53:38 1998
@@ -159,7 +159,7 @@
 
 
     /* create it */
-    rc = make_keysig_packet( &sig, pkc, NULL, NULL, skc, 0x20, 0);
+    rc = make_keysig_packet( &sig, pkc, NULL, NULL, skc, 0x20, 0, NULL, NULL);
     if( rc ) {
 	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc));
 	goto leave;
diff -urN gnupg-0.2.19/g10/ringedit.c gnupg-0.3.0/g10/ringedit.c
--- gnupg-0.2.19/g10/ringedit.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/ringedit.c	Fri Jun 12 18:16:41 1998
@@ -448,6 +448,35 @@
  ********** Functions which operates on regular keyrings ********
  ****************************************************************/
 
+static int
+cmp_seckey( PKT_secret_cert *req_skc, PKT_secret_cert *skc )
+{
+    int n,i;
+
+    assert( req_skc->pubkey_algo == skc->pubkey_algo );
+
+    n = pubkey_get_nskey( req_skc->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	if( mpi_cmp( req_skc->skey[i], skc->skey[i] ) )
+	    return -1;
+    }
+    return 0;
+}
+
+static int
+cmp_pubkey( PKT_public_cert *req_pkc, PKT_public_cert *pkc )
+{
+    int n, i;
+
+    assert( req_pkc->pubkey_algo == pkc->pubkey_algo );
+
+    n = pubkey_get_npkey( req_pkc->pubkey_algo );
+    for(i=0; i < n; i++ ) {
+	if( mpi_cmp( req_pkc->pkey[i], pkc->pkey[i] )  )
+	    return -1;
+    }
+    return 0;
+}
 
 /****************
  * search one keyring, return 0 if found, -1 if not found or an errorcode.
@@ -489,26 +518,7 @@
 	    if(   req_skc->timestamp == skc->timestamp
 	       && req_skc->valid_days == skc->valid_days
 	       && req_skc->pubkey_algo == skc->pubkey_algo
-	       && (   ( is_ELGAMAL(skc->pubkey_algo)
-			&& !mpi_cmp( req_skc->d.elg.p, skc->d.elg.p )
-			&& !mpi_cmp( req_skc->d.elg.g, skc->d.elg.g )
-			&& !mpi_cmp( req_skc->d.elg.y, skc->d.elg.y )
-			&& !mpi_cmp( req_skc->d.elg.x, skc->d.elg.x )
-		      )
-		   || ( skc->pubkey_algo == PUBKEY_ALGO_DSA
-			&& !mpi_cmp( req_skc->d.dsa.p, skc->d.dsa.p )
-			&& !mpi_cmp( req_skc->d.dsa.q, skc->d.dsa.q )
-			&& !mpi_cmp( req_skc->d.dsa.g, skc->d.dsa.g )
-			&& !mpi_cmp( req_skc->d.dsa.y, skc->d.dsa.y )
-			&& !mpi_cmp( req_skc->d.dsa.x, skc->d.dsa.x )
-		      )
-		   || ( is_RSA(skc->pubkey_algo)
-			&& !mpi_cmp( req_skc->d.rsa.n, skc->d.rsa.n )
-			&& !mpi_cmp( req_skc->d.rsa.e, skc->d.rsa.e )
-			&& !mpi_cmp( req_skc->d.rsa.d, skc->d.rsa.d )
-		      )
-		  )
-	      )
+	       && !cmp_seckey( req_skc, skc) )
 		break; /* found */
 	}
 	else if( pkt.pkttype == PKT_PUBLIC_CERT ) {
@@ -517,23 +527,7 @@
 	    if(   req_pkc->timestamp == pkc->timestamp
 	       && req_pkc->valid_days == pkc->valid_days
 	       && req_pkc->pubkey_algo == pkc->pubkey_algo
-	       && (   ( is_ELGAMAL(pkc->pubkey_algo)
-			&& !mpi_cmp( req_pkc->d.elg.p, pkc->d.elg.p )
-			&& !mpi_cmp( req_pkc->d.elg.g, pkc->d.elg.g )
-			&& !mpi_cmp( req_pkc->d.elg.y, pkc->d.elg.y )
-		      )
-		   || ( pkc->pubkey_algo == PUBKEY_ALGO_DSA
-			&& !mpi_cmp( req_pkc->d.dsa.p, pkc->d.dsa.p )
-			&& !mpi_cmp( req_pkc->d.dsa.q, pkc->d.dsa.q )
-			&& !mpi_cmp( req_pkc->d.dsa.g, pkc->d.dsa.g )
-			&& !mpi_cmp( req_pkc->d.dsa.y, pkc->d.dsa.y )
-		      )
-		   || ( is_RSA(pkc->pubkey_algo)
-			&& !mpi_cmp( req_pkc->d.rsa.n, pkc->d.rsa.n )
-			&& !mpi_cmp( req_pkc->d.rsa.e, pkc->d.rsa.e )
-		      )
-		  )
-	      )
+	       && !cmp_pubkey( req_pkc, pkc ) )
 		break; /* found */
 	}
 	else
diff -urN gnupg-0.2.19/g10/rsa.c gnupg-0.3.0/g10/rsa.c
--- gnupg-0.2.19/g10/rsa.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/rsa.c	Thu Jan  1 01:00:00 1970
@@ -1,89 +0,0 @@
-/* rsa.c  - glue code for RSA cipher
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- */
-
-#include <config.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-#include <errno.h>
-#include <assert.h>
-
-#include "options.h"
-#include "packet.h"
-#include "errors.h"
-#include "iobuf.h"
-#include "keydb.h"
-#include "memory.h"
-#include "util.h"
-#include "main.h"
-
-void
-g10_rsa_encrypt( PKT_public_cert *pkc, PKT_pubkey_enc *enc, DEK *dek )
-{
-  #ifdef HAVE_RSA_CIPHER
-    assert( is_RSA(enc->pubkey_algo) );
-
-    keyid_from_pkc( pkc, enc->keyid );
-    enc->d.rsa.rsa_integer = encode_session_key( dek,
-				mpi_get_nbits(pkc->d.rsa.rsa_n) );
-    if( DBG_CIPHER )
-	log_mpidump("Plain DEK frame: ", enc->d.rsa.rsa_integer);
-    rsa_public( enc->d.rsa.rsa_integer, enc->d.rsa.rsa_integer, &pkc->d.rsa);
-    if( DBG_CIPHER )
-	log_mpidump("Encry DEK frame: ", enc->d.rsa.rsa_integer);
-    if( opt.verbose ) {
-	char *ustr = get_user_id_string( enc->keyid );
-	log_info("RSA encrypted for: %s\n", ustr );
-	m_free(ustr);
-    }
- #else
-    BUG();
- #endif/* ! HAVE_RSA_CIPHER*/
-}
-
-
-void
-g10_rsa_sign( PKT_secret_cert *skc, PKT_signature *sig,
-				    MD_HANDLE md, int digest_algo )
-{
- #ifdef HAVE_RSA_CIPHER
-    byte *dp;
-
-    assert( is_RSA(sig->pubkey_algo) );
-    if( !digest_algo )
-	digest_algo = md_get_algo(md);
-
-    dp = md_read( md, digest_algo );
-    sig->digest_algo = digest_algo;
-    sig->digest_start[0] = dp[0];
-    sig->digest_start[1] = dp[1];
-    sig->d.rsa.rsa_integer =
-	   encode_md_value( md, digest_algo, mpi_get_nbits(skc->d.rsa.rsa_n));
-    rsa_secret( sig->d.rsa.rsa_integer, sig->d.rsa.rsa_integer, &skc->d.rsa );
-    if( opt.verbose ) {
-	char *ustr = get_user_id_string( sig->keyid );
-	log_info("RSA signature from: %s\n", ustr );
-	m_free(ustr);
-    }
- #else
-    BUG();
- #endif/* ! HAVE_RSA_CIPHER*/
-}
-
diff -urN gnupg-0.2.19/g10/seckey-cert.c gnupg-0.3.0/g10/seckey-cert.c
--- gnupg-0.2.19/g10/seckey-cert.c	Thu May 28 17:40:23 1998
+++ gnupg-0.3.0/g10/seckey-cert.c	Tue Jun 16 16:06:46 1998
@@ -39,7 +39,7 @@
 {
     byte *buffer;
     u16 csum=0;
-    int res;
+    int i, res;
     unsigned nbytes;
 
     if( cert->is_protected ) { /* remove the protection */
@@ -49,160 +49,63 @@
 	PKT_secret_cert *save_cert;
 	char save_iv[8];
 
-	switch( cert->protect.algo ) {
-	  case CIPHER_ALGO_NONE: BUG(); break;
-	  case CIPHER_ALGO_BLOWFISH160:
-	  case CIPHER_ALGO_BLOWFISH:
-	  case CIPHER_ALGO_CAST:
-	    keyid_from_skc( cert, keyid );
-	    dek = passphrase_to_dek( keyid, cert->protect.algo,
-				     &cert->protect.s2k, 0 );
-	    cipher_hd = cipher_open( cert->protect.algo,
-				     CIPHER_MODE_AUTO_CFB, 1);
-	    cipher_setkey( cipher_hd, dek->key, dek->keylen );
-	    cipher_setiv( cipher_hd, NULL );
-	    m_free(dek); /* pw is in secure memory, so m_free() burns it */
-	    save_cert = copy_secret_cert( NULL, cert );
-	    memcpy(save_iv, cert->protect.iv, 8 );
-	    cipher_decrypt( cipher_hd, cert->protect.iv, cert->protect.iv, 8 );
-	    switch( cert->pubkey_algo ) {
-	      case PUBKEY_ALGO_ELGAMAL:
-	      case PUBKEY_ALGO_ELGAMAL_E:
-		buffer = mpi_get_secure_buffer( cert->d.elg.x, &nbytes, NULL );
-		cipher_decrypt( cipher_hd, buffer, buffer, nbytes );
-		mpi_set_buffer( cert->d.elg.x, buffer, nbytes, 0 );
-		csum = checksum_mpi( cert->d.elg.x );
-		m_free( buffer );
-		break;
-	      case PUBKEY_ALGO_DSA:
-		buffer = mpi_get_secure_buffer( cert->d.dsa.x, &nbytes, NULL );
-		cipher_decrypt( cipher_hd, buffer, buffer, nbytes );
-		mpi_set_buffer( cert->d.dsa.x, buffer, nbytes, 0 );
-		csum = checksum_mpi( cert->d.dsa.x );
-		m_free( buffer );
-		break;
-	    #ifdef HAVE_RSA_CIPHER
-	      case PUBKEY_ALGO_RSA:
-	      case PUBKEY_ALGO_RSA_E:
-	      case PUBKEY_ALGO_RSA_S:
-		csum = 0;
-		#define X(a) do { \
-		    buffer = mpi_get_secure_buffer( cert->d.rsa.##a,	 \
-						    &nbytes, NULL );	 \
-		    csum += checksum_u16( nbytes*8 );			 \
-		    cipher_decrypt( cipher_hd, buffer, buffer, nbytes ); \
-		    csum += checksum( buffer, nbytes ); 		 \
-		    mpi_set_buffer(cert->d.rsa.##a, buffer, nbytes, 0 ); \
-		    m_free( buffer );					 \
-		   } while(0)
-		X(d);
-		X(p);
-		X(q);
-		X(u);
-		#undef X
-		break;
-	    #endif /* HAVE_RSA_CIPHER */
-
-	      default: BUG();
-	    }
-	    cipher_close( cipher_hd );
-	    /* now let's see whether we have used the right passphrase */
-	    if( csum != cert->csum ) {
-		if( cert->pubkey_algo == PUBKEY_ALGO_ELGAMAL_E ) {
-		    /* very bad kludge to work around an early bug */
-		    csum -= checksum_u16( mpi_get_nbits(cert->d.elg.x) );
-		    nbytes = mpi_get_nlimbs(cert->d.elg.x) * 4;
-		    csum += checksum_u16( nbytes*8 );
-		    if( !opt.batch && csum == cert->csum )
-			log_info("Probably you have an old key - use "
-			     "\"--change-passphrase\" to convert.\n");
-		}
-		if( csum != cert->csum ) {
-		    copy_secret_cert( cert, save_cert );
-		    free_secret_cert( save_cert );
-		    memcpy( cert->protect.iv, save_iv, 8 );
-		    return G10ERR_BAD_PASS;
-		}
-	    }
-
-	    switch( cert->pubkey_algo ) {
-	      case PUBKEY_ALGO_ELGAMAL_E:
-	      case PUBKEY_ALGO_ELGAMAL:
-		res = elg_check_secret_key( &cert->d.elg );
-		break;
-	      case PUBKEY_ALGO_DSA:
-		res = dsa_check_secret_key( &cert->d.dsa );
-		break;
-	    #ifdef HAVE_RSA_CIPHER
-	      case PUBKEY_ALGO_RSA:
-	      case PUBKEY_ALGO_RSA_E:
-	      case PUBKEY_ALGO_RSA_S:
-		res = rsa_check_secret_key( &cert->d.rsa );
-		break;
-	    #endif
-	      default: BUG();
-	    }
-	    if( !res ) {
-		copy_secret_cert( cert, save_cert );
-		free_secret_cert( save_cert );
-		memcpy( cert->protect.iv, save_iv, 8 );
-		return G10ERR_BAD_PASS;
-	    }
-	    free_secret_cert( save_cert );
-	    cert->is_protected = 0;
-	    break;
-
-	  default:
+	if( cert->protect.algo == CIPHER_ALGO_NONE )
+	    BUG();
+	if( check_cipher_algo( cert->protect.algo ) )
 	    return G10ERR_CIPHER_ALGO; /* unsupported protection algorithm */
-	}
-    }
-    else { /* not protected */
-	switch( cert->pubkey_algo ) {
-	  case PUBKEY_ALGO_ELGAMAL_E:
-	  case PUBKEY_ALGO_ELGAMAL:
-	    csum = checksum_mpi( cert->d.elg.x );
-	    break;
-	  case PUBKEY_ALGO_DSA:
-	    csum = checksum_mpi( cert->d.dsa.x );
-	    break;
-	#ifdef HAVE_RSA_CIPHER
-	  case PUBKEY_ALGO_RSA_E:
-	  case PUBKEY_ALGO_RSA_S:
-	  case PUBKEY_ALGO_RSA:
-	    csum =0;
-	    buffer = mpi_get_buffer( cert->d.rsa.rsa_d, &nbytes, NULL );
-	    csum += checksum_u16( nbytes*8 );
-	    csum += checksum( buffer, nbytes );
-	    m_free( buffer );
-	    buffer = mpi_get_buffer( cert->d.rsa.rsa_p, &nbytes, NULL );
-	    csum += checksum_u16( nbytes*8 );
-	    csum += checksum( buffer, nbytes );
+	keyid_from_skc( cert, keyid );
+	dek = passphrase_to_dek( keyid, cert->protect.algo,
+				 &cert->protect.s2k, 0 );
+	cipher_hd = cipher_open( cert->protect.algo,
+				 CIPHER_MODE_AUTO_CFB, 1);
+	cipher_setkey( cipher_hd, dek->key, dek->keylen );
+	cipher_setiv( cipher_hd, NULL );
+	m_free(dek);
+	save_cert = copy_secret_cert( NULL, cert );
+	memcpy(save_iv, cert->protect.iv, 8 );
+	cipher_decrypt( cipher_hd, cert->protect.iv, cert->protect.iv, 8 );
+	csum = 0;
+	for(i=pubkey_get_npkey(cert->pubkey_algo);
+		i < pubkey_get_nskey(cert->pubkey_algo); i++ ) {
+	    buffer = mpi_get_secure_buffer( cert->skey[i], &nbytes, NULL );
+	    cipher_sync( cipher_hd );
+	    assert( mpi_is_protected(cert->skey[i]) );
+	    cipher_decrypt( cipher_hd, buffer, buffer, nbytes );
+	    mpi_set_buffer( cert->skey[i], buffer, nbytes, 0 );
+	    mpi_clear_protect_flag( cert->skey[i] );
+	    csum += checksum_mpi( cert->skey[i] );
 	    m_free( buffer );
-	    buffer = mpi_get_buffer( cert->d.rsa.rsa_q, &nbytes, NULL );
-	    csum += checksum_u16( nbytes*8 );
-	    csum += checksum( buffer, nbytes );
-	    m_free( buffer );
-	    buffer = mpi_get_buffer( cert->d.rsa.rsa_u, &nbytes, NULL );
-	    csum += checksum_u16( nbytes*8 );
-	    csum += checksum( buffer, nbytes );
-	    m_free( buffer );
-	    break;
-	#endif
-	  default: BUG();
 	}
+	if( opt.emulate_bugs & 1 ) {
+	   csum = cert->csum;
+	}
+	cipher_close( cipher_hd );
+	/* now let's see whether we have used the right passphrase */
 	if( csum != cert->csum ) {
-	    if( cert->pubkey_algo == PUBKEY_ALGO_ELGAMAL_E ) {
-		/* very bad kludge to work around an early bug */
-		csum -= checksum_u16( mpi_get_nbits(cert->d.elg.x) );
-		nbytes = mpi_get_nlimbs(cert->d.elg.x) * 4;
-		csum += checksum_u16( nbytes*8 );
-		if( !opt.batch && csum == cert->csum )
-		    log_info("Probably you have an old key - use "
-			 "\"--change-passphrase\" to convert.\n");
-	    }
-	    if( csum != cert->csum )
-		return G10ERR_CHECKSUM;
+	    copy_secret_cert( cert, save_cert );
+	    free_secret_cert( save_cert );
+	    memcpy( cert->protect.iv, save_iv, 8 );
+	    return G10ERR_BAD_PASS;
 	}
+	/* the checksum may fail, so we also check the key itself */
+	res = pubkey_check_secret_key( cert->pubkey_algo, cert->skey );
+	if( res ) {
+	    copy_secret_cert( cert, save_cert );
+	    free_secret_cert( save_cert );
+	    memcpy( cert->protect.iv, save_iv, 8 );
+	    return G10ERR_BAD_PASS;
+	}
+	free_secret_cert( save_cert );
+	cert->is_protected = 0;
+    }
+    else { /* not protected, assume it is okay if the checksum is okay */
+	csum = 0;
+	for(i=pubkey_get_npkey(cert->pubkey_algo);
+		i < pubkey_get_nskey(cert->pubkey_algo); i++ ) {
+	    csum += checksum_mpi( cert->skey[i] );
+	}
+	if( csum != cert->csum )
+	    return G10ERR_CHECKSUM;
     }
 
     return 0;
@@ -223,36 +126,22 @@
     for(i=0; i < 3 && rc == G10ERR_BAD_PASS; i++ ) {
 	if( i )
 	    log_error(_("Invalid passphrase; please try again ...\n"));
-	switch( cert->pubkey_algo ) {
-	  case PUBKEY_ALGO_ELGAMAL_E:
-	  case PUBKEY_ALGO_ELGAMAL:
-	  case PUBKEY_ALGO_DSA:
-	    rc = do_check( cert );
-	  #if 0 /* set to 1 to enable the workaround */
-	    if( rc == G10ERR_BAD_PASS && cert->is_protected
-		&& cert->protect.algo == CIPHER_ALGO_BLOWFISH
-		&& cert->pubkey_algo != PUBKEY_ALGO_ELGAMAL ) {
-		/* Workaround for a bug in 0.2.16 which still used
-		 * a 160 bit key for BLOWFISH. */
-     log_info("trying workaround for 0.2.16 passphrase bug ...\n");
-     log_info("If you don't need this, uncomment it in g10/seckey-cert.c\n\n");
-		cert->protect.algo = CIPHER_ALGO_BLOWFISH160;
-		rc = do_check( cert );
-		if( rc )
-		    rc = G10ERR_BAD_PASS;
-		cert->protect.algo = CIPHER_ALGO_BLOWFISH;
-	    }
-	  #endif
-	    break;
-	#ifdef HAVE_RSA_CIPHER
-	  case PUBKEY_ALGO_RSA:
-	  case PUBKEY_ALGO_RSA_E:
-	  case PUBKEY_ALGO_RSA_S:
+	rc = do_check( cert );
+      #if 0 /* set to 1 to enable the workaround */
+	if( rc == G10ERR_BAD_PASS && cert->is_protected
+	    && cert->protect.algo == CIPHER_ALGO_BLOWFISH
+	    && cert->pubkey_algo != PUBKEY_ALGO_ELGAMAL ) {
+	    /* Workaround for a bug in 0.2.16 which still used
+	     * a 160 bit key for BLOWFISH. */
+	    log_info("trying workaround for 0.2.16 passphrase bug ...\n");
+	    log_info("If you don't need this, uncomment it in g10/seckey-cert.c\n\n");
+	    cert->protect.algo = CIPHER_ALGO_BLOWFISH160;
 	    rc = do_check( cert );
-	    break;
-	#endif
-	  default: rc = G10ERR_PUBKEY_ALGO;
+	    if( rc )
+		rc = G10ERR_BAD_PASS;
+	    cert->protect.algo = CIPHER_ALGO_BLOWFISH;
 	}
+      #endif
 	if( get_passphrase_fd() != -1 )
 	    break;
     }
@@ -271,40 +160,6 @@
 }
 
 
-static int
-do_protect( void (*fnc)(CIPHER_HANDLE, byte *, byte *, unsigned),
-	    CIPHER_HANDLE fnc_hd, PKT_secret_cert *cert )
-{
-    byte *buffer;
-    unsigned nbytes;
-
-    switch( cert->pubkey_algo ) {
-      case PUBKEY_ALGO_ELGAMAL_E:
-	/* recalculate the checksum, so that --change-passphrase
-	 * can be used to convert from the faulty to the correct one
-	 * wk 06.04.98:
-	 * fixme: remove this some time in the future.
-	 */
-	cert->csum = checksum_mpi( cert->d.elg.x );
-      case PUBKEY_ALGO_ELGAMAL:
-	buffer = mpi_get_buffer( cert->d.elg.x, &nbytes, NULL );
-	(*fnc)( fnc_hd, buffer, buffer, nbytes );
-	mpi_set_buffer( cert->d.elg.x, buffer, nbytes, 0 );
-	m_free( buffer );
-	break;
-
-      case PUBKEY_ALGO_DSA:
-	buffer = mpi_get_buffer( cert->d.dsa.x, &nbytes, NULL );
-	(*fnc)( fnc_hd, buffer, buffer, nbytes );
-	mpi_set_buffer( cert->d.dsa.x, buffer, nbytes, 0 );
-	m_free( buffer );
-	break;
-
-      default: return G10ERR_PUBKEY_ALGO;
-    }
-    return 0;
-}
-
 
 /****************
  * Protect the secret key certificate with the passphrase from DEK
@@ -312,7 +167,10 @@
 int
 protect_secret_key( PKT_secret_cert *cert, DEK *dek )
 {
-    int rc=0;
+    int i, rc = 0;
+    byte *buffer;
+    unsigned nbytes;
+    u16 csum;
 
     if( !dek )
 	return 0;
@@ -320,24 +178,31 @@
     if( !cert->is_protected ) { /* okay, apply the protection */
 	CIPHER_HANDLE cipher_hd=NULL;
 
-	switch( cert->protect.algo ) {
-	  case CIPHER_ALGO_NONE: BUG(); break;
-	  case CIPHER_ALGO_BLOWFISH160:
-	  case CIPHER_ALGO_BLOWFISH:
-	  case CIPHER_ALGO_CAST:
+	if( check_cipher_algo( cert->protect.algo ) )
+	    rc = G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
+	else {
 	    cipher_hd = cipher_open( cert->protect.algo,
 				     CIPHER_MODE_AUTO_CFB, 1 );
 	    cipher_setkey( cipher_hd, dek->key, dek->keylen );
 	    cipher_setiv( cipher_hd, NULL );
 	    cipher_encrypt( cipher_hd, cert->protect.iv, cert->protect.iv, 8 );
-	    if( !do_protect( &cipher_encrypt, cipher_hd, cert ) )
-		cert->is_protected = 1;
+	    /* NOTE: we always recalculate the checksum because there are some
+	     * test releases which calculated it wrong */
+	    csum = 0;
+	    for(i=pubkey_get_npkey(cert->pubkey_algo);
+		    i < pubkey_get_nskey(cert->pubkey_algo); i++ ) {
+		csum += checksum_mpi_counted_nbits( cert->skey[i] );
+		buffer = mpi_get_buffer( cert->skey[i], &nbytes, NULL );
+		cipher_sync( cipher_hd );
+		assert( !mpi_is_protected(cert->skey[i]) );
+		cipher_encrypt( cipher_hd, buffer, buffer, nbytes );
+		mpi_set_buffer( cert->skey[i], buffer, nbytes, 0 );
+		mpi_set_protect_flag( cert->skey[i] );
+		m_free( buffer );
+	    }
+	    cert->csum = csum;
+	    cert->is_protected = 1;
 	    cipher_close( cipher_hd );
-	    break;
-
-	  default:
-	    rc = G10ERR_CIPHER_ALGO; /* unsupport protection algorithm */
-	    break;
 	}
     }
     return rc;
diff -urN gnupg-0.2.19/g10/seskey.c gnupg-0.3.0/g10/seskey.c
--- gnupg-0.2.19/g10/seskey.c	Fri May 15 15:38:07 1998
+++ gnupg-0.3.0/g10/seskey.c	Mon Jun 15 17:16:46 1998
@@ -144,13 +144,25 @@
 
 
 MPI
-encode_md_value( MD_HANDLE md, int hash_algo, unsigned nbits )
+encode_md_value( int pubkey_algo, MD_HANDLE md, int hash_algo, unsigned nbits )
 {
     int algo = hash_algo? hash_algo : md_get_algo(md);
     const byte *asn;
     size_t asnlen, mdlen;
+    MPI frame;
 
-    asn = md_asn_oid( algo, &asnlen, &mdlen );
-    return do_encode_md( md, algo, mdlen, nbits, asn, asnlen );
+    if( pubkey_algo == PUBKEY_ALGO_DSA ) {
+	frame = md_is_secure(md)? mpi_alloc_secure((md_digest_length(hash_algo)
+				 +BYTES_PER_MPI_LIMB-1) / BYTES_PER_MPI_LIMB )
+				: mpi_alloc((md_digest_length(hash_algo)
+				 +BYTES_PER_MPI_LIMB-1) / BYTES_PER_MPI_LIMB );
+	mpi_set_buffer( frame, md_read(md, hash_algo),
+			       md_digest_length(hash_algo), 0 );
+    }
+    else {
+       asn = md_asn_oid( algo, &asnlen, &mdlen );
+       frame = do_encode_md( md, algo, mdlen, nbits, asn, asnlen );
+    }
+    return frame;
 }
 
diff -urN gnupg-0.2.19/g10/sig-check.c gnupg-0.3.0/g10/sig-check.c
--- gnupg-0.2.19/g10/sig-check.c	Thu May 28 10:42:17 1998
+++ gnupg-0.3.0/g10/sig-check.c	Tue Jun 23 18:41:41 1998
@@ -31,6 +31,12 @@
 #include "cipher.h"
 #include "main.h"
 #include "status.h"
+#include "i18n.h"
+
+struct cmp_help_context_s {
+    PKT_signature *sig;
+    MD_HANDLE md;
+};
 
 
 static int do_check( PKT_public_cert *pkc, PKT_signature *sig,
@@ -49,10 +55,8 @@
     int rc=0;
 
 
-  #ifndef HAVE_RSA_CIPHER
     if( is_RSA(sig->pubkey_algo) )
 	write_status(STATUS_RSA_OR_IDEA);
-  #endif
 
     if( get_pubkey( pkc, sig->keyid ) )
 	rc = G10ERR_NO_PUBKEY;
@@ -64,11 +68,88 @@
 }
 
 
+/****************
+ * This function gets called by pubkey_verify() if the algorithm needs it.
+ */
+static int
+cmp_help( void *opaque, MPI result )
+{
+  #if 0 /* we do not use this anymore */
+    int rc=0, i, j, c, old_enc;
+    byte *dp;
+    const byte *asn;
+    size_t mdlen, asnlen;
+    struct cmp_help_context_s *ctx = opaque;
+    PKT_signature *sig = ctx->sig;
+    MD_HANDLE digest = ctx->md;
+
+    old_enc = 0;
+    for(i=j=0; (c=mpi_getbyte(result, i)) != -1; i++ ) {
+	if( !j ) {
+	    if( !i && c != 1 )
+		break;
+	    else if( i && c == 0xff )
+		; /* skip the padding */
+	    else if( i && !c )
+		j++;
+	    else
+		break;
+	}
+	else if( ++j == 18 && c != 1 )
+	    break;
+	else if( j == 19 && c == 0 ) {
+	    old_enc++;
+	    break;
+	}
+    }
+    if( old_enc ) {
+	log_error("old encoding scheme is not supported\n");
+	return G10ERR_GENERAL;
+    }
+
+    if( (rc=check_digest_algo(sig->digest_algo)) )
+	return rc; /* unsupported algo */
+    asn = md_asn_oid( sig->digest_algo, &asnlen, &mdlen );
+
+    for(i=mdlen,j=asnlen-1; (c=mpi_getbyte(result, i)) != -1 && j >= 0;
+							   i++, j-- )
+	if( asn[j] != c )
+	    break;
+    if( j != -1 || mpi_getbyte(result, i) )
+	return G10ERR_BAD_PUBKEY;  /* ASN is wrong */
+    for(i++; (c=mpi_getbyte(result, i)) != -1; i++ )
+	if( c != 0xff  )
+	    break;
+    i++;
+    if( c != sig->digest_algo || mpi_getbyte(result, i) ) {
+	/* Padding or leading bytes in signature is wrong */
+	return G10ERR_BAD_PUBKEY;
+    }
+    if( mpi_getbyte(result, mdlen-1) != sig->digest_start[0]
+	|| mpi_getbyte(result, mdlen-2) != sig->digest_start[1] ) {
+	/* Wrong key used to check the signature */
+	return G10ERR_BAD_PUBKEY;
+    }
+
+    dp = md_read( digest, sig->digest_algo );
+    for(i=mdlen-1; i >= 0; i--, dp++ ) {
+	if( mpi_getbyte( result, i ) != *dp )
+	    return G10ERR_BAD_SIGN;
+    }
+    return 0;
+  #else
+    return -1;
+  #endif
+}
+
+
 static int
 do_check( PKT_public_cert *pkc, PKT_signature *sig, MD_HANDLE digest )
 {
     MPI result = NULL;
     int rc=0;
+    struct cmp_help_context_s ctx;
+    u32 cur_time;
 
     if( pkc->version == 4 && pkc->pubkey_algo == PUBKEY_ALGO_ELGAMAL_E ) {
 	log_info("this is a PGP generated "
@@ -79,171 +160,71 @@
     if( pkc->timestamp > sig->timestamp )
 	return G10ERR_TIME_CONFLICT; /* pubkey newer that signature */
 
-    if( is_ELGAMAL(pkc->pubkey_algo) ) {
-	if( (rc=check_digest_algo(sig->digest_algo)) )
-	    goto leave;
-	/* make sure the digest algo is enabled (in case of a detached
-	 * signature */
-	md_enable( digest, sig->digest_algo );
-	/* complete the digest */
-	md_putc( digest, sig->sig_class );
-	{   u32 a = sig->timestamp;
-	    md_putc( digest, (a >> 24) & 0xff );
-	    md_putc( digest, (a >> 16) & 0xff );
-	    md_putc( digest, (a >>  8) & 0xff );
-	    md_putc( digest,  a        & 0xff );
-	}
-	md_final( digest );
-	result = encode_md_value( digest, sig->digest_algo,
-					  mpi_get_nbits(pkc->d.elg.p));
-	if( DBG_CIPHER )
-	    log_mpidump("calc sig frame (elg): ", result);
-	if( !elg_verify( sig->d.elg.a, sig->d.elg.b, result, &pkc->d.elg ) )
-	    rc = G10ERR_BAD_SIGN;
-    }
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_DSA ) {
-	if( (rc=check_digest_algo(sig->digest_algo)) )
-	    goto leave;
-	/* make sure the digest algo is enabled (in case of a detached
-	 * signature */
-	md_enable( digest, sig->digest_algo );
-
-	/* complete the digest */
-	if( sig->version >= 4 )
-	    md_putc( digest, sig->version );
-	md_putc( digest, sig->sig_class );
-	if( sig->version < 4 ) {
-	    u32 a = sig->timestamp;
-	    md_putc( digest, (a >> 24) & 0xff );
-	    md_putc( digest, (a >> 16) & 0xff );
-	    md_putc( digest, (a >>  8) & 0xff );
-	    md_putc( digest,  a        & 0xff );
-	}
-	else {
-	    byte buf[6];
-	    size_t n;
-	    md_putc( digest, sig->pubkey_algo );
-	    md_putc( digest, sig->digest_algo );
-	    if( sig->hashed_data ) {
-		n = (sig->hashed_data[0] << 8) | sig->hashed_data[1];
-		md_write( digest, sig->hashed_data, n+2 );
-		n += 6;
-	    }
-	    else
-		n = 6;
-	    /* add some magic */
-	    buf[0] = sig->version;
-	    buf[1] = 0xff;
-	    buf[2] = n >> 24;
-	    buf[3] = n >> 16;
-	    buf[4] = n >>  8;
-	    buf[5] = n;
-	    md_write( digest, buf, 6 );
-	}
-	md_final( digest );
+    cur_time = make_timestamp();
+    if( pkc->timestamp > cur_time ) {
+	log_info(_("public key created in future (time warp or clock problem)\n"));
+	return G10ERR_TIME_CONFLICT;
+    }
 
-	result = mpi_alloc( (md_digest_length(sig->digest_algo)
-			     +BYTES_PER_MPI_LIMB-1) / BYTES_PER_MPI_LIMB );
-	mpi_set_buffer( result, md_read(digest, sig->digest_algo),
-				md_digest_length(sig->digest_algo), 0 );
-	if( DBG_CIPHER )
-	    log_mpidump("calc sig frame: ", result);
-	if( !dsa_verify( sig->d.dsa.r, sig->d.dsa.s, result, &pkc->d.dsa ) )
-	    rc = G10ERR_BAD_SIGN;
-    }
- #ifdef HAVE_RSA_CIPHER
-    else if( pkc->pubkey_algo == PUBKEY_ALGO_RSA
-	     || pkc->pubkey_algo == PUBKEY_ALGO_RSA_S ) {
-	int i, j, c, old_enc;
-	byte *dp;
-	const byte *asn;
-	size_t mdlen, asnlen;
-
-	result = mpi_alloc(40);
-	rsa_public( result, sig->d.rsa.rsa_integer, &pkc->d.rsa );
-
-	old_enc = 0;
-	for(i=j=0; (c=mpi_getbyte(result, i)) != -1; i++ ) {
-	    if( !j ) {
-		if( !i && c != 1 )
-		    break;
-		else if( i && c == 0xff )
-		    ; /* skip the padding */
-		else if( i && !c )
-		    j++;
-		else
-		    break;
-	    }
-	    else if( ++j == 18 && c != 1 )
-		break;
-	    else if( j == 19 && c == 0 ) {
-		old_enc++;
-		break;
-	    }
-	}
-	if( old_enc ) {
-	    log_error("old encoding scheme is not supported\n");
-	    rc = G10ERR_GENERAL;
-	    goto leave;
-	}
+    if( pkc->valid_days && add_days_to_timestamp(pkc->timestamp,
+						pkc->valid_days) < cur_time ) {
+	log_info(_("warning: signature key expired %s\n"), strtimestamp(
+				    add_days_to_timestamp(pkc->timestamp,
+							  pkc->valid_days)));
+	write_status(STATUS_SIGEXPIRED);
+    }
 
-	if( (rc=check_digest_algo(sig->digest_algo)) )
-	    goto leave; /* unsupported algo */
-	md_enable( digest, sig->digest_algo );
-	asn = md_asn_oid( sig->digest_algo, &asnlen, &mdlen );
-
-	for(i=mdlen,j=asnlen-1; (c=mpi_getbyte(result, i)) != -1 && j >= 0;
-							       i++, j-- )
-	    if( asn[j] != c )
-		break;
-	if( j != -1 || mpi_getbyte(result, i) ) { /* ASN is wrong */
-	    rc = G10ERR_BAD_PUBKEY;
-	    goto leave;
-	}
-	for(i++; (c=mpi_getbyte(result, i)) != -1; i++ )
-	    if( c != 0xff  )
-		break;
-	i++;
-	if( c != sig->digest_algo || mpi_getbyte(result, i) ) {
-	    /* Padding or leading bytes in signature is wrong */
-	    rc = G10ERR_BAD_PUBKEY;
-	    goto leave;
-	}
-	if( mpi_getbyte(result, mdlen-1) != sig->digest_start[0]
-	    || mpi_getbyte(result, mdlen-2) != sig->digest_start[1] ) {
-	    /* Wrong key used to check the signature */
-	    rc = G10ERR_BAD_PUBKEY;
-	    goto leave;
-	}
 
-	/* complete the digest */
-	md_putc( digest, sig->sig_class );
-	{   u32 a = sig->timestamp;
-	    md_putc( digest, (a >> 24) & 0xff );
-	    md_putc( digest, (a >> 16) & 0xff );
-	    md_putc( digest, (a >>  8) & 0xff );
-	    md_putc( digest,  a        & 0xff );
-	}
-	md_final( digest );
-	dp = md_read( digest, sig->digest_algo );
-	for(i=mdlen-1; i >= 0; i--, dp++ ) {
-	    if( mpi_getbyte( result, i ) != *dp ) {
-		rc = G10ERR_BAD_SIGN;
-		goto leave;
-	    }
-	}
+    if( (rc=check_digest_algo(sig->digest_algo)) )
+	return rc;
+    if( (rc=check_pubkey_algo(sig->pubkey_algo)) )
+	return rc;
+
+    /* make sure the digest algo is enabled (in case of a detached signature)*/
+    md_enable( digest, sig->digest_algo );
+
+    /* complete the digest */
+    if( sig->version >= 4 )
+	md_putc( digest, sig->version );
+    md_putc( digest, sig->sig_class );
+    if( sig->version < 4 ) {
+	u32 a = sig->timestamp;
+	md_putc( digest, (a >> 24) & 0xff );
+	md_putc( digest, (a >> 16) & 0xff );
+	md_putc( digest, (a >>	8) & 0xff );
+	md_putc( digest,  a	   & 0xff );
     }
-  #endif/*HAVE_RSA_CIPHER*/
     else {
-	/*log_debug("signature_check: unsupported pubkey algo %d\n",
-			pkc->pubkey_algo );*/
-	rc = G10ERR_PUBKEY_ALGO;
-	goto leave;
+	byte buf[6];
+	size_t n;
+	md_putc( digest, sig->pubkey_algo );
+	md_putc( digest, sig->digest_algo );
+	if( sig->hashed_data ) {
+	    n = (sig->hashed_data[0] << 8) | sig->hashed_data[1];
+	    md_write( digest, sig->hashed_data, n+2 );
+	    n += 6;
+	}
+	else
+	    n = 6;
+	/* add some magic */
+	buf[0] = sig->version;
+	buf[1] = 0xff;
+	buf[2] = n >> 24;
+	buf[3] = n >> 16;
+	buf[4] = n >>  8;
+	buf[5] = n;
+	md_write( digest, buf, 6 );
     }
+    md_final( digest );
 
-
-  leave:
+    result = encode_md_value( pkc->pubkey_algo, digest, sig->digest_algo,
+				      mpi_get_nbits(pkc->pkey[0]));
+    ctx.sig = sig;
+    ctx.md = digest;
+    rc = pubkey_verify( pkc->pubkey_algo, result, sig->data, pkc->pkey,
+			cmp_help, &ctx );
     mpi_free( result );
+
     return rc;
 }
 
@@ -318,38 +299,6 @@
 	    log_error("no subkey for key signature packet\n");
 	    rc = G10ERR_SIG_CLASS;
 	}
-    }
-    else if( sig->sig_class >= 0x14 && sig->sig_class <= 0x17 ) {
-	/* a gnupg extension: calculate the signature over all
-	 * preceding userids */
-	KBNODE unode = find_prev_kbnode( root, node, PKT_USER_ID );
-	u32 keyid[2];
-	int any = 0;
-
-	keyid_from_pkc( pkc, keyid );
-	md = md_open( algo, 0 );
-	hash_public_cert( md, pkc );
-
-	for( unode=root->next; unode && unode != node; unode = unode->next ) {
-	    if( unode->pkt->pkttype == PKT_USER_ID ) {
-		hash_uid_node( unode, md, sig );
-		any++;
-	    }
-	}
-	if( any ) {
-	    if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] ) {
-		if( is_selfsig )
-		    *is_selfsig = 1;
-		rc = do_check( pkc, sig, md );
-	    }
-	    else
-		rc = signature_check( sig, md );
-	}
-	else {
-	    log_error("no user id for key signature packet\n");
-	    rc = G10ERR_SIG_CLASS;
-	}
-	md_close(md);
     }
     else {
 	KBNODE unode = find_prev_kbnode( root, node, PKT_USER_ID );
diff -urN gnupg-0.2.19/g10/sign.c gnupg-0.3.0/g10/sign.c
--- gnupg-0.2.19/g10/sign.c	Thu May 21 14:40:04 1998
+++ gnupg-0.3.0/g10/sign.c	Thu Jun 25 09:11:09 1998
@@ -38,22 +38,47 @@
 #include "i18n.h"
 
 
+static int
+do_sign( PKT_secret_cert *skc, PKT_signature *sig,
+	 MD_HANDLE md, int digest_algo )
+{
+    MPI frame;
+    byte *dp;
+    int rc;
+
+    if( !digest_algo )
+	digest_algo = md_get_algo(md);
+
+    dp = md_read( md, digest_algo );
+    sig->digest_algo = digest_algo;
+    sig->digest_start[0] = dp[0];
+    sig->digest_start[1] = dp[1];
+    frame = encode_md_value( skc->pubkey_algo, md,
+			     digest_algo, mpi_get_nbits(skc->skey[0]));
+    rc = pubkey_sign( skc->pubkey_algo, sig->data, frame, skc->skey );
+    mpi_free(frame);
+    if( rc )
+	log_error("pubkey_sign failed: %s\n", g10_errstr(rc) );
+    else {
+	if( opt.verbose ) {
+	    char *ustr = get_user_id_string( sig->keyid );
+	    log_info("%s signature from: %s\n",
+		      pubkey_algo_to_string(skc->pubkey_algo), ustr );
+	    m_free(ustr);
+	}
+    }
+    return rc;
+}
+
+
 
 int
 complete_sig( PKT_signature *sig, PKT_secret_cert *skc, MD_HANDLE md )
 {
     int rc=0;
 
-    if( (rc=check_secret_key( skc )) )
-	;
-    else if( is_ELGAMAL(sig->pubkey_algo) )
-	g10_elg_sign( skc, sig, md, 0 );
-    else if( sig->pubkey_algo == PUBKEY_ALGO_DSA )
-	g10_dsa_sign( skc, sig, md, 0 );
-    else if( is_RSA(sig->pubkey_algo) )
-	g10_rsa_sign( skc, sig, md, 0 );
-    else
-	BUG();
+    if( !(rc=check_secret_key( skc )) )
+	rc = do_sign( skc, sig, md, 0 );
 
     /* fixme: should we check whether the signature is okay?
      * maybe by using an option */
@@ -73,7 +98,22 @@
     return DEFAULT_DIGEST_ALGO;
 }
 
+static int
+only_old_style( SKC_LIST skc_list )
+{
+    SKC_LIST skc_rover = NULL;
+    int old_style = 0;
 
+    /* if there are only old style capable key we use the old sytle */
+    for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
+	PKT_secret_cert *skc = skc_rover->skc;
+	if( skc->pubkey_algo == PUBKEY_ALGO_RSA && skc->version < 4 )
+	    old_style = 1;
+	else
+	    return 0;
+    }
+    return old_style;
+}
 
 /****************
  * Sign the files whose names are in FILENAME.
@@ -106,6 +146,8 @@
     SKC_LIST skc_list = NULL;
     SKC_LIST skc_rover = NULL;
     int multifile = 0;
+    int old_style = opt.rfc1991;
+
 
     memset( &afx, 0, sizeof afx);
     memset( &zfx, 0, sizeof zfx);
@@ -126,6 +168,8 @@
 
     if( (rc=build_skc_list( locusr, &skc_list, 1, 1 )) )
 	goto leave;
+    if( !old_style )
+	old_style = only_old_style( skc_list );
     if( encrypt ) {
 	if( (rc=build_pkc_list( remusr, &pkc_list, 2 )) )
 	    goto leave;
@@ -179,11 +223,13 @@
 	iobuf_push_filter( out, encrypt_filter, &efx );
     }
 
-    if( opt.compress && !outfile )
+    if( opt.compress && !outfile ) {
+	if( old_style )
+	    zfx.algo = 1;
 	iobuf_push_filter( out, compress_filter, &zfx );
+    }
 
-
-    if( !detached ) {
+    if( !detached && !old_style ) {
 	/* loop over the secret certificates and build headers */
 	for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
 	    PKT_secret_cert *skc;
@@ -254,6 +300,8 @@
 	     * data, it is not possible to know the used length
 	     * without a double read of the file - to avoid that
 	     * we simple use partial length packets.
+	     * FIXME: We have to do the double read when opt.rfc1991
+	     *	      is active.
 	     */
 	    if( opt.textmode && !outfile )
 		filesize = 0;
@@ -332,27 +380,20 @@
 	}
 	md_final( md );
 
-	if( is_ELGAMAL(sig->pubkey_algo) )
-	    g10_elg_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else if( sig->pubkey_algo == PUBKEY_ALGO_DSA )
-	    g10_dsa_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else if( is_RSA(sig->pubkey_algo) )
-	    g10_rsa_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else
-	    BUG();
-
+	rc = do_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
 	md_close( md );
 
-	/* and write it */
-	init_packet(&pkt);
-	pkt.pkttype = PKT_SIGNATURE;
-	pkt.pkt.signature = sig;
-	rc = build_packet( out, &pkt );
-	free_packet( &pkt );
-	if( rc ) {
-	    log_error("build signature packet failed: %s\n", g10_errstr(rc) );
-	    goto leave;
+	if( !rc ) { /* and write it */
+	    init_packet(&pkt);
+	    pkt.pkttype = PKT_SIGNATURE;
+	    pkt.pkt.signature = sig;
+	    rc = build_packet( out, &pkt );
+	    free_packet( &pkt );
+	    if( rc )
+		log_error("build signature packet failed: %s\n", g10_errstr(rc) );
 	}
+	if( rc )
+	    goto leave;
     }
 
 
@@ -419,6 +460,7 @@
     int rc = 0;
     SKC_LIST skc_list = NULL;
     SKC_LIST skc_rover = NULL;
+    int old_style = opt.rfc1991;
 
     memset( &afx, 0, sizeof afx);
     memset( &tfx, 0, sizeof tfx);
@@ -426,6 +468,8 @@
 
     if( (rc=build_skc_list( locusr, &skc_list, 1, 1 )) )
 	goto leave;
+    if( !old_style )
+	old_style = only_old_style( skc_list );
 
     /* prepare iobufs */
     if( !(inp = iobuf_open(fname)) ) {
@@ -449,9 +493,10 @@
 	goto leave;
     }
 
-    /* FIXME: This stuff is not correct if mutliplehash algos are used*/
+    /* FIXME: This stuff is not correct if multiple hash algos are used*/
     iobuf_writestr(out, "-----BEGIN PGP SIGNED MESSAGE-----\n" );
-    if( (opt.def_digest_algo?opt.def_digest_algo:DEFAULT_DIGEST_ALGO)
+    if( old_style
+	|| (opt.def_digest_algo?opt.def_digest_algo:DEFAULT_DIGEST_ALGO)
 			      == DIGEST_ALGO_MD5 )
 	iobuf_writestr(out, "\n" );
     else {
@@ -535,27 +580,20 @@
 	}
 	md_final( md );
 
-	if( is_ELGAMAL(sig->pubkey_algo) )
-	    g10_elg_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else if( sig->pubkey_algo == PUBKEY_ALGO_DSA )
-	    g10_dsa_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else if( is_RSA(sig->pubkey_algo) )
-	    g10_rsa_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
-	else
-	    BUG();
-
+	rc = do_sign( skc, sig, md, hash_for(sig->pubkey_algo) );
 	md_close( md );
 
-	/* and write it */
-	init_packet(&pkt);
-	pkt.pkttype = PKT_SIGNATURE;
-	pkt.pkt.signature = sig;
-	rc = build_packet( out, &pkt );
-	free_packet( &pkt );
-	if( rc ) {
-	    log_error("build signature packet failed: %s\n", g10_errstr(rc) );
-	    goto leave;
+	if( !rc ) { /* and write it */
+	    init_packet(&pkt);
+	    pkt.pkttype = PKT_SIGNATURE;
+	    pkt.pkt.signature = sig;
+	    rc = build_packet( out, &pkt );
+	    free_packet( &pkt );
+	    if( rc )
+		log_error("build signature packet failed: %s\n", g10_errstr(rc) );
 	}
+	if( rc )
+	    goto leave;
     }
 
 
diff -urN gnupg-0.2.19/g10/status.c gnupg-0.3.0/g10/status.c
--- gnupg-0.2.19/g10/status.c	Thu May 28 10:34:11 1998
+++ gnupg-0.3.0/g10/status.c	Tue Jun 23 18:39:40 1998
@@ -53,6 +53,7 @@
       case STATUS_LEAVE  : s = "LEAVE\n"; break;
       case STATUS_ABORT  : s = "ABORT\n"; break;
       case STATUS_GOODSIG: s = "GOODSIG\n"; break;
+      case STATUS_SIGEXPIRED: s = "SIGEXPIRED\n"; break;
       case STATUS_BADSIG : s = "BADSIG\n"; break;
       case STATUS_ERRSIG : s = "ERRSIG\n"; break;
       case STATUS_BADARMOR : s = "BADARMOR\n"; break;
diff -urN gnupg-0.2.19/g10/status.h gnupg-0.3.0/g10/status.h
--- gnupg-0.2.19/g10/status.h	Tue May 26 14:16:50 1998
+++ gnupg-0.3.0/g10/status.h	Tue Jun 23 18:39:19 1998
@@ -33,7 +33,7 @@
 #define STATUS_BADARMOR  7
 
 #define STATUS_RSA_OR_IDEA 8
-
+#define STATUS_SIGEXPIRED  9
 
 /*-- status.c --*/
 void set_status_fd( int fd );
diff -urN gnupg-0.2.19/g10/trustdb.c gnupg-0.3.0/g10/trustdb.c
--- gnupg-0.2.19/g10/trustdb.c	Fri May 29 10:01:48 1998
+++ gnupg-0.3.0/g10/trustdb.c	Tue Jun 23 18:35:19 1998
@@ -83,6 +83,7 @@
 	    ulong owner;
 	    u32  keyid[2];
 	    byte pubkey_algo;
+	    byte fingerprint_len;
 	    byte fingerprint[20];
 	    byte ownertrust;
 	} key;
@@ -387,9 +388,11 @@
 	    fputs(", (??)", fp );
 	putc('\n', fp);
 	break;
-      case RECTYPE_KEY: fprintf(fp, "key keyid=%08lX, own=%lu, ownertrust=%02x\n",
+      case RECTYPE_KEY: fprintf(fp,
+		    "key keyid=%08lX, own=%lu, ownertrust=%02x, fl=%d\n",
 		   (ulong)rec->r.key.keyid[1],
-		   rec->r.key.owner, rec->r.key.ownertrust );
+		   rec->r.key.owner, rec->r.key.ownertrust,
+		   rec->r.key.fingerprint_len );
 	break;
       case RECTYPE_CTL: fprintf(fp, "ctl\n");
 	break;
@@ -497,7 +500,10 @@
 	rec->r.key.owner    = buftoulong(p); p += 4;
 	rec->r.dir.keyid[0] = buftou32(p); p += 4;
 	rec->r.dir.keyid[1] = buftou32(p); p += 4;
-	rec->r.key.pubkey_algo = *p++; p++;
+	rec->r.key.pubkey_algo = *p++;
+	rec->r.key.fingerprint_len = *p++;
+	if( rec->r.key.fingerprint_len < 1 || rec->r.key.fingerprint_len > 20 )
+	    rec->r.key.fingerprint_len = 20;
 	memcpy( rec->r.key.fingerprint, p, 20); p += 20;
 	rec->r.key.ownertrust = *p++;
 	break;
@@ -562,7 +568,8 @@
 	ulongtobuf(p, rec->r.key.owner); p += 4;
 	u32tobuf(p, rec->r.key.keyid[0]); p += 4;
 	u32tobuf(p, rec->r.key.keyid[1]); p += 4;
-	*p++ = rec->r.key.pubkey_algo; p++;
+	*p++ = rec->r.key.pubkey_algo;
+	*p++ = rec->r.key.fingerprint_len;
 	memcpy( p, rec->r.key.fingerprint, 20); p += 20;
 	*p++ = rec->r.key.ownertrust;
 	break;
@@ -1166,7 +1173,8 @@
 	log_error(_("%lu: build_sigrecs: can't read key record\n"), pubkeyid);
 	goto leave;
     }
-    rc = get_keyblock_byfprint( &keyblock, krec.r.key.fingerprint );
+    rc = get_keyblock_byfprint( &keyblock, krec.r.key.fingerprint,
+					   krec.r.key.fingerprint_len );
     if( rc ) {
 	log_error(_("build_sigrecs: get_keyblock_byfprint failed\n") );
 	goto leave;
@@ -1697,7 +1705,7 @@
     TRUSTREC rec;
     unsigned trustlevel = TRUST_UNKNOWN;
     int rc=0;
-    int cur_time;
+    u32 cur_time;
 
     if( DBG_TRUST )
 	log_info("check_trust() called.\n");
@@ -1938,6 +1946,7 @@
     rec.r.key.keyid[0] = keyid[0];
     rec.r.key.keyid[1] = keyid[1];
     rec.r.key.pubkey_algo = pkc->pubkey_algo;
+    rec.r.key.fingerprint_len = fingerlen;
     memcpy(rec.r.key.fingerprint, fingerprint, fingerlen );
     rec.r.key.ownertrust = 0;
     if( write_record( knum, &rec ) ) {
diff -urN gnupg-0.2.19/include/ChangeLog gnupg-0.3.0/include/ChangeLog
--- gnupg-0.2.19/include/ChangeLog	Thu May 21 13:26:39 1998
+++ gnupg-0.3.0/include/ChangeLog	Sat Jun 13 17:31:47 1998
@@ -1,3 +1,11 @@
+Sat Jun 13 17:31:32 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10lib.h: New as interface for the g10lib.
+
+Mon Jun  8 22:14:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.h (CIPHER_ALGO_CAST5): Changed name from .. CAST
+
 Thu May 21 13:25:51 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* cipher.h: removed ROT 5 and changed one id and add dummy
diff -urN gnupg-0.2.19/include/cipher.h gnupg-0.3.0/include/cipher.h
--- gnupg-0.2.19/include/cipher.h	Thu May 21 13:23:12 1998
+++ gnupg-0.3.0/include/cipher.h	Wed Jun 24 18:19:28 1998
@@ -1,19 +1,14 @@
 /* cipher.h
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * ATTENTION: This code should not be exported from the United States
- * nor should it be used their without a license agreement with PKP.
- * The RSA alorithm is protected by U.S. Patent #4,405,829 which
- * expires on September 20, 2000!
+ * This file is part of GNUPG.
  *
- * This file is part of G10.
- *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
@@ -25,22 +20,16 @@
 #ifndef G10_CIPHER_H
 #define G10_CIPHER_H
 
-#define DBG_CIPHER cipher_debug_mode
+#define DBG_CIPHER g10c_debug_mode
 
 #include "mpi.h"
-#include "../cipher/md.h"
-#ifdef HAVE_RSA_CIPHER
-  #include "../cipher/rsa.h"
-#endif
-#include "../cipher/elgamal.h"
-#include "../cipher/dsa.h"
 #include "../cipher/random.h"
 
 
 #define CIPHER_ALGO_NONE	 0
 #define CIPHER_ALGO_IDEA	 1
 #define CIPHER_ALGO_3DES	 2
-#define CIPHER_ALGO_CAST	 3
+#define CIPHER_ALGO_CAST5	 3
 #define CIPHER_ALGO_BLOWFISH	 4  /* blowfish 128 bit key */
 #define CIPHER_ALGO_SAFER_SK128  5
 #define CIPHER_ALGO_DES_SK	 6
@@ -57,9 +46,7 @@
 #define DIGEST_ALGO_MD5       1
 #define DIGEST_ALGO_SHA1      2
 #define DIGEST_ALGO_RMD160    3
-#ifdef WITH_TIGER_HASH
 #define DIGEST_ALGO_TIGER     6
-#endif
 
 #define is_RSA(a)     ((a)==PUBKEY_ALGO_RSA || (a)==PUBKEY_ALGO_RSA_E \
 		       || (a)==PUBKEY_ALGO_RSA_S )
@@ -84,7 +71,55 @@
 #define CIPHER_MODE_DUMMY     5  /* used with algo DUMMY for no encryption */
 
 
-int cipher_debug_mode;
+#define MD_BUFFER_SIZE 512
+
+typedef struct {
+    byte buffer[MD_BUFFER_SIZE];
+    int  bufcount;
+    int  secure;
+    FILE  *debug;
+    int guard1;
+    struct md_digest_list_s *list;
+    int guard2;
+} *MD_HANDLE;
+
+
+#ifndef DEFINES_MD_HANDLE /* not really the handle but the algorithm list */
+struct md_digest_list_s { char does_not_matter[1]; };
+#endif
+
+
+
+int g10c_debug_mode;
+int g10_opt_verbose;
+
+/*-- dynload.c --*/
+void register_cipher_extension( const char *fname );
+
+/*-- md.c --*/
+int string_to_digest_algo( const char *string );
+const char * digest_algo_to_string( int algo );
+int check_digest_algo( int algo );
+MD_HANDLE md_open( int algo, int secure );
+void md_enable( MD_HANDLE hd, int algo );
+MD_HANDLE md_copy( MD_HANDLE a );
+void md_close(MD_HANDLE a);
+void md_write( MD_HANDLE a, byte *inbuf, size_t inlen);
+void md_final(MD_HANDLE a);
+byte *md_read( MD_HANDLE a, int algo );
+int md_get_algo( MD_HANDLE a );
+int md_digest_length( int algo );
+const byte *md_asn_oid( int algo, size_t *asnlen, size_t *mdlen );
+void md_start_debug( MD_HANDLE a, const char *suffix );
+void md_stop_debug( MD_HANDLE a );
+#define md_is_secure(a) ((a)->secure)
+#define md_putc(h,c)					    \
+	    do {					    \
+		if( (h)->bufcount == MD_BUFFER_SIZE )	    \
+		    md_write( (h), NULL, 0 );		    \
+		(h)->buffer[(h)->bufcount++] = (c) & 0xff;  \
+	    } while(0)
+
 
 /*-- cipher.c --*/
 int string_to_cipher_algo( const char *string );
@@ -99,15 +134,28 @@
 void cipher_decrypt( CIPHER_HANDLE c, byte *out, byte *in, unsigned nbytes );
 void cipher_sync( CIPHER_HANDLE c );
 
+/*-- pubkey.c --*/
+#define PUBKEY_MAX_NPKEY  4
+#define PUBKEY_MAX_NSKEY  6
+#define PUBKEY_MAX_NSIG   2
+#define PUBKEY_MAX_NENC   2
 
-/*-- misc.c --*/
 int string_to_pubkey_algo( const char *string );
-int string_to_digest_algo( const char *string );
 const char * pubkey_algo_to_string( int algo );
-const char * digest_algo_to_string( int algo );
 int check_pubkey_algo( int algo );
 int check_pubkey_algo2( int algo, unsigned usage );
-int check_digest_algo( int algo );
+int pubkey_get_npkey( int algo );
+int pubkey_get_nskey( int algo );
+int pubkey_get_nsig( int algo );
+int pubkey_get_nenc( int algo );
+unsigned pubkey_nbits( int algo, MPI *pkey );
+int pubkey_generate( int algo, unsigned nbits, MPI *skey, MPI **retfactors );
+int pubkey_check_secret_key( int algo, MPI *skey );
+int pubkey_encrypt( int algo, MPI *resarr, MPI data, MPI *pkey );
+int pubkey_decrypt( int algo, MPI *result, MPI *data, MPI *skey );
+int pubkey_sign( int algo, MPI *resarr, MPI hash, MPI *skey );
+int pubkey_verify( int algo, MPI hash, MPI *data, MPI *pkey,
+		      int (*cmp)(void *, MPI), void *opaque );
 
 /*-- smallprime.c --*/
 extern ushort small_prime_numbers[];
diff -urN gnupg-0.2.19/include/distfiles gnupg-0.3.0/include/distfiles
--- gnupg-0.2.19/include/distfiles	Fri Feb 13 13:21:07 1998
+++ gnupg-0.3.0/include/distfiles	Sat Jun 13 16:50:33 1998
@@ -8,4 +8,6 @@
 util.h
 i18n.h
 
+g10lib.h
+
 ChangeLog
diff -urN gnupg-0.2.19/include/errors.h gnupg-0.3.0/include/errors.h
--- gnupg-0.2.19/include/errors.h	Fri May  8 17:06:37 1998
+++ gnupg-0.3.0/include/errors.h	Tue Jun 16 17:09:14 1998
@@ -1,14 +1,14 @@
 /* errors.h - erro code
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/g10lib.h gnupg-0.3.0/include/g10lib.h
--- gnupg-0.2.19/include/g10lib.h	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/include/g10lib.h	Tue Jun 16 17:07:19 1998
@@ -0,0 +1,192 @@
+/* g10lib.h -  GNU digital encryption libray interface
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#ifndef _g10lib_G10LIB_H
+#define _g10lib_G10LIB_H
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+
+
+#ifndef _g10lib_INTERNAL
+struct g10mpi_struct { int hidden_stuff; };
+typedef struct g10mpi_struct *MPI;
+#endif
+
+int g10c_debug_mode;
+int g10_opt_verbose;
+
+/********************************
+ *******  math functions  *******
+ ********************************/
+MPI  g10m_new( unsigned nbits );
+MPI  g10m_new_secure( unsigned nbits );
+void g10m_release( MPI a );
+void g10m_resize( MPI a, unsigned nbits );
+MPI  g10m_copy( MPI a );
+void g10m_swap( MPI a, MPI b);
+void g10m_set( MPI w, MPI u);
+void g10m_set_ui( MPI w, unsigned long u);
+void g10m_set_bytes( MPI a, unsigned nbits, unsigned char (*fnc)(int), int opaque );
+int  g10m_cmp( MPI u, MPI v );
+int  g10m_cmp_ui( MPI u, unsigned long v );
+
+
+void g10m_add(MPI w, MPI u, MPI v);
+void g10m_add_ui(MPI w, MPI u, unsigned long v );
+void g10m_sub( MPI w, MPI u, MPI v);
+void g10m_sub_ui(MPI w, MPI u, unsigned long v );
+
+void g10m_mul_ui(MPI w, MPI u, unsigned long v );
+void g10m_mul_2exp( MPI w, MPI u, unsigned long cnt);
+void g10m_mul( MPI w, MPI u, MPI v);
+void g10m_mulm( MPI w, MPI u, MPI v, MPI m);
+
+void g10m_fdiv_q( MPI quot, MPI dividend, MPI divisor );
+
+void g10m_powm( MPI res, MPI base, MPI exp, MPI mod);
+
+int  g10m_gcd( MPI g, MPI a, MPI b );
+int  g10m_invm( MPI x, MPI u, MPI v );
+
+unsigned g10m_get_nbits( MPI a );
+unsigned g10m_get_size( MPI a );
+
+
+/********************************************
+ *******  symmetric cipher functions  *******
+ ********************************************/
+
+
+
+/*********************************************
+ *******  asymmetric cipher functions  *******
+ *********************************************/
+
+
+
+
+/*********************************************
+ *******  cryptograhic hash functions  *******
+ *********************************************/
+
+
+/*****************************************
+ *******  miscellaneous functions  *******
+ *****************************************/
+
+const char *g10m_revision_string(int mode);
+const char *g10c_revision_string(int mode);
+const char *g10u_revision_string(int mode);
+
+MPI	      g10c_generate_secret_prime( unsigned nbits );
+unsigned char g10c_get_random_byte( int level );
+
+
+void *g10_malloc( size_t n );
+void *g10_calloc( size_t n );
+void *g10_malloc_secure( size_t n );
+void *g10_calloc_secure( size_t n );
+void *g10_realloc( void *a, size_t n );
+void  g10_free( void *p );
+char *g10_strdup( const char * a);
+
+void g10_log_bug( const char *fmt, ... );
+void g10_log_bug0( const char *, int );
+void g10_log_fatal( const char *fmt, ... );
+void g10_log_error( const char *fmt, ... );
+void g10_log_info( const char *fmt, ... );
+void g10_log_debug( const char *fmt, ... );
+void g10_log_hexdump( const char *text, char *buf, size_t len );
+void g10_log_mpidump( const char *text, MPI a );
+
+
+/***************************
+ *******  constants  *******
+ **************************/
+#define CIPHER_ALGO_NONE	 0
+#define CIPHER_ALGO_IDEA	 1
+#define CIPHER_ALGO_3DES	 2
+#define CIPHER_ALGO_CAST5	 3
+#define CIPHER_ALGO_BLOWFISH	 4  /* blowfish 128 bit key */
+#define CIPHER_ALGO_SAFER_SK128  5
+#define CIPHER_ALGO_DES_SK	 6
+#define CIPHER_ALGO_BLOWFISH160 42  /* blowfish 160 bit key (not in OpenPGP)*/
+#define CIPHER_ALGO_DUMMY      110  /* no encryption at all */
+
+#define PUBKEY_ALGO_RSA        1
+#define PUBKEY_ALGO_RSA_E      2     /* RSA encrypt only */
+#define PUBKEY_ALGO_RSA_S      3     /* RSA sign only */
+#define PUBKEY_ALGO_ELGAMAL_E 16     /* encrypt only ElGamal (but not vor v3)*/
+#define PUBKEY_ALGO_DSA       17
+#define PUBKEY_ALGO_ELGAMAL   20     /* sign and encrypt elgamal */
+
+#define DIGEST_ALGO_MD5       1
+#define DIGEST_ALGO_SHA1      2
+#define DIGEST_ALGO_RMD160    3
+#define DIGEST_ALGO_TIGER     6
+
+#define is_RSA(a)     ((a)==PUBKEY_ALGO_RSA || (a)==PUBKEY_ALGO_RSA_E \
+		       || (a)==PUBKEY_ALGO_RSA_S )
+#define is_ELGAMAL(a) ((a)==PUBKEY_ALGO_ELGAMAL || (a)==PUBKEY_ALGO_ELGAMAL_E)
+
+#define G10ERR_GENERAL	       1
+#define G10ERR_PUBKEY_ALGO     4
+#define G10ERR_DIGEST_ALGO     5
+#define G10ERR_BAD_PUBKEY      6
+#define G10ERR_BAD_SECKEY      7
+#define G10ERR_BAD_SIGN        8
+#define G10ERR_CIPHER_ALGO    12
+#define G10ERR_WRONG_SECKEY   18
+#define G10ERR_UNSUPPORTED    19
+#define G10ERR_NI_PUBKEY      27
+#define G10ERR_NI_CIPHER      28
+#define G10ERR_BAD_MPI	      30
+#define G10ERR_WR_PUBKEY_ALGO 41
+
+
+/***********************************
+ *******  some handy macros  *******
+ ***********************************/
+
+#ifndef BUG
+  #define BUG() g10_log_bug0( __FILE__ , __LINE__ )
+#endif
+
+#ifndef STR
+  #define STR(v) #v
+  #define STR2(v) STR(v)
+#endif
+
+#ifndef DIM
+  #define DIM(v) (sizeof(v)/sizeof((v)[0]))
+  #define DIMof(type,member)   DIM(((type *)0)->member)
+#endif
+
+
+#define DBG_CIPHER  g10c_debug_mode
+#define OPT_VERBOSE g10_opt_verbose
+
+
+#ifdef __cplusplus
+}
+#endif
+#endif /* _g10lib_G10LIB_H */
diff -urN gnupg-0.2.19/include/i18n.h gnupg-0.3.0/include/i18n.h
--- gnupg-0.2.19/include/i18n.h	Thu Mar 12 16:02:07 1998
+++ gnupg-0.3.0/include/i18n.h	Tue Jun 16 17:09:44 1998
@@ -1,14 +1,14 @@
 /* i18n.h
- *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/iobuf.h gnupg-0.3.0/include/iobuf.h
--- gnupg-0.2.19/include/iobuf.h	Wed Feb 11 01:31:27 1998
+++ gnupg-0.3.0/include/iobuf.h	Tue Jun 16 17:09:24 1998
@@ -1,14 +1,14 @@
 /* iobuf.h - I/O buffer
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/memory.h gnupg-0.3.0/include/memory.h
--- gnupg-0.2.19/include/memory.h	Fri Feb 27 10:38:43 1998
+++ gnupg-0.3.0/include/memory.h	Tue Jun 16 17:07:53 1998
@@ -1,14 +1,14 @@
 /* memory.h - memory allocation
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/mpi.h gnupg-0.3.0/include/mpi.h
--- gnupg-0.2.19/include/mpi.h	Fri Feb 27 10:38:43 1998
+++ gnupg-0.3.0/include/mpi.h	Tue Jun 16 13:25:53 1998
@@ -1,15 +1,14 @@
 /* mpi.h  -  Multi Precision Integers
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
- *	Copyright (C) 1994, 1996 Free Software Foundation, Inc.
+ *	Copyright (C) 1994, 1996, 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
@@ -49,13 +48,16 @@
     int nlimbs;     /* number of valid limbs */
     int nbits;	    /* the real number of valid bits (info only) */
     int sign;	    /* indicates a negative number */
-    int secure;     /* array must be allocated in secure memory space */
+    unsigned flags; /* bit 0: array must be allocated in secure memory space */
+		    /* bit 1: the mpi is encrypted */
     mpi_limb_t *d;  /* array with the limbs */
 } *MPI;
 
 #define MPI_NULL NULL
 
 #define mpi_get_nlimbs(a)     ((a)->nlimbs)
+#define mpi_get_nbit_info(a)  ((a)->nbits)
+#define mpi_set_nbit_info(a,b) ((a)->nbits = (b))
 #define mpi_is_neg(a)	      ((a)->sign)
 
 /*-- mpiutil.c --*/
@@ -78,7 +80,10 @@
   void mpi_resize( MPI a, unsigned nlimbs );
   MPI  mpi_copy( MPI a );
 #endif
-#define mpi_is_secure(a) ((a) && (a)->secure)
+#define mpi_is_protected(a) ((a) && ((a)->flags&2))
+#define mpi_set_protect_flag(a) ((a)->flags |= 2)
+#define mpi_clear_protect_flag(a) ((a)->flags &= ~2)
+#define mpi_is_secure(a) ((a) && ((a)->flags&1))
 void mpi_set_secure( MPI a );
 void mpi_clear( MPI a );
 void mpi_set( MPI w, MPI u);
diff -urN gnupg-0.2.19/include/ttyio.h gnupg-0.3.0/include/ttyio.h
--- gnupg-0.2.19/include/ttyio.h	Tue Dec 16 19:35:00 1997
+++ gnupg-0.3.0/include/ttyio.h	Tue Jun 16 17:09:31 1998
@@ -1,14 +1,14 @@
 /* ttyio.h
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/types.h gnupg-0.3.0/include/types.h
--- gnupg-0.2.19/include/types.h	Fri May  8 18:43:17 1998
+++ gnupg-0.3.0/include/types.h	Tue Jun 16 17:09:07 1998
@@ -1,14 +1,14 @@
 /* types.h - some common typedefs
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
diff -urN gnupg-0.2.19/include/util.h gnupg-0.3.0/include/util.h
--- gnupg-0.2.19/include/util.h	Fri May  8 16:51:34 1998
+++ gnupg-0.3.0/include/util.h	Tue Jun 16 17:09:01 1998
@@ -1,14 +1,14 @@
 /* util.h
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
- * This file is part of G10.
+ * This file is part of GNUPG.
  *
- * G10 is free software; you can redistribute it and/or modify
+ * GNUPG is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * G10 is distributed in the hope that it will be useful,
+ * GNUPG is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
@@ -60,29 +60,39 @@
 const char *log_get_name(void);
 void log_set_pid( int pid );
 int  log_get_errorcount( int clear );
-void log_hexdump( const char *text, char *buf, size_t len );
-void log_mpidump( const char *text, MPI a );
+void g10_log_hexdump( const char *text, char *buf, size_t len );
+void g10_log_mpidump( const char *text, MPI a );
 
 #if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5 )
-  void log_bug( const char *fmt, ... )
+  void g10_log_bug( const char *fmt, ... )
 			    __attribute__ ((noreturn, format (printf,1,2)));
-  void log_bug0( const char *, int, const char * ) __attribute__ ((noreturn));
-  void log_fatal( const char *fmt, ... )
+  void g10_log_bug0( const char *, int, const char * ) __attribute__ ((noreturn));
+  void g10_log_fatal( const char *fmt, ... )
 			    __attribute__ ((noreturn, format (printf,1,2)));
-  void log_error( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
-  void log_info( const char *fmt, ... )  __attribute__ ((format (printf,1,2)));
-  void log_debug( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
-  #define BUG() log_bug0(  __FILE__ , __LINE__, __FUNCTION__ )
+  void g10_log_error( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
+  void g10_log_info( const char *fmt, ... )  __attribute__ ((format (printf,1,2)));
+  void g10_log_debug( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
+  #define BUG() g10_log_bug0(  __FILE__ , __LINE__, __FUNCTION__ )
 #else
-  void log_bug( const char *fmt, ... );
-  void log_bug0( const char *, int );
-  void log_fatal( const char *fmt, ... );
-  void log_error( const char *fmt, ... );
-  void log_info( const char *fmt, ... );
-  void log_debug( const char *fmt, ... );
-  #define BUG() log_bug0( __FILE__ , __LINE__ )
+  void g10_log_bug( const char *fmt, ... );
+  void g10_log_bug0( const char *, int );
+  void g10_log_fatal( const char *fmt, ... );
+  void g10_log_error( const char *fmt, ... );
+  void g10_log_info( const char *fmt, ... );
+  void g10_log_debug( const char *fmt, ... );
+  #define BUG() g10_log_bug0( __FILE__ , __LINE__ )
 #endif
 
+#define log_hexdump g10_log_hexdump
+#define log_mpidump g10_log_mpidump
+#define log_bug     g10_log_bug
+#define log_bug0    g10_log_bug0
+#define log_fatal   g10_log_fatal
+#define log_error   g10_log_error
+#define log_info    g10_log_info
+#define log_debug   g10_log_debug
+
+
 
 /*-- errors.c --*/
 const char * g10_errstr( int no );
@@ -101,6 +111,7 @@
 
 /*-- fileutil.c --*/
 char *make_filename( const char *first_part, ... );
+int compare_filenames( const char *a, const char *b );
 const char *print_fname_stdin( const char *s );
 const char *print_fname_stdout( const char *s );
 
diff -urN gnupg-0.2.19/mpi/ChangeLog gnupg-0.3.0/mpi/ChangeLog
--- gnupg-0.2.19/mpi/ChangeLog	Mon May 18 13:48:20 1998
+++ gnupg-0.3.0/mpi/ChangeLog	Thu Jun 25 11:50:21 1998
@@ -1,3 +1,7 @@
+Thu Jun 25 11:50:01 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* mips3/*.S: New
+
 Mon May 18 13:47:06 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* config.links: split mpih-shift into mpih-[lr]shift and
diff -urN gnupg-0.2.19/mpi/Makefile.am gnupg-0.3.0/mpi/Makefile.am
--- gnupg-0.2.19/mpi/Makefile.am	Mon May 18 13:00:28 1998
+++ gnupg-0.3.0/mpi/Makefile.am	Sat Jun 13 16:53:33 1998
@@ -34,7 +34,8 @@
 	      mpih-sub.c     \
 	      mpih-div.c     \
 	      mpih-mul.c     \
-	      mpiutil.c
+	      mpiutil.c      \
+	      g10m.c
 
 # Note this objects are actually links, the sourcefiles are
 # distributed by special code in dist-hook
diff -urN gnupg-0.2.19/mpi/Makefile.in gnupg-0.3.0/mpi/Makefile.in
--- gnupg-0.2.19/mpi/Makefile.in	Fri May 29 12:56:10 1998
+++ gnupg-0.3.0/mpi/Makefile.in	Thu Jun 25 13:08:58 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -122,7 +121,8 @@
 	      mpih-sub.c     \
 	      mpih-div.c     \
 	      mpih-mul.c     \
-	      mpiutil.c
+	      mpiutil.c      \
+	      g10m.c
 
 # Note this objects are actually links, the sourcefiles are
 # distributed by special code in dist-hook
@@ -148,7 +148,7 @@
 LIBS = @LIBS@
 libmpi_a_OBJECTS =  mpi-add.o mpi-bit.o mpi-cmp.o mpi-div.o mpi-gcd.o \
 mpi-inv.o mpi-mul.o mpi-pow.o mpi-mpow.o mpi-scan.o mpicoder.o \
-mpih-cmp.o mpih-add.o mpih-sub.o mpih-div.o mpih-mul.o mpiutil.o
+mpih-cmp.o mpih-add.o mpih-sub.o mpih-div.o mpih-mul.o mpiutil.o g10m.o
 AR = ar
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
@@ -244,6 +244,8 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
+g10m.o: g10m.c ../config.h ../include/mpi.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h ../include/g10lib.h
 mpi-add.o: mpi-add.c ../config.h mpi-internal.h ../include/mpi.h \
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	mpi-inline.h
diff -urN gnupg-0.2.19/mpi/g10m.c gnupg-0.3.0/mpi/g10m.c
--- gnupg-0.2.19/mpi/g10m.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/g10m.c	Mon Jun 15 17:41:03 1998
@@ -0,0 +1,93 @@
+/* g10m.c  -  Wrapper for MPI
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi.h"
+#define _g10lib_INTERNAL 1
+#include "g10lib.h"
+
+
+const char *g10m_revision_string(int dummy) { return "$Revision: 1.2 $"; }
+
+MPI
+g10m_new( unsigned nbits )
+{
+    return mpi_alloc( (nbits+BITS_PER_MPI_LIMB-1) / BITS_PER_MPI_LIMB );
+}
+
+MPI
+g10m_new_secure( unsigned nbits )
+{
+    return mpi_alloc_secure( (nbits+BITS_PER_MPI_LIMB-1) / BITS_PER_MPI_LIMB );
+}
+
+void
+g10m_release( MPI a )
+{
+    mpi_free(a);
+}
+
+void
+g10m_resize( MPI a, unsigned nbits )
+{
+    return mpi_resize( a, (nbits+BITS_PER_MPI_LIMB-1) / BITS_PER_MPI_LIMB );
+}
+
+MPI  g10m_copy( MPI a ) 	   { return mpi_copy( a );   }
+void g10m_swap( MPI a, MPI b)	   { mpi_swap( a, b );	     }
+void g10m_set( MPI w, MPI u)	   { mpi_set( w, u );	     }
+void g10m_set_ui( MPI w, ulong u ) { mpi_set_ui( w, u ); }
+
+void
+g10m_set_bytes( MPI a, unsigned nbits, byte (*fnc)(int), int opaque )
+{
+    mpi_set_bytes( a, nbits, fnc, opaque );
+}
+
+int  g10m_cmp( MPI u, MPI v )	    { return mpi_cmp( u, v ); }
+int  g10m_cmp_ui( MPI u, ulong v )  { return mpi_cmp_ui( u, v ); }
+
+void g10m_add(MPI w, MPI u, MPI v)	  { mpi_add( w, u, v ); }
+void g10m_add_ui(MPI w, MPI u, ulong v )  { mpi_add_ui( w, u, v ); }
+void g10m_sub( MPI w, MPI u, MPI v)	  { mpi_sub( w, u, v ); }
+void g10m_sub_ui(MPI w, MPI u, ulong v )  { mpi_sub_ui( w, u, v ); }
+
+void g10m_mul( MPI w, MPI u, MPI v)	     { mpi_mul( w, u, v ); }
+void g10m_mulm( MPI w, MPI u, MPI v, MPI m)  { mpi_mulm( w, u, v, m ); }
+void g10m_mul_2exp( MPI w, MPI u, ulong cnt) { mpi_mul_2exp( w, u, cnt ); }
+void g10m_mul_ui(MPI w, MPI u, ulong v )     { mpi_mul_ui( w, u, v ); }
+
+void g10m_fdiv_q( MPI q, MPI d, MPI r )      { mpi_fdiv_q( q, d, r ); }
+
+void g10m_powm( MPI r, MPI b, MPI e, MPI m)  { mpi_powm( r, b, e, m );	}
+
+int  g10m_gcd( MPI g, MPI a, MPI b )	{ return mpi_gcd( g, a, b ); }
+int  g10m_invm( MPI x, MPI u, MPI v )	{ mpi_invm( x, u, v ); return 0; }
+
+unsigned g10m_get_nbits( MPI a )   { return mpi_get_nbits( a ); }
+
+unsigned
+g10m_get_size( MPI a )
+{
+    return mpi_get_nlimbs( a ) * BITS_PER_MPI_LIMB;
+}
+
diff -urN gnupg-0.2.19/mpi/mips3/README gnupg-0.3.0/mpi/mips3/README
--- gnupg-0.2.19/mpi/mips3/README	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/README	Thu Jun 25 11:24:48 1998
@@ -0,0 +1,23 @@
+This directory contains mpn functions optimized for MIPS3.  Example of
+processors that implement MIPS3 are R4000, R4400, R4600, R4700, and R8000.
+
+RELEVANT OPTIMIZATION ISSUES
+
+1. On the R4000 and R4400, branches, both the plain and the "likely" ones,
+   take 3 cycles to execute.  (The fastest possible loop will take 4 cycles,
+   because of the delay insn.)
+
+   On the R4600, branches takes a single cycle
+
+   On the R8000, branches often take no noticable cycles, as they are
+   executed in a separate function unit..
+
+2. The R4000 and R4400 have a load latency of 4 cycles.
+
+3. On the R4000 and R4400, multiplies take a data-dependent number of
+   cycles, contrary to the SGI documentation.  There seem to be 3 or 4
+   possible latencies.
+
+STATUS
+
+Good...
diff -urN gnupg-0.2.19/mpi/mips3/distfiles gnupg-0.3.0/mpi/mips3/distfiles
--- gnupg-0.2.19/mpi/mips3/distfiles	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/distfiles	Thu Jun 25 11:48:47 1998
@@ -0,0 +1,9 @@
+README
+mpih-add1.S
+mpih-sub1.S
+mpih-mul1.S
+mpih-mul2.S
+mpih-mul3.S
+mpih-lshift.S
+mpih-rshift.S
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-add1.S gnupg-0.3.0/mpi/mips3/mpih-add1.S
--- gnupg-0.2.19/mpi/mips3/mpih-add1.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-add1.S	Thu Jun 25 11:39:04 1998
@@ -0,0 +1,122 @@
+/* mips3  add_n -- Add two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *	Copyright (C) 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_add_n( mpi_ptr_t res_ptr,	($4)
+ *		   mpi_ptr_t s1_ptr,	($5)
+ *		   mpi_ptr_t s2_ptr,	($6)
+ *		   mpi_size_t size)	($7)
+ */
+
+	.text
+	.align	2
+	.globl	mpihelp_add_n
+	.ent	mpihelp_add_n
+mpihelp_add_n:
+	.set	noreorder
+	.set	nomacro
+
+	ld	$10,0($5)
+	ld	$11,0($6)
+
+	daddiu	$7,$7,-1
+	and	$9,$7,4-1	# number of limbs in first loop
+	beq	$9,$0,.L0	# if multiple of 4 limbs, skip first loop
+	 move	$2,$0
+
+	dsubu	$7,$7,$9
+
+.Loop0: daddiu	$9,$9,-1
+	ld	$12,8($5)
+	daddu	$11,$11,$2
+	ld	$13,8($6)
+	sltu	$8,$11,$2
+	daddu	$11,$10,$11
+	sltu	$2,$11,$10
+	sd	$11,0($4)
+	or	$2,$2,$8
+
+	daddiu	$5,$5,8
+	daddiu	$6,$6,8
+	move	$10,$12
+	move	$11,$13
+	bne	$9,$0,.Loop0
+	 daddiu $4,$4,8
+
+.L0:	beq	$7,$0,.Lend
+	 nop
+
+.Loop:	daddiu	$7,$7,-4
+
+	ld	$12,8($5)
+	daddu	$11,$11,$2
+	ld	$13,8($6)
+	sltu	$8,$11,$2
+	daddu	$11,$10,$11
+	sltu	$2,$11,$10
+	sd	$11,0($4)
+	or	$2,$2,$8
+
+	ld	$10,16($5)
+	daddu	$13,$13,$2
+	ld	$11,16($6)
+	sltu	$8,$13,$2
+	daddu	$13,$12,$13
+	sltu	$2,$13,$12
+	sd	$13,8($4)
+	or	$2,$2,$8
+
+	ld	$12,24($5)
+	daddu	$11,$11,$2
+	ld	$13,24($6)
+	sltu	$8,$11,$2
+	daddu	$11,$10,$11
+	sltu	$2,$11,$10
+	sd	$11,16($4)
+	or	$2,$2,$8
+
+	ld	$10,32($5)
+	daddu	$13,$13,$2
+	ld	$11,32($6)
+	sltu	$8,$13,$2
+	daddu	$13,$12,$13
+	sltu	$2,$13,$12
+	sd	$13,24($4)
+	or	$2,$2,$8
+
+	daddiu	$5,$5,32
+	daddiu	$6,$6,32
+
+	bne	$7,$0,.Loop
+	 daddiu $4,$4,32
+
+.Lend:	daddu	$11,$11,$2
+	sltu	$8,$11,$2
+	daddu	$11,$10,$11
+	sltu	$2,$11,$10
+	sd	$11,0($4)
+	j	$31
+	or	$2,$2,$8
+
+	.end	mpihelp_add_n
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-lshift.S gnupg-0.3.0/mpi/mips3/mpih-lshift.S
--- gnupg-0.2.19/mpi/mips3/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-lshift.S	Thu Jun 25 11:32:39 1998
@@ -0,0 +1,95 @@
+/* mips3    lshift
+ *	Copyright (C) 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	($4)
+ *		   mpi_ptr_t up,	($5)
+ *		   mpi_size_t usize,	($6)
+ *		   unsigned cnt)	($7)
+ */
+
+	.text
+	.align	2
+	.globl	mpihelp_lshift
+	.ent	mpihelp_lshift
+mpihelp_lshift:
+	.set	noreorder
+	.set	nomacro
+
+	dsll	$2,$6,3
+	daddu	$5,$5,$2	# make r5 point at end of src
+	ld	$10,-8($5)	# load first limb
+	dsubu	$13,$0,$7
+	daddu	$4,$4,$2	# make r4 point at end of res
+	daddiu	$6,$6,-1
+	and	$9,$6,4-1	# number of limbs in first loop
+	beq	$9,$0,.L0	# if multiple of 4 limbs, skip first loop
+	 dsrl	$2,$10,$13	# compute function result
+
+	dsubu	$6,$6,$9
+
+.Loop0: ld	$3,-16($5)
+	daddiu	$4,$4,-8
+	daddiu	$5,$5,-8
+	daddiu	$9,$9,-1
+	dsll	$11,$10,$7
+	dsrl	$12,$3,$13
+	move	$10,$3
+	or	$8,$11,$12
+	bne	$9,$0,.Loop0
+	 sd	$8,0($4)
+
+.L0:	beq	$6,$0,.Lend
+	 nop
+
+.Loop:	ld	$3,-16($5)
+	daddiu	$4,$4,-32
+	daddiu	$6,$6,-4
+	dsll	$11,$10,$7
+	dsrl	$12,$3,$13
+
+	ld	$10,-24($5)
+	dsll	$14,$3,$7
+	or	$8,$11,$12
+	sd	$8,24($4)
+	dsrl	$9,$10,$13
+
+	ld	$3,-32($5)
+	dsll	$11,$10,$7
+	or	$8,$14,$9
+	sd	$8,16($4)
+	dsrl	$12,$3,$13
+
+	ld	$10,-40($5)
+	dsll	$14,$3,$7
+	or	$8,$11,$12
+	sd	$8,8($4)
+	dsrl	$9,$10,$13
+
+	daddiu	$5,$5,-32
+	or	$8,$14,$9
+	bgtz	$6,.Loop
+	 sd	$8,0($4)
+
+.Lend:	dsll	$8,$10,$7
+	j	$31
+	sd	$8,-8($4)
+	.end	mpihelp_lshift
diff -urN gnupg-0.2.19/mpi/mips3/mpih-mul1.S gnupg-0.3.0/mpi/mips3/mpih-mul1.S
--- gnupg-0.2.19/mpi/mips3/mpih-mul1.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-mul1.S	Thu Jun 25 11:43:49 1998
@@ -0,0 +1,87 @@
+/* mips3 mpih-mul1.S -- Multiply a limb vector with a limb and store
+ *			the result in a second limb vector.
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_mul_1( mpi_ptr_t res_ptr,	(r4)
+ *		  mpi_ptr_t s1_ptr,	(r5)
+ *		  mpi_size_t s1_size,	(r6)
+ *		  mpi_limb_t s2_limb)	(r7)
+ */
+
+	.text
+	.align	4
+	.globl	mpihelp_mul_1
+	.ent	mpihelp_mul_1
+mpihelp_mul_1:
+	.set	noreorder
+	.set	nomacro
+
+ # warm up phase 0
+	ld	$8,0($5)
+
+ # warm up phase 1
+	daddiu	$5,$5,8
+	dmultu	$8,$7
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC0
+	 move	$2,$0		# zero cy2
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC1
+	ld	$8,0($5)	# load new s1 limb as early as possible
+
+Loop:	mflo	$10
+	mfhi	$9
+	daddiu	$5,$5,8
+	daddu	$10,$10,$2	# add old carry limb to low product limb
+	dmultu	$8,$7
+	ld	$8,0($5)	# load new s1 limb as early as possible
+	daddiu	$6,$6,-1	# decrement loop counter
+	sltu	$2,$10,$2	# carry from previous addition -> $2
+	sd	$10,0($4)
+	daddiu	$4,$4,8
+	bne	$6,$0,Loop
+	 daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 1
+$LC1:	mflo	$10
+	mfhi	$9
+	daddu	$10,$10,$2
+	sltu	$2,$10,$2
+	dmultu	$8,$7
+	sd	$10,0($4)
+	daddiu	$4,$4,8
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 0
+$LC0:	mflo	$10
+	mfhi	$9
+	daddu	$10,$10,$2
+	sltu	$2,$10,$2
+	sd	$10,0($4)
+	j	$31
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+	.end	mpihelp_mul_1
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-mul2.S gnupg-0.3.0/mpi/mips3/mpih-mul2.S
--- gnupg-0.2.19/mpi/mips3/mpih-mul2.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-mul2.S	Thu Jun 25 11:45:57 1998
@@ -0,0 +1,99 @@
+/* MIPS3   addmul_1 -- Multiply a limb vector with a single limb and
+ *		       add the product to a second limb vector.
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_addmul_1( mpi_ptr_t res_ptr,      (r4)
+ *		     mpi_ptr_t s1_ptr,	     (r5)
+ *		     mpi_size_t s1_size,     (r6)
+ *		     mpi_limb_t s2_limb)     (r7)
+ */
+
+	.text
+	.align	4
+	.globl	mpihelp_addmul_1
+	.ent	mpihelp_addmul_1
+mpihelp_addmul_1:
+	.set	noreorder
+	.set	nomacro
+
+ # warm up phase 0
+	ld	$8,0($5)
+
+ # warm up phase 1
+	daddiu	$5,$5,8
+	dmultu	$8,$7
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC0
+	 move	$2,$0		# zero cy2
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC1
+	ld	$8,0($5)	# load new s1 limb as early as possible
+
+Loop:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddiu	$5,$5,8
+	daddu	$3,$3,$2	# add old carry limb to low product limb
+	dmultu	$8,$7
+	ld	$8,0($5)	# load new s1 limb as early as possible
+	daddiu	$6,$6,-1	# decrement loop counter
+	sltu	$2,$3,$2	# carry from previous addition -> $2
+	daddu	$3,$10,$3
+	sltu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	daddiu	$4,$4,8
+	bne	$6,$0,Loop
+	 daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 1
+$LC1:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddu	$3,$3,$2
+	sltu	$2,$3,$2
+	dmultu	$8,$7
+	daddu	$3,$10,$3
+	sltu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	daddiu	$4,$4,8
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 0
+$LC0:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddu	$3,$3,$2
+	sltu	$2,$3,$2
+	daddu	$3,$10,$3
+	sltu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	j	$31
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+	.end	mpihelp_addmul_1
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-mul3.S gnupg-0.3.0/mpi/mips3/mpih-mul3.S
--- gnupg-0.2.19/mpi/mips3/mpih-mul3.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-mul3.S	Thu Jun 25 11:47:54 1998
@@ -0,0 +1,99 @@
+/* MIPS3 submul_1 -- Multiply a limb vector with a single limb and
+ *		     subtract the product from a second limb vector.
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_submul_1( mpi_ptr_t res_ptr,      (r4)
+ *		     mpi_ptr_t s1_ptr,	     (r5)
+ *		     mpi_size_t s1_size,     (r6)
+ *		     mpi_limb_t s2_limb)     (r7)
+ */
+
+	.text
+	.align	4
+	.globl	mpihelp_submul_1
+	.ent	mpihelp_submul_1
+mpihelp_submul_1:
+	.set	noreorder
+	.set	nomacro
+
+ # warm up phase 0
+	ld	$8,0($5)
+
+ # warm up phase 1
+	daddiu	$5,$5,8
+	dmultu	$8,$7
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC0
+	 move	$2,$0		# zero cy2
+
+	daddiu	$6,$6,-1
+	beq	$6,$0,$LC1
+	ld	$8,0($5)	# load new s1 limb as early as possible
+
+Loop:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddiu	$5,$5,8
+	daddu	$3,$3,$2	# add old carry limb to low product limb
+	dmultu	$8,$7
+	ld	$8,0($5)	# load new s1 limb as early as possible
+	daddiu	$6,$6,-1	# decrement loop counter
+	sltu	$2,$3,$2	# carry from previous addition -> $2
+	dsubu	$3,$10,$3
+	sgtu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	daddiu	$4,$4,8
+	bne	$6,$0,Loop
+	 daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 1
+$LC1:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddu	$3,$3,$2
+	sltu	$2,$3,$2
+	dmultu	$8,$7
+	dsubu	$3,$10,$3
+	sgtu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	daddiu	$4,$4,8
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+ # cool down phase 0
+$LC0:	ld	$10,0($4)
+	mflo	$3
+	mfhi	$9
+	daddu	$3,$3,$2
+	sltu	$2,$3,$2
+	dsubu	$3,$10,$3
+	sgtu	$10,$3,$10
+	daddu	$2,$2,$10
+	sd	$3,0($4)
+	j	$31
+	daddu	$2,$9,$2	# add high product limb and carry from addition
+
+	.end	mpihelp_submul_1
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-rshift.S gnupg-0.3.0/mpi/mips3/mpih-rshift.S
--- gnupg-0.2.19/mpi/mips3/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-rshift.S	Thu Jun 25 11:34:47 1998
@@ -0,0 +1,93 @@
+/* mips3    rshift
+ *	Copyright (C) 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	($4)
+ *		   mpi_ptr_t up,	($5)
+ *		   mpi_size_t usize,	($6)
+ *		   unsigned cnt)	($7)
+ */
+
+	.text
+	.align	2
+	.globl	mpihelp_rshift
+	.ent	mpihelp_rshift
+mpihelp_rshift:
+	.set	noreorder
+	.set	nomacro
+
+	ld	$10,0($5)	# load first limb
+	dsubu	$13,$0,$7
+	daddiu	$6,$6,-1
+	and	$9,$6,4-1	# number of limbs in first loop
+	beq	$9,$0,.L0	# if multiple of 4 limbs, skip first loop
+	 dsll	$2,$10,$13	# compute function result
+
+	dsubu	$6,$6,$9
+
+.Loop0: ld	$3,8($5)
+	daddiu	$4,$4,8
+	daddiu	$5,$5,8
+	daddiu	$9,$9,-1
+	dsrl	$11,$10,$7
+	dsll	$12,$3,$13
+	move	$10,$3
+	or	$8,$11,$12
+	bne	$9,$0,.Loop0
+	 sd	$8,-8($4)
+
+.L0:	beq	$6,$0,.Lend
+	 nop
+
+.Loop:	ld	$3,8($5)
+	daddiu	$4,$4,32
+	daddiu	$6,$6,-4
+	dsrl	$11,$10,$7
+	dsll	$12,$3,$13
+
+	ld	$10,16($5)
+	dsrl	$14,$3,$7
+	or	$8,$11,$12
+	sd	$8,-32($4)
+	dsll	$9,$10,$13
+
+	ld	$3,24($5)
+	dsrl	$11,$10,$7
+	or	$8,$14,$9
+	sd	$8,-24($4)
+	dsll	$12,$3,$13
+
+	ld	$10,32($5)
+	dsrl	$14,$3,$7
+	or	$8,$11,$12
+	sd	$8,-16($4)
+	dsll	$9,$10,$13
+
+	daddiu	$5,$5,32
+	or	$8,$14,$9
+	bgtz	$6,.Loop
+	 sd	$8,-8($4)
+
+.Lend:	dsrl	$8,$10,$7
+	j	$31
+	sd	$8,0($4)
+	.end	mpihelp_rshift
+
diff -urN gnupg-0.2.19/mpi/mips3/mpih-sub1.S gnupg-0.3.0/mpi/mips3/mpih-sub1.S
--- gnupg-0.2.19/mpi/mips3/mpih-sub1.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/mpi/mips3/mpih-sub1.S	Thu Jun 25 11:41:22 1998
@@ -0,0 +1,123 @@
+/* mips3  sub_n -- Subtract two limb vectors of the same length > 0 and
+ *		  store difference in a third limb vector.
+ * Copyright (C) 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_sub_n( mpi_ptr_t res_ptr,	(r4)
+ *		   mpi_ptr_t s1_ptr,	(r5)
+ *		   mpi_ptr_t s2_ptr,	(r6)
+ *		   mpi_size_t size)	(r7)
+ */
+
+
+	.text
+	.align	2
+	.globl	mpihelp_sub_n
+	.ent	mpihelp_sub_n
+mpihelp_sub_n:
+	.set	noreorder
+	.set	nomacro
+
+	ld	$10,0($5)
+	ld	$11,0($6)
+
+	daddiu	$7,$7,-1
+	and	$9,$7,4-1	# number of limbs in first loop
+	beq	$9,$0,.L0	# if multiple of 4 limbs, skip first loop
+	move   $2,$0
+
+	dsubu	$7,$7,$9
+
+.Loop0: daddiu	$9,$9,-1
+	ld	$12,8($5)
+	daddu	$11,$11,$2
+	ld	$13,8($6)
+	sltu	$8,$11,$2
+	dsubu	$11,$10,$11
+	sltu	$2,$10,$11
+	sd	$11,0($4)
+	or	$2,$2,$8
+
+	daddiu	$5,$5,8
+	daddiu	$6,$6,8
+	move	$10,$12
+	move	$11,$13
+	bne	$9,$0,.Loop0
+	 daddiu $4,$4,8
+
+.L0:	beq	$7,$0,.Lend
+	 nop
+
+.Loop:	daddiu	$7,$7,-4
+
+	ld	$12,8($5)
+	daddu	$11,$11,$2
+	ld	$13,8($6)
+	sltu	$8,$11,$2
+	dsubu	$11,$10,$11
+	sltu	$2,$10,$11
+	sd	$11,0($4)
+	or	$2,$2,$8
+
+	ld	$10,16($5)
+	daddu	$13,$13,$2
+	ld	$11,16($6)
+	sltu	$8,$13,$2
+	dsubu	$13,$12,$13
+	sltu	$2,$12,$13
+	sd	$13,8($4)
+	or	$2,$2,$8
+
+	ld	$12,24($5)
+	daddu	$11,$11,$2
+	ld	$13,24($6)
+	sltu	$8,$11,$2
+	dsubu	$11,$10,$11
+	sltu	$2,$10,$11
+	sd	$11,16($4)
+	or	$2,$2,$8
+
+	ld	$10,32($5)
+	daddu	$13,$13,$2
+	ld	$11,32($6)
+	sltu	$8,$13,$2
+	dsubu	$13,$12,$13
+	sltu	$2,$12,$13
+	sd	$13,24($4)
+	or	$2,$2,$8
+
+	daddiu	$5,$5,32
+	daddiu	$6,$6,32
+
+	bne	$7,$0,.Loop
+	 daddiu $4,$4,32
+
+.Lend:	daddu	$11,$11,$2
+	sltu	$8,$11,$2
+	dsubu	$11,$10,$11
+	sltu	$2,$10,$11
+	sd	$11,0($4)
+	j	$31
+	or	$2,$2,$8
+
+	.end	mpihelp_sub_n
+	n
diff -urN gnupg-0.2.19/mpi/mpi-bit.c gnupg-0.3.0/mpi/mpi-bit.c
--- gnupg-0.2.19/mpi/mpi-bit.c	Tue Apr 14 19:04:43 1998
+++ gnupg-0.3.0/mpi/mpi-bit.c	Tue Jun 16 13:36:59 1998
@@ -60,6 +60,13 @@
 {
     unsigned n;
 
+    if( mpi_is_protected(a) ) {
+	n = mpi_get_nbit_info(a);
+	if( !n )
+	    n = a->nlimbs * BITS_PER_MPI_LIMB;
+	return n;
+    }
+
     if( a->nlimbs ) {
 	mpi_limb_t alimb = a->d[a->nlimbs-1];
 	if( alimb )
diff -urN gnupg-0.2.19/mpi/mpi-div.c gnupg-0.3.0/mpi/mpi-div.c
--- gnupg-0.2.19/mpi/mpi-div.c	Tue Apr 14 19:04:46 1998
+++ gnupg-0.3.0/mpi/mpi-div.c	Tue Jun 16 13:33:02 1998
@@ -198,7 +198,7 @@
 	/* Make sure QP and NP point to different objects.  Otherwise the
 	 * numerator would be gradually overwritten by the quotient limbs.  */
 	if(qp == np) { /* Copy NP object to temporary space.  */
-	    np = marker[markidx++] = mpi_alloc_limb_space(nsize,quot->secure);
+	    np = marker[markidx++] = mpi_alloc_limb_space(nsize,mpi_is_secure(quot));
 	    MPN_COPY(np, qp, nsize);
 	}
     }
@@ -218,7 +218,7 @@
 	/* Shift up the denominator setting the most significant bit of
 	 * the most significant word.  Use temporary storage not to clobber
 	 * the original contents of the denominator.  */
-	tp = marker[markidx++] = mpi_alloc_limb_space(dsize,den->secure);
+	tp = marker[markidx++] = mpi_alloc_limb_space(dsize,mpi_is_secure(den));
 	mpihelp_lshift( tp, dp, dsize, normalization_steps );
 	dp = tp;
 
@@ -239,7 +239,7 @@
 	if( dp == rp || (quot && (dp == qp))) {
 	    mpi_ptr_t tp;
 
-	    tp = marker[markidx++] = mpi_alloc_limb_space(dsize, den->secure);
+	    tp = marker[markidx++] = mpi_alloc_limb_space(dsize, mpi_is_secure(den));
 	    MPN_COPY( tp, dp, dsize );
 	    dp = tp;
 	}
diff -urN gnupg-0.2.19/mpi/mpi-mul.c gnupg-0.3.0/mpi/mpi-mul.c
--- gnupg-0.2.19/mpi/mpi-mul.c	Mon Feb 23 13:14:51 1998
+++ gnupg-0.3.0/mpi/mpi-mul.c	Tue Jun 16 13:41:33 1998
@@ -123,21 +123,21 @@
     if( u->nlimbs < v->nlimbs ) { /* Swap U and V. */
 	usize = v->nlimbs;
 	usign = v->sign;
-	usecure = v->secure;
+	usecure = mpi_is_secure(v);
 	up    = v->d;
 	vsize = u->nlimbs;
 	vsign = u->sign;
-	vsecure = u->secure;
+	vsecure = mpi_is_secure(u);
 	vp    = u->d;
     }
     else {
 	usize = u->nlimbs;
 	usign = u->sign;
-	usecure = u->secure;
+	usecure = mpi_is_secure(u);
 	up    = u->d;
 	vsize = v->nlimbs;
 	vsign = v->sign;
-	vsecure = v->secure;
+	vsecure = mpi_is_secure(v);
 	vp    = v->d;
     }
     sign_product = usign ^ vsign;
@@ -147,7 +147,7 @@
     wsize = usize + vsize;
     if( w->alloced < wsize ) {
 	if( wp == up || wp == vp ) {
-	    wp = mpi_alloc_limb_space( wsize, w->secure );
+	    wp = mpi_alloc_limb_space( wsize, mpi_is_secure(w) );
 	    assign_wp = 1;
 	}
 	else {
diff -urN gnupg-0.2.19/mpi/mpi-pow.c gnupg-0.3.0/mpi/mpi-pow.c
--- gnupg-0.2.19/mpi/mpi-pow.c	Mon Feb 23 13:14:51 1998
+++ gnupg-0.3.0/mpi/mpi-pow.c	Tue Jun 16 13:44:10 1998
@@ -60,10 +60,10 @@
     esign = exp->sign;
     msign = mod->sign;
 
-    esec = exp->secure;
-    msec = mod->secure;
-    bsec = base->secure;
-    rsec = res->secure;
+    esec = mpi_is_secure(exp);
+    msec = mpi_is_secure(mod);
+    bsec = mpi_is_secure(base);
+    rsec = mpi_is_secure(res);
 
     rp = res->d;
     ep = exp->d;
diff -urN gnupg-0.2.19/mpi/mpicoder.c gnupg-0.3.0/mpi/mpicoder.c
--- gnupg-0.2.19/mpi/mpicoder.c	Tue Apr 14 19:04:50 1998
+++ gnupg-0.3.0/mpi/mpicoder.c	Tue Jun 16 16:05:33 1998
@@ -210,8 +210,15 @@
 
     if( a == MPI_NULL )
 	return fprintf(fp, "[MPI_NULL]");
-    if( !mode )
-	n += fprintf(fp, "[%u bits]", mpi_get_nbits(a) );
+    if( !mode ) {
+	unsigned n1, n2;
+	n1 = mpi_get_nbits(a);
+	n2 = mpi_get_nbit_info(a);
+	if( n2 && n2 != n1 )
+	    n += fprintf(fp, "[%u bits (%u)]", n1, n2 );
+	else
+	    n += fprintf(fp, "[%u bits]", n1);
+    }
     else {
 	if( a->sign )
 	    putc('-', fp);
@@ -278,8 +285,8 @@
     if( sign )
 	*sign = a->sign;
     *nbytes = a->nlimbs * BYTES_PER_MPI_LIMB;
-    p = buffer = force_secure || a->secure ? m_alloc_secure( *nbytes)
-					   : m_alloc( *nbytes );
+    p = buffer = force_secure || mpi_is_secure(a) ? m_alloc_secure( *nbytes)
+						  : m_alloc( *nbytes );
 
     for(i=a->nlimbs-1; i >= 0; i-- ) {
 	alimb = a->d[i];
diff -urN gnupg-0.2.19/mpi/mpiutil.c gnupg-0.3.0/mpi/mpiutil.c
--- gnupg-0.2.19/mpi/mpiutil.c	Mon Feb 23 13:14:51 1998
+++ gnupg-0.3.0/mpi/mpiutil.c	Tue Jun 16 13:47:02 1998
@@ -63,7 +63,7 @@
     a->alloced = nlimbs;
     a->nlimbs = 0;
     a->sign = 0;
-    a->secure = 0;
+    a->flags = 0;
     return a;
 }
 
@@ -93,7 +93,7 @@
     a->d = nlimbs? mpi_alloc_limb_space( nlimbs, 1 ) : NULL;
   #endif
     a->alloced = nlimbs;
-    a->secure = 1;
+    a->flags |= 1;
     a->nlimbs = 0;
     a->sign = 0;
     return a;
@@ -204,9 +204,9 @@
 {
     mpi_ptr_t ap, bp;
 
-    if( a->secure )
+    if( (a->flags & 1) )
 	return;
-    a->secure = 1;
+    a->flags |= 1;
     ap = a->d;
     if( !a->nlimbs ) {
 	assert(!ap);
@@ -243,15 +243,16 @@
 
     if( a ) {
       #ifdef M_DEBUG
-	b = a->secure? mpi_debug_alloc_secure( a->nlimbs, info )
-		     : mpi_debug_alloc( a->nlimbs, info );
+	b = mpi_is_secure(a)? mpi_debug_alloc_secure( a->nlimbs, info )
+			    : mpi_debug_alloc( a->nlimbs, info );
       #else
-	b = a->secure? mpi_alloc_secure( a->nlimbs )
-		     : mpi_alloc( a->nlimbs );
+	b = mpi_is_secure(a)? mpi_alloc_secure( a->nlimbs )
+			    : mpi_alloc( a->nlimbs );
       #endif
 	b->nlimbs = a->nlimbs;
 	b->sign = a->sign;
-	b->secure = a->secure;
+	b->flags  = a->flags;
+	b->nbits = a->nbits;
 	for(i=0; i < b->nlimbs; i++ )
 	    b->d[i] = a->d[i];
     }
@@ -273,6 +274,7 @@
     up = u->d;
     MPN_COPY( wp, up, usize );
     w->nlimbs = usize;
+    w->nbits = u->nbits;
     w->sign = usign;
 }
 
@@ -284,6 +286,7 @@
     w->d[0] = u;
     w->nlimbs = u? 1:0;
     w->sign = 0;
+    w->nbits = 0;
 }
 
 
diff -urN gnupg-0.2.19/mpi/sparc32/mpih-rshift.S gnupg-0.3.0/mpi/sparc32/mpih-rshift.S
--- gnupg-0.2.19/mpi/sparc32/mpih-rshift.S	Mon May 18 13:33:20 1998
+++ gnupg-0.3.0/mpi/sparc32/mpih-rshift.S	Tue Jun  9 12:09:03 1998
@@ -29,7 +29,7 @@
 
 	.text
 	.align	4
-	.global C_SYMBOL_NAME(mpohelp_rshift)
+	.global C_SYMBOL_NAME(mpihelp_rshift)
 C_SYMBOL_NAME(mpihelp_rshift):
 	ld	[%o1],%g2	! load first limb
 	sub	%g0,%o3,%o5	! negate shift count
diff -urN gnupg-0.2.19/po/cat-id-tbl.c gnupg-0.3.0/po/cat-id-tbl.c
--- gnupg-0.2.19/po/cat-id-tbl.c	Thu May 28 10:43:06 1998
+++ gnupg-0.3.0/po/cat-id-tbl.c	Thu Jun 18 13:27:42 1998
@@ -63,10 +63,12 @@
   {"do not write comment packets", 49},
   {"(default is 1)", 50},
   {"(default is 3)", 51},
-  {"|NAME|use cipher algorithm NAME", 52},
-  {"|NAME|use public key algorithm NAME", 53},
-  {"|NAME|use message digest algorithm NAME", 54},
-  {"|N|use compress algorithm N", 55},
+  {"|file|load extension module", 52},
+  {"emulate the mode described in RFC1991", 53},
+  {"|NAME|use cipher algorithm NAME", 54},
+  {"|NAME|use public key algorithm NAME", 55},
+  {"|NAME|use message digest algorithm NAME", 56},
+  {"|N|use compress algorithm N", 57},
   {"\
 @\n\
 Examples:\n\
@@ -75,52 +77,52 @@
  -sat [file]                make a clear text signature\n\
  -sb  [file]                make a detached signature\n\
  -k   [userid]              show keys\n\
- -kc  [userid]              show fingerprint\n", 56},
-  {"Please report bugs to <gnupg-bugs@gnu.org>.\n", 57},
-  {"Usage: gpgm [options] [files] (-h for help)", 58},
-  {"Usage: gpg [options] [files] (-h for help)", 59},
+ -kc  [userid]              show fingerprint\n", 58},
+  {"Please report bugs to <gnupg-bugs@gnu.org>.\n", 59},
+  {"Usage: gpgm [options] [files] (-h for help)", 60},
+  {"Usage: gpg [options] [files] (-h for help)", 61},
   {"\
 Syntax: gpgm [options] [files]\n\
-GNUPG maintenance utility\n", 60},
+GNUPG maintenance utility\n", 62},
   {"\
 Syntax: gpg [options] [files]\n\
 sign, check, encrypt or decrypt\n\
-default operation depends on the input data\n", 61},
-  {"usage: gpgm [options] ", 62},
-  {"usage: gpg [options] ", 63},
-  {"conflicting commands\n", 64},
-  {"selected cipher algorithm is invalid\n", 65},
-  {"selected pubkey algorithm is invalid\n", 66},
-  {"selected digest algorithm is invalid\n", 67},
-  {"compress algorithm must be in range %d..%d\n", 68},
-  {"completes-needed must be greater than 0\n", 69},
-  {"marginals-needed must be greater than 1\n", 70},
-  {"note: no default option file '%s'\n", 71},
-  {"option file '%s': %s\n", 72},
-  {"reading options from '%s'\n", 73},
-  {"failed to initialize the TrustDB: %s\n", 74},
-  {"--store [filename]", 75},
-  {"--symmetric [filename]", 76},
-  {"--encrypt [filename]", 77},
-  {"--sign [filename]", 78},
-  {"--sign --encrypt [filename]", 79},
-  {"--clearsign [filename]", 80},
-  {"--decrypt [filename]", 81},
-  {"--sign-key username", 82},
-  {"--edit-sig username", 83},
-  {"--delete-secret-key username", 84},
-  {"--delete-key username", 85},
-  {"--change-passphrase [username]", 86},
-  {"can't open %s: %s\n", 87},
-  {"-k[v][v][v][c] [userid] [keyring]", 88},
-  {"dearmoring failed: %s\n", 89},
-  {"enarmoring failed: %s\n", 90},
-  {"invalid hash algorithm '%s'\n", 91},
-  {"[filename]", 92},
-  {"can't open '%s'\n", 93},
+default operation depends on the input data\n", 63},
+  {"usage: gpgm [options] ", 64},
+  {"usage: gpg [options] ", 65},
+  {"conflicting commands\n", 66},
+  {"selected cipher algorithm is invalid\n", 67},
+  {"selected pubkey algorithm is invalid\n", 68},
+  {"selected digest algorithm is invalid\n", 69},
+  {"compress algorithm must be in range %d..%d\n", 70},
+  {"completes-needed must be greater than 0\n", 71},
+  {"marginals-needed must be greater than 1\n", 72},
+  {"note: no default option file '%s'\n", 73},
+  {"option file '%s': %s\n", 74},
+  {"reading options from '%s'\n", 75},
+  {"failed to initialize the TrustDB: %s\n", 76},
+  {"--store [filename]", 77},
+  {"--symmetric [filename]", 78},
+  {"--encrypt [filename]", 79},
+  {"--sign [filename]", 80},
+  {"--sign --encrypt [filename]", 81},
+  {"--clearsign [filename]", 82},
+  {"--decrypt [filename]", 83},
+  {"--sign-key username", 84},
+  {"--edit-sig username", 85},
+  {"--delete-secret-key username", 86},
+  {"--delete-key username", 87},
+  {"--change-passphrase [username]", 88},
+  {"can't open %s: %s\n", 89},
+  {"-k[v][v][v][c] [userid] [keyring]", 90},
+  {"dearmoring failed: %s\n", 91},
+  {"enarmoring failed: %s\n", 92},
+  {"invalid hash algorithm '%s'\n", 93},
+  {"[filename]", 94},
+  {"can't open '%s'\n", 95},
   {"\
 No ownertrust defined for %lu:\n\
-%4u%c/%08lX %s \"", 94},
+%4u%c/%08lX %s \"", 96},
   {"\
 \"\n\
 \n\
@@ -133,108 +135,109 @@
  3 = I trust marginally\n\
  4 = I trust fully\n\
  s = please show me more information\n\
-\n", 95},
-  {"Your decision? ", 96},
+\n", 97},
+  {"Your decision? ", 98},
   {"\
 It's up to you to assign a value here; this value will never be exported\n\
 to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n\
-to do with the (implicitly created) web-of-certificates.\n", 97},
-  {"You will see a list of signators etc. here\n", 98},
+to do with the (implicitly created) web-of-certificates.\n", 99},
+  {"You will see a list of signators etc. here\n", 100},
   {"\
 Could not find a valid trust path to the key.  Let's see whether we\n\
 can assign some missing owner trust values.\n\
-\n", 99},
+\n", 101},
   {"\
 No ownertrust values changed.\n\
-\n", 100},
+\n", 102},
   {"\
 It is NOT certain that the key belongs to its owner.\n\
 If you *really* know what you are doing, you may answer\n\
 the next question with yes\n\
-\n", 101},
-  {"WARNING: Using untrusted key!\n", 102},
+\n", 103},
+  {"WARNING: Using untrusted key!\n", 104},
   {"\
 You did not specify a user ID. (you may use \"-r\")\n\
-\n", 103},
-  {"Enter the user ID: ", 104},
-  {"writing self signature\n", 105},
-  {"writing key binding signature\n", 106},
-  {"\
-Please select the algorithm to use:\n\
-   (1) ElGamal is the suggested one.\n\
-   (2) ElGamal using v4 packets (OpenPGP)\n\
-   (3) DSA can only be used for signatures.\n", 107},
-  {"   (4) RSA cannot be used in the U.S.\n", 108},
-  {"Your selection? (1,2,3,4) ", 109},
-  {"Your selection? (1,2,3) ", 110},
+\n", 105},
+  {"Enter the user ID: ", 106},
+  {"writing self signature\n", 107},
+  {"writing key binding signature\n", 108},
+  {"Please select what kind of key you want:\n", 109},
+  {"   (%d) DSA and ElGamal (default)\n", 110},
+  {"   (%d) ElGamal (sign and encrypt)\n", 111},
+  {"   (%d) ElGamal (encrypt only)\n", 112},
+  {"   (%d) DSA (sign only)\n", 113},
+  {"   (%d) ElGamal in a v3 packet\n", 114},
+  {"Your selection? ", 115},
+  {"Invalid selection.\n", 116},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
               default keysize is 1024 bits\n\
-    highest suggested keysize is 2048 bits\n", 111},
-  {"What keysize do you want? (1024) ", 112},
-  {"DSA only allows keysizes from 512 to 1024\n", 113},
-  {"keysize too small; 768 is smallest value allowed.\n", 114},
-  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 115},
-  {"Are you sure, that you want this keysize? ", 116},
-  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 117},
-  {"Do you really need such a large keysize? ", 118},
-  {"Requested keysize is %u bits\n", 119},
-  {"rounded up to %u bits\n", 120},
+    highest suggested keysize is 2048 bits\n", 117},
+  {"What keysize do you want? (1024) ", 118},
+  {"DSA only allows keysizes from 512 to 1024\n", 119},
+  {"keysize too small; 768 is smallest value allowed.\n", 120},
+  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 121},
+  {"Are you sure, that you want this keysize? ", 122},
+  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 123},
+  {"Do you really need such a large keysize? ", 124},
+  {"Requested keysize is %u bits\n", 125},
+  {"rounded up to %u bits\n", 126},
   {"\
 Please specify how long the key should be valid.\n\
          0 = key does not expire\n\
       <n>  = key expires in n days\n\
       <n>w = key expires in n weeks\n\
       <n>m = key expires in n months\n\
-      <n>y = key expires in n years\n", 121},
-  {"Key is valid for? (0) ", 122},
-  {"invalid value\n", 123},
-  {"Key does not expire at all\n", 124},
-  {"Key expires at %s\n", 125},
-  {"Is this correct (y/n)? ", 126},
+      <n>y = key expires in n years\n", 127},
+  {"Key is valid for? (0) ", 128},
+  {"invalid value\n", 129},
+  {"Key does not expire at all\n", 130},
+  {"Key expires at %s\n", 131},
+  {"Is this correct (y/n)? ", 132},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user id\n\
 from Real Name, Comment and Email Address in this form:\n\
     \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\
-\n", 127},
-  {"Real name: ", 128},
-  {"Invalid character in name\n", 129},
-  {"Name may not start with a digit\n", 130},
-  {"Name must be at least 5 characters long\n", 131},
-  {"Email address: ", 132},
-  {"Not a valid email address\n", 133},
-  {"Comment: ", 134},
-  {"Invalid character in comment\n", 135},
+\n", 133},
+  {"Real name: ", 134},
+  {"Invalid character in name\n", 135},
+  {"Name may not start with a digit\n", 136},
+  {"Name must be at least 5 characters long\n", 137},
+  {"Email address: ", 138},
+  {"Not a valid email address\n", 139},
+  {"Comment: ", 140},
+  {"Invalid character in comment\n", 141},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 136},
-  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 137},
+\n", 142},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 143},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 138},
-  {"passphrase not correctly repeated; try again.\n", 139},
+\n", 144},
+  {"passphrase not correctly repeated; try again.\n", 145},
   {"\
 You don't want a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at any time,\n\
 using this program with the option \"--change-passphrase\"\n\
-\n", 140},
+\n", 146},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
-number generator a better chance to gain enough entropy.\n", 141},
-  {"Key generation can only be used in interactive mode\n", 142},
-  {"writing public certificate to '%s'\n", 143},
-  {"writing secret certificate to '%s'\n", 144},
-  {"public and secret key created and signed.\n", 145},
+number generator a better chance to gain enough entropy.\n", 147},
+  {"Key generation can only be used in interactive mode\n", 148},
+  {"DSA keypair will have 1024 bits.\n", 149},
+  {"writing public certificate to '%s'\n", 150},
+  {"writing secret certificate to '%s'\n", 151},
+  {"public and secret key created and signed.\n", 152},
   {"\
 Note that this key cannot be used for encryption.  You may want to use\n\
-the command \"--add-key\" to generate a secondary key for this purpose.\n", 146},
-  {"Key generation failed: %s\n", 147},
-  {"public and secret subkey created.\n", 148},
+the command \"--add-key\" to generate a secondary key for this purpose.\n", 153},
+  {"Key generation failed: %s\n", 154},
+  {"public and secret subkey created.\n", 155},
 };
 
-int _msg_tbl_length = 148;
+int _msg_tbl_length = 155;
diff -urN gnupg-0.2.19/po/de.po gnupg-0.3.0/po/de.po
--- gnupg-0.2.19/po/de.po	Thu May 14 16:53:39 1998
+++ gnupg-0.3.0/po/de.po	Thu Jun 18 12:12:39 1998
@@ -563,10 +563,6 @@
 "   (1) ElGamal wird empfohlen.\n"
 "   (2) DSA kann nur fr Signaturen verwendet werden.\n"
 
-#: g10/keygen.c:305
-msgid "   (3) RSA cannot be used in the U.S.\n"
-msgstr "   (3) RSA darf in den USA nicht benutzt werden\n"
-
 #: g10/keygen.c:314
 msgid "Your selection? (1,2,3) "
 msgstr "Ihre Auswahl? (1,2,3) "
@@ -574,10 +570,6 @@
 #: g10/keygen.c:316
 msgid "Your selection? (1,2) "
 msgstr "Ihre Auswahl? (1,2) "
-
-#: g10/keygen.c:330
-msgid "Sorry; DSA is not yet supported.\n"
-msgstr "Pardon; DSA wird noch nicht untersttzt.\n"
 
 #: g10/keygen.c:343
 msgid ""
diff -urN gnupg-0.2.19/po/gnupg.pot gnupg-0.3.0/po/gnupg.pot
--- gnupg-0.2.19/po/gnupg.pot	Fri May 29 11:45:06 1998
+++ gnupg-0.3.0/po/gnupg.pot	Wed Jun 24 17:10:25 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"Date: 1998-05-29 11:45:05+0200\n"
+"Date: 1998-06-24 17:10:25+0200\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
@@ -211,23 +211,31 @@
 msgid "(default is 3)"
 msgstr ""
 
+#: g10/g10.c:114
+msgid "|file|load extension module"
+msgstr ""
+
 #: g10/g10.c:115
+msgid "emulate the mode described in RFC1991"
+msgstr ""
+
+#: g10/g10.c:117
 msgid "|NAME|use cipher algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:116
+#: g10/g10.c:118
 msgid "|NAME|use public key algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:117
+#: g10/g10.c:119
 msgid "|NAME|use message digest algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:118
+#: g10/g10.c:120
 msgid "|N|use compress algorithm N"
 msgstr ""
 
-#: g10/g10.c:127
+#: g10/g10.c:129
 msgid ""
 "@\n"
 "Examples:\n"
@@ -239,161 +247,159 @@
 " -kc  [userid]              show fingerprint\n"
 msgstr ""
 
-#: g10/g10.c:207
+#: g10/g10.c:210
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr ""
 
-#: g10/g10.c:212
+#: g10/g10.c:215
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:214
+#: g10/g10.c:217
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:219
+#: g10/g10.c:222
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GNUPG maintenance utility\n"
 msgstr ""
 
-#: g10/g10.c:222
+#: g10/g10.c:225
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:299
+#: g10/g10.c:302
 msgid "usage: gpgm [options] "
 msgstr ""
 
-#: g10/g10.c:301
+#: g10/g10.c:304
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:341
+#: g10/g10.c:345
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:354
+#: g10/g10.c:358
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:356
+#: g10/g10.c:360
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:358
+#: g10/g10.c:362
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:360
+#: g10/g10.c:364
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr ""
 
-#: g10/g10.c:362
+#: g10/g10.c:366
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:364
+#: g10/g10.c:368
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:461
+#: g10/g10.c:465
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:465
+#: g10/g10.c:469
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:472
+#: g10/g10.c:476
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:686
+#: g10/g10.c:696
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#. only store the file
-#: g10/g10.c:692
+#: g10/g10.c:702
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:700
+#: g10/g10.c:710
 msgid "--symmetric [filename]"
 msgstr ""
 
-#. encrypt the given file
-#: g10/g10.c:708
+#: g10/g10.c:718
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:721
+#: g10/g10.c:731
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:734
+#. sign and encrypt the given file
+#: g10/g10.c:744
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:748
+#: g10/g10.c:758
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:760
+#: g10/g10.c:770
 msgid "--decrypt [filename]"
 msgstr ""
 
-#. sign the key given as argument
-#: g10/g10.c:768
+#: g10/g10.c:778
 msgid "--sign-key username"
 msgstr ""
 
-#: g10/g10.c:776
+#. Edit a key signature
+#: g10/g10.c:786
 msgid "--edit-sig username"
 msgstr ""
 
-#: g10/g10.c:784
+#: g10/g10.c:794
 msgid "--delete-secret-key username"
 msgstr ""
 
-#: g10/g10.c:787
+#: g10/g10.c:797
 msgid "--delete-key username"
 msgstr ""
 
-#. Change the passphrase
-#. no arg: use default, 1 arg use this one
-#: g10/g10.c:795
+#: g10/g10.c:805
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#: g10/g10.c:819
+#. -kv userid keyring
+#: g10/g10.c:829
 msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:830
+#: g10/g10.c:840
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:882
+#: g10/g10.c:892
 msgid "dearmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:890
+#: g10/g10.c:900
 msgid "enarmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:946
+#: g10/g10.c:956
 msgid "invalid hash algorithm '%s'\n"
 msgstr ""
 
-#: g10/g10.c:996
+#: g10/g10.c:1006
 msgid "[filename]"
 msgstr ""
 
-#: g10/g10.c:998
+#: g10/g10.c:1008
 msgid "can't open '%s'\n"
 msgstr ""
 
@@ -469,35 +475,47 @@
 msgid "Enter the user ID: "
 msgstr ""
 
-#: g10/keygen.c:68
+#: g10/keygen.c:122
 msgid "writing self signature\n"
 msgstr ""
 
-#: g10/keygen.c:105
+#: g10/keygen.c:160
 msgid "writing key binding signature\n"
 msgstr ""
 
+#: g10/keygen.c:382
+msgid "Please select what kind of key you want:\n"
+msgstr ""
+
+#: g10/keygen.c:384
+msgid "   (%d) DSA and ElGamal (default)\n"
+msgstr ""
+
 #: g10/keygen.c:385
-msgid ""
-"Please select the algorithm to use:\n"
-"   (1) ElGamal is the suggested one.\n"
-"   (2) ElGamal using v4 packets (OpenPGP)\n"
-"   (3) DSA can only be used for signatures.\n"
+msgid "   (%d) ElGamal (sign and encrypt)\n"
 msgstr ""
 
-#: g10/keygen.c:390
-msgid "   (4) RSA cannot be used in the U.S.\n"
+#: g10/keygen.c:386
+msgid "   (%d) ElGamal (encrypt only)\n"
 msgstr ""
 
-#: g10/keygen.c:396
-msgid "Your selection? (1,2,3,4) "
+#: g10/keygen.c:387
+msgid "   (%d) DSA (sign only)\n"
 msgstr ""
 
-#: g10/keygen.c:398
-msgid "Your selection? (1,2,3) "
+#: g10/keygen.c:388
+msgid "   (%d) ElGamal in a v3 packet\n"
 msgstr ""
 
-#: g10/keygen.c:431
+#: g10/keygen.c:392
+msgid "Your selection? "
+msgstr ""
+
+#: g10/keygen.c:418
+msgid "Invalid selection.\n"
+msgstr ""
+
+#: g10/keygen.c:430
 msgid ""
 "About to generate a new %s keypair.\n"
 "              minimum keysize is  768 bits\n"
@@ -505,43 +523,43 @@
 "    highest suggested keysize is 2048 bits\n"
 msgstr ""
 
-#: g10/keygen.c:437
+#: g10/keygen.c:436
 msgid "What keysize do you want? (1024) "
 msgstr ""
 
-#: g10/keygen.c:442
+#: g10/keygen.c:441
 msgid "DSA only allows keysizes from 512 to 1024\n"
 msgstr ""
 
-#: g10/keygen.c:444
+#: g10/keygen.c:443
 msgid "keysize too small; 768 is smallest value allowed.\n"
 msgstr ""
 
-#: g10/keygen.c:446
+#: g10/keygen.c:445
 msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
 msgstr ""
 
-#: g10/keygen.c:448
+#: g10/keygen.c:447
 msgid "Are you sure, that you want this keysize? "
 msgstr ""
 
-#: g10/keygen.c:452
+#: g10/keygen.c:451
 msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
 msgstr ""
 
-#: g10/keygen.c:460
+#: g10/keygen.c:459
 msgid "Do you really need such a large keysize? "
 msgstr ""
 
-#: g10/keygen.c:471
+#: g10/keygen.c:470
 msgid "Requested keysize is %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:474 g10/keygen.c:478
+#: g10/keygen.c:473 g10/keygen.c:477
 msgid "rounded up to %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:490
+#: g10/keygen.c:489
 msgid ""
 "Please specify how long the key should be valid.\n"
 "         0 = key does not expire\n"
@@ -551,27 +569,27 @@
 "      <n>y = key expires in n years\n"
 msgstr ""
 
-#: g10/keygen.c:505
+#: g10/keygen.c:504
 msgid "Key is valid for? (0) "
 msgstr ""
 
-#: g10/keygen.c:516
+#: g10/keygen.c:515
 msgid "invalid value\n"
 msgstr ""
 
-#: g10/keygen.c:521
+#: g10/keygen.c:520
 msgid "Key does not expire at all\n"
 msgstr ""
 
-#: g10/keygen.c:523
+#: g10/keygen.c:522
 msgid "Key expires at %s\n"
 msgstr ""
 
-#: g10/keygen.c:528
+#: g10/keygen.c:527
 msgid "Is this correct (y/n)? "
 msgstr ""
 
-#: g10/keygen.c:544
+#: g10/keygen.c:543
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
@@ -580,60 +598,60 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:555
+#: g10/keygen.c:554
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:559
+#: g10/keygen.c:558
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:561
+#: g10/keygen.c:560
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:563
+#: g10/keygen.c:562
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:571
+#: g10/keygen.c:570
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:583
+#: g10/keygen.c:582
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:591
+#: g10/keygen.c:590
 msgid "Comment: "
 msgstr ""
 
-#: g10/keygen.c:597
+#: g10/keygen.c:596
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:617
+#: g10/keygen.c:616
 msgid ""
 "You selected this USER-ID:\n"
 "    \"%s\"\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:620
+#: g10/keygen.c:619
 msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
 msgstr ""
 
-#: g10/keygen.c:659
+#: g10/keygen.c:658
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:667
+#: g10/keygen.c:666
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:673
+#: g10/keygen.c:672
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -641,7 +659,7 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:694
+#: g10/keygen.c:693
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -649,32 +667,36 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:743 g10/keygen.c:871
+#: g10/keygen.c:739 g10/keygen.c:887
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:758
-msgid "writing public certificate to '%s'\n"
+#: g10/keygen.c:747
+msgid "DSA keypair will have 1024 bits.\n"
 msgstr ""
 
 #: g10/keygen.c:759
+msgid "writing public certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:760
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:822
+#: g10/keygen.c:838
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:824
+#: g10/keygen.c:840
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
 msgstr ""
 
-#: g10/keygen.c:838 g10/keygen.c:989
+#: g10/keygen.c:854 g10/keygen.c:1006
 msgid "Key generation failed: %s\n"
 msgstr ""
 
-#: g10/keygen.c:984
+#: g10/keygen.c:1001
 msgid "public and secret subkey created.\n"
 msgstr ""
diff -urN gnupg-0.2.19/tools/Makefile.in gnupg-0.3.0/tools/Makefile.in
--- gnupg-0.2.19/tools/Makefile.in	Fri May 29 12:56:24 1998
+++ gnupg-0.3.0/tools/Makefile.in	Thu Jun 25 13:09:12 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -241,18 +240,6 @@
 bftest.o: bftest.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
-	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	../include/i18n.h
-cast5test.o: cast5test.c ../config.h ../include/util.h \
-	../include/types.h ../include/errors.h ../include/mpi.h \
-	../include/iobuf.h ../include/memory.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/blowfish.h ../include/../cipher/cast5.h \
-	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
 	../include/../cipher/random.h ../include/i18n.h
 clean-sat.o: clean-sat.c
 mk-tdata.o: mk-tdata.c ../config.h
diff -urN gnupg-0.2.19/util/ChangeLog gnupg-0.3.0/util/ChangeLog
--- gnupg-0.2.19/util/ChangeLog	Thu May 14 16:45:29 1998
+++ gnupg-0.3.0/util/ChangeLog	Thu Jun 11 09:19:30 1998
@@ -1,3 +1,9 @@
+Wed Jun 10 07:39:41 1998  Werner Koch,mobil,,,	(wk@tobold)
+
+	* fileutil.c (compare_filenames): New.
+
+	* argparse.c (arg_parse): New flag bit 6 to ignore --version
+
 Thu May 14 16:45:13 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* argparse.c (show_help): Add some formatting stuff
diff -urN gnupg-0.2.19/util/Makefile.am gnupg-0.3.0/util/Makefile.am
--- gnupg-0.2.19/util/Makefile.am	Wed Apr  1 18:44:39 1998
+++ gnupg-0.3.0/util/Makefile.am	Sat Jun 13 17:28:39 1998
@@ -5,7 +5,7 @@
 noinst_LIBRARIES = libutil.a
 
 
-libutil_a_SOURCES = logger.c fileutil.c miscutil.c strgutil.c  \
+libutil_a_SOURCES = g10u.c logger.c fileutil.c miscutil.c strgutil.c  \
 		    ttyio.c  argparse.c memory.c secmem.c errors.c iobuf.c
 
 
diff -urN gnupg-0.2.19/util/Makefile.in gnupg-0.3.0/util/Makefile.in
--- gnupg-0.2.19/util/Makefile.in	Fri May 29 12:56:04 1998
+++ gnupg-0.3.0/util/Makefile.in	Thu Jun 25 13:08:52 1998
@@ -64,10 +64,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
@@ -96,7 +95,7 @@
 
 noinst_LIBRARIES = libutil.a
 
-libutil_a_SOURCES = logger.c fileutil.c miscutil.c strgutil.c  \
+libutil_a_SOURCES = g10u.c logger.c fileutil.c miscutil.c strgutil.c  \
 		    ttyio.c  argparse.c memory.c secmem.c errors.c iobuf.c
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
@@ -109,8 +108,8 @@
 LDFLAGS = @LDFLAGS@
 LIBS = @LIBS@
 libutil_a_LIBADD = 
-libutil_a_OBJECTS =  logger.o fileutil.o miscutil.o strgutil.o ttyio.o \
-argparse.o memory.o secmem.o errors.o iobuf.o
+libutil_a_OBJECTS =  g10u.o logger.o fileutil.o miscutil.o strgutil.o \
+ttyio.o argparse.o memory.o secmem.o errors.o iobuf.o
 AR = ar
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
@@ -213,6 +212,8 @@
 fileutil.o: fileutil.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/ttyio.h
+g10u.o: g10u.c ../config.h ../include/mpi.h ../include/iobuf.h \
+	../include/types.h ../include/memory.h ../include/g10lib.h
 iobuf.o: iobuf.c ../config.h ../include/memory.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h
diff -urN gnupg-0.2.19/util/argparse.c gnupg-0.3.0/util/argparse.c
--- gnupg-0.2.19/util/argparse.c	Thu May 14 16:59:22 1998
+++ gnupg-0.3.0/util/argparse.c	Thu Jun 11 09:19:30 1998
@@ -72,6 +72,7 @@
  *     Bit 3 : Do not use -- to stop option processing.
  *     Bit 4 : Do not skip the first arg.
  *     Bit 5 : allow usage of long option with only one dash
+ *     Bit 6 : ignore --version
  *     all other bits must be set to zero, this value is modified by the function
  *     so assume this is write only.
  *  Local flags (for each option):
@@ -377,8 +378,10 @@
 	if( !opts[i].short_opt && !strcmp( "help", s+2) )
 	    show_help(opts, arg->flags);
 	else if( !opts[i].short_opt && !strcmp( "version", s+2) ) {
-	    show_version();
-	    exit(0);
+	    if( !(arg->flags & (1<<6)) ) {
+		show_version();
+		exit(0);
+	    }
 	}
 	else if( !opts[i].short_opt && !strcmp( "warranty", s+2) ) {
 	    puts( strusage(16) );
diff -urN gnupg-0.2.19/util/fileutil.c gnupg-0.3.0/util/fileutil.c
--- gnupg-0.2.19/util/fileutil.c	Tue Apr 14 19:05:44 1998
+++ gnupg-0.3.0/util/fileutil.c	Thu Jun 11 09:19:30 1998
@@ -65,6 +65,20 @@
 }
 
 
+int
+compare_filenames( const char *a, const char *b )
+{
+    /* ? check whether this is an absolute filename and
+     * resolve symlinks?
+     */
+  #ifdef __MINGW32__
+    return stricmp(a,b);
+  #else
+    return strcmp(a,b);
+  #endif
+}
+
+
 /****************
  * A simple function to decide whether the filename is stdout
  * or a real filename.
diff -urN gnupg-0.2.19/util/g10u.c gnupg-0.3.0/util/g10u.c
--- gnupg-0.2.19/util/g10u.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.3.0/util/g10u.c	Mon Jun 15 17:41:04 1998
@@ -0,0 +1,39 @@
+/* g10u.c  -  Wrapper for utility functions
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi.h"
+#define _g10lib_INTERNAL 1
+#include "g10lib.h"
+
+
+const char *g10u_revision_string(int dummy) { return "$Revision: 1.2 $"; }
+
+
+void *g10_malloc( size_t n )	     { return m_alloc( n ); }
+void *g10_calloc( size_t n )	     { return m_alloc_clear( n ); }
+void *g10_malloc_secure( size_t n )  { return m_alloc_secure( n ); }
+void *g10_calloc_secure( size_t n )  { return m_alloc_secure_clear( n ); }
+void *g10_realloc( void *a, size_t n ) { return m_realloc( a, n ); }
+void  g10_free( void *p )	     { return m_free( p ); }
+char *g10_strdup( const char * a)    { return m_strdup( a ); }
+
diff -urN gnupg-0.2.19/util/logger.c gnupg-0.3.0/util/logger.c
--- gnupg-0.2.19/util/logger.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.3.0/util/logger.c	Tue Jun 16 17:02:54 1998
@@ -74,7 +74,7 @@
 }
 
 void
-log_info( const char *fmt, ... )
+g10_log_info( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
@@ -85,7 +85,7 @@
 }
 
 void
-log_error( const char *fmt, ... )
+g10_log_error( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
@@ -97,7 +97,7 @@
 }
 
 void
-log_fatal( const char *fmt, ... )
+g10_log_fatal( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
@@ -110,7 +110,7 @@
 }
 
 void
-log_bug( const char *fmt, ... )
+g10_log_bug( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
@@ -126,20 +126,20 @@
 
 #if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5 )
 void
-log_bug0( const char *file, int line, const char *func )
+g10_log_bug0( const char *file, int line, const char *func )
 {
     log_bug("Ohhhh jeeee ... (%s:%d:%s)\n", file, line, func );
 }
 #else
 void
-log_bug0( const char *file, int line )
+g10_log_bug0( const char *file, int line )
 {
     log_bug("Ohhhh jeeee ... (%s:%d)\n", file, line);
 }
 #endif
 
 void
-log_debug( const char *fmt, ... )
+g10_log_debug( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
@@ -152,7 +152,7 @@
 
 
 void
-log_hexdump( const char *text, char *buf, size_t len )
+g10_log_hexdump( const char *text, char *buf, size_t len )
 {
     int i;
 
@@ -164,7 +164,7 @@
 
 
 void
-log_mpidump( const char *text, MPI a )
+g10_log_mpidump( const char *text, MPI a )
 {
     print_prefix(text);
     mpi_print(stderr, a, 1 );
diff -urN gnupg-0.2.19/util/memory.c gnupg-0.3.0/util/memory.c
--- gnupg-0.2.19/util/memory.c	Tue Apr 14 19:05:52 1998
+++ gnupg-0.3.0/util/memory.c	Mon Jun 15 16:37:11 1998
@@ -127,7 +127,7 @@
 	index = memtbl_len++;
     else {
 	struct memtbl_entry *e;
-	/* look for a used entry in the table.  We take the first one,
+	/* look for a used entry in the table.	We take the first one,
 	 * so that freed entries remain as long as possible in the table
 	 * (free appends a new one)
 	 */
@@ -338,6 +338,7 @@
 {
     log_fatal("out of %s memory while allocating %u bytes\n",
 			secure? "secure":"" ,(unsigned)n );
+
 }
 
 /****************
diff -urN gnupg-0.2.19/util/secmem.c gnupg-0.3.0/util/secmem.c
--- gnupg-0.2.19/util/secmem.c	Fri Feb 27 13:13:47 1998
+++ gnupg-0.3.0/util/secmem.c	Wed Jun 24 10:50:20 1998
@@ -71,7 +71,7 @@
     uid_t uid;
     int err;
 
-    err = mlock( p, n );
+    err = -1; mlock( p, n );
     if( err && errno )
 	err = errno;
 
diff -urN gnupg-0.2.19/zlib/Makefile.in gnupg-0.3.0/zlib/Makefile.in
--- gnupg-0.2.19/zlib/Makefile.in	Fri May 29 12:55:57 1998
+++ gnupg-0.3.0/zlib/Makefile.in	Thu Jun 25 13:08:45 1998
@@ -69,10 +69,9 @@
 CATALOGS = @CATALOGS@
 CATOBJEXT = @CATOBJEXT@
 CC = @CC@
-CIPHER_EXTRA_DIST = @CIPHER_EXTRA_DIST@
-CIPHER_EXTRA_OBJS = @CIPHER_EXTRA_OBJS@
 CPP = @CPP@
 DATADIRNAME = @DATADIRNAME@
+DYNLINK_LDFLAGS = @DYNLINK_LDFLAGS@
 G10_LOCALEDIR = @G10_LOCALEDIR@
 GENCAT = @GENCAT@
 GMOFILES = @GMOFILES@
